/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface ElastigroupAzureV3Config extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#availability_vs_cost ElastigroupAzureV3#availability_vs_cost}
    */
    readonly availabilityVsCost?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#custom_data ElastigroupAzureV3#custom_data}
    */
    readonly customData?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#description ElastigroupAzureV3#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#desired_capacity ElastigroupAzureV3#desired_capacity}
    */
    readonly desiredCapacity?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#draining_timeout ElastigroupAzureV3#draining_timeout}
    */
    readonly drainingTimeout?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#fallback_to_on_demand ElastigroupAzureV3#fallback_to_on_demand}
    */
    readonly fallbackToOnDemand: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#id ElastigroupAzureV3#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#max_size ElastigroupAzureV3#max_size}
    */
    readonly maxSize?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#min_size ElastigroupAzureV3#min_size}
    */
    readonly minSize?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#name ElastigroupAzureV3#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#on_demand_count ElastigroupAzureV3#on_demand_count}
    */
    readonly onDemandCount?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#optimization_windows ElastigroupAzureV3#optimization_windows}
    */
    readonly optimizationWindows?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#os ElastigroupAzureV3#os}
    */
    readonly os: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#preferred_zones ElastigroupAzureV3#preferred_zones}
    */
    readonly preferredZones?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#region ElastigroupAzureV3#region}
    */
    readonly region: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#resource_group_name ElastigroupAzureV3#resource_group_name}
    */
    readonly resourceGroupName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#shutdown_script ElastigroupAzureV3#shutdown_script}
    */
    readonly shutdownScript?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#spot_percentage ElastigroupAzureV3#spot_percentage}
    */
    readonly spotPercentage?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#user_data ElastigroupAzureV3#user_data}
    */
    readonly userData?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#vm_name_prefix ElastigroupAzureV3#vm_name_prefix}
    */
    readonly vmNamePrefix?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#zones ElastigroupAzureV3#zones}
    */
    readonly zones?: string[];
    /**
    * boot_diagnostics block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#boot_diagnostics ElastigroupAzureV3#boot_diagnostics}
    */
    readonly bootDiagnostics?: ElastigroupAzureV3BootDiagnostics[] | cdktf.IResolvable;
    /**
    * capacity_reservation block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#capacity_reservation ElastigroupAzureV3#capacity_reservation}
    */
    readonly capacityReservation?: ElastigroupAzureV3CapacityReservation;
    /**
    * data_disk block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#data_disk ElastigroupAzureV3#data_disk}
    */
    readonly dataDisk?: ElastigroupAzureV3DataDisk[] | cdktf.IResolvable;
    /**
    * extensions block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#extensions ElastigroupAzureV3#extensions}
    */
    readonly extensions?: ElastigroupAzureV3Extensions[] | cdktf.IResolvable;
    /**
    * health block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#health ElastigroupAzureV3#health}
    */
    readonly health?: ElastigroupAzureV3Health;
    /**
    * image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#image ElastigroupAzureV3#image}
    */
    readonly image?: ElastigroupAzureV3Image[] | cdktf.IResolvable;
    /**
    * load_balancer block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#load_balancer ElastigroupAzureV3#load_balancer}
    */
    readonly loadBalancer?: ElastigroupAzureV3LoadBalancer[] | cdktf.IResolvable;
    /**
    * login block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#login ElastigroupAzureV3#login}
    */
    readonly login?: ElastigroupAzureV3Login;
    /**
    * managed_service_identity block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#managed_service_identity ElastigroupAzureV3#managed_service_identity}
    */
    readonly managedServiceIdentity?: ElastigroupAzureV3ManagedServiceIdentity[] | cdktf.IResolvable;
    /**
    * network block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#network ElastigroupAzureV3#network}
    */
    readonly network: ElastigroupAzureV3Network;
    /**
    * os_disk block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#os_disk ElastigroupAzureV3#os_disk}
    */
    readonly osDisk?: ElastigroupAzureV3OsDisk;
    /**
    * proximity_placement_groups block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#proximity_placement_groups ElastigroupAzureV3#proximity_placement_groups}
    */
    readonly proximityPlacementGroups?: ElastigroupAzureV3ProximityPlacementGroups[] | cdktf.IResolvable;
    /**
    * revert_to_spot block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#revert_to_spot ElastigroupAzureV3#revert_to_spot}
    */
    readonly revertToSpot?: ElastigroupAzureV3RevertToSpot;
    /**
    * scaling_down_policy block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#scaling_down_policy ElastigroupAzureV3#scaling_down_policy}
    */
    readonly scalingDownPolicy?: ElastigroupAzureV3ScalingDownPolicy[] | cdktf.IResolvable;
    /**
    * scaling_up_policy block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#scaling_up_policy ElastigroupAzureV3#scaling_up_policy}
    */
    readonly scalingUpPolicy?: ElastigroupAzureV3ScalingUpPolicy[] | cdktf.IResolvable;
    /**
    * scheduling_task block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#scheduling_task ElastigroupAzureV3#scheduling_task}
    */
    readonly schedulingTask?: ElastigroupAzureV3SchedulingTask[] | cdktf.IResolvable;
    /**
    * secret block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#secret ElastigroupAzureV3#secret}
    */
    readonly secret?: ElastigroupAzureV3Secret[] | cdktf.IResolvable;
    /**
    * security block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#security ElastigroupAzureV3#security}
    */
    readonly security?: ElastigroupAzureV3Security;
    /**
    * signal block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#signal ElastigroupAzureV3#signal}
    */
    readonly signal?: ElastigroupAzureV3Signal[] | cdktf.IResolvable;
    /**
    * tags block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#tags ElastigroupAzureV3#tags}
    */
    readonly tags?: ElastigroupAzureV3Tags[] | cdktf.IResolvable;
    /**
    * vm_sizes block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#vm_sizes ElastigroupAzureV3#vm_sizes}
    */
    readonly vmSizes: ElastigroupAzureV3VmSizes;
}
export interface ElastigroupAzureV3BootDiagnostics {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#is_enabled ElastigroupAzureV3#is_enabled}
    */
    readonly isEnabled: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#storage_url ElastigroupAzureV3#storage_url}
    */
    readonly storageUrl?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#type ElastigroupAzureV3#type}
    */
    readonly type: string;
}
export declare function elastigroupAzureV3BootDiagnosticsToTerraform(struct?: ElastigroupAzureV3BootDiagnostics | cdktf.IResolvable): any;
export declare function elastigroupAzureV3BootDiagnosticsToHclTerraform(struct?: ElastigroupAzureV3BootDiagnostics | cdktf.IResolvable): any;
export declare class ElastigroupAzureV3BootDiagnosticsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAzureV3BootDiagnostics | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAzureV3BootDiagnostics | cdktf.IResolvable | undefined);
    private _isEnabled?;
    get isEnabled(): boolean | cdktf.IResolvable;
    set isEnabled(value: boolean | cdktf.IResolvable);
    get isEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _storageUrl?;
    get storageUrl(): string;
    set storageUrl(value: string);
    resetStorageUrl(): void;
    get storageUrlInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
}
export declare class ElastigroupAzureV3BootDiagnosticsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAzureV3BootDiagnostics[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAzureV3BootDiagnosticsOutputReference;
}
export interface ElastigroupAzureV3CapacityReservationCapacityReservationGroups {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#crg_name ElastigroupAzureV3#crg_name}
    */
    readonly crgName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#crg_resource_group_name ElastigroupAzureV3#crg_resource_group_name}
    */
    readonly crgResourceGroupName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#crg_should_prioritize ElastigroupAzureV3#crg_should_prioritize}
    */
    readonly crgShouldPrioritize?: boolean | cdktf.IResolvable;
}
export declare function elastigroupAzureV3CapacityReservationCapacityReservationGroupsToTerraform(struct?: ElastigroupAzureV3CapacityReservationCapacityReservationGroupsOutputReference | ElastigroupAzureV3CapacityReservationCapacityReservationGroups): any;
export declare function elastigroupAzureV3CapacityReservationCapacityReservationGroupsToHclTerraform(struct?: ElastigroupAzureV3CapacityReservationCapacityReservationGroupsOutputReference | ElastigroupAzureV3CapacityReservationCapacityReservationGroups): any;
export declare class ElastigroupAzureV3CapacityReservationCapacityReservationGroupsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAzureV3CapacityReservationCapacityReservationGroups | undefined;
    set internalValue(value: ElastigroupAzureV3CapacityReservationCapacityReservationGroups | undefined);
    private _crgName?;
    get crgName(): string;
    set crgName(value: string);
    get crgNameInput(): string | undefined;
    private _crgResourceGroupName?;
    get crgResourceGroupName(): string;
    set crgResourceGroupName(value: string);
    get crgResourceGroupNameInput(): string | undefined;
    private _crgShouldPrioritize?;
    get crgShouldPrioritize(): boolean | cdktf.IResolvable;
    set crgShouldPrioritize(value: boolean | cdktf.IResolvable);
    resetCrgShouldPrioritize(): void;
    get crgShouldPrioritizeInput(): boolean | cdktf.IResolvable | undefined;
}
export interface ElastigroupAzureV3CapacityReservation {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#should_utilize ElastigroupAzureV3#should_utilize}
    */
    readonly shouldUtilize: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#utilization_strategy ElastigroupAzureV3#utilization_strategy}
    */
    readonly utilizationStrategy: string;
    /**
    * capacity_reservation_groups block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#capacity_reservation_groups ElastigroupAzureV3#capacity_reservation_groups}
    */
    readonly capacityReservationGroups?: ElastigroupAzureV3CapacityReservationCapacityReservationGroups;
}
export declare function elastigroupAzureV3CapacityReservationToTerraform(struct?: ElastigroupAzureV3CapacityReservationOutputReference | ElastigroupAzureV3CapacityReservation): any;
export declare function elastigroupAzureV3CapacityReservationToHclTerraform(struct?: ElastigroupAzureV3CapacityReservationOutputReference | ElastigroupAzureV3CapacityReservation): any;
export declare class ElastigroupAzureV3CapacityReservationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAzureV3CapacityReservation | undefined;
    set internalValue(value: ElastigroupAzureV3CapacityReservation | undefined);
    private _shouldUtilize?;
    get shouldUtilize(): boolean | cdktf.IResolvable;
    set shouldUtilize(value: boolean | cdktf.IResolvable);
    get shouldUtilizeInput(): boolean | cdktf.IResolvable | undefined;
    private _utilizationStrategy?;
    get utilizationStrategy(): string;
    set utilizationStrategy(value: string);
    get utilizationStrategyInput(): string | undefined;
    private _capacityReservationGroups;
    get capacityReservationGroups(): ElastigroupAzureV3CapacityReservationCapacityReservationGroupsOutputReference;
    putCapacityReservationGroups(value: ElastigroupAzureV3CapacityReservationCapacityReservationGroups): void;
    resetCapacityReservationGroups(): void;
    get capacityReservationGroupsInput(): ElastigroupAzureV3CapacityReservationCapacityReservationGroups | undefined;
}
export interface ElastigroupAzureV3DataDisk {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#lun ElastigroupAzureV3#lun}
    */
    readonly lun: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#size_gb ElastigroupAzureV3#size_gb}
    */
    readonly sizeGb: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#type ElastigroupAzureV3#type}
    */
    readonly type: string;
}
export declare function elastigroupAzureV3DataDiskToTerraform(struct?: ElastigroupAzureV3DataDisk | cdktf.IResolvable): any;
export declare function elastigroupAzureV3DataDiskToHclTerraform(struct?: ElastigroupAzureV3DataDisk | cdktf.IResolvable): any;
export declare class ElastigroupAzureV3DataDiskOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAzureV3DataDisk | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAzureV3DataDisk | cdktf.IResolvable | undefined);
    private _lun?;
    get lun(): number;
    set lun(value: number);
    get lunInput(): number | undefined;
    private _sizeGb?;
    get sizeGb(): number;
    set sizeGb(value: number);
    get sizeGbInput(): number | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
}
export declare class ElastigroupAzureV3DataDiskList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAzureV3DataDisk[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAzureV3DataDiskOutputReference;
}
export interface ElastigroupAzureV3ExtensionsProtectedSettingsFromKeyVault {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#secret_url ElastigroupAzureV3#secret_url}
    */
    readonly secretUrl: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#source_vault ElastigroupAzureV3#source_vault}
    */
    readonly sourceVault: string;
}
export declare function elastigroupAzureV3ExtensionsProtectedSettingsFromKeyVaultToTerraform(struct?: ElastigroupAzureV3ExtensionsProtectedSettingsFromKeyVaultOutputReference | ElastigroupAzureV3ExtensionsProtectedSettingsFromKeyVault): any;
export declare function elastigroupAzureV3ExtensionsProtectedSettingsFromKeyVaultToHclTerraform(struct?: ElastigroupAzureV3ExtensionsProtectedSettingsFromKeyVaultOutputReference | ElastigroupAzureV3ExtensionsProtectedSettingsFromKeyVault): any;
export declare class ElastigroupAzureV3ExtensionsProtectedSettingsFromKeyVaultOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAzureV3ExtensionsProtectedSettingsFromKeyVault | undefined;
    set internalValue(value: ElastigroupAzureV3ExtensionsProtectedSettingsFromKeyVault | undefined);
    private _secretUrl?;
    get secretUrl(): string;
    set secretUrl(value: string);
    get secretUrlInput(): string | undefined;
    private _sourceVault?;
    get sourceVault(): string;
    set sourceVault(value: string);
    get sourceVaultInput(): string | undefined;
}
export interface ElastigroupAzureV3Extensions {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#api_version ElastigroupAzureV3#api_version}
    */
    readonly apiVersion: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#enable_automatic_upgrade ElastigroupAzureV3#enable_automatic_upgrade}
    */
    readonly enableAutomaticUpgrade?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#minor_version_auto_upgrade ElastigroupAzureV3#minor_version_auto_upgrade}
    */
    readonly minorVersionAutoUpgrade: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#name ElastigroupAzureV3#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#protected_settings ElastigroupAzureV3#protected_settings}
    */
    readonly protectedSettings?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#public_settings ElastigroupAzureV3#public_settings}
    */
    readonly publicSettings?: {
        [key: string]: string;
    };
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#publisher ElastigroupAzureV3#publisher}
    */
    readonly publisher: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#type ElastigroupAzureV3#type}
    */
    readonly type: string;
    /**
    * protected_settings_from_key_vault block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#protected_settings_from_key_vault ElastigroupAzureV3#protected_settings_from_key_vault}
    */
    readonly protectedSettingsFromKeyVault?: ElastigroupAzureV3ExtensionsProtectedSettingsFromKeyVault;
}
export declare function elastigroupAzureV3ExtensionsToTerraform(struct?: ElastigroupAzureV3Extensions | cdktf.IResolvable): any;
export declare function elastigroupAzureV3ExtensionsToHclTerraform(struct?: ElastigroupAzureV3Extensions | cdktf.IResolvable): any;
export declare class ElastigroupAzureV3ExtensionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAzureV3Extensions | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAzureV3Extensions | cdktf.IResolvable | undefined);
    private _apiVersion?;
    get apiVersion(): string;
    set apiVersion(value: string);
    get apiVersionInput(): string | undefined;
    private _enableAutomaticUpgrade?;
    get enableAutomaticUpgrade(): boolean | cdktf.IResolvable;
    set enableAutomaticUpgrade(value: boolean | cdktf.IResolvable);
    resetEnableAutomaticUpgrade(): void;
    get enableAutomaticUpgradeInput(): boolean | cdktf.IResolvable | undefined;
    private _minorVersionAutoUpgrade?;
    get minorVersionAutoUpgrade(): boolean | cdktf.IResolvable;
    set minorVersionAutoUpgrade(value: boolean | cdktf.IResolvable);
    get minorVersionAutoUpgradeInput(): boolean | cdktf.IResolvable | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _protectedSettings?;
    get protectedSettings(): {
        [key: string]: string;
    };
    set protectedSettings(value: {
        [key: string]: string;
    });
    resetProtectedSettings(): void;
    get protectedSettingsInput(): {
        [key: string]: string;
    } | undefined;
    private _publicSettings?;
    get publicSettings(): {
        [key: string]: string;
    };
    set publicSettings(value: {
        [key: string]: string;
    });
    resetPublicSettings(): void;
    get publicSettingsInput(): {
        [key: string]: string;
    } | undefined;
    private _publisher?;
    get publisher(): string;
    set publisher(value: string);
    get publisherInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
    private _protectedSettingsFromKeyVault;
    get protectedSettingsFromKeyVault(): ElastigroupAzureV3ExtensionsProtectedSettingsFromKeyVaultOutputReference;
    putProtectedSettingsFromKeyVault(value: ElastigroupAzureV3ExtensionsProtectedSettingsFromKeyVault): void;
    resetProtectedSettingsFromKeyVault(): void;
    get protectedSettingsFromKeyVaultInput(): ElastigroupAzureV3ExtensionsProtectedSettingsFromKeyVault | undefined;
}
export declare class ElastigroupAzureV3ExtensionsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAzureV3Extensions[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAzureV3ExtensionsOutputReference;
}
export interface ElastigroupAzureV3Health {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#auto_healing ElastigroupAzureV3#auto_healing}
    */
    readonly autoHealing?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#grace_period ElastigroupAzureV3#grace_period}
    */
    readonly gracePeriod?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#health_check_types ElastigroupAzureV3#health_check_types}
    */
    readonly healthCheckTypes?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#unhealthy_duration ElastigroupAzureV3#unhealthy_duration}
    */
    readonly unhealthyDuration?: number;
}
export declare function elastigroupAzureV3HealthToTerraform(struct?: ElastigroupAzureV3HealthOutputReference | ElastigroupAzureV3Health): any;
export declare function elastigroupAzureV3HealthToHclTerraform(struct?: ElastigroupAzureV3HealthOutputReference | ElastigroupAzureV3Health): any;
export declare class ElastigroupAzureV3HealthOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAzureV3Health | undefined;
    set internalValue(value: ElastigroupAzureV3Health | undefined);
    private _autoHealing?;
    get autoHealing(): boolean | cdktf.IResolvable;
    set autoHealing(value: boolean | cdktf.IResolvable);
    resetAutoHealing(): void;
    get autoHealingInput(): boolean | cdktf.IResolvable | undefined;
    private _gracePeriod?;
    get gracePeriod(): number;
    set gracePeriod(value: number);
    resetGracePeriod(): void;
    get gracePeriodInput(): number | undefined;
    private _healthCheckTypes?;
    get healthCheckTypes(): string[];
    set healthCheckTypes(value: string[]);
    resetHealthCheckTypes(): void;
    get healthCheckTypesInput(): string[] | undefined;
    private _unhealthyDuration?;
    get unhealthyDuration(): number;
    set unhealthyDuration(value: number);
    resetUnhealthyDuration(): void;
    get unhealthyDurationInput(): number | undefined;
}
export interface ElastigroupAzureV3ImageCustom {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#image_name ElastigroupAzureV3#image_name}
    */
    readonly imageName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#resource_group_name ElastigroupAzureV3#resource_group_name}
    */
    readonly resourceGroupName: string;
}
export declare function elastigroupAzureV3ImageCustomToTerraform(struct?: ElastigroupAzureV3ImageCustom | cdktf.IResolvable): any;
export declare function elastigroupAzureV3ImageCustomToHclTerraform(struct?: ElastigroupAzureV3ImageCustom | cdktf.IResolvable): any;
export declare class ElastigroupAzureV3ImageCustomOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAzureV3ImageCustom | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAzureV3ImageCustom | cdktf.IResolvable | undefined);
    private _imageName?;
    get imageName(): string;
    set imageName(value: string);
    get imageNameInput(): string | undefined;
    private _resourceGroupName?;
    get resourceGroupName(): string;
    set resourceGroupName(value: string);
    get resourceGroupNameInput(): string | undefined;
}
export declare class ElastigroupAzureV3ImageCustomList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAzureV3ImageCustom[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAzureV3ImageCustomOutputReference;
}
export interface ElastigroupAzureV3ImageGalleryImage {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#gallery_name ElastigroupAzureV3#gallery_name}
    */
    readonly galleryName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#image_name ElastigroupAzureV3#image_name}
    */
    readonly imageName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#resource_group_name ElastigroupAzureV3#resource_group_name}
    */
    readonly resourceGroupName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#spot_account_id ElastigroupAzureV3#spot_account_id}
    */
    readonly spotAccountId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#version ElastigroupAzureV3#version}
    */
    readonly version: string;
}
export declare function elastigroupAzureV3ImageGalleryImageToTerraform(struct?: ElastigroupAzureV3ImageGalleryImage | cdktf.IResolvable): any;
export declare function elastigroupAzureV3ImageGalleryImageToHclTerraform(struct?: ElastigroupAzureV3ImageGalleryImage | cdktf.IResolvable): any;
export declare class ElastigroupAzureV3ImageGalleryImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAzureV3ImageGalleryImage | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAzureV3ImageGalleryImage | cdktf.IResolvable | undefined);
    private _galleryName?;
    get galleryName(): string;
    set galleryName(value: string);
    get galleryNameInput(): string | undefined;
    private _imageName?;
    get imageName(): string;
    set imageName(value: string);
    get imageNameInput(): string | undefined;
    private _resourceGroupName?;
    get resourceGroupName(): string;
    set resourceGroupName(value: string);
    get resourceGroupNameInput(): string | undefined;
    private _spotAccountId?;
    get spotAccountId(): string;
    set spotAccountId(value: string);
    resetSpotAccountId(): void;
    get spotAccountIdInput(): string | undefined;
    private _version?;
    get version(): string;
    set version(value: string);
    get versionInput(): string | undefined;
}
export declare class ElastigroupAzureV3ImageGalleryImageList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAzureV3ImageGalleryImage[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAzureV3ImageGalleryImageOutputReference;
}
export interface ElastigroupAzureV3ImageMarketplace {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#offer ElastigroupAzureV3#offer}
    */
    readonly offer: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#publisher ElastigroupAzureV3#publisher}
    */
    readonly publisher: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#sku ElastigroupAzureV3#sku}
    */
    readonly sku: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#version ElastigroupAzureV3#version}
    */
    readonly version: string;
}
export declare function elastigroupAzureV3ImageMarketplaceToTerraform(struct?: ElastigroupAzureV3ImageMarketplace | cdktf.IResolvable): any;
export declare function elastigroupAzureV3ImageMarketplaceToHclTerraform(struct?: ElastigroupAzureV3ImageMarketplace | cdktf.IResolvable): any;
export declare class ElastigroupAzureV3ImageMarketplaceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAzureV3ImageMarketplace | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAzureV3ImageMarketplace | cdktf.IResolvable | undefined);
    private _offer?;
    get offer(): string;
    set offer(value: string);
    get offerInput(): string | undefined;
    private _publisher?;
    get publisher(): string;
    set publisher(value: string);
    get publisherInput(): string | undefined;
    private _sku?;
    get sku(): string;
    set sku(value: string);
    get skuInput(): string | undefined;
    private _version?;
    get version(): string;
    set version(value: string);
    get versionInput(): string | undefined;
}
export declare class ElastigroupAzureV3ImageMarketplaceList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAzureV3ImageMarketplace[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAzureV3ImageMarketplaceOutputReference;
}
export interface ElastigroupAzureV3Image {
    /**
    * custom block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#custom ElastigroupAzureV3#custom}
    */
    readonly custom?: ElastigroupAzureV3ImageCustom[] | cdktf.IResolvable;
    /**
    * gallery_image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#gallery_image ElastigroupAzureV3#gallery_image}
    */
    readonly galleryImage?: ElastigroupAzureV3ImageGalleryImage[] | cdktf.IResolvable;
    /**
    * marketplace block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#marketplace ElastigroupAzureV3#marketplace}
    */
    readonly marketplace?: ElastigroupAzureV3ImageMarketplace[] | cdktf.IResolvable;
}
export declare function elastigroupAzureV3ImageToTerraform(struct?: ElastigroupAzureV3Image | cdktf.IResolvable): any;
export declare function elastigroupAzureV3ImageToHclTerraform(struct?: ElastigroupAzureV3Image | cdktf.IResolvable): any;
export declare class ElastigroupAzureV3ImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAzureV3Image | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAzureV3Image | cdktf.IResolvable | undefined);
    private _custom;
    get custom(): ElastigroupAzureV3ImageCustomList;
    putCustom(value: ElastigroupAzureV3ImageCustom[] | cdktf.IResolvable): void;
    resetCustom(): void;
    get customInput(): cdktf.IResolvable | ElastigroupAzureV3ImageCustom[] | undefined;
    private _galleryImage;
    get galleryImage(): ElastigroupAzureV3ImageGalleryImageList;
    putGalleryImage(value: ElastigroupAzureV3ImageGalleryImage[] | cdktf.IResolvable): void;
    resetGalleryImage(): void;
    get galleryImageInput(): cdktf.IResolvable | ElastigroupAzureV3ImageGalleryImage[] | undefined;
    private _marketplace;
    get marketplace(): ElastigroupAzureV3ImageMarketplaceList;
    putMarketplace(value: ElastigroupAzureV3ImageMarketplace[] | cdktf.IResolvable): void;
    resetMarketplace(): void;
    get marketplaceInput(): cdktf.IResolvable | ElastigroupAzureV3ImageMarketplace[] | undefined;
}
export declare class ElastigroupAzureV3ImageList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAzureV3Image[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAzureV3ImageOutputReference;
}
export interface ElastigroupAzureV3LoadBalancer {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#backend_pool_names ElastigroupAzureV3#backend_pool_names}
    */
    readonly backendPoolNames?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#name ElastigroupAzureV3#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#resource_group_name ElastigroupAzureV3#resource_group_name}
    */
    readonly resourceGroupName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#sku ElastigroupAzureV3#sku}
    */
    readonly sku?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#type ElastigroupAzureV3#type}
    */
    readonly type: string;
}
export declare function elastigroupAzureV3LoadBalancerToTerraform(struct?: ElastigroupAzureV3LoadBalancer | cdktf.IResolvable): any;
export declare function elastigroupAzureV3LoadBalancerToHclTerraform(struct?: ElastigroupAzureV3LoadBalancer | cdktf.IResolvable): any;
export declare class ElastigroupAzureV3LoadBalancerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAzureV3LoadBalancer | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAzureV3LoadBalancer | cdktf.IResolvable | undefined);
    private _backendPoolNames?;
    get backendPoolNames(): string[];
    set backendPoolNames(value: string[]);
    resetBackendPoolNames(): void;
    get backendPoolNamesInput(): string[] | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _resourceGroupName?;
    get resourceGroupName(): string;
    set resourceGroupName(value: string);
    get resourceGroupNameInput(): string | undefined;
    private _sku?;
    get sku(): string;
    set sku(value: string);
    resetSku(): void;
    get skuInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
}
export declare class ElastigroupAzureV3LoadBalancerList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAzureV3LoadBalancer[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAzureV3LoadBalancerOutputReference;
}
export interface ElastigroupAzureV3Login {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#password ElastigroupAzureV3#password}
    */
    readonly password?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#ssh_public_key ElastigroupAzureV3#ssh_public_key}
    */
    readonly sshPublicKey?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#user_name ElastigroupAzureV3#user_name}
    */
    readonly userName: string;
}
export declare function elastigroupAzureV3LoginToTerraform(struct?: ElastigroupAzureV3LoginOutputReference | ElastigroupAzureV3Login): any;
export declare function elastigroupAzureV3LoginToHclTerraform(struct?: ElastigroupAzureV3LoginOutputReference | ElastigroupAzureV3Login): any;
export declare class ElastigroupAzureV3LoginOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAzureV3Login | undefined;
    set internalValue(value: ElastigroupAzureV3Login | undefined);
    private _password?;
    get password(): string;
    set password(value: string);
    resetPassword(): void;
    get passwordInput(): string | undefined;
    private _sshPublicKey?;
    get sshPublicKey(): string;
    set sshPublicKey(value: string);
    resetSshPublicKey(): void;
    get sshPublicKeyInput(): string | undefined;
    private _userName?;
    get userName(): string;
    set userName(value: string);
    get userNameInput(): string | undefined;
}
export interface ElastigroupAzureV3ManagedServiceIdentity {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#name ElastigroupAzureV3#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#resource_group_name ElastigroupAzureV3#resource_group_name}
    */
    readonly resourceGroupName: string;
}
export declare function elastigroupAzureV3ManagedServiceIdentityToTerraform(struct?: ElastigroupAzureV3ManagedServiceIdentity | cdktf.IResolvable): any;
export declare function elastigroupAzureV3ManagedServiceIdentityToHclTerraform(struct?: ElastigroupAzureV3ManagedServiceIdentity | cdktf.IResolvable): any;
export declare class ElastigroupAzureV3ManagedServiceIdentityOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAzureV3ManagedServiceIdentity | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAzureV3ManagedServiceIdentity | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _resourceGroupName?;
    get resourceGroupName(): string;
    set resourceGroupName(value: string);
    get resourceGroupNameInput(): string | undefined;
}
export declare class ElastigroupAzureV3ManagedServiceIdentityList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAzureV3ManagedServiceIdentity[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAzureV3ManagedServiceIdentityOutputReference;
}
export interface ElastigroupAzureV3NetworkNetworkInterfacesAdditionalIpConfigs {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#name ElastigroupAzureV3#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#private_ip_version ElastigroupAzureV3#private_ip_version}
    */
    readonly privateIpVersion?: string;
}
export declare function elastigroupAzureV3NetworkNetworkInterfacesAdditionalIpConfigsToTerraform(struct?: ElastigroupAzureV3NetworkNetworkInterfacesAdditionalIpConfigs | cdktf.IResolvable): any;
export declare function elastigroupAzureV3NetworkNetworkInterfacesAdditionalIpConfigsToHclTerraform(struct?: ElastigroupAzureV3NetworkNetworkInterfacesAdditionalIpConfigs | cdktf.IResolvable): any;
export declare class ElastigroupAzureV3NetworkNetworkInterfacesAdditionalIpConfigsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAzureV3NetworkNetworkInterfacesAdditionalIpConfigs | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAzureV3NetworkNetworkInterfacesAdditionalIpConfigs | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _privateIpVersion?;
    get privateIpVersion(): string;
    set privateIpVersion(value: string);
    resetPrivateIpVersion(): void;
    get privateIpVersionInput(): string | undefined;
}
export declare class ElastigroupAzureV3NetworkNetworkInterfacesAdditionalIpConfigsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAzureV3NetworkNetworkInterfacesAdditionalIpConfigs[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAzureV3NetworkNetworkInterfacesAdditionalIpConfigsOutputReference;
}
export interface ElastigroupAzureV3NetworkNetworkInterfacesApplicationSecurityGroup {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#name ElastigroupAzureV3#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#resource_group_name ElastigroupAzureV3#resource_group_name}
    */
    readonly resourceGroupName: string;
}
export declare function elastigroupAzureV3NetworkNetworkInterfacesApplicationSecurityGroupToTerraform(struct?: ElastigroupAzureV3NetworkNetworkInterfacesApplicationSecurityGroup | cdktf.IResolvable): any;
export declare function elastigroupAzureV3NetworkNetworkInterfacesApplicationSecurityGroupToHclTerraform(struct?: ElastigroupAzureV3NetworkNetworkInterfacesApplicationSecurityGroup | cdktf.IResolvable): any;
export declare class ElastigroupAzureV3NetworkNetworkInterfacesApplicationSecurityGroupOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAzureV3NetworkNetworkInterfacesApplicationSecurityGroup | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAzureV3NetworkNetworkInterfacesApplicationSecurityGroup | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _resourceGroupName?;
    get resourceGroupName(): string;
    set resourceGroupName(value: string);
    get resourceGroupNameInput(): string | undefined;
}
export declare class ElastigroupAzureV3NetworkNetworkInterfacesApplicationSecurityGroupList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAzureV3NetworkNetworkInterfacesApplicationSecurityGroup[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAzureV3NetworkNetworkInterfacesApplicationSecurityGroupOutputReference;
}
export interface ElastigroupAzureV3NetworkNetworkInterfacesSecurityGroup {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#name ElastigroupAzureV3#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#resource_group_name ElastigroupAzureV3#resource_group_name}
    */
    readonly resourceGroupName?: string;
}
export declare function elastigroupAzureV3NetworkNetworkInterfacesSecurityGroupToTerraform(struct?: ElastigroupAzureV3NetworkNetworkInterfacesSecurityGroup | cdktf.IResolvable): any;
export declare function elastigroupAzureV3NetworkNetworkInterfacesSecurityGroupToHclTerraform(struct?: ElastigroupAzureV3NetworkNetworkInterfacesSecurityGroup | cdktf.IResolvable): any;
export declare class ElastigroupAzureV3NetworkNetworkInterfacesSecurityGroupOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAzureV3NetworkNetworkInterfacesSecurityGroup | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAzureV3NetworkNetworkInterfacesSecurityGroup | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _resourceGroupName?;
    get resourceGroupName(): string;
    set resourceGroupName(value: string);
    resetResourceGroupName(): void;
    get resourceGroupNameInput(): string | undefined;
}
export declare class ElastigroupAzureV3NetworkNetworkInterfacesSecurityGroupList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAzureV3NetworkNetworkInterfacesSecurityGroup[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAzureV3NetworkNetworkInterfacesSecurityGroupOutputReference;
}
export interface ElastigroupAzureV3NetworkNetworkInterfaces {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#assign_public_ip ElastigroupAzureV3#assign_public_ip}
    */
    readonly assignPublicIp: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#enable_ip_forwarding ElastigroupAzureV3#enable_ip_forwarding}
    */
    readonly enableIpForwarding?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#is_primary ElastigroupAzureV3#is_primary}
    */
    readonly isPrimary: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#private_ip_addresses ElastigroupAzureV3#private_ip_addresses}
    */
    readonly privateIpAddresses?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#public_ip_sku ElastigroupAzureV3#public_ip_sku}
    */
    readonly publicIpSku?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#subnet_name ElastigroupAzureV3#subnet_name}
    */
    readonly subnetName: string;
    /**
    * additional_ip_configs block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#additional_ip_configs ElastigroupAzureV3#additional_ip_configs}
    */
    readonly additionalIpConfigs?: ElastigroupAzureV3NetworkNetworkInterfacesAdditionalIpConfigs[] | cdktf.IResolvable;
    /**
    * application_security_group block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#application_security_group ElastigroupAzureV3#application_security_group}
    */
    readonly applicationSecurityGroup?: ElastigroupAzureV3NetworkNetworkInterfacesApplicationSecurityGroup[] | cdktf.IResolvable;
    /**
    * security_group block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#security_group ElastigroupAzureV3#security_group}
    */
    readonly securityGroup?: ElastigroupAzureV3NetworkNetworkInterfacesSecurityGroup[] | cdktf.IResolvable;
}
export declare function elastigroupAzureV3NetworkNetworkInterfacesToTerraform(struct?: ElastigroupAzureV3NetworkNetworkInterfaces | cdktf.IResolvable): any;
export declare function elastigroupAzureV3NetworkNetworkInterfacesToHclTerraform(struct?: ElastigroupAzureV3NetworkNetworkInterfaces | cdktf.IResolvable): any;
export declare class ElastigroupAzureV3NetworkNetworkInterfacesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAzureV3NetworkNetworkInterfaces | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAzureV3NetworkNetworkInterfaces | cdktf.IResolvable | undefined);
    private _assignPublicIp?;
    get assignPublicIp(): boolean | cdktf.IResolvable;
    set assignPublicIp(value: boolean | cdktf.IResolvable);
    get assignPublicIpInput(): boolean | cdktf.IResolvable | undefined;
    private _enableIpForwarding?;
    get enableIpForwarding(): boolean | cdktf.IResolvable;
    set enableIpForwarding(value: boolean | cdktf.IResolvable);
    resetEnableIpForwarding(): void;
    get enableIpForwardingInput(): boolean | cdktf.IResolvable | undefined;
    private _isPrimary?;
    get isPrimary(): boolean | cdktf.IResolvable;
    set isPrimary(value: boolean | cdktf.IResolvable);
    get isPrimaryInput(): boolean | cdktf.IResolvable | undefined;
    private _privateIpAddresses?;
    get privateIpAddresses(): string[];
    set privateIpAddresses(value: string[]);
    resetPrivateIpAddresses(): void;
    get privateIpAddressesInput(): string[] | undefined;
    private _publicIpSku?;
    get publicIpSku(): string;
    set publicIpSku(value: string);
    resetPublicIpSku(): void;
    get publicIpSkuInput(): string | undefined;
    private _subnetName?;
    get subnetName(): string;
    set subnetName(value: string);
    get subnetNameInput(): string | undefined;
    private _additionalIpConfigs;
    get additionalIpConfigs(): ElastigroupAzureV3NetworkNetworkInterfacesAdditionalIpConfigsList;
    putAdditionalIpConfigs(value: ElastigroupAzureV3NetworkNetworkInterfacesAdditionalIpConfigs[] | cdktf.IResolvable): void;
    resetAdditionalIpConfigs(): void;
    get additionalIpConfigsInput(): cdktf.IResolvable | ElastigroupAzureV3NetworkNetworkInterfacesAdditionalIpConfigs[] | undefined;
    private _applicationSecurityGroup;
    get applicationSecurityGroup(): ElastigroupAzureV3NetworkNetworkInterfacesApplicationSecurityGroupList;
    putApplicationSecurityGroup(value: ElastigroupAzureV3NetworkNetworkInterfacesApplicationSecurityGroup[] | cdktf.IResolvable): void;
    resetApplicationSecurityGroup(): void;
    get applicationSecurityGroupInput(): cdktf.IResolvable | ElastigroupAzureV3NetworkNetworkInterfacesApplicationSecurityGroup[] | undefined;
    private _securityGroup;
    get securityGroup(): ElastigroupAzureV3NetworkNetworkInterfacesSecurityGroupList;
    putSecurityGroup(value: ElastigroupAzureV3NetworkNetworkInterfacesSecurityGroup[] | cdktf.IResolvable): void;
    resetSecurityGroup(): void;
    get securityGroupInput(): cdktf.IResolvable | ElastigroupAzureV3NetworkNetworkInterfacesSecurityGroup[] | undefined;
}
export declare class ElastigroupAzureV3NetworkNetworkInterfacesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAzureV3NetworkNetworkInterfaces[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAzureV3NetworkNetworkInterfacesOutputReference;
}
export interface ElastigroupAzureV3Network {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#resource_group_name ElastigroupAzureV3#resource_group_name}
    */
    readonly resourceGroupName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#virtual_network_name ElastigroupAzureV3#virtual_network_name}
    */
    readonly virtualNetworkName: string;
    /**
    * network_interfaces block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#network_interfaces ElastigroupAzureV3#network_interfaces}
    */
    readonly networkInterfaces: ElastigroupAzureV3NetworkNetworkInterfaces[] | cdktf.IResolvable;
}
export declare function elastigroupAzureV3NetworkToTerraform(struct?: ElastigroupAzureV3NetworkOutputReference | ElastigroupAzureV3Network): any;
export declare function elastigroupAzureV3NetworkToHclTerraform(struct?: ElastigroupAzureV3NetworkOutputReference | ElastigroupAzureV3Network): any;
export declare class ElastigroupAzureV3NetworkOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAzureV3Network | undefined;
    set internalValue(value: ElastigroupAzureV3Network | undefined);
    private _resourceGroupName?;
    get resourceGroupName(): string;
    set resourceGroupName(value: string);
    get resourceGroupNameInput(): string | undefined;
    private _virtualNetworkName?;
    get virtualNetworkName(): string;
    set virtualNetworkName(value: string);
    get virtualNetworkNameInput(): string | undefined;
    private _networkInterfaces;
    get networkInterfaces(): ElastigroupAzureV3NetworkNetworkInterfacesList;
    putNetworkInterfaces(value: ElastigroupAzureV3NetworkNetworkInterfaces[] | cdktf.IResolvable): void;
    get networkInterfacesInput(): cdktf.IResolvable | ElastigroupAzureV3NetworkNetworkInterfaces[] | undefined;
}
export interface ElastigroupAzureV3OsDisk {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#size_gb ElastigroupAzureV3#size_gb}
    */
    readonly sizeGb?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#type ElastigroupAzureV3#type}
    */
    readonly type: string;
}
export declare function elastigroupAzureV3OsDiskToTerraform(struct?: ElastigroupAzureV3OsDiskOutputReference | ElastigroupAzureV3OsDisk): any;
export declare function elastigroupAzureV3OsDiskToHclTerraform(struct?: ElastigroupAzureV3OsDiskOutputReference | ElastigroupAzureV3OsDisk): any;
export declare class ElastigroupAzureV3OsDiskOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAzureV3OsDisk | undefined;
    set internalValue(value: ElastigroupAzureV3OsDisk | undefined);
    private _sizeGb?;
    get sizeGb(): number;
    set sizeGb(value: number);
    resetSizeGb(): void;
    get sizeGbInput(): number | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
}
export interface ElastigroupAzureV3ProximityPlacementGroups {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#name ElastigroupAzureV3#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#resource_group_name ElastigroupAzureV3#resource_group_name}
    */
    readonly resourceGroupName: string;
}
export declare function elastigroupAzureV3ProximityPlacementGroupsToTerraform(struct?: ElastigroupAzureV3ProximityPlacementGroups | cdktf.IResolvable): any;
export declare function elastigroupAzureV3ProximityPlacementGroupsToHclTerraform(struct?: ElastigroupAzureV3ProximityPlacementGroups | cdktf.IResolvable): any;
export declare class ElastigroupAzureV3ProximityPlacementGroupsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAzureV3ProximityPlacementGroups | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAzureV3ProximityPlacementGroups | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _resourceGroupName?;
    get resourceGroupName(): string;
    set resourceGroupName(value: string);
    get resourceGroupNameInput(): string | undefined;
}
export declare class ElastigroupAzureV3ProximityPlacementGroupsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAzureV3ProximityPlacementGroups[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAzureV3ProximityPlacementGroupsOutputReference;
}
export interface ElastigroupAzureV3RevertToSpot {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#perform_at ElastigroupAzureV3#perform_at}
    */
    readonly performAt: string;
}
export declare function elastigroupAzureV3RevertToSpotToTerraform(struct?: ElastigroupAzureV3RevertToSpotOutputReference | ElastigroupAzureV3RevertToSpot): any;
export declare function elastigroupAzureV3RevertToSpotToHclTerraform(struct?: ElastigroupAzureV3RevertToSpotOutputReference | ElastigroupAzureV3RevertToSpot): any;
export declare class ElastigroupAzureV3RevertToSpotOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAzureV3RevertToSpot | undefined;
    set internalValue(value: ElastigroupAzureV3RevertToSpot | undefined);
    private _performAt?;
    get performAt(): string;
    set performAt(value: string);
    get performAtInput(): string | undefined;
}
export interface ElastigroupAzureV3ScalingDownPolicyAction {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#adjustment ElastigroupAzureV3#adjustment}
    */
    readonly adjustment?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#maximum ElastigroupAzureV3#maximum}
    */
    readonly maximum?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#minimum ElastigroupAzureV3#minimum}
    */
    readonly minimum?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#target ElastigroupAzureV3#target}
    */
    readonly target?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#type ElastigroupAzureV3#type}
    */
    readonly type?: string;
}
export declare function elastigroupAzureV3ScalingDownPolicyActionToTerraform(struct?: ElastigroupAzureV3ScalingDownPolicyActionOutputReference | ElastigroupAzureV3ScalingDownPolicyAction): any;
export declare function elastigroupAzureV3ScalingDownPolicyActionToHclTerraform(struct?: ElastigroupAzureV3ScalingDownPolicyActionOutputReference | ElastigroupAzureV3ScalingDownPolicyAction): any;
export declare class ElastigroupAzureV3ScalingDownPolicyActionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAzureV3ScalingDownPolicyAction | undefined;
    set internalValue(value: ElastigroupAzureV3ScalingDownPolicyAction | undefined);
    private _adjustment?;
    get adjustment(): string;
    set adjustment(value: string);
    resetAdjustment(): void;
    get adjustmentInput(): string | undefined;
    private _maximum?;
    get maximum(): string;
    set maximum(value: string);
    resetMaximum(): void;
    get maximumInput(): string | undefined;
    private _minimum?;
    get minimum(): string;
    set minimum(value: string);
    resetMinimum(): void;
    get minimumInput(): string | undefined;
    private _target?;
    get target(): string;
    set target(value: string);
    resetTarget(): void;
    get targetInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
}
export interface ElastigroupAzureV3ScalingDownPolicyDimensions {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#name ElastigroupAzureV3#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#value ElastigroupAzureV3#value}
    */
    readonly value?: string;
}
export declare function elastigroupAzureV3ScalingDownPolicyDimensionsToTerraform(struct?: ElastigroupAzureV3ScalingDownPolicyDimensions | cdktf.IResolvable): any;
export declare function elastigroupAzureV3ScalingDownPolicyDimensionsToHclTerraform(struct?: ElastigroupAzureV3ScalingDownPolicyDimensions | cdktf.IResolvable): any;
export declare class ElastigroupAzureV3ScalingDownPolicyDimensionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAzureV3ScalingDownPolicyDimensions | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAzureV3ScalingDownPolicyDimensions | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
}
export declare class ElastigroupAzureV3ScalingDownPolicyDimensionsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAzureV3ScalingDownPolicyDimensions[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAzureV3ScalingDownPolicyDimensionsOutputReference;
}
export interface ElastigroupAzureV3ScalingDownPolicy {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#cooldown ElastigroupAzureV3#cooldown}
    */
    readonly cooldown: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#evaluation_periods ElastigroupAzureV3#evaluation_periods}
    */
    readonly evaluationPeriods: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#is_enabled ElastigroupAzureV3#is_enabled}
    */
    readonly isEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#metric_name ElastigroupAzureV3#metric_name}
    */
    readonly metricName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#namespace ElastigroupAzureV3#namespace}
    */
    readonly namespace: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#operator ElastigroupAzureV3#operator}
    */
    readonly operator: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#period ElastigroupAzureV3#period}
    */
    readonly period: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#policy_name ElastigroupAzureV3#policy_name}
    */
    readonly policyName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#source ElastigroupAzureV3#source}
    */
    readonly source?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#statistic ElastigroupAzureV3#statistic}
    */
    readonly statistic: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#threshold ElastigroupAzureV3#threshold}
    */
    readonly threshold: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#unit ElastigroupAzureV3#unit}
    */
    readonly unit?: string;
    /**
    * action block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#action ElastigroupAzureV3#action}
    */
    readonly action: ElastigroupAzureV3ScalingDownPolicyAction;
    /**
    * dimensions block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#dimensions ElastigroupAzureV3#dimensions}
    */
    readonly dimensions?: ElastigroupAzureV3ScalingDownPolicyDimensions[] | cdktf.IResolvable;
}
export declare function elastigroupAzureV3ScalingDownPolicyToTerraform(struct?: ElastigroupAzureV3ScalingDownPolicy | cdktf.IResolvable): any;
export declare function elastigroupAzureV3ScalingDownPolicyToHclTerraform(struct?: ElastigroupAzureV3ScalingDownPolicy | cdktf.IResolvable): any;
export declare class ElastigroupAzureV3ScalingDownPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAzureV3ScalingDownPolicy | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAzureV3ScalingDownPolicy | cdktf.IResolvable | undefined);
    private _cooldown?;
    get cooldown(): number;
    set cooldown(value: number);
    get cooldownInput(): number | undefined;
    private _evaluationPeriods?;
    get evaluationPeriods(): number;
    set evaluationPeriods(value: number);
    get evaluationPeriodsInput(): number | undefined;
    private _isEnabled?;
    get isEnabled(): boolean | cdktf.IResolvable;
    set isEnabled(value: boolean | cdktf.IResolvable);
    resetIsEnabled(): void;
    get isEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _metricName?;
    get metricName(): string;
    set metricName(value: string);
    get metricNameInput(): string | undefined;
    private _namespace?;
    get namespace(): string;
    set namespace(value: string);
    get namespaceInput(): string | undefined;
    private _operator?;
    get operator(): string;
    set operator(value: string);
    get operatorInput(): string | undefined;
    private _period?;
    get period(): number;
    set period(value: number);
    get periodInput(): number | undefined;
    private _policyName?;
    get policyName(): string;
    set policyName(value: string);
    get policyNameInput(): string | undefined;
    private _source?;
    get source(): string;
    set source(value: string);
    resetSource(): void;
    get sourceInput(): string | undefined;
    private _statistic?;
    get statistic(): string;
    set statistic(value: string);
    get statisticInput(): string | undefined;
    private _threshold?;
    get threshold(): number;
    set threshold(value: number);
    get thresholdInput(): number | undefined;
    private _unit?;
    get unit(): string;
    set unit(value: string);
    resetUnit(): void;
    get unitInput(): string | undefined;
    private _action;
    get action(): ElastigroupAzureV3ScalingDownPolicyActionOutputReference;
    putAction(value: ElastigroupAzureV3ScalingDownPolicyAction): void;
    get actionInput(): ElastigroupAzureV3ScalingDownPolicyAction | undefined;
    private _dimensions;
    get dimensions(): ElastigroupAzureV3ScalingDownPolicyDimensionsList;
    putDimensions(value: ElastigroupAzureV3ScalingDownPolicyDimensions[] | cdktf.IResolvable): void;
    resetDimensions(): void;
    get dimensionsInput(): cdktf.IResolvable | ElastigroupAzureV3ScalingDownPolicyDimensions[] | undefined;
}
export declare class ElastigroupAzureV3ScalingDownPolicyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAzureV3ScalingDownPolicy[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAzureV3ScalingDownPolicyOutputReference;
}
export interface ElastigroupAzureV3ScalingUpPolicyAction {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#adjustment ElastigroupAzureV3#adjustment}
    */
    readonly adjustment?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#maximum ElastigroupAzureV3#maximum}
    */
    readonly maximum?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#minimum ElastigroupAzureV3#minimum}
    */
    readonly minimum?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#target ElastigroupAzureV3#target}
    */
    readonly target?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#type ElastigroupAzureV3#type}
    */
    readonly type?: string;
}
export declare function elastigroupAzureV3ScalingUpPolicyActionToTerraform(struct?: ElastigroupAzureV3ScalingUpPolicyActionOutputReference | ElastigroupAzureV3ScalingUpPolicyAction): any;
export declare function elastigroupAzureV3ScalingUpPolicyActionToHclTerraform(struct?: ElastigroupAzureV3ScalingUpPolicyActionOutputReference | ElastigroupAzureV3ScalingUpPolicyAction): any;
export declare class ElastigroupAzureV3ScalingUpPolicyActionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAzureV3ScalingUpPolicyAction | undefined;
    set internalValue(value: ElastigroupAzureV3ScalingUpPolicyAction | undefined);
    private _adjustment?;
    get adjustment(): string;
    set adjustment(value: string);
    resetAdjustment(): void;
    get adjustmentInput(): string | undefined;
    private _maximum?;
    get maximum(): string;
    set maximum(value: string);
    resetMaximum(): void;
    get maximumInput(): string | undefined;
    private _minimum?;
    get minimum(): string;
    set minimum(value: string);
    resetMinimum(): void;
    get minimumInput(): string | undefined;
    private _target?;
    get target(): string;
    set target(value: string);
    resetTarget(): void;
    get targetInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    resetType(): void;
    get typeInput(): string | undefined;
}
export interface ElastigroupAzureV3ScalingUpPolicyDimensions {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#name ElastigroupAzureV3#name}
    */
    readonly name?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#value ElastigroupAzureV3#value}
    */
    readonly value?: string;
}
export declare function elastigroupAzureV3ScalingUpPolicyDimensionsToTerraform(struct?: ElastigroupAzureV3ScalingUpPolicyDimensions | cdktf.IResolvable): any;
export declare function elastigroupAzureV3ScalingUpPolicyDimensionsToHclTerraform(struct?: ElastigroupAzureV3ScalingUpPolicyDimensions | cdktf.IResolvable): any;
export declare class ElastigroupAzureV3ScalingUpPolicyDimensionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAzureV3ScalingUpPolicyDimensions | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAzureV3ScalingUpPolicyDimensions | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    resetName(): void;
    get nameInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
}
export declare class ElastigroupAzureV3ScalingUpPolicyDimensionsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAzureV3ScalingUpPolicyDimensions[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAzureV3ScalingUpPolicyDimensionsOutputReference;
}
export interface ElastigroupAzureV3ScalingUpPolicy {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#cooldown ElastigroupAzureV3#cooldown}
    */
    readonly cooldown: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#evaluation_periods ElastigroupAzureV3#evaluation_periods}
    */
    readonly evaluationPeriods: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#is_enabled ElastigroupAzureV3#is_enabled}
    */
    readonly isEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#metric_name ElastigroupAzureV3#metric_name}
    */
    readonly metricName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#namespace ElastigroupAzureV3#namespace}
    */
    readonly namespace: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#operator ElastigroupAzureV3#operator}
    */
    readonly operator: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#period ElastigroupAzureV3#period}
    */
    readonly period: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#policy_name ElastigroupAzureV3#policy_name}
    */
    readonly policyName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#source ElastigroupAzureV3#source}
    */
    readonly source?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#statistic ElastigroupAzureV3#statistic}
    */
    readonly statistic: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#threshold ElastigroupAzureV3#threshold}
    */
    readonly threshold: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#unit ElastigroupAzureV3#unit}
    */
    readonly unit?: string;
    /**
    * action block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#action ElastigroupAzureV3#action}
    */
    readonly action: ElastigroupAzureV3ScalingUpPolicyAction;
    /**
    * dimensions block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#dimensions ElastigroupAzureV3#dimensions}
    */
    readonly dimensions?: ElastigroupAzureV3ScalingUpPolicyDimensions[] | cdktf.IResolvable;
}
export declare function elastigroupAzureV3ScalingUpPolicyToTerraform(struct?: ElastigroupAzureV3ScalingUpPolicy | cdktf.IResolvable): any;
export declare function elastigroupAzureV3ScalingUpPolicyToHclTerraform(struct?: ElastigroupAzureV3ScalingUpPolicy | cdktf.IResolvable): any;
export declare class ElastigroupAzureV3ScalingUpPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAzureV3ScalingUpPolicy | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAzureV3ScalingUpPolicy | cdktf.IResolvable | undefined);
    private _cooldown?;
    get cooldown(): number;
    set cooldown(value: number);
    get cooldownInput(): number | undefined;
    private _evaluationPeriods?;
    get evaluationPeriods(): number;
    set evaluationPeriods(value: number);
    get evaluationPeriodsInput(): number | undefined;
    private _isEnabled?;
    get isEnabled(): boolean | cdktf.IResolvable;
    set isEnabled(value: boolean | cdktf.IResolvable);
    resetIsEnabled(): void;
    get isEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _metricName?;
    get metricName(): string;
    set metricName(value: string);
    get metricNameInput(): string | undefined;
    private _namespace?;
    get namespace(): string;
    set namespace(value: string);
    get namespaceInput(): string | undefined;
    private _operator?;
    get operator(): string;
    set operator(value: string);
    get operatorInput(): string | undefined;
    private _period?;
    get period(): number;
    set period(value: number);
    get periodInput(): number | undefined;
    private _policyName?;
    get policyName(): string;
    set policyName(value: string);
    get policyNameInput(): string | undefined;
    private _source?;
    get source(): string;
    set source(value: string);
    resetSource(): void;
    get sourceInput(): string | undefined;
    private _statistic?;
    get statistic(): string;
    set statistic(value: string);
    get statisticInput(): string | undefined;
    private _threshold?;
    get threshold(): number;
    set threshold(value: number);
    get thresholdInput(): number | undefined;
    private _unit?;
    get unit(): string;
    set unit(value: string);
    resetUnit(): void;
    get unitInput(): string | undefined;
    private _action;
    get action(): ElastigroupAzureV3ScalingUpPolicyActionOutputReference;
    putAction(value: ElastigroupAzureV3ScalingUpPolicyAction): void;
    get actionInput(): ElastigroupAzureV3ScalingUpPolicyAction | undefined;
    private _dimensions;
    get dimensions(): ElastigroupAzureV3ScalingUpPolicyDimensionsList;
    putDimensions(value: ElastigroupAzureV3ScalingUpPolicyDimensions[] | cdktf.IResolvable): void;
    resetDimensions(): void;
    get dimensionsInput(): cdktf.IResolvable | ElastigroupAzureV3ScalingUpPolicyDimensions[] | undefined;
}
export declare class ElastigroupAzureV3ScalingUpPolicyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAzureV3ScalingUpPolicy[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAzureV3ScalingUpPolicyOutputReference;
}
export interface ElastigroupAzureV3SchedulingTask {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#adjustment ElastigroupAzureV3#adjustment}
    */
    readonly adjustment?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#adjustment_percentage ElastigroupAzureV3#adjustment_percentage}
    */
    readonly adjustmentPercentage?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#batch_size_percentage ElastigroupAzureV3#batch_size_percentage}
    */
    readonly batchSizePercentage?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#cron_expression ElastigroupAzureV3#cron_expression}
    */
    readonly cronExpression: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#grace_period ElastigroupAzureV3#grace_period}
    */
    readonly gracePeriod?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#is_enabled ElastigroupAzureV3#is_enabled}
    */
    readonly isEnabled: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#scale_max_capacity ElastigroupAzureV3#scale_max_capacity}
    */
    readonly scaleMaxCapacity?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#scale_min_capacity ElastigroupAzureV3#scale_min_capacity}
    */
    readonly scaleMinCapacity?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#scale_target_capacity ElastigroupAzureV3#scale_target_capacity}
    */
    readonly scaleTargetCapacity?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#type ElastigroupAzureV3#type}
    */
    readonly type: string;
}
export declare function elastigroupAzureV3SchedulingTaskToTerraform(struct?: ElastigroupAzureV3SchedulingTask | cdktf.IResolvable): any;
export declare function elastigroupAzureV3SchedulingTaskToHclTerraform(struct?: ElastigroupAzureV3SchedulingTask | cdktf.IResolvable): any;
export declare class ElastigroupAzureV3SchedulingTaskOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAzureV3SchedulingTask | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAzureV3SchedulingTask | cdktf.IResolvable | undefined);
    private _adjustment?;
    get adjustment(): string;
    set adjustment(value: string);
    resetAdjustment(): void;
    get adjustmentInput(): string | undefined;
    private _adjustmentPercentage?;
    get adjustmentPercentage(): string;
    set adjustmentPercentage(value: string);
    resetAdjustmentPercentage(): void;
    get adjustmentPercentageInput(): string | undefined;
    private _batchSizePercentage?;
    get batchSizePercentage(): string;
    set batchSizePercentage(value: string);
    resetBatchSizePercentage(): void;
    get batchSizePercentageInput(): string | undefined;
    private _cronExpression?;
    get cronExpression(): string;
    set cronExpression(value: string);
    get cronExpressionInput(): string | undefined;
    private _gracePeriod?;
    get gracePeriod(): string;
    set gracePeriod(value: string);
    resetGracePeriod(): void;
    get gracePeriodInput(): string | undefined;
    private _isEnabled?;
    get isEnabled(): boolean | cdktf.IResolvable;
    set isEnabled(value: boolean | cdktf.IResolvable);
    get isEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _scaleMaxCapacity?;
    get scaleMaxCapacity(): string;
    set scaleMaxCapacity(value: string);
    resetScaleMaxCapacity(): void;
    get scaleMaxCapacityInput(): string | undefined;
    private _scaleMinCapacity?;
    get scaleMinCapacity(): string;
    set scaleMinCapacity(value: string);
    resetScaleMinCapacity(): void;
    get scaleMinCapacityInput(): string | undefined;
    private _scaleTargetCapacity?;
    get scaleTargetCapacity(): string;
    set scaleTargetCapacity(value: string);
    resetScaleTargetCapacity(): void;
    get scaleTargetCapacityInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
}
export declare class ElastigroupAzureV3SchedulingTaskList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAzureV3SchedulingTask[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAzureV3SchedulingTaskOutputReference;
}
export interface ElastigroupAzureV3SecretSourceVault {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#name ElastigroupAzureV3#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#resource_group_name ElastigroupAzureV3#resource_group_name}
    */
    readonly resourceGroupName: string;
}
export declare function elastigroupAzureV3SecretSourceVaultToTerraform(struct?: ElastigroupAzureV3SecretSourceVault | cdktf.IResolvable): any;
export declare function elastigroupAzureV3SecretSourceVaultToHclTerraform(struct?: ElastigroupAzureV3SecretSourceVault | cdktf.IResolvable): any;
export declare class ElastigroupAzureV3SecretSourceVaultOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAzureV3SecretSourceVault | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAzureV3SecretSourceVault | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _resourceGroupName?;
    get resourceGroupName(): string;
    set resourceGroupName(value: string);
    get resourceGroupNameInput(): string | undefined;
}
export declare class ElastigroupAzureV3SecretSourceVaultList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAzureV3SecretSourceVault[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAzureV3SecretSourceVaultOutputReference;
}
export interface ElastigroupAzureV3SecretVaultCertificates {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#certificate_store ElastigroupAzureV3#certificate_store}
    */
    readonly certificateStore: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#certificate_url ElastigroupAzureV3#certificate_url}
    */
    readonly certificateUrl: string;
}
export declare function elastigroupAzureV3SecretVaultCertificatesToTerraform(struct?: ElastigroupAzureV3SecretVaultCertificates | cdktf.IResolvable): any;
export declare function elastigroupAzureV3SecretVaultCertificatesToHclTerraform(struct?: ElastigroupAzureV3SecretVaultCertificates | cdktf.IResolvable): any;
export declare class ElastigroupAzureV3SecretVaultCertificatesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAzureV3SecretVaultCertificates | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAzureV3SecretVaultCertificates | cdktf.IResolvable | undefined);
    private _certificateStore?;
    get certificateStore(): string;
    set certificateStore(value: string);
    get certificateStoreInput(): string | undefined;
    private _certificateUrl?;
    get certificateUrl(): string;
    set certificateUrl(value: string);
    get certificateUrlInput(): string | undefined;
}
export declare class ElastigroupAzureV3SecretVaultCertificatesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAzureV3SecretVaultCertificates[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAzureV3SecretVaultCertificatesOutputReference;
}
export interface ElastigroupAzureV3Secret {
    /**
    * source_vault block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#source_vault ElastigroupAzureV3#source_vault}
    */
    readonly sourceVault: ElastigroupAzureV3SecretSourceVault[] | cdktf.IResolvable;
    /**
    * vault_certificates block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#vault_certificates ElastigroupAzureV3#vault_certificates}
    */
    readonly vaultCertificates: ElastigroupAzureV3SecretVaultCertificates[] | cdktf.IResolvable;
}
export declare function elastigroupAzureV3SecretToTerraform(struct?: ElastigroupAzureV3Secret | cdktf.IResolvable): any;
export declare function elastigroupAzureV3SecretToHclTerraform(struct?: ElastigroupAzureV3Secret | cdktf.IResolvable): any;
export declare class ElastigroupAzureV3SecretOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAzureV3Secret | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAzureV3Secret | cdktf.IResolvable | undefined);
    private _sourceVault;
    get sourceVault(): ElastigroupAzureV3SecretSourceVaultList;
    putSourceVault(value: ElastigroupAzureV3SecretSourceVault[] | cdktf.IResolvable): void;
    get sourceVaultInput(): cdktf.IResolvable | ElastigroupAzureV3SecretSourceVault[] | undefined;
    private _vaultCertificates;
    get vaultCertificates(): ElastigroupAzureV3SecretVaultCertificatesList;
    putVaultCertificates(value: ElastigroupAzureV3SecretVaultCertificates[] | cdktf.IResolvable): void;
    get vaultCertificatesInput(): cdktf.IResolvable | ElastigroupAzureV3SecretVaultCertificates[] | undefined;
}
export declare class ElastigroupAzureV3SecretList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAzureV3Secret[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAzureV3SecretOutputReference;
}
export interface ElastigroupAzureV3Security {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#confidential_os_disk_encryption ElastigroupAzureV3#confidential_os_disk_encryption}
    */
    readonly confidentialOsDiskEncryption?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#secure_boot_enabled ElastigroupAzureV3#secure_boot_enabled}
    */
    readonly secureBootEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#security_type ElastigroupAzureV3#security_type}
    */
    readonly securityType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#vtpm_enabled ElastigroupAzureV3#vtpm_enabled}
    */
    readonly vtpmEnabled?: boolean | cdktf.IResolvable;
}
export declare function elastigroupAzureV3SecurityToTerraform(struct?: ElastigroupAzureV3SecurityOutputReference | ElastigroupAzureV3Security): any;
export declare function elastigroupAzureV3SecurityToHclTerraform(struct?: ElastigroupAzureV3SecurityOutputReference | ElastigroupAzureV3Security): any;
export declare class ElastigroupAzureV3SecurityOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAzureV3Security | undefined;
    set internalValue(value: ElastigroupAzureV3Security | undefined);
    private _confidentialOsDiskEncryption?;
    get confidentialOsDiskEncryption(): boolean | cdktf.IResolvable;
    set confidentialOsDiskEncryption(value: boolean | cdktf.IResolvable);
    resetConfidentialOsDiskEncryption(): void;
    get confidentialOsDiskEncryptionInput(): boolean | cdktf.IResolvable | undefined;
    private _secureBootEnabled?;
    get secureBootEnabled(): boolean | cdktf.IResolvable;
    set secureBootEnabled(value: boolean | cdktf.IResolvable);
    resetSecureBootEnabled(): void;
    get secureBootEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _securityType?;
    get securityType(): string;
    set securityType(value: string);
    resetSecurityType(): void;
    get securityTypeInput(): string | undefined;
    private _vtpmEnabled?;
    get vtpmEnabled(): boolean | cdktf.IResolvable;
    set vtpmEnabled(value: boolean | cdktf.IResolvable);
    resetVtpmEnabled(): void;
    get vtpmEnabledInput(): boolean | cdktf.IResolvable | undefined;
}
export interface ElastigroupAzureV3Signal {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#timeout ElastigroupAzureV3#timeout}
    */
    readonly timeout: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#type ElastigroupAzureV3#type}
    */
    readonly type: string;
}
export declare function elastigroupAzureV3SignalToTerraform(struct?: ElastigroupAzureV3Signal | cdktf.IResolvable): any;
export declare function elastigroupAzureV3SignalToHclTerraform(struct?: ElastigroupAzureV3Signal | cdktf.IResolvable): any;
export declare class ElastigroupAzureV3SignalOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAzureV3Signal | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAzureV3Signal | cdktf.IResolvable | undefined);
    private _timeout?;
    get timeout(): number;
    set timeout(value: number);
    get timeoutInput(): number | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
}
export declare class ElastigroupAzureV3SignalList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAzureV3Signal[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAzureV3SignalOutputReference;
}
export interface ElastigroupAzureV3Tags {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#key ElastigroupAzureV3#key}
    */
    readonly key: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#value ElastigroupAzureV3#value}
    */
    readonly value: string;
}
export declare function elastigroupAzureV3TagsToTerraform(struct?: ElastigroupAzureV3Tags | cdktf.IResolvable): any;
export declare function elastigroupAzureV3TagsToHclTerraform(struct?: ElastigroupAzureV3Tags | cdktf.IResolvable): any;
export declare class ElastigroupAzureV3TagsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAzureV3Tags | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAzureV3Tags | cdktf.IResolvable | undefined);
    private _key?;
    get key(): string;
    set key(value: string);
    get keyInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    get valueInput(): string | undefined;
}
export declare class ElastigroupAzureV3TagsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAzureV3Tags[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAzureV3TagsOutputReference;
}
export interface ElastigroupAzureV3VmSizes {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#od_sizes ElastigroupAzureV3#od_sizes}
    */
    readonly odSizes: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#preferred_spot_sizes ElastigroupAzureV3#preferred_spot_sizes}
    */
    readonly preferredSpotSizes?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#spot_sizes ElastigroupAzureV3#spot_sizes}
    */
    readonly spotSizes: string[];
}
export declare function elastigroupAzureV3VmSizesToTerraform(struct?: ElastigroupAzureV3VmSizesOutputReference | ElastigroupAzureV3VmSizes): any;
export declare function elastigroupAzureV3VmSizesToHclTerraform(struct?: ElastigroupAzureV3VmSizesOutputReference | ElastigroupAzureV3VmSizes): any;
export declare class ElastigroupAzureV3VmSizesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAzureV3VmSizes | undefined;
    set internalValue(value: ElastigroupAzureV3VmSizes | undefined);
    private _odSizes?;
    get odSizes(): string[];
    set odSizes(value: string[]);
    get odSizesInput(): string[] | undefined;
    private _preferredSpotSizes?;
    get preferredSpotSizes(): string[];
    set preferredSpotSizes(value: string[]);
    resetPreferredSpotSizes(): void;
    get preferredSpotSizesInput(): string[] | undefined;
    private _spotSizes?;
    get spotSizes(): string[];
    set spotSizes(value: string[]);
    get spotSizesInput(): string[] | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3 spotinst_elastigroup_azure_v3}
*/
export declare class ElastigroupAzureV3 extends cdktf.TerraformResource {
    static readonly tfResourceType = "spotinst_elastigroup_azure_v3";
    /**
    * Generates CDKTF code for importing a ElastigroupAzureV3 resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the ElastigroupAzureV3 to import
    * @param importFromId The id of the existing ElastigroupAzureV3 that should be imported. Refer to the {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the ElastigroupAzureV3 to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_azure_v3 spotinst_elastigroup_azure_v3} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options ElastigroupAzureV3Config
    */
    constructor(scope: Construct, id: string, config: ElastigroupAzureV3Config);
    private _availabilityVsCost?;
    get availabilityVsCost(): number;
    set availabilityVsCost(value: number);
    resetAvailabilityVsCost(): void;
    get availabilityVsCostInput(): number | undefined;
    private _customData?;
    get customData(): string;
    set customData(value: string);
    resetCustomData(): void;
    get customDataInput(): string | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _desiredCapacity?;
    get desiredCapacity(): number;
    set desiredCapacity(value: number);
    resetDesiredCapacity(): void;
    get desiredCapacityInput(): number | undefined;
    private _drainingTimeout?;
    get drainingTimeout(): number;
    set drainingTimeout(value: number);
    resetDrainingTimeout(): void;
    get drainingTimeoutInput(): number | undefined;
    private _fallbackToOnDemand?;
    get fallbackToOnDemand(): boolean | cdktf.IResolvable;
    set fallbackToOnDemand(value: boolean | cdktf.IResolvable);
    get fallbackToOnDemandInput(): boolean | cdktf.IResolvable | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _maxSize?;
    get maxSize(): number;
    set maxSize(value: number);
    resetMaxSize(): void;
    get maxSizeInput(): number | undefined;
    private _minSize?;
    get minSize(): number;
    set minSize(value: number);
    resetMinSize(): void;
    get minSizeInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _onDemandCount?;
    get onDemandCount(): number;
    set onDemandCount(value: number);
    resetOnDemandCount(): void;
    get onDemandCountInput(): number | undefined;
    private _optimizationWindows?;
    get optimizationWindows(): string[];
    set optimizationWindows(value: string[]);
    resetOptimizationWindows(): void;
    get optimizationWindowsInput(): string[] | undefined;
    private _os?;
    get os(): string;
    set os(value: string);
    get osInput(): string | undefined;
    private _preferredZones?;
    get preferredZones(): string[];
    set preferredZones(value: string[]);
    resetPreferredZones(): void;
    get preferredZonesInput(): string[] | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    get regionInput(): string | undefined;
    private _resourceGroupName?;
    get resourceGroupName(): string;
    set resourceGroupName(value: string);
    get resourceGroupNameInput(): string | undefined;
    private _shutdownScript?;
    get shutdownScript(): string;
    set shutdownScript(value: string);
    resetShutdownScript(): void;
    get shutdownScriptInput(): string | undefined;
    private _spotPercentage?;
    get spotPercentage(): number;
    set spotPercentage(value: number);
    resetSpotPercentage(): void;
    get spotPercentageInput(): number | undefined;
    private _userData?;
    get userData(): string;
    set userData(value: string);
    resetUserData(): void;
    get userDataInput(): string | undefined;
    private _vmNamePrefix?;
    get vmNamePrefix(): string;
    set vmNamePrefix(value: string);
    resetVmNamePrefix(): void;
    get vmNamePrefixInput(): string | undefined;
    private _zones?;
    get zones(): string[];
    set zones(value: string[]);
    resetZones(): void;
    get zonesInput(): string[] | undefined;
    private _bootDiagnostics;
    get bootDiagnostics(): ElastigroupAzureV3BootDiagnosticsList;
    putBootDiagnostics(value: ElastigroupAzureV3BootDiagnostics[] | cdktf.IResolvable): void;
    resetBootDiagnostics(): void;
    get bootDiagnosticsInput(): cdktf.IResolvable | ElastigroupAzureV3BootDiagnostics[] | undefined;
    private _capacityReservation;
    get capacityReservation(): ElastigroupAzureV3CapacityReservationOutputReference;
    putCapacityReservation(value: ElastigroupAzureV3CapacityReservation): void;
    resetCapacityReservation(): void;
    get capacityReservationInput(): ElastigroupAzureV3CapacityReservation | undefined;
    private _dataDisk;
    get dataDisk(): ElastigroupAzureV3DataDiskList;
    putDataDisk(value: ElastigroupAzureV3DataDisk[] | cdktf.IResolvable): void;
    resetDataDisk(): void;
    get dataDiskInput(): cdktf.IResolvable | ElastigroupAzureV3DataDisk[] | undefined;
    private _extensions;
    get extensions(): ElastigroupAzureV3ExtensionsList;
    putExtensions(value: ElastigroupAzureV3Extensions[] | cdktf.IResolvable): void;
    resetExtensions(): void;
    get extensionsInput(): cdktf.IResolvable | ElastigroupAzureV3Extensions[] | undefined;
    private _health;
    get health(): ElastigroupAzureV3HealthOutputReference;
    putHealth(value: ElastigroupAzureV3Health): void;
    resetHealth(): void;
    get healthInput(): ElastigroupAzureV3Health | undefined;
    private _image;
    get image(): ElastigroupAzureV3ImageList;
    putImage(value: ElastigroupAzureV3Image[] | cdktf.IResolvable): void;
    resetImage(): void;
    get imageInput(): cdktf.IResolvable | ElastigroupAzureV3Image[] | undefined;
    private _loadBalancer;
    get loadBalancer(): ElastigroupAzureV3LoadBalancerList;
    putLoadBalancer(value: ElastigroupAzureV3LoadBalancer[] | cdktf.IResolvable): void;
    resetLoadBalancer(): void;
    get loadBalancerInput(): cdktf.IResolvable | ElastigroupAzureV3LoadBalancer[] | undefined;
    private _login;
    get login(): ElastigroupAzureV3LoginOutputReference;
    putLogin(value: ElastigroupAzureV3Login): void;
    resetLogin(): void;
    get loginInput(): ElastigroupAzureV3Login | undefined;
    private _managedServiceIdentity;
    get managedServiceIdentity(): ElastigroupAzureV3ManagedServiceIdentityList;
    putManagedServiceIdentity(value: ElastigroupAzureV3ManagedServiceIdentity[] | cdktf.IResolvable): void;
    resetManagedServiceIdentity(): void;
    get managedServiceIdentityInput(): cdktf.IResolvable | ElastigroupAzureV3ManagedServiceIdentity[] | undefined;
    private _network;
    get network(): ElastigroupAzureV3NetworkOutputReference;
    putNetwork(value: ElastigroupAzureV3Network): void;
    get networkInput(): ElastigroupAzureV3Network | undefined;
    private _osDisk;
    get osDisk(): ElastigroupAzureV3OsDiskOutputReference;
    putOsDisk(value: ElastigroupAzureV3OsDisk): void;
    resetOsDisk(): void;
    get osDiskInput(): ElastigroupAzureV3OsDisk | undefined;
    private _proximityPlacementGroups;
    get proximityPlacementGroups(): ElastigroupAzureV3ProximityPlacementGroupsList;
    putProximityPlacementGroups(value: ElastigroupAzureV3ProximityPlacementGroups[] | cdktf.IResolvable): void;
    resetProximityPlacementGroups(): void;
    get proximityPlacementGroupsInput(): cdktf.IResolvable | ElastigroupAzureV3ProximityPlacementGroups[] | undefined;
    private _revertToSpot;
    get revertToSpot(): ElastigroupAzureV3RevertToSpotOutputReference;
    putRevertToSpot(value: ElastigroupAzureV3RevertToSpot): void;
    resetRevertToSpot(): void;
    get revertToSpotInput(): ElastigroupAzureV3RevertToSpot | undefined;
    private _scalingDownPolicy;
    get scalingDownPolicy(): ElastigroupAzureV3ScalingDownPolicyList;
    putScalingDownPolicy(value: ElastigroupAzureV3ScalingDownPolicy[] | cdktf.IResolvable): void;
    resetScalingDownPolicy(): void;
    get scalingDownPolicyInput(): cdktf.IResolvable | ElastigroupAzureV3ScalingDownPolicy[] | undefined;
    private _scalingUpPolicy;
    get scalingUpPolicy(): ElastigroupAzureV3ScalingUpPolicyList;
    putScalingUpPolicy(value: ElastigroupAzureV3ScalingUpPolicy[] | cdktf.IResolvable): void;
    resetScalingUpPolicy(): void;
    get scalingUpPolicyInput(): cdktf.IResolvable | ElastigroupAzureV3ScalingUpPolicy[] | undefined;
    private _schedulingTask;
    get schedulingTask(): ElastigroupAzureV3SchedulingTaskList;
    putSchedulingTask(value: ElastigroupAzureV3SchedulingTask[] | cdktf.IResolvable): void;
    resetSchedulingTask(): void;
    get schedulingTaskInput(): cdktf.IResolvable | ElastigroupAzureV3SchedulingTask[] | undefined;
    private _secret;
    get secret(): ElastigroupAzureV3SecretList;
    putSecret(value: ElastigroupAzureV3Secret[] | cdktf.IResolvable): void;
    resetSecret(): void;
    get secretInput(): cdktf.IResolvable | ElastigroupAzureV3Secret[] | undefined;
    private _security;
    get security(): ElastigroupAzureV3SecurityOutputReference;
    putSecurity(value: ElastigroupAzureV3Security): void;
    resetSecurity(): void;
    get securityInput(): ElastigroupAzureV3Security | undefined;
    private _signal;
    get signal(): ElastigroupAzureV3SignalList;
    putSignal(value: ElastigroupAzureV3Signal[] | cdktf.IResolvable): void;
    resetSignal(): void;
    get signalInput(): cdktf.IResolvable | ElastigroupAzureV3Signal[] | undefined;
    private _tags;
    get tags(): ElastigroupAzureV3TagsList;
    putTags(value: ElastigroupAzureV3Tags[] | cdktf.IResolvable): void;
    resetTags(): void;
    get tagsInput(): cdktf.IResolvable | ElastigroupAzureV3Tags[] | undefined;
    private _vmSizes;
    get vmSizes(): ElastigroupAzureV3VmSizesOutputReference;
    putVmSizes(value: ElastigroupAzureV3VmSizes): void;
    get vmSizesInput(): ElastigroupAzureV3VmSizes | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
