/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface OceanAwsExtendedResourceDefinitionConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_aws_extended_resource_definition#id OceanAwsExtendedResourceDefinition#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_aws_extended_resource_definition#name OceanAwsExtendedResourceDefinition#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_aws_extended_resource_definition#resource_mapping OceanAwsExtendedResourceDefinition#resource_mapping}
    */
    readonly resourceMapping: {
        [key: string]: string;
    };
}
/**
* Represents a {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_aws_extended_resource_definition spotinst_ocean_aws_extended_resource_definition}
*/
export declare class OceanAwsExtendedResourceDefinition extends cdktf.TerraformResource {
    static readonly tfResourceType = "spotinst_ocean_aws_extended_resource_definition";
    /**
    * Generates CDKTF code for importing a OceanAwsExtendedResourceDefinition resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the OceanAwsExtendedResourceDefinition to import
    * @param importFromId The id of the existing OceanAwsExtendedResourceDefinition that should be imported. Refer to the {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_aws_extended_resource_definition#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the OceanAwsExtendedResourceDefinition to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_aws_extended_resource_definition spotinst_ocean_aws_extended_resource_definition} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options OceanAwsExtendedResourceDefinitionConfig
    */
    constructor(scope: Construct, id: string, config: OceanAwsExtendedResourceDefinitionConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _resourceMapping?;
    get resourceMapping(): {
        [key: string]: string;
    };
    set resourceMapping(value: {
        [key: string]: string;
    });
    get resourceMappingInput(): {
        [key: string]: string;
    } | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
