/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface OceanGkeImportConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#blacklist OceanGkeImport#blacklist}
    */
    readonly blacklist?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#cluster_name OceanGkeImport#cluster_name}
    */
    readonly clusterName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#controller_cluster_id OceanGkeImport#controller_cluster_id}
    */
    readonly controllerClusterId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#desired_capacity OceanGkeImport#desired_capacity}
    */
    readonly desiredCapacity?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#id OceanGkeImport#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#location OceanGkeImport#location}
    */
    readonly location: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#max_size OceanGkeImport#max_size}
    */
    readonly maxSize?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#min_size OceanGkeImport#min_size}
    */
    readonly minSize?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#root_volume_type OceanGkeImport#root_volume_type}
    */
    readonly rootVolumeType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#use_as_template_only OceanGkeImport#use_as_template_only}
    */
    readonly useAsTemplateOnly?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#whitelist OceanGkeImport#whitelist}
    */
    readonly whitelist?: string[];
    /**
    * auto_update block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#auto_update OceanGkeImport#auto_update}
    */
    readonly autoUpdate?: OceanGkeImportAutoUpdate[] | cdktf.IResolvable;
    /**
    * autoscaler block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#autoscaler OceanGkeImport#autoscaler}
    */
    readonly autoscaler?: OceanGkeImportAutoscaler;
    /**
    * backend_services block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#backend_services OceanGkeImport#backend_services}
    */
    readonly backendServices?: OceanGkeImportBackendServices[] | cdktf.IResolvable;
    /**
    * filters block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#filters OceanGkeImport#filters}
    */
    readonly filters?: OceanGkeImportFilters;
    /**
    * scheduled_task block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#scheduled_task OceanGkeImport#scheduled_task}
    */
    readonly scheduledTask?: OceanGkeImportScheduledTask[] | cdktf.IResolvable;
    /**
    * shielded_instance_config block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#shielded_instance_config OceanGkeImport#shielded_instance_config}
    */
    readonly shieldedInstanceConfig?: OceanGkeImportShieldedInstanceConfig;
    /**
    * strategy block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#strategy OceanGkeImport#strategy}
    */
    readonly strategy?: OceanGkeImportStrategy[] | cdktf.IResolvable;
    /**
    * update_policy block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#update_policy OceanGkeImport#update_policy}
    */
    readonly updatePolicy?: OceanGkeImportUpdatePolicy;
}
export interface OceanGkeImportAutoUpdate {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#is_enabled OceanGkeImport#is_enabled}
    */
    readonly isEnabled?: boolean | cdktf.IResolvable;
}
export declare function oceanGkeImportAutoUpdateToTerraform(struct?: OceanGkeImportAutoUpdate | cdktf.IResolvable): any;
export declare function oceanGkeImportAutoUpdateToHclTerraform(struct?: OceanGkeImportAutoUpdate | cdktf.IResolvable): any;
export declare class OceanGkeImportAutoUpdateOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OceanGkeImportAutoUpdate | cdktf.IResolvable | undefined;
    set internalValue(value: OceanGkeImportAutoUpdate | cdktf.IResolvable | undefined);
    private _isEnabled?;
    get isEnabled(): boolean | cdktf.IResolvable;
    set isEnabled(value: boolean | cdktf.IResolvable);
    resetIsEnabled(): void;
    get isEnabledInput(): boolean | cdktf.IResolvable | undefined;
}
export declare class OceanGkeImportAutoUpdateList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OceanGkeImportAutoUpdate[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OceanGkeImportAutoUpdateOutputReference;
}
export interface OceanGkeImportAutoscalerDown {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#evaluation_periods OceanGkeImport#evaluation_periods}
    */
    readonly evaluationPeriods?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#is_aggressive_scale_down_enabled OceanGkeImport#is_aggressive_scale_down_enabled}
    */
    readonly isAggressiveScaleDownEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#max_scale_down_percentage OceanGkeImport#max_scale_down_percentage}
    */
    readonly maxScaleDownPercentage?: number;
}
export declare function oceanGkeImportAutoscalerDownToTerraform(struct?: OceanGkeImportAutoscalerDownOutputReference | OceanGkeImportAutoscalerDown): any;
export declare function oceanGkeImportAutoscalerDownToHclTerraform(struct?: OceanGkeImportAutoscalerDownOutputReference | OceanGkeImportAutoscalerDown): any;
export declare class OceanGkeImportAutoscalerDownOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceanGkeImportAutoscalerDown | undefined;
    set internalValue(value: OceanGkeImportAutoscalerDown | undefined);
    private _evaluationPeriods?;
    get evaluationPeriods(): number;
    set evaluationPeriods(value: number);
    resetEvaluationPeriods(): void;
    get evaluationPeriodsInput(): number | undefined;
    private _isAggressiveScaleDownEnabled?;
    get isAggressiveScaleDownEnabled(): boolean | cdktf.IResolvable;
    set isAggressiveScaleDownEnabled(value: boolean | cdktf.IResolvable);
    resetIsAggressiveScaleDownEnabled(): void;
    get isAggressiveScaleDownEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _maxScaleDownPercentage?;
    get maxScaleDownPercentage(): number;
    set maxScaleDownPercentage(value: number);
    resetMaxScaleDownPercentage(): void;
    get maxScaleDownPercentageInput(): number | undefined;
}
export interface OceanGkeImportAutoscalerHeadroom {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#cpu_per_unit OceanGkeImport#cpu_per_unit}
    */
    readonly cpuPerUnit?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#gpu_per_unit OceanGkeImport#gpu_per_unit}
    */
    readonly gpuPerUnit?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#memory_per_unit OceanGkeImport#memory_per_unit}
    */
    readonly memoryPerUnit?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#num_of_units OceanGkeImport#num_of_units}
    */
    readonly numOfUnits?: number;
}
export declare function oceanGkeImportAutoscalerHeadroomToTerraform(struct?: OceanGkeImportAutoscalerHeadroomOutputReference | OceanGkeImportAutoscalerHeadroom): any;
export declare function oceanGkeImportAutoscalerHeadroomToHclTerraform(struct?: OceanGkeImportAutoscalerHeadroomOutputReference | OceanGkeImportAutoscalerHeadroom): any;
export declare class OceanGkeImportAutoscalerHeadroomOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceanGkeImportAutoscalerHeadroom | undefined;
    set internalValue(value: OceanGkeImportAutoscalerHeadroom | undefined);
    private _cpuPerUnit?;
    get cpuPerUnit(): number;
    set cpuPerUnit(value: number);
    resetCpuPerUnit(): void;
    get cpuPerUnitInput(): number | undefined;
    private _gpuPerUnit?;
    get gpuPerUnit(): number;
    set gpuPerUnit(value: number);
    resetGpuPerUnit(): void;
    get gpuPerUnitInput(): number | undefined;
    private _memoryPerUnit?;
    get memoryPerUnit(): number;
    set memoryPerUnit(value: number);
    resetMemoryPerUnit(): void;
    get memoryPerUnitInput(): number | undefined;
    private _numOfUnits?;
    get numOfUnits(): number;
    set numOfUnits(value: number);
    resetNumOfUnits(): void;
    get numOfUnitsInput(): number | undefined;
}
export interface OceanGkeImportAutoscalerResourceLimits {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#max_memory_gib OceanGkeImport#max_memory_gib}
    */
    readonly maxMemoryGib?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#max_vcpu OceanGkeImport#max_vcpu}
    */
    readonly maxVcpu?: number;
}
export declare function oceanGkeImportAutoscalerResourceLimitsToTerraform(struct?: OceanGkeImportAutoscalerResourceLimitsOutputReference | OceanGkeImportAutoscalerResourceLimits): any;
export declare function oceanGkeImportAutoscalerResourceLimitsToHclTerraform(struct?: OceanGkeImportAutoscalerResourceLimitsOutputReference | OceanGkeImportAutoscalerResourceLimits): any;
export declare class OceanGkeImportAutoscalerResourceLimitsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceanGkeImportAutoscalerResourceLimits | undefined;
    set internalValue(value: OceanGkeImportAutoscalerResourceLimits | undefined);
    private _maxMemoryGib?;
    get maxMemoryGib(): number;
    set maxMemoryGib(value: number);
    resetMaxMemoryGib(): void;
    get maxMemoryGibInput(): number | undefined;
    private _maxVcpu?;
    get maxVcpu(): number;
    set maxVcpu(value: number);
    resetMaxVcpu(): void;
    get maxVcpuInput(): number | undefined;
}
export interface OceanGkeImportAutoscaler {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#auto_headroom_percentage OceanGkeImport#auto_headroom_percentage}
    */
    readonly autoHeadroomPercentage?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#cooldown OceanGkeImport#cooldown}
    */
    readonly cooldown?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#enable_automatic_and_manual_headroom OceanGkeImport#enable_automatic_and_manual_headroom}
    */
    readonly enableAutomaticAndManualHeadroom?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#is_auto_config OceanGkeImport#is_auto_config}
    */
    readonly isAutoConfig?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#is_enabled OceanGkeImport#is_enabled}
    */
    readonly isEnabled?: boolean | cdktf.IResolvable;
    /**
    * down block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#down OceanGkeImport#down}
    */
    readonly down?: OceanGkeImportAutoscalerDown;
    /**
    * headroom block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#headroom OceanGkeImport#headroom}
    */
    readonly headroom?: OceanGkeImportAutoscalerHeadroom;
    /**
    * resource_limits block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#resource_limits OceanGkeImport#resource_limits}
    */
    readonly resourceLimits?: OceanGkeImportAutoscalerResourceLimits;
}
export declare function oceanGkeImportAutoscalerToTerraform(struct?: OceanGkeImportAutoscalerOutputReference | OceanGkeImportAutoscaler): any;
export declare function oceanGkeImportAutoscalerToHclTerraform(struct?: OceanGkeImportAutoscalerOutputReference | OceanGkeImportAutoscaler): any;
export declare class OceanGkeImportAutoscalerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceanGkeImportAutoscaler | undefined;
    set internalValue(value: OceanGkeImportAutoscaler | undefined);
    private _autoHeadroomPercentage?;
    get autoHeadroomPercentage(): number;
    set autoHeadroomPercentage(value: number);
    resetAutoHeadroomPercentage(): void;
    get autoHeadroomPercentageInput(): number | undefined;
    private _cooldown?;
    get cooldown(): number;
    set cooldown(value: number);
    resetCooldown(): void;
    get cooldownInput(): number | undefined;
    private _enableAutomaticAndManualHeadroom?;
    get enableAutomaticAndManualHeadroom(): boolean | cdktf.IResolvable;
    set enableAutomaticAndManualHeadroom(value: boolean | cdktf.IResolvable);
    resetEnableAutomaticAndManualHeadroom(): void;
    get enableAutomaticAndManualHeadroomInput(): boolean | cdktf.IResolvable | undefined;
    private _isAutoConfig?;
    get isAutoConfig(): boolean | cdktf.IResolvable;
    set isAutoConfig(value: boolean | cdktf.IResolvable);
    resetIsAutoConfig(): void;
    get isAutoConfigInput(): boolean | cdktf.IResolvable | undefined;
    private _isEnabled?;
    get isEnabled(): boolean | cdktf.IResolvable;
    set isEnabled(value: boolean | cdktf.IResolvable);
    resetIsEnabled(): void;
    get isEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _down;
    get down(): OceanGkeImportAutoscalerDownOutputReference;
    putDown(value: OceanGkeImportAutoscalerDown): void;
    resetDown(): void;
    get downInput(): OceanGkeImportAutoscalerDown | undefined;
    private _headroom;
    get headroom(): OceanGkeImportAutoscalerHeadroomOutputReference;
    putHeadroom(value: OceanGkeImportAutoscalerHeadroom): void;
    resetHeadroom(): void;
    get headroomInput(): OceanGkeImportAutoscalerHeadroom | undefined;
    private _resourceLimits;
    get resourceLimits(): OceanGkeImportAutoscalerResourceLimitsOutputReference;
    putResourceLimits(value: OceanGkeImportAutoscalerResourceLimits): void;
    resetResourceLimits(): void;
    get resourceLimitsInput(): OceanGkeImportAutoscalerResourceLimits | undefined;
}
export interface OceanGkeImportBackendServicesNamedPorts {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#name OceanGkeImport#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#ports OceanGkeImport#ports}
    */
    readonly ports: string[];
}
export declare function oceanGkeImportBackendServicesNamedPortsToTerraform(struct?: OceanGkeImportBackendServicesNamedPorts | cdktf.IResolvable): any;
export declare function oceanGkeImportBackendServicesNamedPortsToHclTerraform(struct?: OceanGkeImportBackendServicesNamedPorts | cdktf.IResolvable): any;
export declare class OceanGkeImportBackendServicesNamedPortsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OceanGkeImportBackendServicesNamedPorts | cdktf.IResolvable | undefined;
    set internalValue(value: OceanGkeImportBackendServicesNamedPorts | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _ports?;
    get ports(): string[];
    set ports(value: string[]);
    get portsInput(): string[] | undefined;
}
export declare class OceanGkeImportBackendServicesNamedPortsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OceanGkeImportBackendServicesNamedPorts[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OceanGkeImportBackendServicesNamedPortsOutputReference;
}
export interface OceanGkeImportBackendServices {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#location_type OceanGkeImport#location_type}
    */
    readonly locationType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#scheme OceanGkeImport#scheme}
    */
    readonly scheme?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#service_name OceanGkeImport#service_name}
    */
    readonly serviceName: string;
    /**
    * named_ports block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#named_ports OceanGkeImport#named_ports}
    */
    readonly namedPorts?: OceanGkeImportBackendServicesNamedPorts[] | cdktf.IResolvable;
}
export declare function oceanGkeImportBackendServicesToTerraform(struct?: OceanGkeImportBackendServices | cdktf.IResolvable): any;
export declare function oceanGkeImportBackendServicesToHclTerraform(struct?: OceanGkeImportBackendServices | cdktf.IResolvable): any;
export declare class OceanGkeImportBackendServicesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OceanGkeImportBackendServices | cdktf.IResolvable | undefined;
    set internalValue(value: OceanGkeImportBackendServices | cdktf.IResolvable | undefined);
    private _locationType?;
    get locationType(): string;
    set locationType(value: string);
    resetLocationType(): void;
    get locationTypeInput(): string | undefined;
    private _scheme?;
    get scheme(): string;
    set scheme(value: string);
    resetScheme(): void;
    get schemeInput(): string | undefined;
    private _serviceName?;
    get serviceName(): string;
    set serviceName(value: string);
    get serviceNameInput(): string | undefined;
    private _namedPorts;
    get namedPorts(): OceanGkeImportBackendServicesNamedPortsList;
    putNamedPorts(value: OceanGkeImportBackendServicesNamedPorts[] | cdktf.IResolvable): void;
    resetNamedPorts(): void;
    get namedPortsInput(): cdktf.IResolvable | OceanGkeImportBackendServicesNamedPorts[] | undefined;
}
export declare class OceanGkeImportBackendServicesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OceanGkeImportBackendServices[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OceanGkeImportBackendServicesOutputReference;
}
export interface OceanGkeImportFilters {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#exclude_families OceanGkeImport#exclude_families}
    */
    readonly excludeFamilies?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#include_families OceanGkeImport#include_families}
    */
    readonly includeFamilies?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#max_memory_gib OceanGkeImport#max_memory_gib}
    */
    readonly maxMemoryGib?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#max_vcpu OceanGkeImport#max_vcpu}
    */
    readonly maxVcpu?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#min_memory_gib OceanGkeImport#min_memory_gib}
    */
    readonly minMemoryGib?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#min_vcpu OceanGkeImport#min_vcpu}
    */
    readonly minVcpu?: number;
}
export declare function oceanGkeImportFiltersToTerraform(struct?: OceanGkeImportFiltersOutputReference | OceanGkeImportFilters): any;
export declare function oceanGkeImportFiltersToHclTerraform(struct?: OceanGkeImportFiltersOutputReference | OceanGkeImportFilters): any;
export declare class OceanGkeImportFiltersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceanGkeImportFilters | undefined;
    set internalValue(value: OceanGkeImportFilters | undefined);
    private _excludeFamilies?;
    get excludeFamilies(): string[];
    set excludeFamilies(value: string[]);
    resetExcludeFamilies(): void;
    get excludeFamiliesInput(): string[] | undefined;
    private _includeFamilies?;
    get includeFamilies(): string[];
    set includeFamilies(value: string[]);
    resetIncludeFamilies(): void;
    get includeFamiliesInput(): string[] | undefined;
    private _maxMemoryGib?;
    get maxMemoryGib(): number;
    set maxMemoryGib(value: number);
    resetMaxMemoryGib(): void;
    get maxMemoryGibInput(): number | undefined;
    private _maxVcpu?;
    get maxVcpu(): number;
    set maxVcpu(value: number);
    resetMaxVcpu(): void;
    get maxVcpuInput(): number | undefined;
    private _minMemoryGib?;
    get minMemoryGib(): number;
    set minMemoryGib(value: number);
    resetMinMemoryGib(): void;
    get minMemoryGibInput(): number | undefined;
    private _minVcpu?;
    get minVcpu(): number;
    set minVcpu(value: number);
    resetMinVcpu(): void;
    get minVcpuInput(): number | undefined;
}
export interface OceanGkeImportScheduledTaskShutdownHours {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#is_enabled OceanGkeImport#is_enabled}
    */
    readonly isEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#time_windows OceanGkeImport#time_windows}
    */
    readonly timeWindows: string[];
}
export declare function oceanGkeImportScheduledTaskShutdownHoursToTerraform(struct?: OceanGkeImportScheduledTaskShutdownHoursOutputReference | OceanGkeImportScheduledTaskShutdownHours): any;
export declare function oceanGkeImportScheduledTaskShutdownHoursToHclTerraform(struct?: OceanGkeImportScheduledTaskShutdownHoursOutputReference | OceanGkeImportScheduledTaskShutdownHours): any;
export declare class OceanGkeImportScheduledTaskShutdownHoursOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceanGkeImportScheduledTaskShutdownHours | undefined;
    set internalValue(value: OceanGkeImportScheduledTaskShutdownHours | undefined);
    private _isEnabled?;
    get isEnabled(): boolean | cdktf.IResolvable;
    set isEnabled(value: boolean | cdktf.IResolvable);
    resetIsEnabled(): void;
    get isEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _timeWindows?;
    get timeWindows(): string[];
    set timeWindows(value: string[]);
    get timeWindowsInput(): string[] | undefined;
}
export interface OceanGkeImportScheduledTaskTasksTaskParametersClusterRoll {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#batch_min_healthy_percentage OceanGkeImport#batch_min_healthy_percentage}
    */
    readonly batchMinHealthyPercentage?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#batch_size_percentage OceanGkeImport#batch_size_percentage}
    */
    readonly batchSizePercentage?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#comment OceanGkeImport#comment}
    */
    readonly comment?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#respect_pdb OceanGkeImport#respect_pdb}
    */
    readonly respectPdb?: boolean | cdktf.IResolvable;
}
export declare function oceanGkeImportScheduledTaskTasksTaskParametersClusterRollToTerraform(struct?: OceanGkeImportScheduledTaskTasksTaskParametersClusterRollOutputReference | OceanGkeImportScheduledTaskTasksTaskParametersClusterRoll): any;
export declare function oceanGkeImportScheduledTaskTasksTaskParametersClusterRollToHclTerraform(struct?: OceanGkeImportScheduledTaskTasksTaskParametersClusterRollOutputReference | OceanGkeImportScheduledTaskTasksTaskParametersClusterRoll): any;
export declare class OceanGkeImportScheduledTaskTasksTaskParametersClusterRollOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceanGkeImportScheduledTaskTasksTaskParametersClusterRoll | undefined;
    set internalValue(value: OceanGkeImportScheduledTaskTasksTaskParametersClusterRoll | undefined);
    private _batchMinHealthyPercentage?;
    get batchMinHealthyPercentage(): number;
    set batchMinHealthyPercentage(value: number);
    resetBatchMinHealthyPercentage(): void;
    get batchMinHealthyPercentageInput(): number | undefined;
    private _batchSizePercentage?;
    get batchSizePercentage(): number;
    set batchSizePercentage(value: number);
    resetBatchSizePercentage(): void;
    get batchSizePercentageInput(): number | undefined;
    private _comment?;
    get comment(): string;
    set comment(value: string);
    resetComment(): void;
    get commentInput(): string | undefined;
    private _respectPdb?;
    get respectPdb(): boolean | cdktf.IResolvable;
    set respectPdb(value: boolean | cdktf.IResolvable);
    resetRespectPdb(): void;
    get respectPdbInput(): boolean | cdktf.IResolvable | undefined;
}
export interface OceanGkeImportScheduledTaskTasksTaskParameters {
    /**
    * cluster_roll block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#cluster_roll OceanGkeImport#cluster_roll}
    */
    readonly clusterRoll?: OceanGkeImportScheduledTaskTasksTaskParametersClusterRoll;
}
export declare function oceanGkeImportScheduledTaskTasksTaskParametersToTerraform(struct?: OceanGkeImportScheduledTaskTasksTaskParametersOutputReference | OceanGkeImportScheduledTaskTasksTaskParameters): any;
export declare function oceanGkeImportScheduledTaskTasksTaskParametersToHclTerraform(struct?: OceanGkeImportScheduledTaskTasksTaskParametersOutputReference | OceanGkeImportScheduledTaskTasksTaskParameters): any;
export declare class OceanGkeImportScheduledTaskTasksTaskParametersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceanGkeImportScheduledTaskTasksTaskParameters | undefined;
    set internalValue(value: OceanGkeImportScheduledTaskTasksTaskParameters | undefined);
    private _clusterRoll;
    get clusterRoll(): OceanGkeImportScheduledTaskTasksTaskParametersClusterRollOutputReference;
    putClusterRoll(value: OceanGkeImportScheduledTaskTasksTaskParametersClusterRoll): void;
    resetClusterRoll(): void;
    get clusterRollInput(): OceanGkeImportScheduledTaskTasksTaskParametersClusterRoll | undefined;
}
export interface OceanGkeImportScheduledTaskTasks {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#cron_expression OceanGkeImport#cron_expression}
    */
    readonly cronExpression: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#is_enabled OceanGkeImport#is_enabled}
    */
    readonly isEnabled: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#task_type OceanGkeImport#task_type}
    */
    readonly taskType: string;
    /**
    * task_parameters block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#task_parameters OceanGkeImport#task_parameters}
    */
    readonly taskParameters?: OceanGkeImportScheduledTaskTasksTaskParameters;
}
export declare function oceanGkeImportScheduledTaskTasksToTerraform(struct?: OceanGkeImportScheduledTaskTasks | cdktf.IResolvable): any;
export declare function oceanGkeImportScheduledTaskTasksToHclTerraform(struct?: OceanGkeImportScheduledTaskTasks | cdktf.IResolvable): any;
export declare class OceanGkeImportScheduledTaskTasksOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OceanGkeImportScheduledTaskTasks | cdktf.IResolvable | undefined;
    set internalValue(value: OceanGkeImportScheduledTaskTasks | cdktf.IResolvable | undefined);
    private _cronExpression?;
    get cronExpression(): string;
    set cronExpression(value: string);
    get cronExpressionInput(): string | undefined;
    private _isEnabled?;
    get isEnabled(): boolean | cdktf.IResolvable;
    set isEnabled(value: boolean | cdktf.IResolvable);
    get isEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _taskType?;
    get taskType(): string;
    set taskType(value: string);
    get taskTypeInput(): string | undefined;
    private _taskParameters;
    get taskParameters(): OceanGkeImportScheduledTaskTasksTaskParametersOutputReference;
    putTaskParameters(value: OceanGkeImportScheduledTaskTasksTaskParameters): void;
    resetTaskParameters(): void;
    get taskParametersInput(): OceanGkeImportScheduledTaskTasksTaskParameters | undefined;
}
export declare class OceanGkeImportScheduledTaskTasksList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OceanGkeImportScheduledTaskTasks[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OceanGkeImportScheduledTaskTasksOutputReference;
}
export interface OceanGkeImportScheduledTask {
    /**
    * shutdown_hours block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#shutdown_hours OceanGkeImport#shutdown_hours}
    */
    readonly shutdownHours?: OceanGkeImportScheduledTaskShutdownHours;
    /**
    * tasks block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#tasks OceanGkeImport#tasks}
    */
    readonly tasks?: OceanGkeImportScheduledTaskTasks[] | cdktf.IResolvable;
}
export declare function oceanGkeImportScheduledTaskToTerraform(struct?: OceanGkeImportScheduledTask | cdktf.IResolvable): any;
export declare function oceanGkeImportScheduledTaskToHclTerraform(struct?: OceanGkeImportScheduledTask | cdktf.IResolvable): any;
export declare class OceanGkeImportScheduledTaskOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OceanGkeImportScheduledTask | cdktf.IResolvable | undefined;
    set internalValue(value: OceanGkeImportScheduledTask | cdktf.IResolvable | undefined);
    private _shutdownHours;
    get shutdownHours(): OceanGkeImportScheduledTaskShutdownHoursOutputReference;
    putShutdownHours(value: OceanGkeImportScheduledTaskShutdownHours): void;
    resetShutdownHours(): void;
    get shutdownHoursInput(): OceanGkeImportScheduledTaskShutdownHours | undefined;
    private _tasks;
    get tasks(): OceanGkeImportScheduledTaskTasksList;
    putTasks(value: OceanGkeImportScheduledTaskTasks[] | cdktf.IResolvable): void;
    resetTasks(): void;
    get tasksInput(): cdktf.IResolvable | OceanGkeImportScheduledTaskTasks[] | undefined;
}
export declare class OceanGkeImportScheduledTaskList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OceanGkeImportScheduledTask[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OceanGkeImportScheduledTaskOutputReference;
}
export interface OceanGkeImportShieldedInstanceConfig {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#enable_integrity_monitoring OceanGkeImport#enable_integrity_monitoring}
    */
    readonly enableIntegrityMonitoring?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#enable_secure_boot OceanGkeImport#enable_secure_boot}
    */
    readonly enableSecureBoot?: boolean | cdktf.IResolvable;
}
export declare function oceanGkeImportShieldedInstanceConfigToTerraform(struct?: OceanGkeImportShieldedInstanceConfigOutputReference | OceanGkeImportShieldedInstanceConfig): any;
export declare function oceanGkeImportShieldedInstanceConfigToHclTerraform(struct?: OceanGkeImportShieldedInstanceConfigOutputReference | OceanGkeImportShieldedInstanceConfig): any;
export declare class OceanGkeImportShieldedInstanceConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceanGkeImportShieldedInstanceConfig | undefined;
    set internalValue(value: OceanGkeImportShieldedInstanceConfig | undefined);
    private _enableIntegrityMonitoring?;
    get enableIntegrityMonitoring(): boolean | cdktf.IResolvable;
    set enableIntegrityMonitoring(value: boolean | cdktf.IResolvable);
    resetEnableIntegrityMonitoring(): void;
    get enableIntegrityMonitoringInput(): boolean | cdktf.IResolvable | undefined;
    private _enableSecureBoot?;
    get enableSecureBoot(): boolean | cdktf.IResolvable;
    set enableSecureBoot(value: boolean | cdktf.IResolvable);
    resetEnableSecureBoot(): void;
    get enableSecureBootInput(): boolean | cdktf.IResolvable | undefined;
}
export interface OceanGkeImportStrategy {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#draining_timeout OceanGkeImport#draining_timeout}
    */
    readonly drainingTimeout?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#preemptible_percentage OceanGkeImport#preemptible_percentage}
    */
    readonly preemptiblePercentage?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#provisioning_model OceanGkeImport#provisioning_model}
    */
    readonly provisioningModel?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#scaling_orientation OceanGkeImport#scaling_orientation}
    */
    readonly scalingOrientation?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#should_utilize_commitments OceanGkeImport#should_utilize_commitments}
    */
    readonly shouldUtilizeCommitments?: boolean | cdktf.IResolvable;
}
export declare function oceanGkeImportStrategyToTerraform(struct?: OceanGkeImportStrategy | cdktf.IResolvable): any;
export declare function oceanGkeImportStrategyToHclTerraform(struct?: OceanGkeImportStrategy | cdktf.IResolvable): any;
export declare class OceanGkeImportStrategyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OceanGkeImportStrategy | cdktf.IResolvable | undefined;
    set internalValue(value: OceanGkeImportStrategy | cdktf.IResolvable | undefined);
    private _drainingTimeout?;
    get drainingTimeout(): number;
    set drainingTimeout(value: number);
    resetDrainingTimeout(): void;
    get drainingTimeoutInput(): number | undefined;
    private _preemptiblePercentage?;
    get preemptiblePercentage(): number;
    set preemptiblePercentage(value: number);
    resetPreemptiblePercentage(): void;
    get preemptiblePercentageInput(): number | undefined;
    private _provisioningModel?;
    get provisioningModel(): string;
    set provisioningModel(value: string);
    resetProvisioningModel(): void;
    get provisioningModelInput(): string | undefined;
    private _scalingOrientation?;
    get scalingOrientation(): string;
    set scalingOrientation(value: string);
    resetScalingOrientation(): void;
    get scalingOrientationInput(): string | undefined;
    private _shouldUtilizeCommitments?;
    get shouldUtilizeCommitments(): boolean | cdktf.IResolvable;
    set shouldUtilizeCommitments(value: boolean | cdktf.IResolvable);
    resetShouldUtilizeCommitments(): void;
    get shouldUtilizeCommitmentsInput(): boolean | cdktf.IResolvable | undefined;
}
export declare class OceanGkeImportStrategyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OceanGkeImportStrategy[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OceanGkeImportStrategyOutputReference;
}
export interface OceanGkeImportUpdatePolicyRollConfig {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#batch_min_healthy_percentage OceanGkeImport#batch_min_healthy_percentage}
    */
    readonly batchMinHealthyPercentage?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#batch_size_percentage OceanGkeImport#batch_size_percentage}
    */
    readonly batchSizePercentage: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#launch_spec_ids OceanGkeImport#launch_spec_ids}
    */
    readonly launchSpecIds?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#respect_pdb OceanGkeImport#respect_pdb}
    */
    readonly respectPdb?: boolean | cdktf.IResolvable;
}
export declare function oceanGkeImportUpdatePolicyRollConfigToTerraform(struct?: OceanGkeImportUpdatePolicyRollConfigOutputReference | OceanGkeImportUpdatePolicyRollConfig): any;
export declare function oceanGkeImportUpdatePolicyRollConfigToHclTerraform(struct?: OceanGkeImportUpdatePolicyRollConfigOutputReference | OceanGkeImportUpdatePolicyRollConfig): any;
export declare class OceanGkeImportUpdatePolicyRollConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceanGkeImportUpdatePolicyRollConfig | undefined;
    set internalValue(value: OceanGkeImportUpdatePolicyRollConfig | undefined);
    private _batchMinHealthyPercentage?;
    get batchMinHealthyPercentage(): number;
    set batchMinHealthyPercentage(value: number);
    resetBatchMinHealthyPercentage(): void;
    get batchMinHealthyPercentageInput(): number | undefined;
    private _batchSizePercentage?;
    get batchSizePercentage(): number;
    set batchSizePercentage(value: number);
    get batchSizePercentageInput(): number | undefined;
    private _launchSpecIds?;
    get launchSpecIds(): string[];
    set launchSpecIds(value: string[]);
    resetLaunchSpecIds(): void;
    get launchSpecIdsInput(): string[] | undefined;
    private _respectPdb?;
    get respectPdb(): boolean | cdktf.IResolvable;
    set respectPdb(value: boolean | cdktf.IResolvable);
    resetRespectPdb(): void;
    get respectPdbInput(): boolean | cdktf.IResolvable | undefined;
}
export interface OceanGkeImportUpdatePolicy {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#conditioned_roll OceanGkeImport#conditioned_roll}
    */
    readonly conditionedRoll?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#should_roll OceanGkeImport#should_roll}
    */
    readonly shouldRoll: boolean | cdktf.IResolvable;
    /**
    * roll_config block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#roll_config OceanGkeImport#roll_config}
    */
    readonly rollConfig?: OceanGkeImportUpdatePolicyRollConfig;
}
export declare function oceanGkeImportUpdatePolicyToTerraform(struct?: OceanGkeImportUpdatePolicyOutputReference | OceanGkeImportUpdatePolicy): any;
export declare function oceanGkeImportUpdatePolicyToHclTerraform(struct?: OceanGkeImportUpdatePolicyOutputReference | OceanGkeImportUpdatePolicy): any;
export declare class OceanGkeImportUpdatePolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceanGkeImportUpdatePolicy | undefined;
    set internalValue(value: OceanGkeImportUpdatePolicy | undefined);
    private _conditionedRoll?;
    get conditionedRoll(): boolean | cdktf.IResolvable;
    set conditionedRoll(value: boolean | cdktf.IResolvable);
    resetConditionedRoll(): void;
    get conditionedRollInput(): boolean | cdktf.IResolvable | undefined;
    private _shouldRoll?;
    get shouldRoll(): boolean | cdktf.IResolvable;
    set shouldRoll(value: boolean | cdktf.IResolvable);
    get shouldRollInput(): boolean | cdktf.IResolvable | undefined;
    private _rollConfig;
    get rollConfig(): OceanGkeImportUpdatePolicyRollConfigOutputReference;
    putRollConfig(value: OceanGkeImportUpdatePolicyRollConfig): void;
    resetRollConfig(): void;
    get rollConfigInput(): OceanGkeImportUpdatePolicyRollConfig | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import spotinst_ocean_gke_import}
*/
export declare class OceanGkeImport extends cdktf.TerraformResource {
    static readonly tfResourceType = "spotinst_ocean_gke_import";
    /**
    * Generates CDKTF code for importing a OceanGkeImport resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the OceanGkeImport to import
    * @param importFromId The id of the existing OceanGkeImport that should be imported. Refer to the {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the OceanGkeImport to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_gke_import spotinst_ocean_gke_import} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options OceanGkeImportConfig
    */
    constructor(scope: Construct, id: string, config: OceanGkeImportConfig);
    private _blacklist?;
    get blacklist(): string[];
    set blacklist(value: string[]);
    resetBlacklist(): void;
    get blacklistInput(): string[] | undefined;
    get clusterControllerId(): string;
    private _clusterName?;
    get clusterName(): string;
    set clusterName(value: string);
    get clusterNameInput(): string | undefined;
    private _controllerClusterId?;
    get controllerClusterId(): string;
    set controllerClusterId(value: string);
    resetControllerClusterId(): void;
    get controllerClusterIdInput(): string | undefined;
    private _desiredCapacity?;
    get desiredCapacity(): number;
    set desiredCapacity(value: number);
    resetDesiredCapacity(): void;
    get desiredCapacityInput(): number | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _location?;
    get location(): string;
    set location(value: string);
    get locationInput(): string | undefined;
    private _maxSize?;
    get maxSize(): number;
    set maxSize(value: number);
    resetMaxSize(): void;
    get maxSizeInput(): number | undefined;
    private _minSize?;
    get minSize(): number;
    set minSize(value: number);
    resetMinSize(): void;
    get minSizeInput(): number | undefined;
    private _rootVolumeType?;
    get rootVolumeType(): string;
    set rootVolumeType(value: string);
    resetRootVolumeType(): void;
    get rootVolumeTypeInput(): string | undefined;
    private _useAsTemplateOnly?;
    get useAsTemplateOnly(): boolean | cdktf.IResolvable;
    set useAsTemplateOnly(value: boolean | cdktf.IResolvable);
    resetUseAsTemplateOnly(): void;
    get useAsTemplateOnlyInput(): boolean | cdktf.IResolvable | undefined;
    private _whitelist?;
    get whitelist(): string[];
    set whitelist(value: string[]);
    resetWhitelist(): void;
    get whitelistInput(): string[] | undefined;
    private _autoUpdate;
    get autoUpdate(): OceanGkeImportAutoUpdateList;
    putAutoUpdate(value: OceanGkeImportAutoUpdate[] | cdktf.IResolvable): void;
    resetAutoUpdate(): void;
    get autoUpdateInput(): cdktf.IResolvable | OceanGkeImportAutoUpdate[] | undefined;
    private _autoscaler;
    get autoscaler(): OceanGkeImportAutoscalerOutputReference;
    putAutoscaler(value: OceanGkeImportAutoscaler): void;
    resetAutoscaler(): void;
    get autoscalerInput(): OceanGkeImportAutoscaler | undefined;
    private _backendServices;
    get backendServices(): OceanGkeImportBackendServicesList;
    putBackendServices(value: OceanGkeImportBackendServices[] | cdktf.IResolvable): void;
    resetBackendServices(): void;
    get backendServicesInput(): cdktf.IResolvable | OceanGkeImportBackendServices[] | undefined;
    private _filters;
    get filters(): OceanGkeImportFiltersOutputReference;
    putFilters(value: OceanGkeImportFilters): void;
    resetFilters(): void;
    get filtersInput(): OceanGkeImportFilters | undefined;
    private _scheduledTask;
    get scheduledTask(): OceanGkeImportScheduledTaskList;
    putScheduledTask(value: OceanGkeImportScheduledTask[] | cdktf.IResolvable): void;
    resetScheduledTask(): void;
    get scheduledTaskInput(): cdktf.IResolvable | OceanGkeImportScheduledTask[] | undefined;
    private _shieldedInstanceConfig;
    get shieldedInstanceConfig(): OceanGkeImportShieldedInstanceConfigOutputReference;
    putShieldedInstanceConfig(value: OceanGkeImportShieldedInstanceConfig): void;
    resetShieldedInstanceConfig(): void;
    get shieldedInstanceConfigInput(): OceanGkeImportShieldedInstanceConfig | undefined;
    private _strategy;
    get strategy(): OceanGkeImportStrategyList;
    putStrategy(value: OceanGkeImportStrategy[] | cdktf.IResolvable): void;
    resetStrategy(): void;
    get strategyInput(): cdktf.IResolvable | OceanGkeImportStrategy[] | undefined;
    private _updatePolicy;
    get updatePolicy(): OceanGkeImportUpdatePolicyOutputReference;
    putUpdatePolicy(value: OceanGkeImportUpdatePolicy): void;
    resetUpdatePolicy(): void;
    get updatePolicyInput(): OceanGkeImportUpdatePolicy | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
