/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface OceanRightSizingRuleConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#exclude_preliminary_recommendations OceanRightSizingRule#exclude_preliminary_recommendations}
    */
    readonly excludePreliminaryRecommendations?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#id OceanRightSizingRule#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#ocean_id OceanRightSizingRule#ocean_id}
    */
    readonly oceanId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#restart_replicas OceanRightSizingRule#restart_replicas}
    */
    readonly restartReplicas?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#rule_name OceanRightSizingRule#rule_name}
    */
    readonly ruleName: string;
    /**
    * attach_workloads block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#attach_workloads OceanRightSizingRule#attach_workloads}
    */
    readonly attachWorkloads?: OceanRightSizingRuleAttachWorkloads[] | cdktf.IResolvable;
    /**
    * detach_workloads block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#detach_workloads OceanRightSizingRule#detach_workloads}
    */
    readonly detachWorkloads?: OceanRightSizingRuleDetachWorkloads[] | cdktf.IResolvable;
    /**
    * recommendation_application_boundaries block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#recommendation_application_boundaries OceanRightSizingRule#recommendation_application_boundaries}
    */
    readonly recommendationApplicationBoundaries?: OceanRightSizingRuleRecommendationApplicationBoundaries[] | cdktf.IResolvable;
    /**
    * recommendation_application_hpa block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#recommendation_application_hpa OceanRightSizingRule#recommendation_application_hpa}
    */
    readonly recommendationApplicationHpa?: OceanRightSizingRuleRecommendationApplicationHpa[] | cdktf.IResolvable;
    /**
    * recommendation_application_intervals block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#recommendation_application_intervals OceanRightSizingRule#recommendation_application_intervals}
    */
    readonly recommendationApplicationIntervals: OceanRightSizingRuleRecommendationApplicationIntervals[] | cdktf.IResolvable;
    /**
    * recommendation_application_min_threshold block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#recommendation_application_min_threshold OceanRightSizingRule#recommendation_application_min_threshold}
    */
    readonly recommendationApplicationMinThreshold?: OceanRightSizingRuleRecommendationApplicationMinThreshold[] | cdktf.IResolvable;
    /**
    * recommendation_application_overhead_values block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#recommendation_application_overhead_values OceanRightSizingRule#recommendation_application_overhead_values}
    */
    readonly recommendationApplicationOverheadValues?: OceanRightSizingRuleRecommendationApplicationOverheadValues[] | cdktf.IResolvable;
}
export interface OceanRightSizingRuleAttachWorkloadsNamespacesLabels {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#key OceanRightSizingRule#key}
    */
    readonly key: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#value OceanRightSizingRule#value}
    */
    readonly value: string;
}
export declare function oceanRightSizingRuleAttachWorkloadsNamespacesLabelsToTerraform(struct?: OceanRightSizingRuleAttachWorkloadsNamespacesLabels | cdktf.IResolvable): any;
export declare function oceanRightSizingRuleAttachWorkloadsNamespacesLabelsToHclTerraform(struct?: OceanRightSizingRuleAttachWorkloadsNamespacesLabels | cdktf.IResolvable): any;
export declare class OceanRightSizingRuleAttachWorkloadsNamespacesLabelsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OceanRightSizingRuleAttachWorkloadsNamespacesLabels | cdktf.IResolvable | undefined;
    set internalValue(value: OceanRightSizingRuleAttachWorkloadsNamespacesLabels | cdktf.IResolvable | undefined);
    private _key?;
    get key(): string;
    set key(value: string);
    get keyInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    get valueInput(): string | undefined;
}
export declare class OceanRightSizingRuleAttachWorkloadsNamespacesLabelsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OceanRightSizingRuleAttachWorkloadsNamespacesLabels[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OceanRightSizingRuleAttachWorkloadsNamespacesLabelsOutputReference;
}
export interface OceanRightSizingRuleAttachWorkloadsNamespacesWorkloads {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#regex_name OceanRightSizingRule#regex_name}
    */
    readonly regexName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#workload_name OceanRightSizingRule#workload_name}
    */
    readonly workloadName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#workload_type OceanRightSizingRule#workload_type}
    */
    readonly workloadType: string;
}
export declare function oceanRightSizingRuleAttachWorkloadsNamespacesWorkloadsToTerraform(struct?: OceanRightSizingRuleAttachWorkloadsNamespacesWorkloads | cdktf.IResolvable): any;
export declare function oceanRightSizingRuleAttachWorkloadsNamespacesWorkloadsToHclTerraform(struct?: OceanRightSizingRuleAttachWorkloadsNamespacesWorkloads | cdktf.IResolvable): any;
export declare class OceanRightSizingRuleAttachWorkloadsNamespacesWorkloadsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OceanRightSizingRuleAttachWorkloadsNamespacesWorkloads | cdktf.IResolvable | undefined;
    set internalValue(value: OceanRightSizingRuleAttachWorkloadsNamespacesWorkloads | cdktf.IResolvable | undefined);
    private _regexName?;
    get regexName(): string;
    set regexName(value: string);
    resetRegexName(): void;
    get regexNameInput(): string | undefined;
    private _workloadName?;
    get workloadName(): string;
    set workloadName(value: string);
    resetWorkloadName(): void;
    get workloadNameInput(): string | undefined;
    private _workloadType?;
    get workloadType(): string;
    set workloadType(value: string);
    get workloadTypeInput(): string | undefined;
}
export declare class OceanRightSizingRuleAttachWorkloadsNamespacesWorkloadsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OceanRightSizingRuleAttachWorkloadsNamespacesWorkloads[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OceanRightSizingRuleAttachWorkloadsNamespacesWorkloadsOutputReference;
}
export interface OceanRightSizingRuleAttachWorkloadsNamespaces {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#namespace_name OceanRightSizingRule#namespace_name}
    */
    readonly namespaceName: string;
    /**
    * labels block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#labels OceanRightSizingRule#labels}
    */
    readonly labels?: OceanRightSizingRuleAttachWorkloadsNamespacesLabels[] | cdktf.IResolvable;
    /**
    * workloads block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#workloads OceanRightSizingRule#workloads}
    */
    readonly workloads?: OceanRightSizingRuleAttachWorkloadsNamespacesWorkloads[] | cdktf.IResolvable;
}
export declare function oceanRightSizingRuleAttachWorkloadsNamespacesToTerraform(struct?: OceanRightSizingRuleAttachWorkloadsNamespaces | cdktf.IResolvable): any;
export declare function oceanRightSizingRuleAttachWorkloadsNamespacesToHclTerraform(struct?: OceanRightSizingRuleAttachWorkloadsNamespaces | cdktf.IResolvable): any;
export declare class OceanRightSizingRuleAttachWorkloadsNamespacesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OceanRightSizingRuleAttachWorkloadsNamespaces | cdktf.IResolvable | undefined;
    set internalValue(value: OceanRightSizingRuleAttachWorkloadsNamespaces | cdktf.IResolvable | undefined);
    private _namespaceName?;
    get namespaceName(): string;
    set namespaceName(value: string);
    get namespaceNameInput(): string | undefined;
    private _labels;
    get labels(): OceanRightSizingRuleAttachWorkloadsNamespacesLabelsList;
    putLabels(value: OceanRightSizingRuleAttachWorkloadsNamespacesLabels[] | cdktf.IResolvable): void;
    resetLabels(): void;
    get labelsInput(): cdktf.IResolvable | OceanRightSizingRuleAttachWorkloadsNamespacesLabels[] | undefined;
    private _workloads;
    get workloads(): OceanRightSizingRuleAttachWorkloadsNamespacesWorkloadsList;
    putWorkloads(value: OceanRightSizingRuleAttachWorkloadsNamespacesWorkloads[] | cdktf.IResolvable): void;
    resetWorkloads(): void;
    get workloadsInput(): cdktf.IResolvable | OceanRightSizingRuleAttachWorkloadsNamespacesWorkloads[] | undefined;
}
export declare class OceanRightSizingRuleAttachWorkloadsNamespacesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OceanRightSizingRuleAttachWorkloadsNamespaces[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OceanRightSizingRuleAttachWorkloadsNamespacesOutputReference;
}
export interface OceanRightSizingRuleAttachWorkloads {
    /**
    * namespaces block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#namespaces OceanRightSizingRule#namespaces}
    */
    readonly namespaces: OceanRightSizingRuleAttachWorkloadsNamespaces[] | cdktf.IResolvable;
}
export declare function oceanRightSizingRuleAttachWorkloadsToTerraform(struct?: OceanRightSizingRuleAttachWorkloads | cdktf.IResolvable): any;
export declare function oceanRightSizingRuleAttachWorkloadsToHclTerraform(struct?: OceanRightSizingRuleAttachWorkloads | cdktf.IResolvable): any;
export declare class OceanRightSizingRuleAttachWorkloadsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OceanRightSizingRuleAttachWorkloads | cdktf.IResolvable | undefined;
    set internalValue(value: OceanRightSizingRuleAttachWorkloads | cdktf.IResolvable | undefined);
    private _namespaces;
    get namespaces(): OceanRightSizingRuleAttachWorkloadsNamespacesList;
    putNamespaces(value: OceanRightSizingRuleAttachWorkloadsNamespaces[] | cdktf.IResolvable): void;
    get namespacesInput(): cdktf.IResolvable | OceanRightSizingRuleAttachWorkloadsNamespaces[] | undefined;
}
export declare class OceanRightSizingRuleAttachWorkloadsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OceanRightSizingRuleAttachWorkloads[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OceanRightSizingRuleAttachWorkloadsOutputReference;
}
export interface OceanRightSizingRuleDetachWorkloadsNamespacesLabels {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#key OceanRightSizingRule#key}
    */
    readonly key: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#value OceanRightSizingRule#value}
    */
    readonly value: string;
}
export declare function oceanRightSizingRuleDetachWorkloadsNamespacesLabelsToTerraform(struct?: OceanRightSizingRuleDetachWorkloadsNamespacesLabels | cdktf.IResolvable): any;
export declare function oceanRightSizingRuleDetachWorkloadsNamespacesLabelsToHclTerraform(struct?: OceanRightSizingRuleDetachWorkloadsNamespacesLabels | cdktf.IResolvable): any;
export declare class OceanRightSizingRuleDetachWorkloadsNamespacesLabelsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OceanRightSizingRuleDetachWorkloadsNamespacesLabels | cdktf.IResolvable | undefined;
    set internalValue(value: OceanRightSizingRuleDetachWorkloadsNamespacesLabels | cdktf.IResolvable | undefined);
    private _key?;
    get key(): string;
    set key(value: string);
    get keyInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    get valueInput(): string | undefined;
}
export declare class OceanRightSizingRuleDetachWorkloadsNamespacesLabelsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OceanRightSizingRuleDetachWorkloadsNamespacesLabels[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OceanRightSizingRuleDetachWorkloadsNamespacesLabelsOutputReference;
}
export interface OceanRightSizingRuleDetachWorkloadsNamespacesWorkloads {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#regex_name OceanRightSizingRule#regex_name}
    */
    readonly regexName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#workload_name OceanRightSizingRule#workload_name}
    */
    readonly workloadName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#workload_type OceanRightSizingRule#workload_type}
    */
    readonly workloadType: string;
}
export declare function oceanRightSizingRuleDetachWorkloadsNamespacesWorkloadsToTerraform(struct?: OceanRightSizingRuleDetachWorkloadsNamespacesWorkloads | cdktf.IResolvable): any;
export declare function oceanRightSizingRuleDetachWorkloadsNamespacesWorkloadsToHclTerraform(struct?: OceanRightSizingRuleDetachWorkloadsNamespacesWorkloads | cdktf.IResolvable): any;
export declare class OceanRightSizingRuleDetachWorkloadsNamespacesWorkloadsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OceanRightSizingRuleDetachWorkloadsNamespacesWorkloads | cdktf.IResolvable | undefined;
    set internalValue(value: OceanRightSizingRuleDetachWorkloadsNamespacesWorkloads | cdktf.IResolvable | undefined);
    private _regexName?;
    get regexName(): string;
    set regexName(value: string);
    resetRegexName(): void;
    get regexNameInput(): string | undefined;
    private _workloadName?;
    get workloadName(): string;
    set workloadName(value: string);
    resetWorkloadName(): void;
    get workloadNameInput(): string | undefined;
    private _workloadType?;
    get workloadType(): string;
    set workloadType(value: string);
    get workloadTypeInput(): string | undefined;
}
export declare class OceanRightSizingRuleDetachWorkloadsNamespacesWorkloadsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OceanRightSizingRuleDetachWorkloadsNamespacesWorkloads[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OceanRightSizingRuleDetachWorkloadsNamespacesWorkloadsOutputReference;
}
export interface OceanRightSizingRuleDetachWorkloadsNamespaces {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#namespace_name OceanRightSizingRule#namespace_name}
    */
    readonly namespaceName: string;
    /**
    * labels block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#labels OceanRightSizingRule#labels}
    */
    readonly labels?: OceanRightSizingRuleDetachWorkloadsNamespacesLabels[] | cdktf.IResolvable;
    /**
    * workloads block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#workloads OceanRightSizingRule#workloads}
    */
    readonly workloads?: OceanRightSizingRuleDetachWorkloadsNamespacesWorkloads[] | cdktf.IResolvable;
}
export declare function oceanRightSizingRuleDetachWorkloadsNamespacesToTerraform(struct?: OceanRightSizingRuleDetachWorkloadsNamespaces | cdktf.IResolvable): any;
export declare function oceanRightSizingRuleDetachWorkloadsNamespacesToHclTerraform(struct?: OceanRightSizingRuleDetachWorkloadsNamespaces | cdktf.IResolvable): any;
export declare class OceanRightSizingRuleDetachWorkloadsNamespacesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OceanRightSizingRuleDetachWorkloadsNamespaces | cdktf.IResolvable | undefined;
    set internalValue(value: OceanRightSizingRuleDetachWorkloadsNamespaces | cdktf.IResolvable | undefined);
    private _namespaceName?;
    get namespaceName(): string;
    set namespaceName(value: string);
    get namespaceNameInput(): string | undefined;
    private _labels;
    get labels(): OceanRightSizingRuleDetachWorkloadsNamespacesLabelsList;
    putLabels(value: OceanRightSizingRuleDetachWorkloadsNamespacesLabels[] | cdktf.IResolvable): void;
    resetLabels(): void;
    get labelsInput(): cdktf.IResolvable | OceanRightSizingRuleDetachWorkloadsNamespacesLabels[] | undefined;
    private _workloads;
    get workloads(): OceanRightSizingRuleDetachWorkloadsNamespacesWorkloadsList;
    putWorkloads(value: OceanRightSizingRuleDetachWorkloadsNamespacesWorkloads[] | cdktf.IResolvable): void;
    resetWorkloads(): void;
    get workloadsInput(): cdktf.IResolvable | OceanRightSizingRuleDetachWorkloadsNamespacesWorkloads[] | undefined;
}
export declare class OceanRightSizingRuleDetachWorkloadsNamespacesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OceanRightSizingRuleDetachWorkloadsNamespaces[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OceanRightSizingRuleDetachWorkloadsNamespacesOutputReference;
}
export interface OceanRightSizingRuleDetachWorkloads {
    /**
    * namespaces block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#namespaces OceanRightSizingRule#namespaces}
    */
    readonly namespaces: OceanRightSizingRuleDetachWorkloadsNamespaces[] | cdktf.IResolvable;
}
export declare function oceanRightSizingRuleDetachWorkloadsToTerraform(struct?: OceanRightSizingRuleDetachWorkloads | cdktf.IResolvable): any;
export declare function oceanRightSizingRuleDetachWorkloadsToHclTerraform(struct?: OceanRightSizingRuleDetachWorkloads | cdktf.IResolvable): any;
export declare class OceanRightSizingRuleDetachWorkloadsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OceanRightSizingRuleDetachWorkloads | cdktf.IResolvable | undefined;
    set internalValue(value: OceanRightSizingRuleDetachWorkloads | cdktf.IResolvable | undefined);
    private _namespaces;
    get namespaces(): OceanRightSizingRuleDetachWorkloadsNamespacesList;
    putNamespaces(value: OceanRightSizingRuleDetachWorkloadsNamespaces[] | cdktf.IResolvable): void;
    get namespacesInput(): cdktf.IResolvable | OceanRightSizingRuleDetachWorkloadsNamespaces[] | undefined;
}
export declare class OceanRightSizingRuleDetachWorkloadsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OceanRightSizingRuleDetachWorkloads[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OceanRightSizingRuleDetachWorkloadsOutputReference;
}
export interface OceanRightSizingRuleRecommendationApplicationBoundaries {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#cpu_max OceanRightSizingRule#cpu_max}
    */
    readonly cpuMax?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#cpu_min OceanRightSizingRule#cpu_min}
    */
    readonly cpuMin?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#memory_max OceanRightSizingRule#memory_max}
    */
    readonly memoryMax?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#memory_min OceanRightSizingRule#memory_min}
    */
    readonly memoryMin?: number;
}
export declare function oceanRightSizingRuleRecommendationApplicationBoundariesToTerraform(struct?: OceanRightSizingRuleRecommendationApplicationBoundaries | cdktf.IResolvable): any;
export declare function oceanRightSizingRuleRecommendationApplicationBoundariesToHclTerraform(struct?: OceanRightSizingRuleRecommendationApplicationBoundaries | cdktf.IResolvable): any;
export declare class OceanRightSizingRuleRecommendationApplicationBoundariesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OceanRightSizingRuleRecommendationApplicationBoundaries | cdktf.IResolvable | undefined;
    set internalValue(value: OceanRightSizingRuleRecommendationApplicationBoundaries | cdktf.IResolvable | undefined);
    private _cpuMax?;
    get cpuMax(): number;
    set cpuMax(value: number);
    resetCpuMax(): void;
    get cpuMaxInput(): number | undefined;
    private _cpuMin?;
    get cpuMin(): number;
    set cpuMin(value: number);
    resetCpuMin(): void;
    get cpuMinInput(): number | undefined;
    private _memoryMax?;
    get memoryMax(): number;
    set memoryMax(value: number);
    resetMemoryMax(): void;
    get memoryMaxInput(): number | undefined;
    private _memoryMin?;
    get memoryMin(): number;
    set memoryMin(value: number);
    resetMemoryMin(): void;
    get memoryMinInput(): number | undefined;
}
export declare class OceanRightSizingRuleRecommendationApplicationBoundariesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OceanRightSizingRuleRecommendationApplicationBoundaries[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OceanRightSizingRuleRecommendationApplicationBoundariesOutputReference;
}
export interface OceanRightSizingRuleRecommendationApplicationHpa {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#allow_hpa_recommendations OceanRightSizingRule#allow_hpa_recommendations}
    */
    readonly allowHpaRecommendations?: boolean | cdktf.IResolvable;
}
export declare function oceanRightSizingRuleRecommendationApplicationHpaToTerraform(struct?: OceanRightSizingRuleRecommendationApplicationHpa | cdktf.IResolvable): any;
export declare function oceanRightSizingRuleRecommendationApplicationHpaToHclTerraform(struct?: OceanRightSizingRuleRecommendationApplicationHpa | cdktf.IResolvable): any;
export declare class OceanRightSizingRuleRecommendationApplicationHpaOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OceanRightSizingRuleRecommendationApplicationHpa | cdktf.IResolvable | undefined;
    set internalValue(value: OceanRightSizingRuleRecommendationApplicationHpa | cdktf.IResolvable | undefined);
    private _allowHpaRecommendations?;
    get allowHpaRecommendations(): boolean | cdktf.IResolvable;
    set allowHpaRecommendations(value: boolean | cdktf.IResolvable);
    resetAllowHpaRecommendations(): void;
    get allowHpaRecommendationsInput(): boolean | cdktf.IResolvable | undefined;
}
export declare class OceanRightSizingRuleRecommendationApplicationHpaList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OceanRightSizingRuleRecommendationApplicationHpa[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OceanRightSizingRuleRecommendationApplicationHpaOutputReference;
}
export interface OceanRightSizingRuleRecommendationApplicationIntervalsMonthlyRepetitionBasisWeeklyRepetitionBasis {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#interval_days OceanRightSizingRule#interval_days}
    */
    readonly intervalDays: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#interval_hours_end_time OceanRightSizingRule#interval_hours_end_time}
    */
    readonly intervalHoursEndTime: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#interval_hours_start_time OceanRightSizingRule#interval_hours_start_time}
    */
    readonly intervalHoursStartTime: string;
}
export declare function oceanRightSizingRuleRecommendationApplicationIntervalsMonthlyRepetitionBasisWeeklyRepetitionBasisToTerraform(struct?: OceanRightSizingRuleRecommendationApplicationIntervalsMonthlyRepetitionBasisWeeklyRepetitionBasis | cdktf.IResolvable): any;
export declare function oceanRightSizingRuleRecommendationApplicationIntervalsMonthlyRepetitionBasisWeeklyRepetitionBasisToHclTerraform(struct?: OceanRightSizingRuleRecommendationApplicationIntervalsMonthlyRepetitionBasisWeeklyRepetitionBasis | cdktf.IResolvable): any;
export declare class OceanRightSizingRuleRecommendationApplicationIntervalsMonthlyRepetitionBasisWeeklyRepetitionBasisOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OceanRightSizingRuleRecommendationApplicationIntervalsMonthlyRepetitionBasisWeeklyRepetitionBasis | cdktf.IResolvable | undefined;
    set internalValue(value: OceanRightSizingRuleRecommendationApplicationIntervalsMonthlyRepetitionBasisWeeklyRepetitionBasis | cdktf.IResolvable | undefined);
    private _intervalDays?;
    get intervalDays(): string[];
    set intervalDays(value: string[]);
    get intervalDaysInput(): string[] | undefined;
    private _intervalHoursEndTime?;
    get intervalHoursEndTime(): string;
    set intervalHoursEndTime(value: string);
    get intervalHoursEndTimeInput(): string | undefined;
    private _intervalHoursStartTime?;
    get intervalHoursStartTime(): string;
    set intervalHoursStartTime(value: string);
    get intervalHoursStartTimeInput(): string | undefined;
}
export declare class OceanRightSizingRuleRecommendationApplicationIntervalsMonthlyRepetitionBasisWeeklyRepetitionBasisList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OceanRightSizingRuleRecommendationApplicationIntervalsMonthlyRepetitionBasisWeeklyRepetitionBasis[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OceanRightSizingRuleRecommendationApplicationIntervalsMonthlyRepetitionBasisWeeklyRepetitionBasisOutputReference;
}
export interface OceanRightSizingRuleRecommendationApplicationIntervalsMonthlyRepetitionBasis {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#interval_months OceanRightSizingRule#interval_months}
    */
    readonly intervalMonths: number[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#week_of_the_month OceanRightSizingRule#week_of_the_month}
    */
    readonly weekOfTheMonth: string[];
    /**
    * weekly_repetition_basis block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#weekly_repetition_basis OceanRightSizingRule#weekly_repetition_basis}
    */
    readonly weeklyRepetitionBasis?: OceanRightSizingRuleRecommendationApplicationIntervalsMonthlyRepetitionBasisWeeklyRepetitionBasis[] | cdktf.IResolvable;
}
export declare function oceanRightSizingRuleRecommendationApplicationIntervalsMonthlyRepetitionBasisToTerraform(struct?: OceanRightSizingRuleRecommendationApplicationIntervalsMonthlyRepetitionBasis | cdktf.IResolvable): any;
export declare function oceanRightSizingRuleRecommendationApplicationIntervalsMonthlyRepetitionBasisToHclTerraform(struct?: OceanRightSizingRuleRecommendationApplicationIntervalsMonthlyRepetitionBasis | cdktf.IResolvable): any;
export declare class OceanRightSizingRuleRecommendationApplicationIntervalsMonthlyRepetitionBasisOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OceanRightSizingRuleRecommendationApplicationIntervalsMonthlyRepetitionBasis | cdktf.IResolvable | undefined;
    set internalValue(value: OceanRightSizingRuleRecommendationApplicationIntervalsMonthlyRepetitionBasis | cdktf.IResolvable | undefined);
    private _intervalMonths?;
    get intervalMonths(): number[];
    set intervalMonths(value: number[]);
    get intervalMonthsInput(): number[] | undefined;
    private _weekOfTheMonth?;
    get weekOfTheMonth(): string[];
    set weekOfTheMonth(value: string[]);
    get weekOfTheMonthInput(): string[] | undefined;
    private _weeklyRepetitionBasis;
    get weeklyRepetitionBasis(): OceanRightSizingRuleRecommendationApplicationIntervalsMonthlyRepetitionBasisWeeklyRepetitionBasisList;
    putWeeklyRepetitionBasis(value: OceanRightSizingRuleRecommendationApplicationIntervalsMonthlyRepetitionBasisWeeklyRepetitionBasis[] | cdktf.IResolvable): void;
    resetWeeklyRepetitionBasis(): void;
    get weeklyRepetitionBasisInput(): cdktf.IResolvable | OceanRightSizingRuleRecommendationApplicationIntervalsMonthlyRepetitionBasisWeeklyRepetitionBasis[] | undefined;
}
export declare class OceanRightSizingRuleRecommendationApplicationIntervalsMonthlyRepetitionBasisList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OceanRightSizingRuleRecommendationApplicationIntervalsMonthlyRepetitionBasis[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OceanRightSizingRuleRecommendationApplicationIntervalsMonthlyRepetitionBasisOutputReference;
}
export interface OceanRightSizingRuleRecommendationApplicationIntervalsWeeklyRepetitionBasis {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#interval_days OceanRightSizingRule#interval_days}
    */
    readonly intervalDays: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#interval_hours_end_time OceanRightSizingRule#interval_hours_end_time}
    */
    readonly intervalHoursEndTime: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#interval_hours_start_time OceanRightSizingRule#interval_hours_start_time}
    */
    readonly intervalHoursStartTime: string;
}
export declare function oceanRightSizingRuleRecommendationApplicationIntervalsWeeklyRepetitionBasisToTerraform(struct?: OceanRightSizingRuleRecommendationApplicationIntervalsWeeklyRepetitionBasis | cdktf.IResolvable): any;
export declare function oceanRightSizingRuleRecommendationApplicationIntervalsWeeklyRepetitionBasisToHclTerraform(struct?: OceanRightSizingRuleRecommendationApplicationIntervalsWeeklyRepetitionBasis | cdktf.IResolvable): any;
export declare class OceanRightSizingRuleRecommendationApplicationIntervalsWeeklyRepetitionBasisOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OceanRightSizingRuleRecommendationApplicationIntervalsWeeklyRepetitionBasis | cdktf.IResolvable | undefined;
    set internalValue(value: OceanRightSizingRuleRecommendationApplicationIntervalsWeeklyRepetitionBasis | cdktf.IResolvable | undefined);
    private _intervalDays?;
    get intervalDays(): string[];
    set intervalDays(value: string[]);
    get intervalDaysInput(): string[] | undefined;
    private _intervalHoursEndTime?;
    get intervalHoursEndTime(): string;
    set intervalHoursEndTime(value: string);
    get intervalHoursEndTimeInput(): string | undefined;
    private _intervalHoursStartTime?;
    get intervalHoursStartTime(): string;
    set intervalHoursStartTime(value: string);
    get intervalHoursStartTimeInput(): string | undefined;
}
export declare class OceanRightSizingRuleRecommendationApplicationIntervalsWeeklyRepetitionBasisList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OceanRightSizingRuleRecommendationApplicationIntervalsWeeklyRepetitionBasis[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OceanRightSizingRuleRecommendationApplicationIntervalsWeeklyRepetitionBasisOutputReference;
}
export interface OceanRightSizingRuleRecommendationApplicationIntervals {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#repetition_basis OceanRightSizingRule#repetition_basis}
    */
    readonly repetitionBasis: string;
    /**
    * monthly_repetition_basis block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#monthly_repetition_basis OceanRightSizingRule#monthly_repetition_basis}
    */
    readonly monthlyRepetitionBasis?: OceanRightSizingRuleRecommendationApplicationIntervalsMonthlyRepetitionBasis[] | cdktf.IResolvable;
    /**
    * weekly_repetition_basis block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#weekly_repetition_basis OceanRightSizingRule#weekly_repetition_basis}
    */
    readonly weeklyRepetitionBasis?: OceanRightSizingRuleRecommendationApplicationIntervalsWeeklyRepetitionBasis[] | cdktf.IResolvable;
}
export declare function oceanRightSizingRuleRecommendationApplicationIntervalsToTerraform(struct?: OceanRightSizingRuleRecommendationApplicationIntervals | cdktf.IResolvable): any;
export declare function oceanRightSizingRuleRecommendationApplicationIntervalsToHclTerraform(struct?: OceanRightSizingRuleRecommendationApplicationIntervals | cdktf.IResolvable): any;
export declare class OceanRightSizingRuleRecommendationApplicationIntervalsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OceanRightSizingRuleRecommendationApplicationIntervals | cdktf.IResolvable | undefined;
    set internalValue(value: OceanRightSizingRuleRecommendationApplicationIntervals | cdktf.IResolvable | undefined);
    private _repetitionBasis?;
    get repetitionBasis(): string;
    set repetitionBasis(value: string);
    get repetitionBasisInput(): string | undefined;
    private _monthlyRepetitionBasis;
    get monthlyRepetitionBasis(): OceanRightSizingRuleRecommendationApplicationIntervalsMonthlyRepetitionBasisList;
    putMonthlyRepetitionBasis(value: OceanRightSizingRuleRecommendationApplicationIntervalsMonthlyRepetitionBasis[] | cdktf.IResolvable): void;
    resetMonthlyRepetitionBasis(): void;
    get monthlyRepetitionBasisInput(): cdktf.IResolvable | OceanRightSizingRuleRecommendationApplicationIntervalsMonthlyRepetitionBasis[] | undefined;
    private _weeklyRepetitionBasis;
    get weeklyRepetitionBasis(): OceanRightSizingRuleRecommendationApplicationIntervalsWeeklyRepetitionBasisList;
    putWeeklyRepetitionBasis(value: OceanRightSizingRuleRecommendationApplicationIntervalsWeeklyRepetitionBasis[] | cdktf.IResolvable): void;
    resetWeeklyRepetitionBasis(): void;
    get weeklyRepetitionBasisInput(): cdktf.IResolvable | OceanRightSizingRuleRecommendationApplicationIntervalsWeeklyRepetitionBasis[] | undefined;
}
export declare class OceanRightSizingRuleRecommendationApplicationIntervalsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OceanRightSizingRuleRecommendationApplicationIntervals[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OceanRightSizingRuleRecommendationApplicationIntervalsOutputReference;
}
export interface OceanRightSizingRuleRecommendationApplicationMinThreshold {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#cpu_percentage OceanRightSizingRule#cpu_percentage}
    */
    readonly cpuPercentage?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#memory_percentage OceanRightSizingRule#memory_percentage}
    */
    readonly memoryPercentage?: number;
}
export declare function oceanRightSizingRuleRecommendationApplicationMinThresholdToTerraform(struct?: OceanRightSizingRuleRecommendationApplicationMinThreshold | cdktf.IResolvable): any;
export declare function oceanRightSizingRuleRecommendationApplicationMinThresholdToHclTerraform(struct?: OceanRightSizingRuleRecommendationApplicationMinThreshold | cdktf.IResolvable): any;
export declare class OceanRightSizingRuleRecommendationApplicationMinThresholdOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OceanRightSizingRuleRecommendationApplicationMinThreshold | cdktf.IResolvable | undefined;
    set internalValue(value: OceanRightSizingRuleRecommendationApplicationMinThreshold | cdktf.IResolvable | undefined);
    private _cpuPercentage?;
    get cpuPercentage(): number;
    set cpuPercentage(value: number);
    resetCpuPercentage(): void;
    get cpuPercentageInput(): number | undefined;
    private _memoryPercentage?;
    get memoryPercentage(): number;
    set memoryPercentage(value: number);
    resetMemoryPercentage(): void;
    get memoryPercentageInput(): number | undefined;
}
export declare class OceanRightSizingRuleRecommendationApplicationMinThresholdList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OceanRightSizingRuleRecommendationApplicationMinThreshold[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OceanRightSizingRuleRecommendationApplicationMinThresholdOutputReference;
}
export interface OceanRightSizingRuleRecommendationApplicationOverheadValues {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#cpu_percentage OceanRightSizingRule#cpu_percentage}
    */
    readonly cpuPercentage?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#memory_percentage OceanRightSizingRule#memory_percentage}
    */
    readonly memoryPercentage?: number;
}
export declare function oceanRightSizingRuleRecommendationApplicationOverheadValuesToTerraform(struct?: OceanRightSizingRuleRecommendationApplicationOverheadValues | cdktf.IResolvable): any;
export declare function oceanRightSizingRuleRecommendationApplicationOverheadValuesToHclTerraform(struct?: OceanRightSizingRuleRecommendationApplicationOverheadValues | cdktf.IResolvable): any;
export declare class OceanRightSizingRuleRecommendationApplicationOverheadValuesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OceanRightSizingRuleRecommendationApplicationOverheadValues | cdktf.IResolvable | undefined;
    set internalValue(value: OceanRightSizingRuleRecommendationApplicationOverheadValues | cdktf.IResolvable | undefined);
    private _cpuPercentage?;
    get cpuPercentage(): number;
    set cpuPercentage(value: number);
    resetCpuPercentage(): void;
    get cpuPercentageInput(): number | undefined;
    private _memoryPercentage?;
    get memoryPercentage(): number;
    set memoryPercentage(value: number);
    resetMemoryPercentage(): void;
    get memoryPercentageInput(): number | undefined;
}
export declare class OceanRightSizingRuleRecommendationApplicationOverheadValuesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OceanRightSizingRuleRecommendationApplicationOverheadValues[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OceanRightSizingRuleRecommendationApplicationOverheadValuesOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule spotinst_ocean_right_sizing_rule}
*/
export declare class OceanRightSizingRule extends cdktf.TerraformResource {
    static readonly tfResourceType = "spotinst_ocean_right_sizing_rule";
    /**
    * Generates CDKTF code for importing a OceanRightSizingRule resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the OceanRightSizingRule to import
    * @param importFromId The id of the existing OceanRightSizingRule that should be imported. Refer to the {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the OceanRightSizingRule to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/ocean_right_sizing_rule spotinst_ocean_right_sizing_rule} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options OceanRightSizingRuleConfig
    */
    constructor(scope: Construct, id: string, config: OceanRightSizingRuleConfig);
    private _excludePreliminaryRecommendations?;
    get excludePreliminaryRecommendations(): boolean | cdktf.IResolvable;
    set excludePreliminaryRecommendations(value: boolean | cdktf.IResolvable);
    resetExcludePreliminaryRecommendations(): void;
    get excludePreliminaryRecommendationsInput(): boolean | cdktf.IResolvable | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _oceanId?;
    get oceanId(): string;
    set oceanId(value: string);
    resetOceanId(): void;
    get oceanIdInput(): string | undefined;
    private _restartReplicas?;
    get restartReplicas(): string;
    set restartReplicas(value: string);
    resetRestartReplicas(): void;
    get restartReplicasInput(): string | undefined;
    private _ruleName?;
    get ruleName(): string;
    set ruleName(value: string);
    get ruleNameInput(): string | undefined;
    private _attachWorkloads;
    get attachWorkloads(): OceanRightSizingRuleAttachWorkloadsList;
    putAttachWorkloads(value: OceanRightSizingRuleAttachWorkloads[] | cdktf.IResolvable): void;
    resetAttachWorkloads(): void;
    get attachWorkloadsInput(): cdktf.IResolvable | OceanRightSizingRuleAttachWorkloads[] | undefined;
    private _detachWorkloads;
    get detachWorkloads(): OceanRightSizingRuleDetachWorkloadsList;
    putDetachWorkloads(value: OceanRightSizingRuleDetachWorkloads[] | cdktf.IResolvable): void;
    resetDetachWorkloads(): void;
    get detachWorkloadsInput(): cdktf.IResolvable | OceanRightSizingRuleDetachWorkloads[] | undefined;
    private _recommendationApplicationBoundaries;
    get recommendationApplicationBoundaries(): OceanRightSizingRuleRecommendationApplicationBoundariesList;
    putRecommendationApplicationBoundaries(value: OceanRightSizingRuleRecommendationApplicationBoundaries[] | cdktf.IResolvable): void;
    resetRecommendationApplicationBoundaries(): void;
    get recommendationApplicationBoundariesInput(): cdktf.IResolvable | OceanRightSizingRuleRecommendationApplicationBoundaries[] | undefined;
    private _recommendationApplicationHpa;
    get recommendationApplicationHpa(): OceanRightSizingRuleRecommendationApplicationHpaList;
    putRecommendationApplicationHpa(value: OceanRightSizingRuleRecommendationApplicationHpa[] | cdktf.IResolvable): void;
    resetRecommendationApplicationHpa(): void;
    get recommendationApplicationHpaInput(): cdktf.IResolvable | OceanRightSizingRuleRecommendationApplicationHpa[] | undefined;
    private _recommendationApplicationIntervals;
    get recommendationApplicationIntervals(): OceanRightSizingRuleRecommendationApplicationIntervalsList;
    putRecommendationApplicationIntervals(value: OceanRightSizingRuleRecommendationApplicationIntervals[] | cdktf.IResolvable): void;
    get recommendationApplicationIntervalsInput(): cdktf.IResolvable | OceanRightSizingRuleRecommendationApplicationIntervals[] | undefined;
    private _recommendationApplicationMinThreshold;
    get recommendationApplicationMinThreshold(): OceanRightSizingRuleRecommendationApplicationMinThresholdList;
    putRecommendationApplicationMinThreshold(value: OceanRightSizingRuleRecommendationApplicationMinThreshold[] | cdktf.IResolvable): void;
    resetRecommendationApplicationMinThreshold(): void;
    get recommendationApplicationMinThresholdInput(): cdktf.IResolvable | OceanRightSizingRuleRecommendationApplicationMinThreshold[] | undefined;
    private _recommendationApplicationOverheadValues;
    get recommendationApplicationOverheadValues(): OceanRightSizingRuleRecommendationApplicationOverheadValuesList;
    putRecommendationApplicationOverheadValues(value: OceanRightSizingRuleRecommendationApplicationOverheadValues[] | cdktf.IResolvable): void;
    resetRecommendationApplicationOverheadValues(): void;
    get recommendationApplicationOverheadValuesInput(): cdktf.IResolvable | OceanRightSizingRuleRecommendationApplicationOverheadValues[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
