/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface OceancdStrategyConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_strategy#id OceancdStrategy#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_strategy#strategy_name OceancdStrategy#strategy_name}
    */
    readonly strategyName: string;
    /**
    * canary block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_strategy#canary OceancdStrategy#canary}
    */
    readonly canary?: OceancdStrategyCanary;
    /**
    * rolling block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_strategy#rolling OceancdStrategy#rolling}
    */
    readonly rolling?: OceancdStrategyRolling;
}
export interface OceancdStrategyCanaryBackgroundVerification {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_strategy#template_names OceancdStrategy#template_names}
    */
    readonly templateNames: string[];
}
export declare function oceancdStrategyCanaryBackgroundVerificationToTerraform(struct?: OceancdStrategyCanaryBackgroundVerificationOutputReference | OceancdStrategyCanaryBackgroundVerification): any;
export declare function oceancdStrategyCanaryBackgroundVerificationToHclTerraform(struct?: OceancdStrategyCanaryBackgroundVerificationOutputReference | OceancdStrategyCanaryBackgroundVerification): any;
export declare class OceancdStrategyCanaryBackgroundVerificationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceancdStrategyCanaryBackgroundVerification | undefined;
    set internalValue(value: OceancdStrategyCanaryBackgroundVerification | undefined);
    private _templateNames?;
    get templateNames(): string[];
    set templateNames(value: string[]);
    get templateNamesInput(): string[] | undefined;
}
export interface OceancdStrategyCanaryStepsPause {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_strategy#duration OceancdStrategy#duration}
    */
    readonly duration?: string;
}
export declare function oceancdStrategyCanaryStepsPauseToTerraform(struct?: OceancdStrategyCanaryStepsPauseOutputReference | OceancdStrategyCanaryStepsPause): any;
export declare function oceancdStrategyCanaryStepsPauseToHclTerraform(struct?: OceancdStrategyCanaryStepsPauseOutputReference | OceancdStrategyCanaryStepsPause): any;
export declare class OceancdStrategyCanaryStepsPauseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceancdStrategyCanaryStepsPause | undefined;
    set internalValue(value: OceancdStrategyCanaryStepsPause | undefined);
    private _duration?;
    get duration(): string;
    set duration(value: string);
    resetDuration(): void;
    get durationInput(): string | undefined;
}
export interface OceancdStrategyCanaryStepsSetCanaryScale {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_strategy#match_traffic_weight OceancdStrategy#match_traffic_weight}
    */
    readonly matchTrafficWeight?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_strategy#replicas OceancdStrategy#replicas}
    */
    readonly replicas?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_strategy#weight OceancdStrategy#weight}
    */
    readonly weight?: number;
}
export declare function oceancdStrategyCanaryStepsSetCanaryScaleToTerraform(struct?: OceancdStrategyCanaryStepsSetCanaryScaleOutputReference | OceancdStrategyCanaryStepsSetCanaryScale): any;
export declare function oceancdStrategyCanaryStepsSetCanaryScaleToHclTerraform(struct?: OceancdStrategyCanaryStepsSetCanaryScaleOutputReference | OceancdStrategyCanaryStepsSetCanaryScale): any;
export declare class OceancdStrategyCanaryStepsSetCanaryScaleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceancdStrategyCanaryStepsSetCanaryScale | undefined;
    set internalValue(value: OceancdStrategyCanaryStepsSetCanaryScale | undefined);
    private _matchTrafficWeight?;
    get matchTrafficWeight(): boolean | cdktf.IResolvable;
    set matchTrafficWeight(value: boolean | cdktf.IResolvable);
    resetMatchTrafficWeight(): void;
    get matchTrafficWeightInput(): boolean | cdktf.IResolvable | undefined;
    private _replicas?;
    get replicas(): number;
    set replicas(value: number);
    resetReplicas(): void;
    get replicasInput(): number | undefined;
    private _weight?;
    get weight(): number;
    set weight(value: number);
    resetWeight(): void;
    get weightInput(): number | undefined;
}
export interface OceancdStrategyCanaryStepsSetHeaderRouteMatchHeaderValue {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_strategy#exact OceancdStrategy#exact}
    */
    readonly exact?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_strategy#prefix OceancdStrategy#prefix}
    */
    readonly prefix?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_strategy#regex OceancdStrategy#regex}
    */
    readonly regex?: string;
}
export declare function oceancdStrategyCanaryStepsSetHeaderRouteMatchHeaderValueToTerraform(struct?: OceancdStrategyCanaryStepsSetHeaderRouteMatchHeaderValueOutputReference | OceancdStrategyCanaryStepsSetHeaderRouteMatchHeaderValue): any;
export declare function oceancdStrategyCanaryStepsSetHeaderRouteMatchHeaderValueToHclTerraform(struct?: OceancdStrategyCanaryStepsSetHeaderRouteMatchHeaderValueOutputReference | OceancdStrategyCanaryStepsSetHeaderRouteMatchHeaderValue): any;
export declare class OceancdStrategyCanaryStepsSetHeaderRouteMatchHeaderValueOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceancdStrategyCanaryStepsSetHeaderRouteMatchHeaderValue | undefined;
    set internalValue(value: OceancdStrategyCanaryStepsSetHeaderRouteMatchHeaderValue | undefined);
    private _exact?;
    get exact(): string;
    set exact(value: string);
    resetExact(): void;
    get exactInput(): string | undefined;
    private _prefix?;
    get prefix(): string;
    set prefix(value: string);
    resetPrefix(): void;
    get prefixInput(): string | undefined;
    private _regex?;
    get regex(): string;
    set regex(value: string);
    resetRegex(): void;
    get regexInput(): string | undefined;
}
export interface OceancdStrategyCanaryStepsSetHeaderRouteMatch {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_strategy#header_name OceancdStrategy#header_name}
    */
    readonly headerName: string;
    /**
    * header_value block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_strategy#header_value OceancdStrategy#header_value}
    */
    readonly headerValue: OceancdStrategyCanaryStepsSetHeaderRouteMatchHeaderValue;
}
export declare function oceancdStrategyCanaryStepsSetHeaderRouteMatchToTerraform(struct?: OceancdStrategyCanaryStepsSetHeaderRouteMatch | cdktf.IResolvable): any;
export declare function oceancdStrategyCanaryStepsSetHeaderRouteMatchToHclTerraform(struct?: OceancdStrategyCanaryStepsSetHeaderRouteMatch | cdktf.IResolvable): any;
export declare class OceancdStrategyCanaryStepsSetHeaderRouteMatchOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OceancdStrategyCanaryStepsSetHeaderRouteMatch | cdktf.IResolvable | undefined;
    set internalValue(value: OceancdStrategyCanaryStepsSetHeaderRouteMatch | cdktf.IResolvable | undefined);
    private _headerName?;
    get headerName(): string;
    set headerName(value: string);
    get headerNameInput(): string | undefined;
    private _headerValue;
    get headerValue(): OceancdStrategyCanaryStepsSetHeaderRouteMatchHeaderValueOutputReference;
    putHeaderValue(value: OceancdStrategyCanaryStepsSetHeaderRouteMatchHeaderValue): void;
    get headerValueInput(): OceancdStrategyCanaryStepsSetHeaderRouteMatchHeaderValue | undefined;
}
export declare class OceancdStrategyCanaryStepsSetHeaderRouteMatchList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OceancdStrategyCanaryStepsSetHeaderRouteMatch[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OceancdStrategyCanaryStepsSetHeaderRouteMatchOutputReference;
}
export interface OceancdStrategyCanaryStepsSetHeaderRoute {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_strategy#header_route_name OceancdStrategy#header_route_name}
    */
    readonly headerRouteName: string;
    /**
    * match block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_strategy#match OceancdStrategy#match}
    */
    readonly match: OceancdStrategyCanaryStepsSetHeaderRouteMatch[] | cdktf.IResolvable;
}
export declare function oceancdStrategyCanaryStepsSetHeaderRouteToTerraform(struct?: OceancdStrategyCanaryStepsSetHeaderRouteOutputReference | OceancdStrategyCanaryStepsSetHeaderRoute): any;
export declare function oceancdStrategyCanaryStepsSetHeaderRouteToHclTerraform(struct?: OceancdStrategyCanaryStepsSetHeaderRouteOutputReference | OceancdStrategyCanaryStepsSetHeaderRoute): any;
export declare class OceancdStrategyCanaryStepsSetHeaderRouteOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceancdStrategyCanaryStepsSetHeaderRoute | undefined;
    set internalValue(value: OceancdStrategyCanaryStepsSetHeaderRoute | undefined);
    private _headerRouteName?;
    get headerRouteName(): string;
    set headerRouteName(value: string);
    get headerRouteNameInput(): string | undefined;
    private _match;
    get match(): OceancdStrategyCanaryStepsSetHeaderRouteMatchList;
    putMatch(value: OceancdStrategyCanaryStepsSetHeaderRouteMatch[] | cdktf.IResolvable): void;
    get matchInput(): cdktf.IResolvable | OceancdStrategyCanaryStepsSetHeaderRouteMatch[] | undefined;
}
export interface OceancdStrategyCanaryStepsVerification {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_strategy#template_names OceancdStrategy#template_names}
    */
    readonly templateNames: string[];
}
export declare function oceancdStrategyCanaryStepsVerificationToTerraform(struct?: OceancdStrategyCanaryStepsVerificationOutputReference | OceancdStrategyCanaryStepsVerification): any;
export declare function oceancdStrategyCanaryStepsVerificationToHclTerraform(struct?: OceancdStrategyCanaryStepsVerificationOutputReference | OceancdStrategyCanaryStepsVerification): any;
export declare class OceancdStrategyCanaryStepsVerificationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceancdStrategyCanaryStepsVerification | undefined;
    set internalValue(value: OceancdStrategyCanaryStepsVerification | undefined);
    private _templateNames?;
    get templateNames(): string[];
    set templateNames(value: string[]);
    get templateNamesInput(): string[] | undefined;
}
export interface OceancdStrategyCanarySteps {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_strategy#set_weight OceancdStrategy#set_weight}
    */
    readonly setWeight?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_strategy#step_name OceancdStrategy#step_name}
    */
    readonly stepName?: string;
    /**
    * pause block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_strategy#pause OceancdStrategy#pause}
    */
    readonly pause?: OceancdStrategyCanaryStepsPause;
    /**
    * set_canary_scale block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_strategy#set_canary_scale OceancdStrategy#set_canary_scale}
    */
    readonly setCanaryScale?: OceancdStrategyCanaryStepsSetCanaryScale;
    /**
    * set_header_route block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_strategy#set_header_route OceancdStrategy#set_header_route}
    */
    readonly setHeaderRoute?: OceancdStrategyCanaryStepsSetHeaderRoute;
    /**
    * verification block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_strategy#verification OceancdStrategy#verification}
    */
    readonly verification?: OceancdStrategyCanaryStepsVerification;
}
export declare function oceancdStrategyCanaryStepsToTerraform(struct?: OceancdStrategyCanarySteps | cdktf.IResolvable): any;
export declare function oceancdStrategyCanaryStepsToHclTerraform(struct?: OceancdStrategyCanarySteps | cdktf.IResolvable): any;
export declare class OceancdStrategyCanaryStepsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OceancdStrategyCanarySteps | cdktf.IResolvable | undefined;
    set internalValue(value: OceancdStrategyCanarySteps | cdktf.IResolvable | undefined);
    private _setWeight?;
    get setWeight(): number;
    set setWeight(value: number);
    resetSetWeight(): void;
    get setWeightInput(): number | undefined;
    private _stepName?;
    get stepName(): string;
    set stepName(value: string);
    resetStepName(): void;
    get stepNameInput(): string | undefined;
    private _pause;
    get pause(): OceancdStrategyCanaryStepsPauseOutputReference;
    putPause(value: OceancdStrategyCanaryStepsPause): void;
    resetPause(): void;
    get pauseInput(): OceancdStrategyCanaryStepsPause | undefined;
    private _setCanaryScale;
    get setCanaryScale(): OceancdStrategyCanaryStepsSetCanaryScaleOutputReference;
    putSetCanaryScale(value: OceancdStrategyCanaryStepsSetCanaryScale): void;
    resetSetCanaryScale(): void;
    get setCanaryScaleInput(): OceancdStrategyCanaryStepsSetCanaryScale | undefined;
    private _setHeaderRoute;
    get setHeaderRoute(): OceancdStrategyCanaryStepsSetHeaderRouteOutputReference;
    putSetHeaderRoute(value: OceancdStrategyCanaryStepsSetHeaderRoute): void;
    resetSetHeaderRoute(): void;
    get setHeaderRouteInput(): OceancdStrategyCanaryStepsSetHeaderRoute | undefined;
    private _verification;
    get verification(): OceancdStrategyCanaryStepsVerificationOutputReference;
    putVerification(value: OceancdStrategyCanaryStepsVerification): void;
    resetVerification(): void;
    get verificationInput(): OceancdStrategyCanaryStepsVerification | undefined;
}
export declare class OceancdStrategyCanaryStepsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OceancdStrategyCanarySteps[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OceancdStrategyCanaryStepsOutputReference;
}
export interface OceancdStrategyCanary {
    /**
    * background_verification block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_strategy#background_verification OceancdStrategy#background_verification}
    */
    readonly backgroundVerification?: OceancdStrategyCanaryBackgroundVerification;
    /**
    * steps block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_strategy#steps OceancdStrategy#steps}
    */
    readonly steps: OceancdStrategyCanarySteps[] | cdktf.IResolvable;
}
export declare function oceancdStrategyCanaryToTerraform(struct?: OceancdStrategyCanaryOutputReference | OceancdStrategyCanary): any;
export declare function oceancdStrategyCanaryToHclTerraform(struct?: OceancdStrategyCanaryOutputReference | OceancdStrategyCanary): any;
export declare class OceancdStrategyCanaryOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceancdStrategyCanary | undefined;
    set internalValue(value: OceancdStrategyCanary | undefined);
    private _backgroundVerification;
    get backgroundVerification(): OceancdStrategyCanaryBackgroundVerificationOutputReference;
    putBackgroundVerification(value: OceancdStrategyCanaryBackgroundVerification): void;
    resetBackgroundVerification(): void;
    get backgroundVerificationInput(): OceancdStrategyCanaryBackgroundVerification | undefined;
    private _steps;
    get steps(): OceancdStrategyCanaryStepsList;
    putSteps(value: OceancdStrategyCanarySteps[] | cdktf.IResolvable): void;
    get stepsInput(): cdktf.IResolvable | OceancdStrategyCanarySteps[] | undefined;
}
export interface OceancdStrategyRollingStepsPause {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_strategy#duration OceancdStrategy#duration}
    */
    readonly duration?: string;
}
export declare function oceancdStrategyRollingStepsPauseToTerraform(struct?: OceancdStrategyRollingStepsPauseOutputReference | OceancdStrategyRollingStepsPause): any;
export declare function oceancdStrategyRollingStepsPauseToHclTerraform(struct?: OceancdStrategyRollingStepsPauseOutputReference | OceancdStrategyRollingStepsPause): any;
export declare class OceancdStrategyRollingStepsPauseOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceancdStrategyRollingStepsPause | undefined;
    set internalValue(value: OceancdStrategyRollingStepsPause | undefined);
    private _duration?;
    get duration(): string;
    set duration(value: string);
    resetDuration(): void;
    get durationInput(): string | undefined;
}
export interface OceancdStrategyRollingStepsVerification {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_strategy#template_names OceancdStrategy#template_names}
    */
    readonly templateNames: string[];
}
export declare function oceancdStrategyRollingStepsVerificationToTerraform(struct?: OceancdStrategyRollingStepsVerificationOutputReference | OceancdStrategyRollingStepsVerification): any;
export declare function oceancdStrategyRollingStepsVerificationToHclTerraform(struct?: OceancdStrategyRollingStepsVerificationOutputReference | OceancdStrategyRollingStepsVerification): any;
export declare class OceancdStrategyRollingStepsVerificationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceancdStrategyRollingStepsVerification | undefined;
    set internalValue(value: OceancdStrategyRollingStepsVerification | undefined);
    private _templateNames?;
    get templateNames(): string[];
    set templateNames(value: string[]);
    get templateNamesInput(): string[] | undefined;
}
export interface OceancdStrategyRollingSteps {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_strategy#steps_name OceancdStrategy#steps_name}
    */
    readonly stepsName?: string;
    /**
    * pause block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_strategy#pause OceancdStrategy#pause}
    */
    readonly pause?: OceancdStrategyRollingStepsPause;
    /**
    * verification block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_strategy#verification OceancdStrategy#verification}
    */
    readonly verification?: OceancdStrategyRollingStepsVerification;
}
export declare function oceancdStrategyRollingStepsToTerraform(struct?: OceancdStrategyRollingSteps | cdktf.IResolvable): any;
export declare function oceancdStrategyRollingStepsToHclTerraform(struct?: OceancdStrategyRollingSteps | cdktf.IResolvable): any;
export declare class OceancdStrategyRollingStepsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OceancdStrategyRollingSteps | cdktf.IResolvable | undefined;
    set internalValue(value: OceancdStrategyRollingSteps | cdktf.IResolvable | undefined);
    private _stepsName?;
    get stepsName(): string;
    set stepsName(value: string);
    resetStepsName(): void;
    get stepsNameInput(): string | undefined;
    private _pause;
    get pause(): OceancdStrategyRollingStepsPauseOutputReference;
    putPause(value: OceancdStrategyRollingStepsPause): void;
    resetPause(): void;
    get pauseInput(): OceancdStrategyRollingStepsPause | undefined;
    private _verification;
    get verification(): OceancdStrategyRollingStepsVerificationOutputReference;
    putVerification(value: OceancdStrategyRollingStepsVerification): void;
    resetVerification(): void;
    get verificationInput(): OceancdStrategyRollingStepsVerification | undefined;
}
export declare class OceancdStrategyRollingStepsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OceancdStrategyRollingSteps[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OceancdStrategyRollingStepsOutputReference;
}
export interface OceancdStrategyRolling {
    /**
    * steps block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_strategy#steps OceancdStrategy#steps}
    */
    readonly steps: OceancdStrategyRollingSteps[] | cdktf.IResolvable;
}
export declare function oceancdStrategyRollingToTerraform(struct?: OceancdStrategyRollingOutputReference | OceancdStrategyRolling): any;
export declare function oceancdStrategyRollingToHclTerraform(struct?: OceancdStrategyRollingOutputReference | OceancdStrategyRolling): any;
export declare class OceancdStrategyRollingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceancdStrategyRolling | undefined;
    set internalValue(value: OceancdStrategyRolling | undefined);
    private _steps;
    get steps(): OceancdStrategyRollingStepsList;
    putSteps(value: OceancdStrategyRollingSteps[] | cdktf.IResolvable): void;
    get stepsInput(): cdktf.IResolvable | OceancdStrategyRollingSteps[] | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_strategy spotinst_oceancd_strategy}
*/
export declare class OceancdStrategy extends cdktf.TerraformResource {
    static readonly tfResourceType = "spotinst_oceancd_strategy";
    /**
    * Generates CDKTF code for importing a OceancdStrategy resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the OceancdStrategy to import
    * @param importFromId The id of the existing OceancdStrategy that should be imported. Refer to the {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_strategy#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the OceancdStrategy to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_strategy spotinst_oceancd_strategy} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options OceancdStrategyConfig
    */
    constructor(scope: Construct, id: string, config: OceancdStrategyConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _strategyName?;
    get strategyName(): string;
    set strategyName(value: string);
    get strategyNameInput(): string | undefined;
    private _canary;
    get canary(): OceancdStrategyCanaryOutputReference;
    putCanary(value: OceancdStrategyCanary): void;
    resetCanary(): void;
    get canaryInput(): OceancdStrategyCanary | undefined;
    private _rolling;
    get rolling(): OceancdStrategyRollingOutputReference;
    putRolling(value: OceancdStrategyRolling): void;
    resetRolling(): void;
    get rollingInput(): OceancdStrategyRolling | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
