/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface OceancdVerificationTemplateConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#id OceancdVerificationTemplate#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#name OceancdVerificationTemplate#name}
    */
    readonly name: string;
    /**
    * args block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#args OceancdVerificationTemplate#args}
    */
    readonly args?: OceancdVerificationTemplateArgs[] | cdktf.IResolvable;
    /**
    * metrics block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#metrics OceancdVerificationTemplate#metrics}
    */
    readonly metrics?: OceancdVerificationTemplateMetrics[] | cdktf.IResolvable;
}
export interface OceancdVerificationTemplateArgsValueFromSecretKeyRef {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#key OceancdVerificationTemplate#key}
    */
    readonly key: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#name OceancdVerificationTemplate#name}
    */
    readonly name: string;
}
export declare function oceancdVerificationTemplateArgsValueFromSecretKeyRefToTerraform(struct?: OceancdVerificationTemplateArgsValueFromSecretKeyRefOutputReference | OceancdVerificationTemplateArgsValueFromSecretKeyRef): any;
export declare function oceancdVerificationTemplateArgsValueFromSecretKeyRefToHclTerraform(struct?: OceancdVerificationTemplateArgsValueFromSecretKeyRefOutputReference | OceancdVerificationTemplateArgsValueFromSecretKeyRef): any;
export declare class OceancdVerificationTemplateArgsValueFromSecretKeyRefOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceancdVerificationTemplateArgsValueFromSecretKeyRef | undefined;
    set internalValue(value: OceancdVerificationTemplateArgsValueFromSecretKeyRef | undefined);
    private _key?;
    get key(): string;
    set key(value: string);
    get keyInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
}
export interface OceancdVerificationTemplateArgsValueFrom {
    /**
    * secret_key_ref block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#secret_key_ref OceancdVerificationTemplate#secret_key_ref}
    */
    readonly secretKeyRef?: OceancdVerificationTemplateArgsValueFromSecretKeyRef;
}
export declare function oceancdVerificationTemplateArgsValueFromToTerraform(struct?: OceancdVerificationTemplateArgsValueFromOutputReference | OceancdVerificationTemplateArgsValueFrom): any;
export declare function oceancdVerificationTemplateArgsValueFromToHclTerraform(struct?: OceancdVerificationTemplateArgsValueFromOutputReference | OceancdVerificationTemplateArgsValueFrom): any;
export declare class OceancdVerificationTemplateArgsValueFromOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceancdVerificationTemplateArgsValueFrom | undefined;
    set internalValue(value: OceancdVerificationTemplateArgsValueFrom | undefined);
    private _secretKeyRef;
    get secretKeyRef(): OceancdVerificationTemplateArgsValueFromSecretKeyRefOutputReference;
    putSecretKeyRef(value: OceancdVerificationTemplateArgsValueFromSecretKeyRef): void;
    resetSecretKeyRef(): void;
    get secretKeyRefInput(): OceancdVerificationTemplateArgsValueFromSecretKeyRef | undefined;
}
export interface OceancdVerificationTemplateArgs {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#arg_name OceancdVerificationTemplate#arg_name}
    */
    readonly argName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#value OceancdVerificationTemplate#value}
    */
    readonly value?: string;
    /**
    * value_from block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#value_from OceancdVerificationTemplate#value_from}
    */
    readonly valueFrom?: OceancdVerificationTemplateArgsValueFrom;
}
export declare function oceancdVerificationTemplateArgsToTerraform(struct?: OceancdVerificationTemplateArgs | cdktf.IResolvable): any;
export declare function oceancdVerificationTemplateArgsToHclTerraform(struct?: OceancdVerificationTemplateArgs | cdktf.IResolvable): any;
export declare class OceancdVerificationTemplateArgsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OceancdVerificationTemplateArgs | cdktf.IResolvable | undefined;
    set internalValue(value: OceancdVerificationTemplateArgs | cdktf.IResolvable | undefined);
    private _argName?;
    get argName(): string;
    set argName(value: string);
    get argNameInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
    private _valueFrom;
    get valueFrom(): OceancdVerificationTemplateArgsValueFromOutputReference;
    putValueFrom(value: OceancdVerificationTemplateArgsValueFrom): void;
    resetValueFrom(): void;
    get valueFromInput(): OceancdVerificationTemplateArgsValueFrom | undefined;
}
export declare class OceancdVerificationTemplateArgsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OceancdVerificationTemplateArgs[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OceancdVerificationTemplateArgsOutputReference;
}
export interface OceancdVerificationTemplateMetricsBaselineBaselineProviderDatadog {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#datadog_query OceancdVerificationTemplate#datadog_query}
    */
    readonly datadogQuery: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#duration OceancdVerificationTemplate#duration}
    */
    readonly duration?: string;
}
export declare function oceancdVerificationTemplateMetricsBaselineBaselineProviderDatadogToTerraform(struct?: OceancdVerificationTemplateMetricsBaselineBaselineProviderDatadogOutputReference | OceancdVerificationTemplateMetricsBaselineBaselineProviderDatadog): any;
export declare function oceancdVerificationTemplateMetricsBaselineBaselineProviderDatadogToHclTerraform(struct?: OceancdVerificationTemplateMetricsBaselineBaselineProviderDatadogOutputReference | OceancdVerificationTemplateMetricsBaselineBaselineProviderDatadog): any;
export declare class OceancdVerificationTemplateMetricsBaselineBaselineProviderDatadogOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceancdVerificationTemplateMetricsBaselineBaselineProviderDatadog | undefined;
    set internalValue(value: OceancdVerificationTemplateMetricsBaselineBaselineProviderDatadog | undefined);
    private _datadogQuery?;
    get datadogQuery(): string;
    set datadogQuery(value: string);
    get datadogQueryInput(): string | undefined;
    private _duration?;
    get duration(): string;
    set duration(value: string);
    resetDuration(): void;
    get durationInput(): string | undefined;
}
export interface OceancdVerificationTemplateMetricsBaselineBaselineProviderNewRelic {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#new_relic_query OceancdVerificationTemplate#new_relic_query}
    */
    readonly newRelicQuery: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#profile OceancdVerificationTemplate#profile}
    */
    readonly profile?: string;
}
export declare function oceancdVerificationTemplateMetricsBaselineBaselineProviderNewRelicToTerraform(struct?: OceancdVerificationTemplateMetricsBaselineBaselineProviderNewRelicOutputReference | OceancdVerificationTemplateMetricsBaselineBaselineProviderNewRelic): any;
export declare function oceancdVerificationTemplateMetricsBaselineBaselineProviderNewRelicToHclTerraform(struct?: OceancdVerificationTemplateMetricsBaselineBaselineProviderNewRelicOutputReference | OceancdVerificationTemplateMetricsBaselineBaselineProviderNewRelic): any;
export declare class OceancdVerificationTemplateMetricsBaselineBaselineProviderNewRelicOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceancdVerificationTemplateMetricsBaselineBaselineProviderNewRelic | undefined;
    set internalValue(value: OceancdVerificationTemplateMetricsBaselineBaselineProviderNewRelic | undefined);
    private _newRelicQuery?;
    get newRelicQuery(): string;
    set newRelicQuery(value: string);
    get newRelicQueryInput(): string | undefined;
    private _profile?;
    get profile(): string;
    set profile(value: string);
    resetProfile(): void;
    get profileInput(): string | undefined;
}
export interface OceancdVerificationTemplateMetricsBaselineBaselineProviderPrometheus {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#prometheus_query OceancdVerificationTemplate#prometheus_query}
    */
    readonly prometheusQuery: string;
}
export declare function oceancdVerificationTemplateMetricsBaselineBaselineProviderPrometheusToTerraform(struct?: OceancdVerificationTemplateMetricsBaselineBaselineProviderPrometheusOutputReference | OceancdVerificationTemplateMetricsBaselineBaselineProviderPrometheus): any;
export declare function oceancdVerificationTemplateMetricsBaselineBaselineProviderPrometheusToHclTerraform(struct?: OceancdVerificationTemplateMetricsBaselineBaselineProviderPrometheusOutputReference | OceancdVerificationTemplateMetricsBaselineBaselineProviderPrometheus): any;
export declare class OceancdVerificationTemplateMetricsBaselineBaselineProviderPrometheusOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceancdVerificationTemplateMetricsBaselineBaselineProviderPrometheus | undefined;
    set internalValue(value: OceancdVerificationTemplateMetricsBaselineBaselineProviderPrometheus | undefined);
    private _prometheusQuery?;
    get prometheusQuery(): string;
    set prometheusQuery(value: string);
    get prometheusQueryInput(): string | undefined;
}
export interface OceancdVerificationTemplateMetricsBaselineBaselineProvider {
    /**
    * datadog block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#datadog OceancdVerificationTemplate#datadog}
    */
    readonly datadog?: OceancdVerificationTemplateMetricsBaselineBaselineProviderDatadog;
    /**
    * new_relic block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#new_relic OceancdVerificationTemplate#new_relic}
    */
    readonly newRelic?: OceancdVerificationTemplateMetricsBaselineBaselineProviderNewRelic;
    /**
    * prometheus block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#prometheus OceancdVerificationTemplate#prometheus}
    */
    readonly prometheus?: OceancdVerificationTemplateMetricsBaselineBaselineProviderPrometheus;
}
export declare function oceancdVerificationTemplateMetricsBaselineBaselineProviderToTerraform(struct?: OceancdVerificationTemplateMetricsBaselineBaselineProvider | cdktf.IResolvable): any;
export declare function oceancdVerificationTemplateMetricsBaselineBaselineProviderToHclTerraform(struct?: OceancdVerificationTemplateMetricsBaselineBaselineProvider | cdktf.IResolvable): any;
export declare class OceancdVerificationTemplateMetricsBaselineBaselineProviderOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OceancdVerificationTemplateMetricsBaselineBaselineProvider | cdktf.IResolvable | undefined;
    set internalValue(value: OceancdVerificationTemplateMetricsBaselineBaselineProvider | cdktf.IResolvable | undefined);
    private _datadog;
    get datadog(): OceancdVerificationTemplateMetricsBaselineBaselineProviderDatadogOutputReference;
    putDatadog(value: OceancdVerificationTemplateMetricsBaselineBaselineProviderDatadog): void;
    resetDatadog(): void;
    get datadogInput(): OceancdVerificationTemplateMetricsBaselineBaselineProviderDatadog | undefined;
    private _newRelic;
    get newRelic(): OceancdVerificationTemplateMetricsBaselineBaselineProviderNewRelicOutputReference;
    putNewRelic(value: OceancdVerificationTemplateMetricsBaselineBaselineProviderNewRelic): void;
    resetNewRelic(): void;
    get newRelicInput(): OceancdVerificationTemplateMetricsBaselineBaselineProviderNewRelic | undefined;
    private _prometheus;
    get prometheus(): OceancdVerificationTemplateMetricsBaselineBaselineProviderPrometheusOutputReference;
    putPrometheus(value: OceancdVerificationTemplateMetricsBaselineBaselineProviderPrometheus): void;
    resetPrometheus(): void;
    get prometheusInput(): OceancdVerificationTemplateMetricsBaselineBaselineProviderPrometheus | undefined;
}
export declare class OceancdVerificationTemplateMetricsBaselineBaselineProviderList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OceancdVerificationTemplateMetricsBaselineBaselineProvider[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OceancdVerificationTemplateMetricsBaselineBaselineProviderOutputReference;
}
export interface OceancdVerificationTemplateMetricsBaseline {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#max_range OceancdVerificationTemplate#max_range}
    */
    readonly maxRange?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#min_range OceancdVerificationTemplate#min_range}
    */
    readonly minRange?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#threshold OceancdVerificationTemplate#threshold}
    */
    readonly threshold: string;
    /**
    * baseline_provider block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#baseline_provider OceancdVerificationTemplate#baseline_provider}
    */
    readonly baselineProvider: OceancdVerificationTemplateMetricsBaselineBaselineProvider[] | cdktf.IResolvable;
}
export declare function oceancdVerificationTemplateMetricsBaselineToTerraform(struct?: OceancdVerificationTemplateMetricsBaselineOutputReference | OceancdVerificationTemplateMetricsBaseline): any;
export declare function oceancdVerificationTemplateMetricsBaselineToHclTerraform(struct?: OceancdVerificationTemplateMetricsBaselineOutputReference | OceancdVerificationTemplateMetricsBaseline): any;
export declare class OceancdVerificationTemplateMetricsBaselineOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceancdVerificationTemplateMetricsBaseline | undefined;
    set internalValue(value: OceancdVerificationTemplateMetricsBaseline | undefined);
    private _maxRange?;
    get maxRange(): number;
    set maxRange(value: number);
    resetMaxRange(): void;
    get maxRangeInput(): number | undefined;
    private _minRange?;
    get minRange(): number;
    set minRange(value: number);
    resetMinRange(): void;
    get minRangeInput(): number | undefined;
    private _threshold?;
    get threshold(): string;
    set threshold(value: string);
    get thresholdInput(): string | undefined;
    private _baselineProvider;
    get baselineProvider(): OceancdVerificationTemplateMetricsBaselineBaselineProviderList;
    putBaselineProvider(value: OceancdVerificationTemplateMetricsBaselineBaselineProvider[] | cdktf.IResolvable): void;
    get baselineProviderInput(): cdktf.IResolvable | OceancdVerificationTemplateMetricsBaselineBaselineProvider[] | undefined;
}
export interface OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesMetricStatMetricDimensions {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#dimension_name OceancdVerificationTemplate#dimension_name}
    */
    readonly dimensionName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#dimension_value OceancdVerificationTemplate#dimension_value}
    */
    readonly dimensionValue: string;
}
export declare function oceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesMetricStatMetricDimensionsToTerraform(struct?: OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesMetricStatMetricDimensions | cdktf.IResolvable): any;
export declare function oceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesMetricStatMetricDimensionsToHclTerraform(struct?: OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesMetricStatMetricDimensions | cdktf.IResolvable): any;
export declare class OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesMetricStatMetricDimensionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesMetricStatMetricDimensions | cdktf.IResolvable | undefined;
    set internalValue(value: OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesMetricStatMetricDimensions | cdktf.IResolvable | undefined);
    private _dimensionName?;
    get dimensionName(): string;
    set dimensionName(value: string);
    get dimensionNameInput(): string | undefined;
    private _dimensionValue?;
    get dimensionValue(): string;
    set dimensionValue(value: string);
    get dimensionValueInput(): string | undefined;
}
export declare class OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesMetricStatMetricDimensionsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesMetricStatMetricDimensions[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesMetricStatMetricDimensionsOutputReference;
}
export interface OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesMetricStatMetric {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#metric_name OceancdVerificationTemplate#metric_name}
    */
    readonly metricName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#namespace OceancdVerificationTemplate#namespace}
    */
    readonly namespace?: string;
    /**
    * dimensions block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#dimensions OceancdVerificationTemplate#dimensions}
    */
    readonly dimensions?: OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesMetricStatMetricDimensions[] | cdktf.IResolvable;
}
export declare function oceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesMetricStatMetricToTerraform(struct?: OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesMetricStatMetricOutputReference | OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesMetricStatMetric): any;
export declare function oceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesMetricStatMetricToHclTerraform(struct?: OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesMetricStatMetricOutputReference | OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesMetricStatMetric): any;
export declare class OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesMetricStatMetricOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesMetricStatMetric | undefined;
    set internalValue(value: OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesMetricStatMetric | undefined);
    private _metricName?;
    get metricName(): string;
    set metricName(value: string);
    get metricNameInput(): string | undefined;
    private _namespace?;
    get namespace(): string;
    set namespace(value: string);
    resetNamespace(): void;
    get namespaceInput(): string | undefined;
    private _dimensions;
    get dimensions(): OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesMetricStatMetricDimensionsList;
    putDimensions(value: OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesMetricStatMetricDimensions[] | cdktf.IResolvable): void;
    resetDimensions(): void;
    get dimensionsInput(): cdktf.IResolvable | OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesMetricStatMetricDimensions[] | undefined;
}
export interface OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesMetricStat {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#metric_period OceancdVerificationTemplate#metric_period}
    */
    readonly metricPeriod?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#stat OceancdVerificationTemplate#stat}
    */
    readonly stat?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#unit OceancdVerificationTemplate#unit}
    */
    readonly unit?: string;
    /**
    * metric block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#metric OceancdVerificationTemplate#metric}
    */
    readonly metric?: OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesMetricStatMetric;
}
export declare function oceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesMetricStatToTerraform(struct?: OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesMetricStatOutputReference | OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesMetricStat): any;
export declare function oceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesMetricStatToHclTerraform(struct?: OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesMetricStatOutputReference | OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesMetricStat): any;
export declare class OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesMetricStatOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesMetricStat | undefined;
    set internalValue(value: OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesMetricStat | undefined);
    private _metricPeriod?;
    get metricPeriod(): number;
    set metricPeriod(value: number);
    resetMetricPeriod(): void;
    get metricPeriodInput(): number | undefined;
    private _stat?;
    get stat(): string;
    set stat(value: string);
    resetStat(): void;
    get statInput(): string | undefined;
    private _unit?;
    get unit(): string;
    set unit(value: string);
    resetUnit(): void;
    get unitInput(): string | undefined;
    private _metric;
    get metric(): OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesMetricStatMetricOutputReference;
    putMetric(value: OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesMetricStatMetric): void;
    resetMetric(): void;
    get metricInput(): OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesMetricStatMetric | undefined;
}
export interface OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueries {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#expression OceancdVerificationTemplate#expression}
    */
    readonly expression?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#id OceancdVerificationTemplate#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#label OceancdVerificationTemplate#label}
    */
    readonly label?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#period OceancdVerificationTemplate#period}
    */
    readonly period?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#return_data OceancdVerificationTemplate#return_data}
    */
    readonly returnData?: boolean | cdktf.IResolvable;
    /**
    * metric_stat block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#metric_stat OceancdVerificationTemplate#metric_stat}
    */
    readonly metricStat?: OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesMetricStat;
}
export declare function oceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesToTerraform(struct?: OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueries | cdktf.IResolvable): any;
export declare function oceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesToHclTerraform(struct?: OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueries | cdktf.IResolvable): any;
export declare class OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueries | cdktf.IResolvable | undefined;
    set internalValue(value: OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueries | cdktf.IResolvable | undefined);
    private _expression?;
    get expression(): string;
    set expression(value: string);
    resetExpression(): void;
    get expressionInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    get idInput(): string | undefined;
    private _label?;
    get label(): string;
    set label(value: string);
    resetLabel(): void;
    get labelInput(): string | undefined;
    private _period?;
    get period(): number;
    set period(value: number);
    resetPeriod(): void;
    get periodInput(): number | undefined;
    private _returnData?;
    get returnData(): boolean | cdktf.IResolvable;
    set returnData(value: boolean | cdktf.IResolvable);
    resetReturnData(): void;
    get returnDataInput(): boolean | cdktf.IResolvable | undefined;
    private _metricStat;
    get metricStat(): OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesMetricStatOutputReference;
    putMetricStat(value: OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesMetricStat): void;
    resetMetricStat(): void;
    get metricStatInput(): OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesMetricStat | undefined;
}
export declare class OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueries[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesOutputReference;
}
export interface OceancdVerificationTemplateMetricsProviderCloudWatch {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#duration OceancdVerificationTemplate#duration}
    */
    readonly duration?: string;
    /**
    * metric_data_queries block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#metric_data_queries OceancdVerificationTemplate#metric_data_queries}
    */
    readonly metricDataQueries: OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueries[] | cdktf.IResolvable;
}
export declare function oceancdVerificationTemplateMetricsProviderCloudWatchToTerraform(struct?: OceancdVerificationTemplateMetricsProviderCloudWatchOutputReference | OceancdVerificationTemplateMetricsProviderCloudWatch): any;
export declare function oceancdVerificationTemplateMetricsProviderCloudWatchToHclTerraform(struct?: OceancdVerificationTemplateMetricsProviderCloudWatchOutputReference | OceancdVerificationTemplateMetricsProviderCloudWatch): any;
export declare class OceancdVerificationTemplateMetricsProviderCloudWatchOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceancdVerificationTemplateMetricsProviderCloudWatch | undefined;
    set internalValue(value: OceancdVerificationTemplateMetricsProviderCloudWatch | undefined);
    private _duration?;
    get duration(): string;
    set duration(value: string);
    resetDuration(): void;
    get durationInput(): string | undefined;
    private _metricDataQueries;
    get metricDataQueries(): OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueriesList;
    putMetricDataQueries(value: OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueries[] | cdktf.IResolvable): void;
    get metricDataQueriesInput(): cdktf.IResolvable | OceancdVerificationTemplateMetricsProviderCloudWatchMetricDataQueries[] | undefined;
}
export interface OceancdVerificationTemplateMetricsProviderDatadog {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#datadog_query OceancdVerificationTemplate#datadog_query}
    */
    readonly datadogQuery?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#duration OceancdVerificationTemplate#duration}
    */
    readonly duration?: string;
}
export declare function oceancdVerificationTemplateMetricsProviderDatadogToTerraform(struct?: OceancdVerificationTemplateMetricsProviderDatadogOutputReference | OceancdVerificationTemplateMetricsProviderDatadog): any;
export declare function oceancdVerificationTemplateMetricsProviderDatadogToHclTerraform(struct?: OceancdVerificationTemplateMetricsProviderDatadogOutputReference | OceancdVerificationTemplateMetricsProviderDatadog): any;
export declare class OceancdVerificationTemplateMetricsProviderDatadogOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceancdVerificationTemplateMetricsProviderDatadog | undefined;
    set internalValue(value: OceancdVerificationTemplateMetricsProviderDatadog | undefined);
    private _datadogQuery?;
    get datadogQuery(): string;
    set datadogQuery(value: string);
    resetDatadogQuery(): void;
    get datadogQueryInput(): string | undefined;
    private _duration?;
    get duration(): string;
    set duration(value: string);
    resetDuration(): void;
    get durationInput(): string | undefined;
}
export interface OceancdVerificationTemplateMetricsProviderJenkinsJenkinsParameters {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#parameter_key OceancdVerificationTemplate#parameter_key}
    */
    readonly parameterKey: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#parameter_value OceancdVerificationTemplate#parameter_value}
    */
    readonly parameterValue: string;
}
export declare function oceancdVerificationTemplateMetricsProviderJenkinsJenkinsParametersToTerraform(struct?: OceancdVerificationTemplateMetricsProviderJenkinsJenkinsParametersOutputReference | OceancdVerificationTemplateMetricsProviderJenkinsJenkinsParameters): any;
export declare function oceancdVerificationTemplateMetricsProviderJenkinsJenkinsParametersToHclTerraform(struct?: OceancdVerificationTemplateMetricsProviderJenkinsJenkinsParametersOutputReference | OceancdVerificationTemplateMetricsProviderJenkinsJenkinsParameters): any;
export declare class OceancdVerificationTemplateMetricsProviderJenkinsJenkinsParametersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceancdVerificationTemplateMetricsProviderJenkinsJenkinsParameters | undefined;
    set internalValue(value: OceancdVerificationTemplateMetricsProviderJenkinsJenkinsParameters | undefined);
    private _parameterKey?;
    get parameterKey(): string;
    set parameterKey(value: string);
    get parameterKeyInput(): string | undefined;
    private _parameterValue?;
    get parameterValue(): string;
    set parameterValue(value: string);
    get parameterValueInput(): string | undefined;
}
export interface OceancdVerificationTemplateMetricsProviderJenkins {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#jenkins_interval OceancdVerificationTemplate#jenkins_interval}
    */
    readonly jenkinsInterval: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#pipeline_name OceancdVerificationTemplate#pipeline_name}
    */
    readonly pipelineName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#timeout OceancdVerificationTemplate#timeout}
    */
    readonly timeout: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#tls_verification OceancdVerificationTemplate#tls_verification}
    */
    readonly tlsVerification?: boolean | cdktf.IResolvable;
    /**
    * jenkins_parameters block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#jenkins_parameters OceancdVerificationTemplate#jenkins_parameters}
    */
    readonly jenkinsParameters?: OceancdVerificationTemplateMetricsProviderJenkinsJenkinsParameters;
}
export declare function oceancdVerificationTemplateMetricsProviderJenkinsToTerraform(struct?: OceancdVerificationTemplateMetricsProviderJenkinsOutputReference | OceancdVerificationTemplateMetricsProviderJenkins): any;
export declare function oceancdVerificationTemplateMetricsProviderJenkinsToHclTerraform(struct?: OceancdVerificationTemplateMetricsProviderJenkinsOutputReference | OceancdVerificationTemplateMetricsProviderJenkins): any;
export declare class OceancdVerificationTemplateMetricsProviderJenkinsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceancdVerificationTemplateMetricsProviderJenkins | undefined;
    set internalValue(value: OceancdVerificationTemplateMetricsProviderJenkins | undefined);
    private _jenkinsInterval?;
    get jenkinsInterval(): string;
    set jenkinsInterval(value: string);
    get jenkinsIntervalInput(): string | undefined;
    private _pipelineName?;
    get pipelineName(): string;
    set pipelineName(value: string);
    get pipelineNameInput(): string | undefined;
    private _timeout?;
    get timeout(): string;
    set timeout(value: string);
    get timeoutInput(): string | undefined;
    private _tlsVerification?;
    get tlsVerification(): boolean | cdktf.IResolvable;
    set tlsVerification(value: boolean | cdktf.IResolvable);
    resetTlsVerification(): void;
    get tlsVerificationInput(): boolean | cdktf.IResolvable | undefined;
    private _jenkinsParameters;
    get jenkinsParameters(): OceancdVerificationTemplateMetricsProviderJenkinsJenkinsParametersOutputReference;
    putJenkinsParameters(value: OceancdVerificationTemplateMetricsProviderJenkinsJenkinsParameters): void;
    resetJenkinsParameters(): void;
    get jenkinsParametersInput(): OceancdVerificationTemplateMetricsProviderJenkinsJenkinsParameters | undefined;
}
export interface OceancdVerificationTemplateMetricsProviderJobSpecJobTemplateTemplateSpecContainers {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#command OceancdVerificationTemplate#command}
    */
    readonly command: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#container_name OceancdVerificationTemplate#container_name}
    */
    readonly containerName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#image OceancdVerificationTemplate#image}
    */
    readonly image: string;
}
export declare function oceancdVerificationTemplateMetricsProviderJobSpecJobTemplateTemplateSpecContainersToTerraform(struct?: OceancdVerificationTemplateMetricsProviderJobSpecJobTemplateTemplateSpecContainers | cdktf.IResolvable): any;
export declare function oceancdVerificationTemplateMetricsProviderJobSpecJobTemplateTemplateSpecContainersToHclTerraform(struct?: OceancdVerificationTemplateMetricsProviderJobSpecJobTemplateTemplateSpecContainers | cdktf.IResolvable): any;
export declare class OceancdVerificationTemplateMetricsProviderJobSpecJobTemplateTemplateSpecContainersOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OceancdVerificationTemplateMetricsProviderJobSpecJobTemplateTemplateSpecContainers | cdktf.IResolvable | undefined;
    set internalValue(value: OceancdVerificationTemplateMetricsProviderJobSpecJobTemplateTemplateSpecContainers | cdktf.IResolvable | undefined);
    private _command?;
    get command(): string[];
    set command(value: string[]);
    get commandInput(): string[] | undefined;
    private _containerName?;
    get containerName(): string;
    set containerName(value: string);
    get containerNameInput(): string | undefined;
    private _image?;
    get image(): string;
    set image(value: string);
    get imageInput(): string | undefined;
}
export declare class OceancdVerificationTemplateMetricsProviderJobSpecJobTemplateTemplateSpecContainersList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OceancdVerificationTemplateMetricsProviderJobSpecJobTemplateTemplateSpecContainers[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OceancdVerificationTemplateMetricsProviderJobSpecJobTemplateTemplateSpecContainersOutputReference;
}
export interface OceancdVerificationTemplateMetricsProviderJobSpecJobTemplateTemplateSpec {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#restart_policy OceancdVerificationTemplate#restart_policy}
    */
    readonly restartPolicy: string;
    /**
    * containers block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#containers OceancdVerificationTemplate#containers}
    */
    readonly containers: OceancdVerificationTemplateMetricsProviderJobSpecJobTemplateTemplateSpecContainers[] | cdktf.IResolvable;
}
export declare function oceancdVerificationTemplateMetricsProviderJobSpecJobTemplateTemplateSpecToTerraform(struct?: OceancdVerificationTemplateMetricsProviderJobSpecJobTemplateTemplateSpec | cdktf.IResolvable): any;
export declare function oceancdVerificationTemplateMetricsProviderJobSpecJobTemplateTemplateSpecToHclTerraform(struct?: OceancdVerificationTemplateMetricsProviderJobSpecJobTemplateTemplateSpec | cdktf.IResolvable): any;
export declare class OceancdVerificationTemplateMetricsProviderJobSpecJobTemplateTemplateSpecOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OceancdVerificationTemplateMetricsProviderJobSpecJobTemplateTemplateSpec | cdktf.IResolvable | undefined;
    set internalValue(value: OceancdVerificationTemplateMetricsProviderJobSpecJobTemplateTemplateSpec | cdktf.IResolvable | undefined);
    private _restartPolicy?;
    get restartPolicy(): string;
    set restartPolicy(value: string);
    get restartPolicyInput(): string | undefined;
    private _containers;
    get containers(): OceancdVerificationTemplateMetricsProviderJobSpecJobTemplateTemplateSpecContainersList;
    putContainers(value: OceancdVerificationTemplateMetricsProviderJobSpecJobTemplateTemplateSpecContainers[] | cdktf.IResolvable): void;
    get containersInput(): cdktf.IResolvable | OceancdVerificationTemplateMetricsProviderJobSpecJobTemplateTemplateSpecContainers[] | undefined;
}
export declare class OceancdVerificationTemplateMetricsProviderJobSpecJobTemplateTemplateSpecList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OceancdVerificationTemplateMetricsProviderJobSpecJobTemplateTemplateSpec[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OceancdVerificationTemplateMetricsProviderJobSpecJobTemplateTemplateSpecOutputReference;
}
export interface OceancdVerificationTemplateMetricsProviderJobSpecJobTemplate {
    /**
    * template_spec block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#template_spec OceancdVerificationTemplate#template_spec}
    */
    readonly templateSpec: OceancdVerificationTemplateMetricsProviderJobSpecJobTemplateTemplateSpec[] | cdktf.IResolvable;
}
export declare function oceancdVerificationTemplateMetricsProviderJobSpecJobTemplateToTerraform(struct?: OceancdVerificationTemplateMetricsProviderJobSpecJobTemplate | cdktf.IResolvable): any;
export declare function oceancdVerificationTemplateMetricsProviderJobSpecJobTemplateToHclTerraform(struct?: OceancdVerificationTemplateMetricsProviderJobSpecJobTemplate | cdktf.IResolvable): any;
export declare class OceancdVerificationTemplateMetricsProviderJobSpecJobTemplateOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OceancdVerificationTemplateMetricsProviderJobSpecJobTemplate | cdktf.IResolvable | undefined;
    set internalValue(value: OceancdVerificationTemplateMetricsProviderJobSpecJobTemplate | cdktf.IResolvable | undefined);
    private _templateSpec;
    get templateSpec(): OceancdVerificationTemplateMetricsProviderJobSpecJobTemplateTemplateSpecList;
    putTemplateSpec(value: OceancdVerificationTemplateMetricsProviderJobSpecJobTemplateTemplateSpec[] | cdktf.IResolvable): void;
    get templateSpecInput(): cdktf.IResolvable | OceancdVerificationTemplateMetricsProviderJobSpecJobTemplateTemplateSpec[] | undefined;
}
export declare class OceancdVerificationTemplateMetricsProviderJobSpecJobTemplateList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OceancdVerificationTemplateMetricsProviderJobSpecJobTemplate[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OceancdVerificationTemplateMetricsProviderJobSpecJobTemplateOutputReference;
}
export interface OceancdVerificationTemplateMetricsProviderJobSpec {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#backoff_limit OceancdVerificationTemplate#backoff_limit}
    */
    readonly backoffLimit?: number;
    /**
    * job_template block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#job_template OceancdVerificationTemplate#job_template}
    */
    readonly jobTemplate: OceancdVerificationTemplateMetricsProviderJobSpecJobTemplate[] | cdktf.IResolvable;
}
export declare function oceancdVerificationTemplateMetricsProviderJobSpecToTerraform(struct?: OceancdVerificationTemplateMetricsProviderJobSpec | cdktf.IResolvable): any;
export declare function oceancdVerificationTemplateMetricsProviderJobSpecToHclTerraform(struct?: OceancdVerificationTemplateMetricsProviderJobSpec | cdktf.IResolvable): any;
export declare class OceancdVerificationTemplateMetricsProviderJobSpecOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OceancdVerificationTemplateMetricsProviderJobSpec | cdktf.IResolvable | undefined;
    set internalValue(value: OceancdVerificationTemplateMetricsProviderJobSpec | cdktf.IResolvable | undefined);
    private _backoffLimit?;
    get backoffLimit(): number;
    set backoffLimit(value: number);
    resetBackoffLimit(): void;
    get backoffLimitInput(): number | undefined;
    private _jobTemplate;
    get jobTemplate(): OceancdVerificationTemplateMetricsProviderJobSpecJobTemplateList;
    putJobTemplate(value: OceancdVerificationTemplateMetricsProviderJobSpecJobTemplate[] | cdktf.IResolvable): void;
    get jobTemplateInput(): cdktf.IResolvable | OceancdVerificationTemplateMetricsProviderJobSpecJobTemplate[] | undefined;
}
export declare class OceancdVerificationTemplateMetricsProviderJobSpecList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OceancdVerificationTemplateMetricsProviderJobSpec[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OceancdVerificationTemplateMetricsProviderJobSpecOutputReference;
}
export interface OceancdVerificationTemplateMetricsProviderJob {
    /**
    * spec block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#spec OceancdVerificationTemplate#spec}
    */
    readonly spec: OceancdVerificationTemplateMetricsProviderJobSpec[] | cdktf.IResolvable;
}
export declare function oceancdVerificationTemplateMetricsProviderJobToTerraform(struct?: OceancdVerificationTemplateMetricsProviderJobOutputReference | OceancdVerificationTemplateMetricsProviderJob): any;
export declare function oceancdVerificationTemplateMetricsProviderJobToHclTerraform(struct?: OceancdVerificationTemplateMetricsProviderJobOutputReference | OceancdVerificationTemplateMetricsProviderJob): any;
export declare class OceancdVerificationTemplateMetricsProviderJobOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceancdVerificationTemplateMetricsProviderJob | undefined;
    set internalValue(value: OceancdVerificationTemplateMetricsProviderJob | undefined);
    private _spec;
    get spec(): OceancdVerificationTemplateMetricsProviderJobSpecList;
    putSpec(value: OceancdVerificationTemplateMetricsProviderJobSpec[] | cdktf.IResolvable): void;
    get specInput(): cdktf.IResolvable | OceancdVerificationTemplateMetricsProviderJobSpec[] | undefined;
}
export interface OceancdVerificationTemplateMetricsProviderNewRelic {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#new_relic_query OceancdVerificationTemplate#new_relic_query}
    */
    readonly newRelicQuery: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#profile OceancdVerificationTemplate#profile}
    */
    readonly profile?: string;
}
export declare function oceancdVerificationTemplateMetricsProviderNewRelicToTerraform(struct?: OceancdVerificationTemplateMetricsProviderNewRelicOutputReference | OceancdVerificationTemplateMetricsProviderNewRelic): any;
export declare function oceancdVerificationTemplateMetricsProviderNewRelicToHclTerraform(struct?: OceancdVerificationTemplateMetricsProviderNewRelicOutputReference | OceancdVerificationTemplateMetricsProviderNewRelic): any;
export declare class OceancdVerificationTemplateMetricsProviderNewRelicOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceancdVerificationTemplateMetricsProviderNewRelic | undefined;
    set internalValue(value: OceancdVerificationTemplateMetricsProviderNewRelic | undefined);
    private _newRelicQuery?;
    get newRelicQuery(): string;
    set newRelicQuery(value: string);
    get newRelicQueryInput(): string | undefined;
    private _profile?;
    get profile(): string;
    set profile(value: string);
    resetProfile(): void;
    get profileInput(): string | undefined;
}
export interface OceancdVerificationTemplateMetricsProviderPrometheus {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#prometheus_query OceancdVerificationTemplate#prometheus_query}
    */
    readonly prometheusQuery: string;
}
export declare function oceancdVerificationTemplateMetricsProviderPrometheusToTerraform(struct?: OceancdVerificationTemplateMetricsProviderPrometheusOutputReference | OceancdVerificationTemplateMetricsProviderPrometheus): any;
export declare function oceancdVerificationTemplateMetricsProviderPrometheusToHclTerraform(struct?: OceancdVerificationTemplateMetricsProviderPrometheusOutputReference | OceancdVerificationTemplateMetricsProviderPrometheus): any;
export declare class OceancdVerificationTemplateMetricsProviderPrometheusOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceancdVerificationTemplateMetricsProviderPrometheus | undefined;
    set internalValue(value: OceancdVerificationTemplateMetricsProviderPrometheus | undefined);
    private _prometheusQuery?;
    get prometheusQuery(): string;
    set prometheusQuery(value: string);
    get prometheusQueryInput(): string | undefined;
}
export interface OceancdVerificationTemplateMetricsProviderWebWebHeader {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#web_header_key OceancdVerificationTemplate#web_header_key}
    */
    readonly webHeaderKey: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#web_header_value OceancdVerificationTemplate#web_header_value}
    */
    readonly webHeaderValue: string;
}
export declare function oceancdVerificationTemplateMetricsProviderWebWebHeaderToTerraform(struct?: OceancdVerificationTemplateMetricsProviderWebWebHeader | cdktf.IResolvable): any;
export declare function oceancdVerificationTemplateMetricsProviderWebWebHeaderToHclTerraform(struct?: OceancdVerificationTemplateMetricsProviderWebWebHeader | cdktf.IResolvable): any;
export declare class OceancdVerificationTemplateMetricsProviderWebWebHeaderOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OceancdVerificationTemplateMetricsProviderWebWebHeader | cdktf.IResolvable | undefined;
    set internalValue(value: OceancdVerificationTemplateMetricsProviderWebWebHeader | cdktf.IResolvable | undefined);
    private _webHeaderKey?;
    get webHeaderKey(): string;
    set webHeaderKey(value: string);
    get webHeaderKeyInput(): string | undefined;
    private _webHeaderValue?;
    get webHeaderValue(): string;
    set webHeaderValue(value: string);
    get webHeaderValueInput(): string | undefined;
}
export declare class OceancdVerificationTemplateMetricsProviderWebWebHeaderList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OceancdVerificationTemplateMetricsProviderWebWebHeader[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OceancdVerificationTemplateMetricsProviderWebWebHeaderOutputReference;
}
export interface OceancdVerificationTemplateMetricsProviderWeb {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#body OceancdVerificationTemplate#body}
    */
    readonly body?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#insecure OceancdVerificationTemplate#insecure}
    */
    readonly insecure?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#json_path OceancdVerificationTemplate#json_path}
    */
    readonly jsonPath?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#method OceancdVerificationTemplate#method}
    */
    readonly method?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#timeout_seconds OceancdVerificationTemplate#timeout_seconds}
    */
    readonly timeoutSeconds?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#url OceancdVerificationTemplate#url}
    */
    readonly url: string;
    /**
    * web_header block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#web_header OceancdVerificationTemplate#web_header}
    */
    readonly webHeader?: OceancdVerificationTemplateMetricsProviderWebWebHeader[] | cdktf.IResolvable;
}
export declare function oceancdVerificationTemplateMetricsProviderWebToTerraform(struct?: OceancdVerificationTemplateMetricsProviderWebOutputReference | OceancdVerificationTemplateMetricsProviderWeb): any;
export declare function oceancdVerificationTemplateMetricsProviderWebToHclTerraform(struct?: OceancdVerificationTemplateMetricsProviderWebOutputReference | OceancdVerificationTemplateMetricsProviderWeb): any;
export declare class OceancdVerificationTemplateMetricsProviderWebOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): OceancdVerificationTemplateMetricsProviderWeb | undefined;
    set internalValue(value: OceancdVerificationTemplateMetricsProviderWeb | undefined);
    private _body?;
    get body(): string;
    set body(value: string);
    resetBody(): void;
    get bodyInput(): string | undefined;
    private _insecure?;
    get insecure(): boolean | cdktf.IResolvable;
    set insecure(value: boolean | cdktf.IResolvable);
    resetInsecure(): void;
    get insecureInput(): boolean | cdktf.IResolvable | undefined;
    private _jsonPath?;
    get jsonPath(): string;
    set jsonPath(value: string);
    resetJsonPath(): void;
    get jsonPathInput(): string | undefined;
    private _method?;
    get method(): string;
    set method(value: string);
    resetMethod(): void;
    get methodInput(): string | undefined;
    private _timeoutSeconds?;
    get timeoutSeconds(): number;
    set timeoutSeconds(value: number);
    resetTimeoutSeconds(): void;
    get timeoutSecondsInput(): number | undefined;
    private _url?;
    get url(): string;
    set url(value: string);
    get urlInput(): string | undefined;
    private _webHeader;
    get webHeader(): OceancdVerificationTemplateMetricsProviderWebWebHeaderList;
    putWebHeader(value: OceancdVerificationTemplateMetricsProviderWebWebHeader[] | cdktf.IResolvable): void;
    resetWebHeader(): void;
    get webHeaderInput(): cdktf.IResolvable | OceancdVerificationTemplateMetricsProviderWebWebHeader[] | undefined;
}
export interface OceancdVerificationTemplateMetricsProvider {
    /**
    * cloud_watch block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#cloud_watch OceancdVerificationTemplate#cloud_watch}
    */
    readonly cloudWatch?: OceancdVerificationTemplateMetricsProviderCloudWatch;
    /**
    * datadog block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#datadog OceancdVerificationTemplate#datadog}
    */
    readonly datadog?: OceancdVerificationTemplateMetricsProviderDatadog;
    /**
    * jenkins block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#jenkins OceancdVerificationTemplate#jenkins}
    */
    readonly jenkins?: OceancdVerificationTemplateMetricsProviderJenkins;
    /**
    * job block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#job OceancdVerificationTemplate#job}
    */
    readonly job?: OceancdVerificationTemplateMetricsProviderJob;
    /**
    * new_relic block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#new_relic OceancdVerificationTemplate#new_relic}
    */
    readonly newRelic?: OceancdVerificationTemplateMetricsProviderNewRelic;
    /**
    * prometheus block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#prometheus OceancdVerificationTemplate#prometheus}
    */
    readonly prometheus?: OceancdVerificationTemplateMetricsProviderPrometheus;
    /**
    * web block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#web OceancdVerificationTemplate#web}
    */
    readonly web?: OceancdVerificationTemplateMetricsProviderWeb;
}
export declare function oceancdVerificationTemplateMetricsProviderToTerraform(struct?: OceancdVerificationTemplateMetricsProvider | cdktf.IResolvable): any;
export declare function oceancdVerificationTemplateMetricsProviderToHclTerraform(struct?: OceancdVerificationTemplateMetricsProvider | cdktf.IResolvable): any;
export declare class OceancdVerificationTemplateMetricsProviderOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OceancdVerificationTemplateMetricsProvider | cdktf.IResolvable | undefined;
    set internalValue(value: OceancdVerificationTemplateMetricsProvider | cdktf.IResolvable | undefined);
    private _cloudWatch;
    get cloudWatch(): OceancdVerificationTemplateMetricsProviderCloudWatchOutputReference;
    putCloudWatch(value: OceancdVerificationTemplateMetricsProviderCloudWatch): void;
    resetCloudWatch(): void;
    get cloudWatchInput(): OceancdVerificationTemplateMetricsProviderCloudWatch | undefined;
    private _datadog;
    get datadog(): OceancdVerificationTemplateMetricsProviderDatadogOutputReference;
    putDatadog(value: OceancdVerificationTemplateMetricsProviderDatadog): void;
    resetDatadog(): void;
    get datadogInput(): OceancdVerificationTemplateMetricsProviderDatadog | undefined;
    private _jenkins;
    get jenkins(): OceancdVerificationTemplateMetricsProviderJenkinsOutputReference;
    putJenkins(value: OceancdVerificationTemplateMetricsProviderJenkins): void;
    resetJenkins(): void;
    get jenkinsInput(): OceancdVerificationTemplateMetricsProviderJenkins | undefined;
    private _job;
    get job(): OceancdVerificationTemplateMetricsProviderJobOutputReference;
    putJob(value: OceancdVerificationTemplateMetricsProviderJob): void;
    resetJob(): void;
    get jobInput(): OceancdVerificationTemplateMetricsProviderJob | undefined;
    private _newRelic;
    get newRelic(): OceancdVerificationTemplateMetricsProviderNewRelicOutputReference;
    putNewRelic(value: OceancdVerificationTemplateMetricsProviderNewRelic): void;
    resetNewRelic(): void;
    get newRelicInput(): OceancdVerificationTemplateMetricsProviderNewRelic | undefined;
    private _prometheus;
    get prometheus(): OceancdVerificationTemplateMetricsProviderPrometheusOutputReference;
    putPrometheus(value: OceancdVerificationTemplateMetricsProviderPrometheus): void;
    resetPrometheus(): void;
    get prometheusInput(): OceancdVerificationTemplateMetricsProviderPrometheus | undefined;
    private _web;
    get web(): OceancdVerificationTemplateMetricsProviderWebOutputReference;
    putWeb(value: OceancdVerificationTemplateMetricsProviderWeb): void;
    resetWeb(): void;
    get webInput(): OceancdVerificationTemplateMetricsProviderWeb | undefined;
}
export declare class OceancdVerificationTemplateMetricsProviderList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OceancdVerificationTemplateMetricsProvider[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OceancdVerificationTemplateMetricsProviderOutputReference;
}
export interface OceancdVerificationTemplateMetrics {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#consecutive_error_limit OceancdVerificationTemplate#consecutive_error_limit}
    */
    readonly consecutiveErrorLimit?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#count OceancdVerificationTemplate#count}
    */
    readonly count?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#dry_run OceancdVerificationTemplate#dry_run}
    */
    readonly dryRun?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#failure_condition OceancdVerificationTemplate#failure_condition}
    */
    readonly failureCondition?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#failure_limit OceancdVerificationTemplate#failure_limit}
    */
    readonly failureLimit?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#initial_delay OceancdVerificationTemplate#initial_delay}
    */
    readonly initialDelay?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#interval OceancdVerificationTemplate#interval}
    */
    readonly interval?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#metrics_name OceancdVerificationTemplate#metrics_name}
    */
    readonly metricsName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#success_condition OceancdVerificationTemplate#success_condition}
    */
    readonly successCondition?: string;
    /**
    * baseline block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#baseline OceancdVerificationTemplate#baseline}
    */
    readonly baseline?: OceancdVerificationTemplateMetricsBaseline;
    /**
    * provider block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#provider OceancdVerificationTemplate#provider}
    */
    readonly provider: OceancdVerificationTemplateMetricsProvider[] | cdktf.IResolvable;
}
export declare function oceancdVerificationTemplateMetricsToTerraform(struct?: OceancdVerificationTemplateMetrics | cdktf.IResolvable): any;
export declare function oceancdVerificationTemplateMetricsToHclTerraform(struct?: OceancdVerificationTemplateMetrics | cdktf.IResolvable): any;
export declare class OceancdVerificationTemplateMetricsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): OceancdVerificationTemplateMetrics | cdktf.IResolvable | undefined;
    set internalValue(value: OceancdVerificationTemplateMetrics | cdktf.IResolvable | undefined);
    private _consecutiveErrorLimit?;
    get consecutiveErrorLimit(): number;
    set consecutiveErrorLimit(value: number);
    resetConsecutiveErrorLimit(): void;
    get consecutiveErrorLimitInput(): number | undefined;
    private _count?;
    get count(): number;
    set count(value: number);
    resetCount(): void;
    get countInput(): number | undefined;
    private _dryRun?;
    get dryRun(): boolean | cdktf.IResolvable;
    set dryRun(value: boolean | cdktf.IResolvable);
    resetDryRun(): void;
    get dryRunInput(): boolean | cdktf.IResolvable | undefined;
    private _failureCondition?;
    get failureCondition(): string;
    set failureCondition(value: string);
    resetFailureCondition(): void;
    get failureConditionInput(): string | undefined;
    private _failureLimit?;
    get failureLimit(): number;
    set failureLimit(value: number);
    resetFailureLimit(): void;
    get failureLimitInput(): number | undefined;
    private _initialDelay?;
    get initialDelay(): string;
    set initialDelay(value: string);
    resetInitialDelay(): void;
    get initialDelayInput(): string | undefined;
    private _interval?;
    get interval(): string;
    set interval(value: string);
    resetInterval(): void;
    get intervalInput(): string | undefined;
    private _metricsName?;
    get metricsName(): string;
    set metricsName(value: string);
    get metricsNameInput(): string | undefined;
    private _successCondition?;
    get successCondition(): string;
    set successCondition(value: string);
    resetSuccessCondition(): void;
    get successConditionInput(): string | undefined;
    private _baseline;
    get baseline(): OceancdVerificationTemplateMetricsBaselineOutputReference;
    putBaseline(value: OceancdVerificationTemplateMetricsBaseline): void;
    resetBaseline(): void;
    get baselineInput(): OceancdVerificationTemplateMetricsBaseline | undefined;
    private _provider;
    get provider(): OceancdVerificationTemplateMetricsProviderList;
    putProvider(value: OceancdVerificationTemplateMetricsProvider[] | cdktf.IResolvable): void;
    get providerInput(): cdktf.IResolvable | OceancdVerificationTemplateMetricsProvider[] | undefined;
}
export declare class OceancdVerificationTemplateMetricsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: OceancdVerificationTemplateMetrics[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): OceancdVerificationTemplateMetricsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template spotinst_oceancd_verification_template}
*/
export declare class OceancdVerificationTemplate extends cdktf.TerraformResource {
    static readonly tfResourceType = "spotinst_oceancd_verification_template";
    /**
    * Generates CDKTF code for importing a OceancdVerificationTemplate resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the OceancdVerificationTemplate to import
    * @param importFromId The id of the existing OceancdVerificationTemplate that should be imported. Refer to the {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the OceancdVerificationTemplate to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/oceancd_verification_template spotinst_oceancd_verification_template} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options OceancdVerificationTemplateConfig
    */
    constructor(scope: Construct, id: string, config: OceancdVerificationTemplateConfig);
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _args;
    get args(): OceancdVerificationTemplateArgsList;
    putArgs(value: OceancdVerificationTemplateArgs[] | cdktf.IResolvable): void;
    resetArgs(): void;
    get argsInput(): cdktf.IResolvable | OceancdVerificationTemplateArgs[] | undefined;
    private _metrics;
    get metrics(): OceancdVerificationTemplateMetricsList;
    putMetrics(value: OceancdVerificationTemplateMetrics[] | cdktf.IResolvable): void;
    resetMetrics(): void;
    get metricsInput(): cdktf.IResolvable | OceancdVerificationTemplateMetrics[] | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
