/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface ElastigroupAwsConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#auto_healing ElastigroupAws#auto_healing}
    */
    readonly autoHealing?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#availability_zones ElastigroupAws#availability_zones}
    */
    readonly availabilityZones?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#block_devices_mode ElastigroupAws#block_devices_mode}
    */
    readonly blockDevicesMode?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#capacity_unit ElastigroupAws#capacity_unit}
    */
    readonly capacityUnit?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#consider_od_pricing ElastigroupAws#consider_od_pricing}
    */
    readonly considerOdPricing?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#cpu_credits ElastigroupAws#cpu_credits}
    */
    readonly cpuCredits?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#description ElastigroupAws#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#desired_capacity ElastigroupAws#desired_capacity}
    */
    readonly desiredCapacity?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#draining_timeout ElastigroupAws#draining_timeout}
    */
    readonly drainingTimeout?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#ebs_optimized ElastigroupAws#ebs_optimized}
    */
    readonly ebsOptimized?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#elastic_ips ElastigroupAws#elastic_ips}
    */
    readonly elasticIps?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#elastic_load_balancers ElastigroupAws#elastic_load_balancers}
    */
    readonly elasticLoadBalancers?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#enable_monitoring ElastigroupAws#enable_monitoring}
    */
    readonly enableMonitoring?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#fallback_to_ondemand ElastigroupAws#fallback_to_ondemand}
    */
    readonly fallbackToOndemand: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#health_check_grace_period ElastigroupAws#health_check_grace_period}
    */
    readonly healthCheckGracePeriod?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#health_check_type ElastigroupAws#health_check_type}
    */
    readonly healthCheckType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#health_check_unhealthy_duration_before_replacement ElastigroupAws#health_check_unhealthy_duration_before_replacement}
    */
    readonly healthCheckUnhealthyDurationBeforeReplacement?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#iam_instance_profile ElastigroupAws#iam_instance_profile}
    */
    readonly iamInstanceProfile?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#id ElastigroupAws#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#image_id ElastigroupAws#image_id}
    */
    readonly imageId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#immediate_od_recover_threshold ElastigroupAws#immediate_od_recover_threshold}
    */
    readonly immediateOdRecoverThreshold?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#instance_types_ondemand ElastigroupAws#instance_types_ondemand}
    */
    readonly instanceTypesOndemand?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#instance_types_preferred_spot ElastigroupAws#instance_types_preferred_spot}
    */
    readonly instanceTypesPreferredSpot?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#instance_types_spot ElastigroupAws#instance_types_spot}
    */
    readonly instanceTypesSpot?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#key_name ElastigroupAws#key_name}
    */
    readonly keyName?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#lifetime_period ElastigroupAws#lifetime_period}
    */
    readonly lifetimePeriod?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#max_replacements_percentage ElastigroupAws#max_replacements_percentage}
    */
    readonly maxReplacementsPercentage?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#max_size ElastigroupAws#max_size}
    */
    readonly maxSize?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#min_size ElastigroupAws#min_size}
    */
    readonly minSize?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#minimum_instance_lifetime ElastigroupAws#minimum_instance_lifetime}
    */
    readonly minimumInstanceLifetime?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#name ElastigroupAws#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#on_demand_types ElastigroupAws#on_demand_types}
    */
    readonly onDemandTypes?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#ondemand_count ElastigroupAws#ondemand_count}
    */
    readonly ondemandCount?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#orientation ElastigroupAws#orientation}
    */
    readonly orientation: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#persist_block_devices ElastigroupAws#persist_block_devices}
    */
    readonly persistBlockDevices?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#persist_private_ip ElastigroupAws#persist_private_ip}
    */
    readonly persistPrivateIp?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#persist_root_device ElastigroupAws#persist_root_device}
    */
    readonly persistRootDevice?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#placement_tenancy ElastigroupAws#placement_tenancy}
    */
    readonly placementTenancy?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#preferred_availability_zones ElastigroupAws#preferred_availability_zones}
    */
    readonly preferredAvailabilityZones?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#private_ips ElastigroupAws#private_ips}
    */
    readonly privateIps?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#product ElastigroupAws#product}
    */
    readonly product: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#region ElastigroupAws#region}
    */
    readonly region?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#restrict_single_az ElastigroupAws#restrict_single_az}
    */
    readonly restrictSingleAz?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#security_groups ElastigroupAws#security_groups}
    */
    readonly securityGroups: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#shutdown_script ElastigroupAws#shutdown_script}
    */
    readonly shutdownScript?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#spot_percentage ElastigroupAws#spot_percentage}
    */
    readonly spotPercentage?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#subnet_ids ElastigroupAws#subnet_ids}
    */
    readonly subnetIds?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#target_group_arns ElastigroupAws#target_group_arns}
    */
    readonly targetGroupArns?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#user_data ElastigroupAws#user_data}
    */
    readonly userData?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#utilize_commitments ElastigroupAws#utilize_commitments}
    */
    readonly utilizeCommitments?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#utilize_reserved_instances ElastigroupAws#utilize_reserved_instances}
    */
    readonly utilizeReservedInstances?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#wait_for_capacity ElastigroupAws#wait_for_capacity}
    */
    readonly waitForCapacity?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#wait_for_capacity_timeout ElastigroupAws#wait_for_capacity_timeout}
    */
    readonly waitForCapacityTimeout?: number;
    /**
    * cpu_options block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#cpu_options ElastigroupAws#cpu_options}
    */
    readonly cpuOptions?: ElastigroupAwsCpuOptions;
    /**
    * ebs_block_device block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#ebs_block_device ElastigroupAws#ebs_block_device}
    */
    readonly ebsBlockDevice?: ElastigroupAwsEbsBlockDevice[] | cdktf.IResolvable;
    /**
    * ephemeral_block_device block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#ephemeral_block_device ElastigroupAws#ephemeral_block_device}
    */
    readonly ephemeralBlockDevice?: ElastigroupAwsEphemeralBlockDevice[] | cdktf.IResolvable;
    /**
    * images block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#images ElastigroupAws#images}
    */
    readonly images?: ElastigroupAwsImages[] | cdktf.IResolvable;
    /**
    * instance_types_weights block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#instance_types_weights ElastigroupAws#instance_types_weights}
    */
    readonly instanceTypesWeights?: ElastigroupAwsInstanceTypesWeights[] | cdktf.IResolvable;
    /**
    * integration_beanstalk block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#integration_beanstalk ElastigroupAws#integration_beanstalk}
    */
    readonly integrationBeanstalk?: ElastigroupAwsIntegrationBeanstalk;
    /**
    * integration_codedeploy block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#integration_codedeploy ElastigroupAws#integration_codedeploy}
    */
    readonly integrationCodedeploy?: ElastigroupAwsIntegrationCodedeploy;
    /**
    * integration_docker_swarm block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#integration_docker_swarm ElastigroupAws#integration_docker_swarm}
    */
    readonly integrationDockerSwarm?: ElastigroupAwsIntegrationDockerSwarm;
    /**
    * integration_ecs block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#integration_ecs ElastigroupAws#integration_ecs}
    */
    readonly integrationEcs?: ElastigroupAwsIntegrationEcs;
    /**
    * integration_gitlab block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#integration_gitlab ElastigroupAws#integration_gitlab}
    */
    readonly integrationGitlab?: ElastigroupAwsIntegrationGitlab;
    /**
    * integration_kubernetes block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#integration_kubernetes ElastigroupAws#integration_kubernetes}
    */
    readonly integrationKubernetes?: ElastigroupAwsIntegrationKubernetes;
    /**
    * integration_mesosphere block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#integration_mesosphere ElastigroupAws#integration_mesosphere}
    */
    readonly integrationMesosphere?: ElastigroupAwsIntegrationMesosphere;
    /**
    * integration_nomad block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#integration_nomad ElastigroupAws#integration_nomad}
    */
    readonly integrationNomad?: ElastigroupAwsIntegrationNomad;
    /**
    * integration_rancher block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#integration_rancher ElastigroupAws#integration_rancher}
    */
    readonly integrationRancher?: ElastigroupAwsIntegrationRancher;
    /**
    * integration_route53 block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#integration_route53 ElastigroupAws#integration_route53}
    */
    readonly integrationRoute53?: ElastigroupAwsIntegrationRoute53;
    /**
    * itf block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#itf ElastigroupAws#itf}
    */
    readonly itf?: ElastigroupAwsItf[] | cdktf.IResolvable;
    /**
    * logging block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#logging ElastigroupAws#logging}
    */
    readonly logging?: ElastigroupAwsLogging;
    /**
    * metadata_options block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#metadata_options ElastigroupAws#metadata_options}
    */
    readonly metadataOptions?: ElastigroupAwsMetadataOptions;
    /**
    * multiple_metrics block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#multiple_metrics ElastigroupAws#multiple_metrics}
    */
    readonly multipleMetrics?: ElastigroupAwsMultipleMetrics;
    /**
    * network_interface block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#network_interface ElastigroupAws#network_interface}
    */
    readonly networkInterface?: ElastigroupAwsNetworkInterface[] | cdktf.IResolvable;
    /**
    * resource_requirements block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#resource_requirements ElastigroupAws#resource_requirements}
    */
    readonly resourceRequirements?: ElastigroupAwsResourceRequirements[] | cdktf.IResolvable;
    /**
    * resource_tag_specification block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#resource_tag_specification ElastigroupAws#resource_tag_specification}
    */
    readonly resourceTagSpecification?: ElastigroupAwsResourceTagSpecification[] | cdktf.IResolvable;
    /**
    * revert_to_spot block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#revert_to_spot ElastigroupAws#revert_to_spot}
    */
    readonly revertToSpot?: ElastigroupAwsRevertToSpot;
    /**
    * scaling_down_policy block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#scaling_down_policy ElastigroupAws#scaling_down_policy}
    */
    readonly scalingDownPolicy?: ElastigroupAwsScalingDownPolicy[] | cdktf.IResolvable;
    /**
    * scaling_strategy block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#scaling_strategy ElastigroupAws#scaling_strategy}
    */
    readonly scalingStrategy?: ElastigroupAwsScalingStrategy[] | cdktf.IResolvable;
    /**
    * scaling_target_policy block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#scaling_target_policy ElastigroupAws#scaling_target_policy}
    */
    readonly scalingTargetPolicy?: ElastigroupAwsScalingTargetPolicy[] | cdktf.IResolvable;
    /**
    * scaling_up_policy block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#scaling_up_policy ElastigroupAws#scaling_up_policy}
    */
    readonly scalingUpPolicy?: ElastigroupAwsScalingUpPolicy[] | cdktf.IResolvable;
    /**
    * scheduled_task block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#scheduled_task ElastigroupAws#scheduled_task}
    */
    readonly scheduledTask?: ElastigroupAwsScheduledTask[] | cdktf.IResolvable;
    /**
    * signal block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#signal ElastigroupAws#signal}
    */
    readonly signal?: ElastigroupAwsSignal[] | cdktf.IResolvable;
    /**
    * stateful_deallocation block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#stateful_deallocation ElastigroupAws#stateful_deallocation}
    */
    readonly statefulDeallocation?: ElastigroupAwsStatefulDeallocation;
    /**
    * stateful_instance_action block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#stateful_instance_action ElastigroupAws#stateful_instance_action}
    */
    readonly statefulInstanceAction?: ElastigroupAwsStatefulInstanceAction[] | cdktf.IResolvable;
    /**
    * tags block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#tags ElastigroupAws#tags}
    */
    readonly tags?: ElastigroupAwsTags[] | cdktf.IResolvable;
    /**
    * update_policy block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#update_policy ElastigroupAws#update_policy}
    */
    readonly updatePolicy?: ElastigroupAwsUpdatePolicy;
}
export interface ElastigroupAwsCpuOptions {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#threads_per_core ElastigroupAws#threads_per_core}
    */
    readonly threadsPerCore: number;
}
export declare function elastigroupAwsCpuOptionsToTerraform(struct?: ElastigroupAwsCpuOptionsOutputReference | ElastigroupAwsCpuOptions): any;
export declare function elastigroupAwsCpuOptionsToHclTerraform(struct?: ElastigroupAwsCpuOptionsOutputReference | ElastigroupAwsCpuOptions): any;
export declare class ElastigroupAwsCpuOptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAwsCpuOptions | undefined;
    set internalValue(value: ElastigroupAwsCpuOptions | undefined);
    private _threadsPerCore?;
    get threadsPerCore(): number;
    set threadsPerCore(value: number);
    get threadsPerCoreInput(): number | undefined;
}
export interface ElastigroupAwsEbsBlockDeviceDynamicIops {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#base_size ElastigroupAws#base_size}
    */
    readonly baseSize?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#resource ElastigroupAws#resource}
    */
    readonly resource?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#size_per_resource_unit ElastigroupAws#size_per_resource_unit}
    */
    readonly sizePerResourceUnit?: number;
}
export declare function elastigroupAwsEbsBlockDeviceDynamicIopsToTerraform(struct?: ElastigroupAwsEbsBlockDeviceDynamicIopsOutputReference | ElastigroupAwsEbsBlockDeviceDynamicIops): any;
export declare function elastigroupAwsEbsBlockDeviceDynamicIopsToHclTerraform(struct?: ElastigroupAwsEbsBlockDeviceDynamicIopsOutputReference | ElastigroupAwsEbsBlockDeviceDynamicIops): any;
export declare class ElastigroupAwsEbsBlockDeviceDynamicIopsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAwsEbsBlockDeviceDynamicIops | undefined;
    set internalValue(value: ElastigroupAwsEbsBlockDeviceDynamicIops | undefined);
    private _baseSize?;
    get baseSize(): number;
    set baseSize(value: number);
    resetBaseSize(): void;
    get baseSizeInput(): number | undefined;
    private _resource?;
    get resource(): string;
    set resource(value: string);
    resetResource(): void;
    get resourceInput(): string | undefined;
    private _sizePerResourceUnit?;
    get sizePerResourceUnit(): number;
    set sizePerResourceUnit(value: number);
    resetSizePerResourceUnit(): void;
    get sizePerResourceUnitInput(): number | undefined;
}
export interface ElastigroupAwsEbsBlockDeviceDynamicVolumeSize {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#base_size ElastigroupAws#base_size}
    */
    readonly baseSize?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#resource ElastigroupAws#resource}
    */
    readonly resource?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#size_per_resource_unit ElastigroupAws#size_per_resource_unit}
    */
    readonly sizePerResourceUnit?: number;
}
export declare function elastigroupAwsEbsBlockDeviceDynamicVolumeSizeToTerraform(struct?: ElastigroupAwsEbsBlockDeviceDynamicVolumeSizeOutputReference | ElastigroupAwsEbsBlockDeviceDynamicVolumeSize): any;
export declare function elastigroupAwsEbsBlockDeviceDynamicVolumeSizeToHclTerraform(struct?: ElastigroupAwsEbsBlockDeviceDynamicVolumeSizeOutputReference | ElastigroupAwsEbsBlockDeviceDynamicVolumeSize): any;
export declare class ElastigroupAwsEbsBlockDeviceDynamicVolumeSizeOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAwsEbsBlockDeviceDynamicVolumeSize | undefined;
    set internalValue(value: ElastigroupAwsEbsBlockDeviceDynamicVolumeSize | undefined);
    private _baseSize?;
    get baseSize(): number;
    set baseSize(value: number);
    resetBaseSize(): void;
    get baseSizeInput(): number | undefined;
    private _resource?;
    get resource(): string;
    set resource(value: string);
    resetResource(): void;
    get resourceInput(): string | undefined;
    private _sizePerResourceUnit?;
    get sizePerResourceUnit(): number;
    set sizePerResourceUnit(value: number);
    resetSizePerResourceUnit(): void;
    get sizePerResourceUnitInput(): number | undefined;
}
export interface ElastigroupAwsEbsBlockDevice {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#delete_on_termination ElastigroupAws#delete_on_termination}
    */
    readonly deleteOnTermination?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#device_name ElastigroupAws#device_name}
    */
    readonly deviceName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#encrypted ElastigroupAws#encrypted}
    */
    readonly encrypted?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#iops ElastigroupAws#iops}
    */
    readonly iops?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#kms_key_id ElastigroupAws#kms_key_id}
    */
    readonly kmsKeyId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#snapshot_id ElastigroupAws#snapshot_id}
    */
    readonly snapshotId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#throughput ElastigroupAws#throughput}
    */
    readonly throughput?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#volume_size ElastigroupAws#volume_size}
    */
    readonly volumeSize?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#volume_type ElastigroupAws#volume_type}
    */
    readonly volumeType?: string;
    /**
    * dynamic_iops block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#dynamic_iops ElastigroupAws#dynamic_iops}
    */
    readonly dynamicIops?: ElastigroupAwsEbsBlockDeviceDynamicIops;
    /**
    * dynamic_volume_size block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#dynamic_volume_size ElastigroupAws#dynamic_volume_size}
    */
    readonly dynamicVolumeSize?: ElastigroupAwsEbsBlockDeviceDynamicVolumeSize;
}
export declare function elastigroupAwsEbsBlockDeviceToTerraform(struct?: ElastigroupAwsEbsBlockDevice | cdktf.IResolvable): any;
export declare function elastigroupAwsEbsBlockDeviceToHclTerraform(struct?: ElastigroupAwsEbsBlockDevice | cdktf.IResolvable): any;
export declare class ElastigroupAwsEbsBlockDeviceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAwsEbsBlockDevice | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAwsEbsBlockDevice | cdktf.IResolvable | undefined);
    private _deleteOnTermination?;
    get deleteOnTermination(): boolean | cdktf.IResolvable;
    set deleteOnTermination(value: boolean | cdktf.IResolvable);
    resetDeleteOnTermination(): void;
    get deleteOnTerminationInput(): boolean | cdktf.IResolvable | undefined;
    private _deviceName?;
    get deviceName(): string;
    set deviceName(value: string);
    get deviceNameInput(): string | undefined;
    private _encrypted?;
    get encrypted(): boolean | cdktf.IResolvable;
    set encrypted(value: boolean | cdktf.IResolvable);
    resetEncrypted(): void;
    get encryptedInput(): boolean | cdktf.IResolvable | undefined;
    private _iops?;
    get iops(): number;
    set iops(value: number);
    resetIops(): void;
    get iopsInput(): number | undefined;
    private _kmsKeyId?;
    get kmsKeyId(): string;
    set kmsKeyId(value: string);
    resetKmsKeyId(): void;
    get kmsKeyIdInput(): string | undefined;
    private _snapshotId?;
    get snapshotId(): string;
    set snapshotId(value: string);
    resetSnapshotId(): void;
    get snapshotIdInput(): string | undefined;
    private _throughput?;
    get throughput(): number;
    set throughput(value: number);
    resetThroughput(): void;
    get throughputInput(): number | undefined;
    private _volumeSize?;
    get volumeSize(): number;
    set volumeSize(value: number);
    resetVolumeSize(): void;
    get volumeSizeInput(): number | undefined;
    private _volumeType?;
    get volumeType(): string;
    set volumeType(value: string);
    resetVolumeType(): void;
    get volumeTypeInput(): string | undefined;
    private _dynamicIops;
    get dynamicIops(): ElastigroupAwsEbsBlockDeviceDynamicIopsOutputReference;
    putDynamicIops(value: ElastigroupAwsEbsBlockDeviceDynamicIops): void;
    resetDynamicIops(): void;
    get dynamicIopsInput(): ElastigroupAwsEbsBlockDeviceDynamicIops | undefined;
    private _dynamicVolumeSize;
    get dynamicVolumeSize(): ElastigroupAwsEbsBlockDeviceDynamicVolumeSizeOutputReference;
    putDynamicVolumeSize(value: ElastigroupAwsEbsBlockDeviceDynamicVolumeSize): void;
    resetDynamicVolumeSize(): void;
    get dynamicVolumeSizeInput(): ElastigroupAwsEbsBlockDeviceDynamicVolumeSize | undefined;
}
export declare class ElastigroupAwsEbsBlockDeviceList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAwsEbsBlockDevice[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAwsEbsBlockDeviceOutputReference;
}
export interface ElastigroupAwsEphemeralBlockDevice {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#device_name ElastigroupAws#device_name}
    */
    readonly deviceName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#virtual_name ElastigroupAws#virtual_name}
    */
    readonly virtualName: string;
}
export declare function elastigroupAwsEphemeralBlockDeviceToTerraform(struct?: ElastigroupAwsEphemeralBlockDevice | cdktf.IResolvable): any;
export declare function elastigroupAwsEphemeralBlockDeviceToHclTerraform(struct?: ElastigroupAwsEphemeralBlockDevice | cdktf.IResolvable): any;
export declare class ElastigroupAwsEphemeralBlockDeviceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAwsEphemeralBlockDevice | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAwsEphemeralBlockDevice | cdktf.IResolvable | undefined);
    private _deviceName?;
    get deviceName(): string;
    set deviceName(value: string);
    get deviceNameInput(): string | undefined;
    private _virtualName?;
    get virtualName(): string;
    set virtualName(value: string);
    get virtualNameInput(): string | undefined;
}
export declare class ElastigroupAwsEphemeralBlockDeviceList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAwsEphemeralBlockDevice[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAwsEphemeralBlockDeviceOutputReference;
}
export interface ElastigroupAwsImagesImage {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#id ElastigroupAws#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id: string;
}
export declare function elastigroupAwsImagesImageToTerraform(struct?: ElastigroupAwsImagesImage | cdktf.IResolvable): any;
export declare function elastigroupAwsImagesImageToHclTerraform(struct?: ElastigroupAwsImagesImage | cdktf.IResolvable): any;
export declare class ElastigroupAwsImagesImageOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAwsImagesImage | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAwsImagesImage | cdktf.IResolvable | undefined);
    private _id?;
    get id(): string;
    set id(value: string);
    get idInput(): string | undefined;
}
export declare class ElastigroupAwsImagesImageList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAwsImagesImage[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAwsImagesImageOutputReference;
}
export interface ElastigroupAwsImages {
    /**
    * image block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#image ElastigroupAws#image}
    */
    readonly image: ElastigroupAwsImagesImage[] | cdktf.IResolvable;
}
export declare function elastigroupAwsImagesToTerraform(struct?: ElastigroupAwsImages | cdktf.IResolvable): any;
export declare function elastigroupAwsImagesToHclTerraform(struct?: ElastigroupAwsImages | cdktf.IResolvable): any;
export declare class ElastigroupAwsImagesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAwsImages | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAwsImages | cdktf.IResolvable | undefined);
    private _image;
    get image(): ElastigroupAwsImagesImageList;
    putImage(value: ElastigroupAwsImagesImage[] | cdktf.IResolvable): void;
    get imageInput(): cdktf.IResolvable | ElastigroupAwsImagesImage[] | undefined;
}
export declare class ElastigroupAwsImagesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAwsImages[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAwsImagesOutputReference;
}
export interface ElastigroupAwsInstanceTypesWeights {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#instance_type ElastigroupAws#instance_type}
    */
    readonly instanceType: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#weight ElastigroupAws#weight}
    */
    readonly weight: number;
}
export declare function elastigroupAwsInstanceTypesWeightsToTerraform(struct?: ElastigroupAwsInstanceTypesWeights | cdktf.IResolvable): any;
export declare function elastigroupAwsInstanceTypesWeightsToHclTerraform(struct?: ElastigroupAwsInstanceTypesWeights | cdktf.IResolvable): any;
export declare class ElastigroupAwsInstanceTypesWeightsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAwsInstanceTypesWeights | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAwsInstanceTypesWeights | cdktf.IResolvable | undefined);
    private _instanceType?;
    get instanceType(): string;
    set instanceType(value: string);
    get instanceTypeInput(): string | undefined;
    private _weight?;
    get weight(): number;
    set weight(value: number);
    get weightInput(): number | undefined;
}
export declare class ElastigroupAwsInstanceTypesWeightsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAwsInstanceTypesWeights[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAwsInstanceTypesWeightsOutputReference;
}
export interface ElastigroupAwsIntegrationBeanstalkDeploymentPreferencesStrategy {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#action ElastigroupAws#action}
    */
    readonly action?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#should_drain_instances ElastigroupAws#should_drain_instances}
    */
    readonly shouldDrainInstances?: boolean | cdktf.IResolvable;
}
export declare function elastigroupAwsIntegrationBeanstalkDeploymentPreferencesStrategyToTerraform(struct?: ElastigroupAwsIntegrationBeanstalkDeploymentPreferencesStrategyOutputReference | ElastigroupAwsIntegrationBeanstalkDeploymentPreferencesStrategy): any;
export declare function elastigroupAwsIntegrationBeanstalkDeploymentPreferencesStrategyToHclTerraform(struct?: ElastigroupAwsIntegrationBeanstalkDeploymentPreferencesStrategyOutputReference | ElastigroupAwsIntegrationBeanstalkDeploymentPreferencesStrategy): any;
export declare class ElastigroupAwsIntegrationBeanstalkDeploymentPreferencesStrategyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAwsIntegrationBeanstalkDeploymentPreferencesStrategy | undefined;
    set internalValue(value: ElastigroupAwsIntegrationBeanstalkDeploymentPreferencesStrategy | undefined);
    private _action?;
    get action(): string;
    set action(value: string);
    resetAction(): void;
    get actionInput(): string | undefined;
    private _shouldDrainInstances?;
    get shouldDrainInstances(): boolean | cdktf.IResolvable;
    set shouldDrainInstances(value: boolean | cdktf.IResolvable);
    resetShouldDrainInstances(): void;
    get shouldDrainInstancesInput(): boolean | cdktf.IResolvable | undefined;
}
export interface ElastigroupAwsIntegrationBeanstalkDeploymentPreferences {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#automatic_roll ElastigroupAws#automatic_roll}
    */
    readonly automaticRoll?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#batch_size_percentage ElastigroupAws#batch_size_percentage}
    */
    readonly batchSizePercentage?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#grace_period ElastigroupAws#grace_period}
    */
    readonly gracePeriod?: number;
    /**
    * strategy block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#strategy ElastigroupAws#strategy}
    */
    readonly strategy?: ElastigroupAwsIntegrationBeanstalkDeploymentPreferencesStrategy;
}
export declare function elastigroupAwsIntegrationBeanstalkDeploymentPreferencesToTerraform(struct?: ElastigroupAwsIntegrationBeanstalkDeploymentPreferencesOutputReference | ElastigroupAwsIntegrationBeanstalkDeploymentPreferences): any;
export declare function elastigroupAwsIntegrationBeanstalkDeploymentPreferencesToHclTerraform(struct?: ElastigroupAwsIntegrationBeanstalkDeploymentPreferencesOutputReference | ElastigroupAwsIntegrationBeanstalkDeploymentPreferences): any;
export declare class ElastigroupAwsIntegrationBeanstalkDeploymentPreferencesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAwsIntegrationBeanstalkDeploymentPreferences | undefined;
    set internalValue(value: ElastigroupAwsIntegrationBeanstalkDeploymentPreferences | undefined);
    private _automaticRoll?;
    get automaticRoll(): boolean | cdktf.IResolvable;
    set automaticRoll(value: boolean | cdktf.IResolvable);
    resetAutomaticRoll(): void;
    get automaticRollInput(): boolean | cdktf.IResolvable | undefined;
    private _batchSizePercentage?;
    get batchSizePercentage(): number;
    set batchSizePercentage(value: number);
    resetBatchSizePercentage(): void;
    get batchSizePercentageInput(): number | undefined;
    private _gracePeriod?;
    get gracePeriod(): number;
    set gracePeriod(value: number);
    resetGracePeriod(): void;
    get gracePeriodInput(): number | undefined;
    private _strategy;
    get strategy(): ElastigroupAwsIntegrationBeanstalkDeploymentPreferencesStrategyOutputReference;
    putStrategy(value: ElastigroupAwsIntegrationBeanstalkDeploymentPreferencesStrategy): void;
    resetStrategy(): void;
    get strategyInput(): ElastigroupAwsIntegrationBeanstalkDeploymentPreferencesStrategy | undefined;
}
export interface ElastigroupAwsIntegrationBeanstalkManagedActionsPlatformUpdate {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#perform_at ElastigroupAws#perform_at}
    */
    readonly performAt?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#time_window ElastigroupAws#time_window}
    */
    readonly timeWindow?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#update_level ElastigroupAws#update_level}
    */
    readonly updateLevel?: string;
}
export declare function elastigroupAwsIntegrationBeanstalkManagedActionsPlatformUpdateToTerraform(struct?: ElastigroupAwsIntegrationBeanstalkManagedActionsPlatformUpdateOutputReference | ElastigroupAwsIntegrationBeanstalkManagedActionsPlatformUpdate): any;
export declare function elastigroupAwsIntegrationBeanstalkManagedActionsPlatformUpdateToHclTerraform(struct?: ElastigroupAwsIntegrationBeanstalkManagedActionsPlatformUpdateOutputReference | ElastigroupAwsIntegrationBeanstalkManagedActionsPlatformUpdate): any;
export declare class ElastigroupAwsIntegrationBeanstalkManagedActionsPlatformUpdateOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAwsIntegrationBeanstalkManagedActionsPlatformUpdate | undefined;
    set internalValue(value: ElastigroupAwsIntegrationBeanstalkManagedActionsPlatformUpdate | undefined);
    private _performAt?;
    get performAt(): string;
    set performAt(value: string);
    resetPerformAt(): void;
    get performAtInput(): string | undefined;
    private _timeWindow?;
    get timeWindow(): string;
    set timeWindow(value: string);
    resetTimeWindow(): void;
    get timeWindowInput(): string | undefined;
    private _updateLevel?;
    get updateLevel(): string;
    set updateLevel(value: string);
    resetUpdateLevel(): void;
    get updateLevelInput(): string | undefined;
}
export interface ElastigroupAwsIntegrationBeanstalkManagedActions {
    /**
    * platform_update block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#platform_update ElastigroupAws#platform_update}
    */
    readonly platformUpdate?: ElastigroupAwsIntegrationBeanstalkManagedActionsPlatformUpdate;
}
export declare function elastigroupAwsIntegrationBeanstalkManagedActionsToTerraform(struct?: ElastigroupAwsIntegrationBeanstalkManagedActionsOutputReference | ElastigroupAwsIntegrationBeanstalkManagedActions): any;
export declare function elastigroupAwsIntegrationBeanstalkManagedActionsToHclTerraform(struct?: ElastigroupAwsIntegrationBeanstalkManagedActionsOutputReference | ElastigroupAwsIntegrationBeanstalkManagedActions): any;
export declare class ElastigroupAwsIntegrationBeanstalkManagedActionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAwsIntegrationBeanstalkManagedActions | undefined;
    set internalValue(value: ElastigroupAwsIntegrationBeanstalkManagedActions | undefined);
    private _platformUpdate;
    get platformUpdate(): ElastigroupAwsIntegrationBeanstalkManagedActionsPlatformUpdateOutputReference;
    putPlatformUpdate(value: ElastigroupAwsIntegrationBeanstalkManagedActionsPlatformUpdate): void;
    resetPlatformUpdate(): void;
    get platformUpdateInput(): ElastigroupAwsIntegrationBeanstalkManagedActionsPlatformUpdate | undefined;
}
export interface ElastigroupAwsIntegrationBeanstalk {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#environment_id ElastigroupAws#environment_id}
    */
    readonly environmentId?: string;
    /**
    * deployment_preferences block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#deployment_preferences ElastigroupAws#deployment_preferences}
    */
    readonly deploymentPreferences?: ElastigroupAwsIntegrationBeanstalkDeploymentPreferences;
    /**
    * managed_actions block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#managed_actions ElastigroupAws#managed_actions}
    */
    readonly managedActions?: ElastigroupAwsIntegrationBeanstalkManagedActions;
}
export declare function elastigroupAwsIntegrationBeanstalkToTerraform(struct?: ElastigroupAwsIntegrationBeanstalkOutputReference | ElastigroupAwsIntegrationBeanstalk): any;
export declare function elastigroupAwsIntegrationBeanstalkToHclTerraform(struct?: ElastigroupAwsIntegrationBeanstalkOutputReference | ElastigroupAwsIntegrationBeanstalk): any;
export declare class ElastigroupAwsIntegrationBeanstalkOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAwsIntegrationBeanstalk | undefined;
    set internalValue(value: ElastigroupAwsIntegrationBeanstalk | undefined);
    private _environmentId?;
    get environmentId(): string;
    set environmentId(value: string);
    resetEnvironmentId(): void;
    get environmentIdInput(): string | undefined;
    private _deploymentPreferences;
    get deploymentPreferences(): ElastigroupAwsIntegrationBeanstalkDeploymentPreferencesOutputReference;
    putDeploymentPreferences(value: ElastigroupAwsIntegrationBeanstalkDeploymentPreferences): void;
    resetDeploymentPreferences(): void;
    get deploymentPreferencesInput(): ElastigroupAwsIntegrationBeanstalkDeploymentPreferences | undefined;
    private _managedActions;
    get managedActions(): ElastigroupAwsIntegrationBeanstalkManagedActionsOutputReference;
    putManagedActions(value: ElastigroupAwsIntegrationBeanstalkManagedActions): void;
    resetManagedActions(): void;
    get managedActionsInput(): ElastigroupAwsIntegrationBeanstalkManagedActions | undefined;
}
export interface ElastigroupAwsIntegrationCodedeployDeploymentGroups {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#application_name ElastigroupAws#application_name}
    */
    readonly applicationName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#deployment_group_name ElastigroupAws#deployment_group_name}
    */
    readonly deploymentGroupName: string;
}
export declare function elastigroupAwsIntegrationCodedeployDeploymentGroupsToTerraform(struct?: ElastigroupAwsIntegrationCodedeployDeploymentGroups | cdktf.IResolvable): any;
export declare function elastigroupAwsIntegrationCodedeployDeploymentGroupsToHclTerraform(struct?: ElastigroupAwsIntegrationCodedeployDeploymentGroups | cdktf.IResolvable): any;
export declare class ElastigroupAwsIntegrationCodedeployDeploymentGroupsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAwsIntegrationCodedeployDeploymentGroups | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAwsIntegrationCodedeployDeploymentGroups | cdktf.IResolvable | undefined);
    private _applicationName?;
    get applicationName(): string;
    set applicationName(value: string);
    get applicationNameInput(): string | undefined;
    private _deploymentGroupName?;
    get deploymentGroupName(): string;
    set deploymentGroupName(value: string);
    get deploymentGroupNameInput(): string | undefined;
}
export declare class ElastigroupAwsIntegrationCodedeployDeploymentGroupsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAwsIntegrationCodedeployDeploymentGroups[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAwsIntegrationCodedeployDeploymentGroupsOutputReference;
}
export interface ElastigroupAwsIntegrationCodedeploy {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#cleanup_on_failure ElastigroupAws#cleanup_on_failure}
    */
    readonly cleanupOnFailure: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#terminate_instance_on_failure ElastigroupAws#terminate_instance_on_failure}
    */
    readonly terminateInstanceOnFailure: boolean | cdktf.IResolvable;
    /**
    * deployment_groups block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#deployment_groups ElastigroupAws#deployment_groups}
    */
    readonly deploymentGroups: ElastigroupAwsIntegrationCodedeployDeploymentGroups[] | cdktf.IResolvable;
}
export declare function elastigroupAwsIntegrationCodedeployToTerraform(struct?: ElastigroupAwsIntegrationCodedeployOutputReference | ElastigroupAwsIntegrationCodedeploy): any;
export declare function elastigroupAwsIntegrationCodedeployToHclTerraform(struct?: ElastigroupAwsIntegrationCodedeployOutputReference | ElastigroupAwsIntegrationCodedeploy): any;
export declare class ElastigroupAwsIntegrationCodedeployOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAwsIntegrationCodedeploy | undefined;
    set internalValue(value: ElastigroupAwsIntegrationCodedeploy | undefined);
    private _cleanupOnFailure?;
    get cleanupOnFailure(): boolean | cdktf.IResolvable;
    set cleanupOnFailure(value: boolean | cdktf.IResolvable);
    get cleanupOnFailureInput(): boolean | cdktf.IResolvable | undefined;
    private _terminateInstanceOnFailure?;
    get terminateInstanceOnFailure(): boolean | cdktf.IResolvable;
    set terminateInstanceOnFailure(value: boolean | cdktf.IResolvable);
    get terminateInstanceOnFailureInput(): boolean | cdktf.IResolvable | undefined;
    private _deploymentGroups;
    get deploymentGroups(): ElastigroupAwsIntegrationCodedeployDeploymentGroupsList;
    putDeploymentGroups(value: ElastigroupAwsIntegrationCodedeployDeploymentGroups[] | cdktf.IResolvable): void;
    get deploymentGroupsInput(): cdktf.IResolvable | ElastigroupAwsIntegrationCodedeployDeploymentGroups[] | undefined;
}
export interface ElastigroupAwsIntegrationDockerSwarmAutoscaleDown {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#evaluation_periods ElastigroupAws#evaluation_periods}
    */
    readonly evaluationPeriods?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#max_scale_down_percentage ElastigroupAws#max_scale_down_percentage}
    */
    readonly maxScaleDownPercentage?: number;
}
export declare function elastigroupAwsIntegrationDockerSwarmAutoscaleDownToTerraform(struct?: ElastigroupAwsIntegrationDockerSwarmAutoscaleDownOutputReference | ElastigroupAwsIntegrationDockerSwarmAutoscaleDown): any;
export declare function elastigroupAwsIntegrationDockerSwarmAutoscaleDownToHclTerraform(struct?: ElastigroupAwsIntegrationDockerSwarmAutoscaleDownOutputReference | ElastigroupAwsIntegrationDockerSwarmAutoscaleDown): any;
export declare class ElastigroupAwsIntegrationDockerSwarmAutoscaleDownOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAwsIntegrationDockerSwarmAutoscaleDown | undefined;
    set internalValue(value: ElastigroupAwsIntegrationDockerSwarmAutoscaleDown | undefined);
    private _evaluationPeriods?;
    get evaluationPeriods(): number;
    set evaluationPeriods(value: number);
    resetEvaluationPeriods(): void;
    get evaluationPeriodsInput(): number | undefined;
    private _maxScaleDownPercentage?;
    get maxScaleDownPercentage(): number;
    set maxScaleDownPercentage(value: number);
    resetMaxScaleDownPercentage(): void;
    get maxScaleDownPercentageInput(): number | undefined;
}
export interface ElastigroupAwsIntegrationDockerSwarmAutoscaleHeadroom {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#cpu_per_unit ElastigroupAws#cpu_per_unit}
    */
    readonly cpuPerUnit?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#memory_per_unit ElastigroupAws#memory_per_unit}
    */
    readonly memoryPerUnit?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#num_of_units ElastigroupAws#num_of_units}
    */
    readonly numOfUnits?: number;
}
export declare function elastigroupAwsIntegrationDockerSwarmAutoscaleHeadroomToTerraform(struct?: ElastigroupAwsIntegrationDockerSwarmAutoscaleHeadroomOutputReference | ElastigroupAwsIntegrationDockerSwarmAutoscaleHeadroom): any;
export declare function elastigroupAwsIntegrationDockerSwarmAutoscaleHeadroomToHclTerraform(struct?: ElastigroupAwsIntegrationDockerSwarmAutoscaleHeadroomOutputReference | ElastigroupAwsIntegrationDockerSwarmAutoscaleHeadroom): any;
export declare class ElastigroupAwsIntegrationDockerSwarmAutoscaleHeadroomOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAwsIntegrationDockerSwarmAutoscaleHeadroom | undefined;
    set internalValue(value: ElastigroupAwsIntegrationDockerSwarmAutoscaleHeadroom | undefined);
    private _cpuPerUnit?;
    get cpuPerUnit(): number;
    set cpuPerUnit(value: number);
    resetCpuPerUnit(): void;
    get cpuPerUnitInput(): number | undefined;
    private _memoryPerUnit?;
    get memoryPerUnit(): number;
    set memoryPerUnit(value: number);
    resetMemoryPerUnit(): void;
    get memoryPerUnitInput(): number | undefined;
    private _numOfUnits?;
    get numOfUnits(): number;
    set numOfUnits(value: number);
    resetNumOfUnits(): void;
    get numOfUnitsInput(): number | undefined;
}
export interface ElastigroupAwsIntegrationDockerSwarm {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#autoscale_cooldown ElastigroupAws#autoscale_cooldown}
    */
    readonly autoscaleCooldown?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#autoscale_is_enabled ElastigroupAws#autoscale_is_enabled}
    */
    readonly autoscaleIsEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#master_host ElastigroupAws#master_host}
    */
    readonly masterHost: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#master_port ElastigroupAws#master_port}
    */
    readonly masterPort: number;
    /**
    * autoscale_down block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#autoscale_down ElastigroupAws#autoscale_down}
    */
    readonly autoscaleDown?: ElastigroupAwsIntegrationDockerSwarmAutoscaleDown;
    /**
    * autoscale_headroom block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#autoscale_headroom ElastigroupAws#autoscale_headroom}
    */
    readonly autoscaleHeadroom?: ElastigroupAwsIntegrationDockerSwarmAutoscaleHeadroom;
}
export declare function elastigroupAwsIntegrationDockerSwarmToTerraform(struct?: ElastigroupAwsIntegrationDockerSwarmOutputReference | ElastigroupAwsIntegrationDockerSwarm): any;
export declare function elastigroupAwsIntegrationDockerSwarmToHclTerraform(struct?: ElastigroupAwsIntegrationDockerSwarmOutputReference | ElastigroupAwsIntegrationDockerSwarm): any;
export declare class ElastigroupAwsIntegrationDockerSwarmOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAwsIntegrationDockerSwarm | undefined;
    set internalValue(value: ElastigroupAwsIntegrationDockerSwarm | undefined);
    private _autoscaleCooldown?;
    get autoscaleCooldown(): number;
    set autoscaleCooldown(value: number);
    resetAutoscaleCooldown(): void;
    get autoscaleCooldownInput(): number | undefined;
    private _autoscaleIsEnabled?;
    get autoscaleIsEnabled(): boolean | cdktf.IResolvable;
    set autoscaleIsEnabled(value: boolean | cdktf.IResolvable);
    resetAutoscaleIsEnabled(): void;
    get autoscaleIsEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _masterHost?;
    get masterHost(): string;
    set masterHost(value: string);
    get masterHostInput(): string | undefined;
    private _masterPort?;
    get masterPort(): number;
    set masterPort(value: number);
    get masterPortInput(): number | undefined;
    private _autoscaleDown;
    get autoscaleDown(): ElastigroupAwsIntegrationDockerSwarmAutoscaleDownOutputReference;
    putAutoscaleDown(value: ElastigroupAwsIntegrationDockerSwarmAutoscaleDown): void;
    resetAutoscaleDown(): void;
    get autoscaleDownInput(): ElastigroupAwsIntegrationDockerSwarmAutoscaleDown | undefined;
    private _autoscaleHeadroom;
    get autoscaleHeadroom(): ElastigroupAwsIntegrationDockerSwarmAutoscaleHeadroomOutputReference;
    putAutoscaleHeadroom(value: ElastigroupAwsIntegrationDockerSwarmAutoscaleHeadroom): void;
    resetAutoscaleHeadroom(): void;
    get autoscaleHeadroomInput(): ElastigroupAwsIntegrationDockerSwarmAutoscaleHeadroom | undefined;
}
export interface ElastigroupAwsIntegrationEcsAutoscaleAttributes {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#key ElastigroupAws#key}
    */
    readonly key: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#value ElastigroupAws#value}
    */
    readonly value: string;
}
export declare function elastigroupAwsIntegrationEcsAutoscaleAttributesToTerraform(struct?: ElastigroupAwsIntegrationEcsAutoscaleAttributes | cdktf.IResolvable): any;
export declare function elastigroupAwsIntegrationEcsAutoscaleAttributesToHclTerraform(struct?: ElastigroupAwsIntegrationEcsAutoscaleAttributes | cdktf.IResolvable): any;
export declare class ElastigroupAwsIntegrationEcsAutoscaleAttributesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAwsIntegrationEcsAutoscaleAttributes | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAwsIntegrationEcsAutoscaleAttributes | cdktf.IResolvable | undefined);
    private _key?;
    get key(): string;
    set key(value: string);
    get keyInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    get valueInput(): string | undefined;
}
export declare class ElastigroupAwsIntegrationEcsAutoscaleAttributesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAwsIntegrationEcsAutoscaleAttributes[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAwsIntegrationEcsAutoscaleAttributesOutputReference;
}
export interface ElastigroupAwsIntegrationEcsAutoscaleDown {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#evaluation_periods ElastigroupAws#evaluation_periods}
    */
    readonly evaluationPeriods?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#max_scale_down_percentage ElastigroupAws#max_scale_down_percentage}
    */
    readonly maxScaleDownPercentage?: number;
}
export declare function elastigroupAwsIntegrationEcsAutoscaleDownToTerraform(struct?: ElastigroupAwsIntegrationEcsAutoscaleDownOutputReference | ElastigroupAwsIntegrationEcsAutoscaleDown): any;
export declare function elastigroupAwsIntegrationEcsAutoscaleDownToHclTerraform(struct?: ElastigroupAwsIntegrationEcsAutoscaleDownOutputReference | ElastigroupAwsIntegrationEcsAutoscaleDown): any;
export declare class ElastigroupAwsIntegrationEcsAutoscaleDownOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAwsIntegrationEcsAutoscaleDown | undefined;
    set internalValue(value: ElastigroupAwsIntegrationEcsAutoscaleDown | undefined);
    private _evaluationPeriods?;
    get evaluationPeriods(): number;
    set evaluationPeriods(value: number);
    resetEvaluationPeriods(): void;
    get evaluationPeriodsInput(): number | undefined;
    private _maxScaleDownPercentage?;
    get maxScaleDownPercentage(): number;
    set maxScaleDownPercentage(value: number);
    resetMaxScaleDownPercentage(): void;
    get maxScaleDownPercentageInput(): number | undefined;
}
export interface ElastigroupAwsIntegrationEcsAutoscaleHeadroom {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#cpu_per_unit ElastigroupAws#cpu_per_unit}
    */
    readonly cpuPerUnit?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#memory_per_unit ElastigroupAws#memory_per_unit}
    */
    readonly memoryPerUnit?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#num_of_units ElastigroupAws#num_of_units}
    */
    readonly numOfUnits?: number;
}
export declare function elastigroupAwsIntegrationEcsAutoscaleHeadroomToTerraform(struct?: ElastigroupAwsIntegrationEcsAutoscaleHeadroomOutputReference | ElastigroupAwsIntegrationEcsAutoscaleHeadroom): any;
export declare function elastigroupAwsIntegrationEcsAutoscaleHeadroomToHclTerraform(struct?: ElastigroupAwsIntegrationEcsAutoscaleHeadroomOutputReference | ElastigroupAwsIntegrationEcsAutoscaleHeadroom): any;
export declare class ElastigroupAwsIntegrationEcsAutoscaleHeadroomOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAwsIntegrationEcsAutoscaleHeadroom | undefined;
    set internalValue(value: ElastigroupAwsIntegrationEcsAutoscaleHeadroom | undefined);
    private _cpuPerUnit?;
    get cpuPerUnit(): number;
    set cpuPerUnit(value: number);
    resetCpuPerUnit(): void;
    get cpuPerUnitInput(): number | undefined;
    private _memoryPerUnit?;
    get memoryPerUnit(): number;
    set memoryPerUnit(value: number);
    resetMemoryPerUnit(): void;
    get memoryPerUnitInput(): number | undefined;
    private _numOfUnits?;
    get numOfUnits(): number;
    set numOfUnits(value: number);
    resetNumOfUnits(): void;
    get numOfUnitsInput(): number | undefined;
}
export interface ElastigroupAwsIntegrationEcsBatch {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#job_queue_names ElastigroupAws#job_queue_names}
    */
    readonly jobQueueNames: string[];
}
export declare function elastigroupAwsIntegrationEcsBatchToTerraform(struct?: ElastigroupAwsIntegrationEcsBatchOutputReference | ElastigroupAwsIntegrationEcsBatch): any;
export declare function elastigroupAwsIntegrationEcsBatchToHclTerraform(struct?: ElastigroupAwsIntegrationEcsBatchOutputReference | ElastigroupAwsIntegrationEcsBatch): any;
export declare class ElastigroupAwsIntegrationEcsBatchOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAwsIntegrationEcsBatch | undefined;
    set internalValue(value: ElastigroupAwsIntegrationEcsBatch | undefined);
    private _jobQueueNames?;
    get jobQueueNames(): string[];
    set jobQueueNames(value: string[]);
    get jobQueueNamesInput(): string[] | undefined;
}
export interface ElastigroupAwsIntegrationEcs {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#autoscale_cooldown ElastigroupAws#autoscale_cooldown}
    */
    readonly autoscaleCooldown?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#autoscale_is_auto_config ElastigroupAws#autoscale_is_auto_config}
    */
    readonly autoscaleIsAutoConfig?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#autoscale_is_enabled ElastigroupAws#autoscale_is_enabled}
    */
    readonly autoscaleIsEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#autoscale_scale_down_non_service_tasks ElastigroupAws#autoscale_scale_down_non_service_tasks}
    */
    readonly autoscaleScaleDownNonServiceTasks?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#cluster_name ElastigroupAws#cluster_name}
    */
    readonly clusterName: string;
    /**
    * autoscale_attributes block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#autoscale_attributes ElastigroupAws#autoscale_attributes}
    */
    readonly autoscaleAttributes?: ElastigroupAwsIntegrationEcsAutoscaleAttributes[] | cdktf.IResolvable;
    /**
    * autoscale_down block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#autoscale_down ElastigroupAws#autoscale_down}
    */
    readonly autoscaleDown?: ElastigroupAwsIntegrationEcsAutoscaleDown;
    /**
    * autoscale_headroom block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#autoscale_headroom ElastigroupAws#autoscale_headroom}
    */
    readonly autoscaleHeadroom?: ElastigroupAwsIntegrationEcsAutoscaleHeadroom;
    /**
    * batch block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#batch ElastigroupAws#batch}
    */
    readonly batch?: ElastigroupAwsIntegrationEcsBatch;
}
export declare function elastigroupAwsIntegrationEcsToTerraform(struct?: ElastigroupAwsIntegrationEcsOutputReference | ElastigroupAwsIntegrationEcs): any;
export declare function elastigroupAwsIntegrationEcsToHclTerraform(struct?: ElastigroupAwsIntegrationEcsOutputReference | ElastigroupAwsIntegrationEcs): any;
export declare class ElastigroupAwsIntegrationEcsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAwsIntegrationEcs | undefined;
    set internalValue(value: ElastigroupAwsIntegrationEcs | undefined);
    private _autoscaleCooldown?;
    get autoscaleCooldown(): number;
    set autoscaleCooldown(value: number);
    resetAutoscaleCooldown(): void;
    get autoscaleCooldownInput(): number | undefined;
    private _autoscaleIsAutoConfig?;
    get autoscaleIsAutoConfig(): boolean | cdktf.IResolvable;
    set autoscaleIsAutoConfig(value: boolean | cdktf.IResolvable);
    resetAutoscaleIsAutoConfig(): void;
    get autoscaleIsAutoConfigInput(): boolean | cdktf.IResolvable | undefined;
    private _autoscaleIsEnabled?;
    get autoscaleIsEnabled(): boolean | cdktf.IResolvable;
    set autoscaleIsEnabled(value: boolean | cdktf.IResolvable);
    resetAutoscaleIsEnabled(): void;
    get autoscaleIsEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _autoscaleScaleDownNonServiceTasks?;
    get autoscaleScaleDownNonServiceTasks(): boolean | cdktf.IResolvable;
    set autoscaleScaleDownNonServiceTasks(value: boolean | cdktf.IResolvable);
    resetAutoscaleScaleDownNonServiceTasks(): void;
    get autoscaleScaleDownNonServiceTasksInput(): boolean | cdktf.IResolvable | undefined;
    private _clusterName?;
    get clusterName(): string;
    set clusterName(value: string);
    get clusterNameInput(): string | undefined;
    private _autoscaleAttributes;
    get autoscaleAttributes(): ElastigroupAwsIntegrationEcsAutoscaleAttributesList;
    putAutoscaleAttributes(value: ElastigroupAwsIntegrationEcsAutoscaleAttributes[] | cdktf.IResolvable): void;
    resetAutoscaleAttributes(): void;
    get autoscaleAttributesInput(): cdktf.IResolvable | ElastigroupAwsIntegrationEcsAutoscaleAttributes[] | undefined;
    private _autoscaleDown;
    get autoscaleDown(): ElastigroupAwsIntegrationEcsAutoscaleDownOutputReference;
    putAutoscaleDown(value: ElastigroupAwsIntegrationEcsAutoscaleDown): void;
    resetAutoscaleDown(): void;
    get autoscaleDownInput(): ElastigroupAwsIntegrationEcsAutoscaleDown | undefined;
    private _autoscaleHeadroom;
    get autoscaleHeadroom(): ElastigroupAwsIntegrationEcsAutoscaleHeadroomOutputReference;
    putAutoscaleHeadroom(value: ElastigroupAwsIntegrationEcsAutoscaleHeadroom): void;
    resetAutoscaleHeadroom(): void;
    get autoscaleHeadroomInput(): ElastigroupAwsIntegrationEcsAutoscaleHeadroom | undefined;
    private _batch;
    get batch(): ElastigroupAwsIntegrationEcsBatchOutputReference;
    putBatch(value: ElastigroupAwsIntegrationEcsBatch): void;
    resetBatch(): void;
    get batchInput(): ElastigroupAwsIntegrationEcsBatch | undefined;
}
export interface ElastigroupAwsIntegrationGitlabRunner {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#is_enabled ElastigroupAws#is_enabled}
    */
    readonly isEnabled?: boolean | cdktf.IResolvable;
}
export declare function elastigroupAwsIntegrationGitlabRunnerToTerraform(struct?: ElastigroupAwsIntegrationGitlabRunnerOutputReference | ElastigroupAwsIntegrationGitlabRunner): any;
export declare function elastigroupAwsIntegrationGitlabRunnerToHclTerraform(struct?: ElastigroupAwsIntegrationGitlabRunnerOutputReference | ElastigroupAwsIntegrationGitlabRunner): any;
export declare class ElastigroupAwsIntegrationGitlabRunnerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAwsIntegrationGitlabRunner | undefined;
    set internalValue(value: ElastigroupAwsIntegrationGitlabRunner | undefined);
    private _isEnabled?;
    get isEnabled(): boolean | cdktf.IResolvable;
    set isEnabled(value: boolean | cdktf.IResolvable);
    resetIsEnabled(): void;
    get isEnabledInput(): boolean | cdktf.IResolvable | undefined;
}
export interface ElastigroupAwsIntegrationGitlab {
    /**
    * runner block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#runner ElastigroupAws#runner}
    */
    readonly runner?: ElastigroupAwsIntegrationGitlabRunner;
}
export declare function elastigroupAwsIntegrationGitlabToTerraform(struct?: ElastigroupAwsIntegrationGitlabOutputReference | ElastigroupAwsIntegrationGitlab): any;
export declare function elastigroupAwsIntegrationGitlabToHclTerraform(struct?: ElastigroupAwsIntegrationGitlabOutputReference | ElastigroupAwsIntegrationGitlab): any;
export declare class ElastigroupAwsIntegrationGitlabOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAwsIntegrationGitlab | undefined;
    set internalValue(value: ElastigroupAwsIntegrationGitlab | undefined);
    private _runner;
    get runner(): ElastigroupAwsIntegrationGitlabRunnerOutputReference;
    putRunner(value: ElastigroupAwsIntegrationGitlabRunner): void;
    resetRunner(): void;
    get runnerInput(): ElastigroupAwsIntegrationGitlabRunner | undefined;
}
export interface ElastigroupAwsIntegrationKubernetesAutoscaleDown {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#evaluation_periods ElastigroupAws#evaluation_periods}
    */
    readonly evaluationPeriods?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#max_scale_down_percentage ElastigroupAws#max_scale_down_percentage}
    */
    readonly maxScaleDownPercentage?: number;
}
export declare function elastigroupAwsIntegrationKubernetesAutoscaleDownToTerraform(struct?: ElastigroupAwsIntegrationKubernetesAutoscaleDownOutputReference | ElastigroupAwsIntegrationKubernetesAutoscaleDown): any;
export declare function elastigroupAwsIntegrationKubernetesAutoscaleDownToHclTerraform(struct?: ElastigroupAwsIntegrationKubernetesAutoscaleDownOutputReference | ElastigroupAwsIntegrationKubernetesAutoscaleDown): any;
export declare class ElastigroupAwsIntegrationKubernetesAutoscaleDownOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAwsIntegrationKubernetesAutoscaleDown | undefined;
    set internalValue(value: ElastigroupAwsIntegrationKubernetesAutoscaleDown | undefined);
    private _evaluationPeriods?;
    get evaluationPeriods(): number;
    set evaluationPeriods(value: number);
    resetEvaluationPeriods(): void;
    get evaluationPeriodsInput(): number | undefined;
    private _maxScaleDownPercentage?;
    get maxScaleDownPercentage(): number;
    set maxScaleDownPercentage(value: number);
    resetMaxScaleDownPercentage(): void;
    get maxScaleDownPercentageInput(): number | undefined;
}
export interface ElastigroupAwsIntegrationKubernetesAutoscaleHeadroom {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#cpu_per_unit ElastigroupAws#cpu_per_unit}
    */
    readonly cpuPerUnit?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#memory_per_unit ElastigroupAws#memory_per_unit}
    */
    readonly memoryPerUnit?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#num_of_units ElastigroupAws#num_of_units}
    */
    readonly numOfUnits?: number;
}
export declare function elastigroupAwsIntegrationKubernetesAutoscaleHeadroomToTerraform(struct?: ElastigroupAwsIntegrationKubernetesAutoscaleHeadroomOutputReference | ElastigroupAwsIntegrationKubernetesAutoscaleHeadroom): any;
export declare function elastigroupAwsIntegrationKubernetesAutoscaleHeadroomToHclTerraform(struct?: ElastigroupAwsIntegrationKubernetesAutoscaleHeadroomOutputReference | ElastigroupAwsIntegrationKubernetesAutoscaleHeadroom): any;
export declare class ElastigroupAwsIntegrationKubernetesAutoscaleHeadroomOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAwsIntegrationKubernetesAutoscaleHeadroom | undefined;
    set internalValue(value: ElastigroupAwsIntegrationKubernetesAutoscaleHeadroom | undefined);
    private _cpuPerUnit?;
    get cpuPerUnit(): number;
    set cpuPerUnit(value: number);
    resetCpuPerUnit(): void;
    get cpuPerUnitInput(): number | undefined;
    private _memoryPerUnit?;
    get memoryPerUnit(): number;
    set memoryPerUnit(value: number);
    resetMemoryPerUnit(): void;
    get memoryPerUnitInput(): number | undefined;
    private _numOfUnits?;
    get numOfUnits(): number;
    set numOfUnits(value: number);
    resetNumOfUnits(): void;
    get numOfUnitsInput(): number | undefined;
}
export interface ElastigroupAwsIntegrationKubernetesAutoscaleLabels {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#key ElastigroupAws#key}
    */
    readonly key: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#value ElastigroupAws#value}
    */
    readonly value: string;
}
export declare function elastigroupAwsIntegrationKubernetesAutoscaleLabelsToTerraform(struct?: ElastigroupAwsIntegrationKubernetesAutoscaleLabels | cdktf.IResolvable): any;
export declare function elastigroupAwsIntegrationKubernetesAutoscaleLabelsToHclTerraform(struct?: ElastigroupAwsIntegrationKubernetesAutoscaleLabels | cdktf.IResolvable): any;
export declare class ElastigroupAwsIntegrationKubernetesAutoscaleLabelsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAwsIntegrationKubernetesAutoscaleLabels | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAwsIntegrationKubernetesAutoscaleLabels | cdktf.IResolvable | undefined);
    private _key?;
    get key(): string;
    set key(value: string);
    get keyInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    get valueInput(): string | undefined;
}
export declare class ElastigroupAwsIntegrationKubernetesAutoscaleLabelsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAwsIntegrationKubernetesAutoscaleLabels[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAwsIntegrationKubernetesAutoscaleLabelsOutputReference;
}
export interface ElastigroupAwsIntegrationKubernetes {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#api_server ElastigroupAws#api_server}
    */
    readonly apiServer?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#autoscale_cooldown ElastigroupAws#autoscale_cooldown}
    */
    readonly autoscaleCooldown?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#autoscale_is_auto_config ElastigroupAws#autoscale_is_auto_config}
    */
    readonly autoscaleIsAutoConfig?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#autoscale_is_enabled ElastigroupAws#autoscale_is_enabled}
    */
    readonly autoscaleIsEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#cluster_identifier ElastigroupAws#cluster_identifier}
    */
    readonly clusterIdentifier?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#integration_mode ElastigroupAws#integration_mode}
    */
    readonly integrationMode?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#token ElastigroupAws#token}
    */
    readonly token?: string;
    /**
    * autoscale_down block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#autoscale_down ElastigroupAws#autoscale_down}
    */
    readonly autoscaleDown?: ElastigroupAwsIntegrationKubernetesAutoscaleDown;
    /**
    * autoscale_headroom block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#autoscale_headroom ElastigroupAws#autoscale_headroom}
    */
    readonly autoscaleHeadroom?: ElastigroupAwsIntegrationKubernetesAutoscaleHeadroom;
    /**
    * autoscale_labels block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#autoscale_labels ElastigroupAws#autoscale_labels}
    */
    readonly autoscaleLabels?: ElastigroupAwsIntegrationKubernetesAutoscaleLabels[] | cdktf.IResolvable;
}
export declare function elastigroupAwsIntegrationKubernetesToTerraform(struct?: ElastigroupAwsIntegrationKubernetesOutputReference | ElastigroupAwsIntegrationKubernetes): any;
export declare function elastigroupAwsIntegrationKubernetesToHclTerraform(struct?: ElastigroupAwsIntegrationKubernetesOutputReference | ElastigroupAwsIntegrationKubernetes): any;
export declare class ElastigroupAwsIntegrationKubernetesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAwsIntegrationKubernetes | undefined;
    set internalValue(value: ElastigroupAwsIntegrationKubernetes | undefined);
    private _apiServer?;
    get apiServer(): string;
    set apiServer(value: string);
    resetApiServer(): void;
    get apiServerInput(): string | undefined;
    private _autoscaleCooldown?;
    get autoscaleCooldown(): number;
    set autoscaleCooldown(value: number);
    resetAutoscaleCooldown(): void;
    get autoscaleCooldownInput(): number | undefined;
    private _autoscaleIsAutoConfig?;
    get autoscaleIsAutoConfig(): boolean | cdktf.IResolvable;
    set autoscaleIsAutoConfig(value: boolean | cdktf.IResolvable);
    resetAutoscaleIsAutoConfig(): void;
    get autoscaleIsAutoConfigInput(): boolean | cdktf.IResolvable | undefined;
    private _autoscaleIsEnabled?;
    get autoscaleIsEnabled(): boolean | cdktf.IResolvable;
    set autoscaleIsEnabled(value: boolean | cdktf.IResolvable);
    resetAutoscaleIsEnabled(): void;
    get autoscaleIsEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _clusterIdentifier?;
    get clusterIdentifier(): string;
    set clusterIdentifier(value: string);
    resetClusterIdentifier(): void;
    get clusterIdentifierInput(): string | undefined;
    private _integrationMode?;
    get integrationMode(): string;
    set integrationMode(value: string);
    resetIntegrationMode(): void;
    get integrationModeInput(): string | undefined;
    private _token?;
    get token(): string;
    set token(value: string);
    resetToken(): void;
    get tokenInput(): string | undefined;
    private _autoscaleDown;
    get autoscaleDown(): ElastigroupAwsIntegrationKubernetesAutoscaleDownOutputReference;
    putAutoscaleDown(value: ElastigroupAwsIntegrationKubernetesAutoscaleDown): void;
    resetAutoscaleDown(): void;
    get autoscaleDownInput(): ElastigroupAwsIntegrationKubernetesAutoscaleDown | undefined;
    private _autoscaleHeadroom;
    get autoscaleHeadroom(): ElastigroupAwsIntegrationKubernetesAutoscaleHeadroomOutputReference;
    putAutoscaleHeadroom(value: ElastigroupAwsIntegrationKubernetesAutoscaleHeadroom): void;
    resetAutoscaleHeadroom(): void;
    get autoscaleHeadroomInput(): ElastigroupAwsIntegrationKubernetesAutoscaleHeadroom | undefined;
    private _autoscaleLabels;
    get autoscaleLabels(): ElastigroupAwsIntegrationKubernetesAutoscaleLabelsList;
    putAutoscaleLabels(value: ElastigroupAwsIntegrationKubernetesAutoscaleLabels[] | cdktf.IResolvable): void;
    resetAutoscaleLabels(): void;
    get autoscaleLabelsInput(): cdktf.IResolvable | ElastigroupAwsIntegrationKubernetesAutoscaleLabels[] | undefined;
}
export interface ElastigroupAwsIntegrationMesosphere {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#api_server ElastigroupAws#api_server}
    */
    readonly apiServer: string;
}
export declare function elastigroupAwsIntegrationMesosphereToTerraform(struct?: ElastigroupAwsIntegrationMesosphereOutputReference | ElastigroupAwsIntegrationMesosphere): any;
export declare function elastigroupAwsIntegrationMesosphereToHclTerraform(struct?: ElastigroupAwsIntegrationMesosphereOutputReference | ElastigroupAwsIntegrationMesosphere): any;
export declare class ElastigroupAwsIntegrationMesosphereOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAwsIntegrationMesosphere | undefined;
    set internalValue(value: ElastigroupAwsIntegrationMesosphere | undefined);
    private _apiServer?;
    get apiServer(): string;
    set apiServer(value: string);
    get apiServerInput(): string | undefined;
}
export interface ElastigroupAwsIntegrationNomadAutoscaleConstraints {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#key ElastigroupAws#key}
    */
    readonly key: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#value ElastigroupAws#value}
    */
    readonly value: string;
}
export declare function elastigroupAwsIntegrationNomadAutoscaleConstraintsToTerraform(struct?: ElastigroupAwsIntegrationNomadAutoscaleConstraints | cdktf.IResolvable): any;
export declare function elastigroupAwsIntegrationNomadAutoscaleConstraintsToHclTerraform(struct?: ElastigroupAwsIntegrationNomadAutoscaleConstraints | cdktf.IResolvable): any;
export declare class ElastigroupAwsIntegrationNomadAutoscaleConstraintsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAwsIntegrationNomadAutoscaleConstraints | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAwsIntegrationNomadAutoscaleConstraints | cdktf.IResolvable | undefined);
    private _key?;
    get key(): string;
    set key(value: string);
    get keyInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    get valueInput(): string | undefined;
}
export declare class ElastigroupAwsIntegrationNomadAutoscaleConstraintsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAwsIntegrationNomadAutoscaleConstraints[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAwsIntegrationNomadAutoscaleConstraintsOutputReference;
}
export interface ElastigroupAwsIntegrationNomadAutoscaleDown {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#evaluation_periods ElastigroupAws#evaluation_periods}
    */
    readonly evaluationPeriods?: number;
}
export declare function elastigroupAwsIntegrationNomadAutoscaleDownToTerraform(struct?: ElastigroupAwsIntegrationNomadAutoscaleDownOutputReference | ElastigroupAwsIntegrationNomadAutoscaleDown): any;
export declare function elastigroupAwsIntegrationNomadAutoscaleDownToHclTerraform(struct?: ElastigroupAwsIntegrationNomadAutoscaleDownOutputReference | ElastigroupAwsIntegrationNomadAutoscaleDown): any;
export declare class ElastigroupAwsIntegrationNomadAutoscaleDownOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAwsIntegrationNomadAutoscaleDown | undefined;
    set internalValue(value: ElastigroupAwsIntegrationNomadAutoscaleDown | undefined);
    private _evaluationPeriods?;
    get evaluationPeriods(): number;
    set evaluationPeriods(value: number);
    resetEvaluationPeriods(): void;
    get evaluationPeriodsInput(): number | undefined;
}
export interface ElastigroupAwsIntegrationNomadAutoscaleHeadroom {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#cpu_per_unit ElastigroupAws#cpu_per_unit}
    */
    readonly cpuPerUnit?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#memory_per_unit ElastigroupAws#memory_per_unit}
    */
    readonly memoryPerUnit?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#num_of_units ElastigroupAws#num_of_units}
    */
    readonly numOfUnits?: number;
}
export declare function elastigroupAwsIntegrationNomadAutoscaleHeadroomToTerraform(struct?: ElastigroupAwsIntegrationNomadAutoscaleHeadroomOutputReference | ElastigroupAwsIntegrationNomadAutoscaleHeadroom): any;
export declare function elastigroupAwsIntegrationNomadAutoscaleHeadroomToHclTerraform(struct?: ElastigroupAwsIntegrationNomadAutoscaleHeadroomOutputReference | ElastigroupAwsIntegrationNomadAutoscaleHeadroom): any;
export declare class ElastigroupAwsIntegrationNomadAutoscaleHeadroomOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAwsIntegrationNomadAutoscaleHeadroom | undefined;
    set internalValue(value: ElastigroupAwsIntegrationNomadAutoscaleHeadroom | undefined);
    private _cpuPerUnit?;
    get cpuPerUnit(): number;
    set cpuPerUnit(value: number);
    resetCpuPerUnit(): void;
    get cpuPerUnitInput(): number | undefined;
    private _memoryPerUnit?;
    get memoryPerUnit(): number;
    set memoryPerUnit(value: number);
    resetMemoryPerUnit(): void;
    get memoryPerUnitInput(): number | undefined;
    private _numOfUnits?;
    get numOfUnits(): number;
    set numOfUnits(value: number);
    resetNumOfUnits(): void;
    get numOfUnitsInput(): number | undefined;
}
export interface ElastigroupAwsIntegrationNomad {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#acl_token ElastigroupAws#acl_token}
    */
    readonly aclToken?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#autoscale_cooldown ElastigroupAws#autoscale_cooldown}
    */
    readonly autoscaleCooldown?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#autoscale_is_enabled ElastigroupAws#autoscale_is_enabled}
    */
    readonly autoscaleIsEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#master_host ElastigroupAws#master_host}
    */
    readonly masterHost: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#master_port ElastigroupAws#master_port}
    */
    readonly masterPort: number;
    /**
    * autoscale_constraints block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#autoscale_constraints ElastigroupAws#autoscale_constraints}
    */
    readonly autoscaleConstraints?: ElastigroupAwsIntegrationNomadAutoscaleConstraints[] | cdktf.IResolvable;
    /**
    * autoscale_down block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#autoscale_down ElastigroupAws#autoscale_down}
    */
    readonly autoscaleDown?: ElastigroupAwsIntegrationNomadAutoscaleDown;
    /**
    * autoscale_headroom block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#autoscale_headroom ElastigroupAws#autoscale_headroom}
    */
    readonly autoscaleHeadroom?: ElastigroupAwsIntegrationNomadAutoscaleHeadroom;
}
export declare function elastigroupAwsIntegrationNomadToTerraform(struct?: ElastigroupAwsIntegrationNomadOutputReference | ElastigroupAwsIntegrationNomad): any;
export declare function elastigroupAwsIntegrationNomadToHclTerraform(struct?: ElastigroupAwsIntegrationNomadOutputReference | ElastigroupAwsIntegrationNomad): any;
export declare class ElastigroupAwsIntegrationNomadOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAwsIntegrationNomad | undefined;
    set internalValue(value: ElastigroupAwsIntegrationNomad | undefined);
    private _aclToken?;
    get aclToken(): string;
    set aclToken(value: string);
    resetAclToken(): void;
    get aclTokenInput(): string | undefined;
    private _autoscaleCooldown?;
    get autoscaleCooldown(): number;
    set autoscaleCooldown(value: number);
    resetAutoscaleCooldown(): void;
    get autoscaleCooldownInput(): number | undefined;
    private _autoscaleIsEnabled?;
    get autoscaleIsEnabled(): boolean | cdktf.IResolvable;
    set autoscaleIsEnabled(value: boolean | cdktf.IResolvable);
    resetAutoscaleIsEnabled(): void;
    get autoscaleIsEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _masterHost?;
    get masterHost(): string;
    set masterHost(value: string);
    get masterHostInput(): string | undefined;
    private _masterPort?;
    get masterPort(): number;
    set masterPort(value: number);
    get masterPortInput(): number | undefined;
    private _autoscaleConstraints;
    get autoscaleConstraints(): ElastigroupAwsIntegrationNomadAutoscaleConstraintsList;
    putAutoscaleConstraints(value: ElastigroupAwsIntegrationNomadAutoscaleConstraints[] | cdktf.IResolvable): void;
    resetAutoscaleConstraints(): void;
    get autoscaleConstraintsInput(): cdktf.IResolvable | ElastigroupAwsIntegrationNomadAutoscaleConstraints[] | undefined;
    private _autoscaleDown;
    get autoscaleDown(): ElastigroupAwsIntegrationNomadAutoscaleDownOutputReference;
    putAutoscaleDown(value: ElastigroupAwsIntegrationNomadAutoscaleDown): void;
    resetAutoscaleDown(): void;
    get autoscaleDownInput(): ElastigroupAwsIntegrationNomadAutoscaleDown | undefined;
    private _autoscaleHeadroom;
    get autoscaleHeadroom(): ElastigroupAwsIntegrationNomadAutoscaleHeadroomOutputReference;
    putAutoscaleHeadroom(value: ElastigroupAwsIntegrationNomadAutoscaleHeadroom): void;
    resetAutoscaleHeadroom(): void;
    get autoscaleHeadroomInput(): ElastigroupAwsIntegrationNomadAutoscaleHeadroom | undefined;
}
export interface ElastigroupAwsIntegrationRancher {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#access_key ElastigroupAws#access_key}
    */
    readonly accessKey: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#master_host ElastigroupAws#master_host}
    */
    readonly masterHost: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#secret_key ElastigroupAws#secret_key}
    */
    readonly secretKey: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#version ElastigroupAws#version}
    */
    readonly version?: string;
}
export declare function elastigroupAwsIntegrationRancherToTerraform(struct?: ElastigroupAwsIntegrationRancherOutputReference | ElastigroupAwsIntegrationRancher): any;
export declare function elastigroupAwsIntegrationRancherToHclTerraform(struct?: ElastigroupAwsIntegrationRancherOutputReference | ElastigroupAwsIntegrationRancher): any;
export declare class ElastigroupAwsIntegrationRancherOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAwsIntegrationRancher | undefined;
    set internalValue(value: ElastigroupAwsIntegrationRancher | undefined);
    private _accessKey?;
    get accessKey(): string;
    set accessKey(value: string);
    get accessKeyInput(): string | undefined;
    private _masterHost?;
    get masterHost(): string;
    set masterHost(value: string);
    get masterHostInput(): string | undefined;
    private _secretKey?;
    get secretKey(): string;
    set secretKey(value: string);
    get secretKeyInput(): string | undefined;
    private _version?;
    get version(): string;
    set version(value: string);
    resetVersion(): void;
    get versionInput(): string | undefined;
}
export interface ElastigroupAwsIntegrationRoute53DomainsRecordSets {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#name ElastigroupAws#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#use_public_dns ElastigroupAws#use_public_dns}
    */
    readonly usePublicDns?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#use_public_ip ElastigroupAws#use_public_ip}
    */
    readonly usePublicIp?: boolean | cdktf.IResolvable;
}
export declare function elastigroupAwsIntegrationRoute53DomainsRecordSetsToTerraform(struct?: ElastigroupAwsIntegrationRoute53DomainsRecordSets | cdktf.IResolvable): any;
export declare function elastigroupAwsIntegrationRoute53DomainsRecordSetsToHclTerraform(struct?: ElastigroupAwsIntegrationRoute53DomainsRecordSets | cdktf.IResolvable): any;
export declare class ElastigroupAwsIntegrationRoute53DomainsRecordSetsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAwsIntegrationRoute53DomainsRecordSets | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAwsIntegrationRoute53DomainsRecordSets | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _usePublicDns?;
    get usePublicDns(): boolean | cdktf.IResolvable;
    set usePublicDns(value: boolean | cdktf.IResolvable);
    resetUsePublicDns(): void;
    get usePublicDnsInput(): boolean | cdktf.IResolvable | undefined;
    private _usePublicIp?;
    get usePublicIp(): boolean | cdktf.IResolvable;
    set usePublicIp(value: boolean | cdktf.IResolvable);
    resetUsePublicIp(): void;
    get usePublicIpInput(): boolean | cdktf.IResolvable | undefined;
}
export declare class ElastigroupAwsIntegrationRoute53DomainsRecordSetsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAwsIntegrationRoute53DomainsRecordSets[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAwsIntegrationRoute53DomainsRecordSetsOutputReference;
}
export interface ElastigroupAwsIntegrationRoute53Domains {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#hosted_zone_id ElastigroupAws#hosted_zone_id}
    */
    readonly hostedZoneId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#record_set_type ElastigroupAws#record_set_type}
    */
    readonly recordSetType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#spotinst_acct_id ElastigroupAws#spotinst_acct_id}
    */
    readonly spotinstAcctId?: string;
    /**
    * record_sets block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#record_sets ElastigroupAws#record_sets}
    */
    readonly recordSets: ElastigroupAwsIntegrationRoute53DomainsRecordSets[] | cdktf.IResolvable;
}
export declare function elastigroupAwsIntegrationRoute53DomainsToTerraform(struct?: ElastigroupAwsIntegrationRoute53Domains | cdktf.IResolvable): any;
export declare function elastigroupAwsIntegrationRoute53DomainsToHclTerraform(struct?: ElastigroupAwsIntegrationRoute53Domains | cdktf.IResolvable): any;
export declare class ElastigroupAwsIntegrationRoute53DomainsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAwsIntegrationRoute53Domains | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAwsIntegrationRoute53Domains | cdktf.IResolvable | undefined);
    private _hostedZoneId?;
    get hostedZoneId(): string;
    set hostedZoneId(value: string);
    get hostedZoneIdInput(): string | undefined;
    private _recordSetType?;
    get recordSetType(): string;
    set recordSetType(value: string);
    resetRecordSetType(): void;
    get recordSetTypeInput(): string | undefined;
    private _spotinstAcctId?;
    get spotinstAcctId(): string;
    set spotinstAcctId(value: string);
    resetSpotinstAcctId(): void;
    get spotinstAcctIdInput(): string | undefined;
    private _recordSets;
    get recordSets(): ElastigroupAwsIntegrationRoute53DomainsRecordSetsList;
    putRecordSets(value: ElastigroupAwsIntegrationRoute53DomainsRecordSets[] | cdktf.IResolvable): void;
    get recordSetsInput(): cdktf.IResolvable | ElastigroupAwsIntegrationRoute53DomainsRecordSets[] | undefined;
}
export declare class ElastigroupAwsIntegrationRoute53DomainsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAwsIntegrationRoute53Domains[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAwsIntegrationRoute53DomainsOutputReference;
}
export interface ElastigroupAwsIntegrationRoute53 {
    /**
    * domains block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#domains ElastigroupAws#domains}
    */
    readonly domains: ElastigroupAwsIntegrationRoute53Domains[] | cdktf.IResolvable;
}
export declare function elastigroupAwsIntegrationRoute53ToTerraform(struct?: ElastigroupAwsIntegrationRoute53OutputReference | ElastigroupAwsIntegrationRoute53): any;
export declare function elastigroupAwsIntegrationRoute53ToHclTerraform(struct?: ElastigroupAwsIntegrationRoute53OutputReference | ElastigroupAwsIntegrationRoute53): any;
export declare class ElastigroupAwsIntegrationRoute53OutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAwsIntegrationRoute53 | undefined;
    set internalValue(value: ElastigroupAwsIntegrationRoute53 | undefined);
    private _domains;
    get domains(): ElastigroupAwsIntegrationRoute53DomainsList;
    putDomains(value: ElastigroupAwsIntegrationRoute53Domains[] | cdktf.IResolvable): void;
    get domainsInput(): cdktf.IResolvable | ElastigroupAwsIntegrationRoute53Domains[] | undefined;
}
export interface ElastigroupAwsItfDefaultStaticTargetGroup {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#arn ElastigroupAws#arn}
    */
    readonly arn: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#percentage ElastigroupAws#percentage}
    */
    readonly percentage: number;
}
export declare function elastigroupAwsItfDefaultStaticTargetGroupToTerraform(struct?: ElastigroupAwsItfDefaultStaticTargetGroupOutputReference | ElastigroupAwsItfDefaultStaticTargetGroup): any;
export declare function elastigroupAwsItfDefaultStaticTargetGroupToHclTerraform(struct?: ElastigroupAwsItfDefaultStaticTargetGroupOutputReference | ElastigroupAwsItfDefaultStaticTargetGroup): any;
export declare class ElastigroupAwsItfDefaultStaticTargetGroupOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAwsItfDefaultStaticTargetGroup | undefined;
    set internalValue(value: ElastigroupAwsItfDefaultStaticTargetGroup | undefined);
    private _arn?;
    get arn(): string;
    set arn(value: string);
    get arnInput(): string | undefined;
    private _percentage?;
    get percentage(): number;
    set percentage(value: number);
    get percentageInput(): number | undefined;
}
export interface ElastigroupAwsItfLoadBalancerListenerRuleStaticTargetGroup {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#arn ElastigroupAws#arn}
    */
    readonly arn: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#percentage ElastigroupAws#percentage}
    */
    readonly percentage: number;
}
export declare function elastigroupAwsItfLoadBalancerListenerRuleStaticTargetGroupToTerraform(struct?: ElastigroupAwsItfLoadBalancerListenerRuleStaticTargetGroupOutputReference | ElastigroupAwsItfLoadBalancerListenerRuleStaticTargetGroup): any;
export declare function elastigroupAwsItfLoadBalancerListenerRuleStaticTargetGroupToHclTerraform(struct?: ElastigroupAwsItfLoadBalancerListenerRuleStaticTargetGroupOutputReference | ElastigroupAwsItfLoadBalancerListenerRuleStaticTargetGroup): any;
export declare class ElastigroupAwsItfLoadBalancerListenerRuleStaticTargetGroupOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAwsItfLoadBalancerListenerRuleStaticTargetGroup | undefined;
    set internalValue(value: ElastigroupAwsItfLoadBalancerListenerRuleStaticTargetGroup | undefined);
    private _arn?;
    get arn(): string;
    set arn(value: string);
    get arnInput(): string | undefined;
    private _percentage?;
    get percentage(): number;
    set percentage(value: number);
    get percentageInput(): number | undefined;
}
export interface ElastigroupAwsItfLoadBalancerListenerRule {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#rule_arn ElastigroupAws#rule_arn}
    */
    readonly ruleArn: string;
    /**
    * static_target_group block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#static_target_group ElastigroupAws#static_target_group}
    */
    readonly staticTargetGroup?: ElastigroupAwsItfLoadBalancerListenerRuleStaticTargetGroup;
}
export declare function elastigroupAwsItfLoadBalancerListenerRuleToTerraform(struct?: ElastigroupAwsItfLoadBalancerListenerRule | cdktf.IResolvable): any;
export declare function elastigroupAwsItfLoadBalancerListenerRuleToHclTerraform(struct?: ElastigroupAwsItfLoadBalancerListenerRule | cdktf.IResolvable): any;
export declare class ElastigroupAwsItfLoadBalancerListenerRuleOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAwsItfLoadBalancerListenerRule | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAwsItfLoadBalancerListenerRule | cdktf.IResolvable | undefined);
    private _ruleArn?;
    get ruleArn(): string;
    set ruleArn(value: string);
    get ruleArnInput(): string | undefined;
    private _staticTargetGroup;
    get staticTargetGroup(): ElastigroupAwsItfLoadBalancerListenerRuleStaticTargetGroupOutputReference;
    putStaticTargetGroup(value: ElastigroupAwsItfLoadBalancerListenerRuleStaticTargetGroup): void;
    resetStaticTargetGroup(): void;
    get staticTargetGroupInput(): ElastigroupAwsItfLoadBalancerListenerRuleStaticTargetGroup | undefined;
}
export declare class ElastigroupAwsItfLoadBalancerListenerRuleList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAwsItfLoadBalancerListenerRule[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAwsItfLoadBalancerListenerRuleOutputReference;
}
export interface ElastigroupAwsItfLoadBalancer {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#load_balancer_arn ElastigroupAws#load_balancer_arn}
    */
    readonly loadBalancerArn: string;
    /**
    * listener_rule block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#listener_rule ElastigroupAws#listener_rule}
    */
    readonly listenerRule: ElastigroupAwsItfLoadBalancerListenerRule[] | cdktf.IResolvable;
}
export declare function elastigroupAwsItfLoadBalancerToTerraform(struct?: ElastigroupAwsItfLoadBalancer | cdktf.IResolvable): any;
export declare function elastigroupAwsItfLoadBalancerToHclTerraform(struct?: ElastigroupAwsItfLoadBalancer | cdktf.IResolvable): any;
export declare class ElastigroupAwsItfLoadBalancerOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAwsItfLoadBalancer | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAwsItfLoadBalancer | cdktf.IResolvable | undefined);
    private _loadBalancerArn?;
    get loadBalancerArn(): string;
    set loadBalancerArn(value: string);
    get loadBalancerArnInput(): string | undefined;
    private _listenerRule;
    get listenerRule(): ElastigroupAwsItfLoadBalancerListenerRuleList;
    putListenerRule(value: ElastigroupAwsItfLoadBalancerListenerRule[] | cdktf.IResolvable): void;
    get listenerRuleInput(): cdktf.IResolvable | ElastigroupAwsItfLoadBalancerListenerRule[] | undefined;
}
export declare class ElastigroupAwsItfLoadBalancerList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAwsItfLoadBalancer[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAwsItfLoadBalancerOutputReference;
}
export interface ElastigroupAwsItfTargetGroupConfigMatcher {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#grpc_code ElastigroupAws#grpc_code}
    */
    readonly grpcCode?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#http_code ElastigroupAws#http_code}
    */
    readonly httpCode?: string;
}
export declare function elastigroupAwsItfTargetGroupConfigMatcherToTerraform(struct?: ElastigroupAwsItfTargetGroupConfigMatcher | cdktf.IResolvable): any;
export declare function elastigroupAwsItfTargetGroupConfigMatcherToHclTerraform(struct?: ElastigroupAwsItfTargetGroupConfigMatcher | cdktf.IResolvable): any;
export declare class ElastigroupAwsItfTargetGroupConfigMatcherOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAwsItfTargetGroupConfigMatcher | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAwsItfTargetGroupConfigMatcher | cdktf.IResolvable | undefined);
    private _grpcCode?;
    get grpcCode(): string;
    set grpcCode(value: string);
    resetGrpcCode(): void;
    get grpcCodeInput(): string | undefined;
    private _httpCode?;
    get httpCode(): string;
    set httpCode(value: string);
    resetHttpCode(): void;
    get httpCodeInput(): string | undefined;
}
export declare class ElastigroupAwsItfTargetGroupConfigMatcherList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAwsItfTargetGroupConfigMatcher[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAwsItfTargetGroupConfigMatcherOutputReference;
}
export interface ElastigroupAwsItfTargetGroupConfigTags {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#tag_key ElastigroupAws#tag_key}
    */
    readonly tagKey: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#tag_value ElastigroupAws#tag_value}
    */
    readonly tagValue?: string;
}
export declare function elastigroupAwsItfTargetGroupConfigTagsToTerraform(struct?: ElastigroupAwsItfTargetGroupConfigTags | cdktf.IResolvable): any;
export declare function elastigroupAwsItfTargetGroupConfigTagsToHclTerraform(struct?: ElastigroupAwsItfTargetGroupConfigTags | cdktf.IResolvable): any;
export declare class ElastigroupAwsItfTargetGroupConfigTagsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAwsItfTargetGroupConfigTags | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAwsItfTargetGroupConfigTags | cdktf.IResolvable | undefined);
    private _tagKey?;
    get tagKey(): string;
    set tagKey(value: string);
    get tagKeyInput(): string | undefined;
    private _tagValue?;
    get tagValue(): string;
    set tagValue(value: string);
    resetTagValue(): void;
    get tagValueInput(): string | undefined;
}
export declare class ElastigroupAwsItfTargetGroupConfigTagsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAwsItfTargetGroupConfigTags[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAwsItfTargetGroupConfigTagsOutputReference;
}
export interface ElastigroupAwsItfTargetGroupConfig {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#health_check_interval_seconds ElastigroupAws#health_check_interval_seconds}
    */
    readonly healthCheckIntervalSeconds?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#health_check_path ElastigroupAws#health_check_path}
    */
    readonly healthCheckPath: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#health_check_port ElastigroupAws#health_check_port}
    */
    readonly healthCheckPort?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#health_check_protocol ElastigroupAws#health_check_protocol}
    */
    readonly healthCheckProtocol?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#health_check_timeout_seconds ElastigroupAws#health_check_timeout_seconds}
    */
    readonly healthCheckTimeoutSeconds?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#healthy_threshold_count ElastigroupAws#healthy_threshold_count}
    */
    readonly healthyThresholdCount?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#port ElastigroupAws#port}
    */
    readonly port: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#protocol ElastigroupAws#protocol}
    */
    readonly protocol: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#protocol_version ElastigroupAws#protocol_version}
    */
    readonly protocolVersion?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#unhealthy_threshold_count ElastigroupAws#unhealthy_threshold_count}
    */
    readonly unhealthyThresholdCount?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#vpc_id ElastigroupAws#vpc_id}
    */
    readonly vpcId: string;
    /**
    * matcher block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#matcher ElastigroupAws#matcher}
    */
    readonly matcher?: ElastigroupAwsItfTargetGroupConfigMatcher[] | cdktf.IResolvable;
    /**
    * tags block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#tags ElastigroupAws#tags}
    */
    readonly tags?: ElastigroupAwsItfTargetGroupConfigTags[] | cdktf.IResolvable;
}
export declare function elastigroupAwsItfTargetGroupConfigToTerraform(struct?: ElastigroupAwsItfTargetGroupConfig | cdktf.IResolvable): any;
export declare function elastigroupAwsItfTargetGroupConfigToHclTerraform(struct?: ElastigroupAwsItfTargetGroupConfig | cdktf.IResolvable): any;
export declare class ElastigroupAwsItfTargetGroupConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAwsItfTargetGroupConfig | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAwsItfTargetGroupConfig | cdktf.IResolvable | undefined);
    private _healthCheckIntervalSeconds?;
    get healthCheckIntervalSeconds(): number;
    set healthCheckIntervalSeconds(value: number);
    resetHealthCheckIntervalSeconds(): void;
    get healthCheckIntervalSecondsInput(): number | undefined;
    private _healthCheckPath?;
    get healthCheckPath(): string;
    set healthCheckPath(value: string);
    get healthCheckPathInput(): string | undefined;
    private _healthCheckPort?;
    get healthCheckPort(): string;
    set healthCheckPort(value: string);
    resetHealthCheckPort(): void;
    get healthCheckPortInput(): string | undefined;
    private _healthCheckProtocol?;
    get healthCheckProtocol(): string;
    set healthCheckProtocol(value: string);
    resetHealthCheckProtocol(): void;
    get healthCheckProtocolInput(): string | undefined;
    private _healthCheckTimeoutSeconds?;
    get healthCheckTimeoutSeconds(): number;
    set healthCheckTimeoutSeconds(value: number);
    resetHealthCheckTimeoutSeconds(): void;
    get healthCheckTimeoutSecondsInput(): number | undefined;
    private _healthyThresholdCount?;
    get healthyThresholdCount(): number;
    set healthyThresholdCount(value: number);
    resetHealthyThresholdCount(): void;
    get healthyThresholdCountInput(): number | undefined;
    private _port?;
    get port(): number;
    set port(value: number);
    get portInput(): number | undefined;
    private _protocol?;
    get protocol(): string;
    set protocol(value: string);
    get protocolInput(): string | undefined;
    private _protocolVersion?;
    get protocolVersion(): string;
    set protocolVersion(value: string);
    resetProtocolVersion(): void;
    get protocolVersionInput(): string | undefined;
    private _unhealthyThresholdCount?;
    get unhealthyThresholdCount(): number;
    set unhealthyThresholdCount(value: number);
    resetUnhealthyThresholdCount(): void;
    get unhealthyThresholdCountInput(): number | undefined;
    private _vpcId?;
    get vpcId(): string;
    set vpcId(value: string);
    get vpcIdInput(): string | undefined;
    private _matcher;
    get matcher(): ElastigroupAwsItfTargetGroupConfigMatcherList;
    putMatcher(value: ElastigroupAwsItfTargetGroupConfigMatcher[] | cdktf.IResolvable): void;
    resetMatcher(): void;
    get matcherInput(): cdktf.IResolvable | ElastigroupAwsItfTargetGroupConfigMatcher[] | undefined;
    private _tags;
    get tags(): ElastigroupAwsItfTargetGroupConfigTagsList;
    putTags(value: ElastigroupAwsItfTargetGroupConfigTags[] | cdktf.IResolvable): void;
    resetTags(): void;
    get tagsInput(): cdktf.IResolvable | ElastigroupAwsItfTargetGroupConfigTags[] | undefined;
}
export declare class ElastigroupAwsItfTargetGroupConfigList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAwsItfTargetGroupConfig[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAwsItfTargetGroupConfigOutputReference;
}
export interface ElastigroupAwsItf {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#fixed_target_groups ElastigroupAws#fixed_target_groups}
    */
    readonly fixedTargetGroups: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#migration_healthiness_threshold ElastigroupAws#migration_healthiness_threshold}
    */
    readonly migrationHealthinessThreshold?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#weight_strategy ElastigroupAws#weight_strategy}
    */
    readonly weightStrategy: string;
    /**
    * default_static_target_group block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#default_static_target_group ElastigroupAws#default_static_target_group}
    */
    readonly defaultStaticTargetGroup?: ElastigroupAwsItfDefaultStaticTargetGroup;
    /**
    * load_balancer block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#load_balancer ElastigroupAws#load_balancer}
    */
    readonly loadBalancer: ElastigroupAwsItfLoadBalancer[] | cdktf.IResolvable;
    /**
    * target_group_config block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#target_group_config ElastigroupAws#target_group_config}
    */
    readonly targetGroupConfig: ElastigroupAwsItfTargetGroupConfig[] | cdktf.IResolvable;
}
export declare function elastigroupAwsItfToTerraform(struct?: ElastigroupAwsItf | cdktf.IResolvable): any;
export declare function elastigroupAwsItfToHclTerraform(struct?: ElastigroupAwsItf | cdktf.IResolvable): any;
export declare class ElastigroupAwsItfOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAwsItf | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAwsItf | cdktf.IResolvable | undefined);
    private _fixedTargetGroups?;
    get fixedTargetGroups(): boolean | cdktf.IResolvable;
    set fixedTargetGroups(value: boolean | cdktf.IResolvable);
    get fixedTargetGroupsInput(): boolean | cdktf.IResolvable | undefined;
    private _migrationHealthinessThreshold?;
    get migrationHealthinessThreshold(): number;
    set migrationHealthinessThreshold(value: number);
    resetMigrationHealthinessThreshold(): void;
    get migrationHealthinessThresholdInput(): number | undefined;
    private _weightStrategy?;
    get weightStrategy(): string;
    set weightStrategy(value: string);
    get weightStrategyInput(): string | undefined;
    private _defaultStaticTargetGroup;
    get defaultStaticTargetGroup(): ElastigroupAwsItfDefaultStaticTargetGroupOutputReference;
    putDefaultStaticTargetGroup(value: ElastigroupAwsItfDefaultStaticTargetGroup): void;
    resetDefaultStaticTargetGroup(): void;
    get defaultStaticTargetGroupInput(): ElastigroupAwsItfDefaultStaticTargetGroup | undefined;
    private _loadBalancer;
    get loadBalancer(): ElastigroupAwsItfLoadBalancerList;
    putLoadBalancer(value: ElastigroupAwsItfLoadBalancer[] | cdktf.IResolvable): void;
    get loadBalancerInput(): cdktf.IResolvable | ElastigroupAwsItfLoadBalancer[] | undefined;
    private _targetGroupConfig;
    get targetGroupConfig(): ElastigroupAwsItfTargetGroupConfigList;
    putTargetGroupConfig(value: ElastigroupAwsItfTargetGroupConfig[] | cdktf.IResolvable): void;
    get targetGroupConfigInput(): cdktf.IResolvable | ElastigroupAwsItfTargetGroupConfig[] | undefined;
}
export declare class ElastigroupAwsItfList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAwsItf[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAwsItfOutputReference;
}
export interface ElastigroupAwsLoggingExportS3 {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#id ElastigroupAws#id}
    *
    * Please be aware that the id field is automatically added to all resources in Terraform providers using a Terraform provider SDK version below 2.
    * If you experience problems setting this value it might not be settable. Please take a look at the provider documentation to ensure it should be settable.
    */
    readonly id: string;
}
export declare function elastigroupAwsLoggingExportS3ToTerraform(struct?: ElastigroupAwsLoggingExportS3 | cdktf.IResolvable): any;
export declare function elastigroupAwsLoggingExportS3ToHclTerraform(struct?: ElastigroupAwsLoggingExportS3 | cdktf.IResolvable): any;
export declare class ElastigroupAwsLoggingExportS3OutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAwsLoggingExportS3 | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAwsLoggingExportS3 | cdktf.IResolvable | undefined);
    private _id?;
    get id(): string;
    set id(value: string);
    get idInput(): string | undefined;
}
export declare class ElastigroupAwsLoggingExportS3List extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAwsLoggingExportS3[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAwsLoggingExportS3OutputReference;
}
export interface ElastigroupAwsLoggingExport {
    /**
    * s3 block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#s3 ElastigroupAws#s3}
    */
    readonly s3?: ElastigroupAwsLoggingExportS3[] | cdktf.IResolvable;
}
export declare function elastigroupAwsLoggingExportToTerraform(struct?: ElastigroupAwsLoggingExportOutputReference | ElastigroupAwsLoggingExport): any;
export declare function elastigroupAwsLoggingExportToHclTerraform(struct?: ElastigroupAwsLoggingExportOutputReference | ElastigroupAwsLoggingExport): any;
export declare class ElastigroupAwsLoggingExportOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAwsLoggingExport | undefined;
    set internalValue(value: ElastigroupAwsLoggingExport | undefined);
    private _s3;
    get s3(): ElastigroupAwsLoggingExportS3List;
    putS3(value: ElastigroupAwsLoggingExportS3[] | cdktf.IResolvable): void;
    resetS3(): void;
    get s3Input(): cdktf.IResolvable | ElastigroupAwsLoggingExportS3[] | undefined;
}
export interface ElastigroupAwsLogging {
    /**
    * export block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#export ElastigroupAws#export}
    */
    readonly export?: ElastigroupAwsLoggingExport;
}
export declare function elastigroupAwsLoggingToTerraform(struct?: ElastigroupAwsLoggingOutputReference | ElastigroupAwsLogging): any;
export declare function elastigroupAwsLoggingToHclTerraform(struct?: ElastigroupAwsLoggingOutputReference | ElastigroupAwsLogging): any;
export declare class ElastigroupAwsLoggingOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAwsLogging | undefined;
    set internalValue(value: ElastigroupAwsLogging | undefined);
    private _export;
    get export(): ElastigroupAwsLoggingExportOutputReference;
    putExport(value: ElastigroupAwsLoggingExport): void;
    resetExport(): void;
    get exportInput(): ElastigroupAwsLoggingExport | undefined;
}
export interface ElastigroupAwsMetadataOptions {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#http_put_response_hop_limit ElastigroupAws#http_put_response_hop_limit}
    */
    readonly httpPutResponseHopLimit?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#http_tokens ElastigroupAws#http_tokens}
    */
    readonly httpTokens: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#instance_metadata_tags ElastigroupAws#instance_metadata_tags}
    */
    readonly instanceMetadataTags?: string;
}
export declare function elastigroupAwsMetadataOptionsToTerraform(struct?: ElastigroupAwsMetadataOptionsOutputReference | ElastigroupAwsMetadataOptions): any;
export declare function elastigroupAwsMetadataOptionsToHclTerraform(struct?: ElastigroupAwsMetadataOptionsOutputReference | ElastigroupAwsMetadataOptions): any;
export declare class ElastigroupAwsMetadataOptionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAwsMetadataOptions | undefined;
    set internalValue(value: ElastigroupAwsMetadataOptions | undefined);
    private _httpPutResponseHopLimit?;
    get httpPutResponseHopLimit(): number;
    set httpPutResponseHopLimit(value: number);
    resetHttpPutResponseHopLimit(): void;
    get httpPutResponseHopLimitInput(): number | undefined;
    private _httpTokens?;
    get httpTokens(): string;
    set httpTokens(value: string);
    get httpTokensInput(): string | undefined;
    private _instanceMetadataTags?;
    get instanceMetadataTags(): string;
    set instanceMetadataTags(value: string);
    resetInstanceMetadataTags(): void;
    get instanceMetadataTagsInput(): string | undefined;
}
export interface ElastigroupAwsMultipleMetricsExpressions {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#expression ElastigroupAws#expression}
    */
    readonly expression: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#name ElastigroupAws#name}
    */
    readonly name: string;
}
export declare function elastigroupAwsMultipleMetricsExpressionsToTerraform(struct?: ElastigroupAwsMultipleMetricsExpressions | cdktf.IResolvable): any;
export declare function elastigroupAwsMultipleMetricsExpressionsToHclTerraform(struct?: ElastigroupAwsMultipleMetricsExpressions | cdktf.IResolvable): any;
export declare class ElastigroupAwsMultipleMetricsExpressionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAwsMultipleMetricsExpressions | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAwsMultipleMetricsExpressions | cdktf.IResolvable | undefined);
    private _expression?;
    get expression(): string;
    set expression(value: string);
    get expressionInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
}
export declare class ElastigroupAwsMultipleMetricsExpressionsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAwsMultipleMetricsExpressions[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAwsMultipleMetricsExpressionsOutputReference;
}
export interface ElastigroupAwsMultipleMetricsMetricsDimensions {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#name ElastigroupAws#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#value ElastigroupAws#value}
    */
    readonly value?: string;
}
export declare function elastigroupAwsMultipleMetricsMetricsDimensionsToTerraform(struct?: ElastigroupAwsMultipleMetricsMetricsDimensions | cdktf.IResolvable): any;
export declare function elastigroupAwsMultipleMetricsMetricsDimensionsToHclTerraform(struct?: ElastigroupAwsMultipleMetricsMetricsDimensions | cdktf.IResolvable): any;
export declare class ElastigroupAwsMultipleMetricsMetricsDimensionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAwsMultipleMetricsMetricsDimensions | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAwsMultipleMetricsMetricsDimensions | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
}
export declare class ElastigroupAwsMultipleMetricsMetricsDimensionsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAwsMultipleMetricsMetricsDimensions[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAwsMultipleMetricsMetricsDimensionsOutputReference;
}
export interface ElastigroupAwsMultipleMetricsMetrics {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#extended_statistic ElastigroupAws#extended_statistic}
    */
    readonly extendedStatistic?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#metric_name ElastigroupAws#metric_name}
    */
    readonly metricName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#name ElastigroupAws#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#namespace ElastigroupAws#namespace}
    */
    readonly namespace: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#statistic ElastigroupAws#statistic}
    */
    readonly statistic?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#unit ElastigroupAws#unit}
    */
    readonly unit?: string;
    /**
    * dimensions block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#dimensions ElastigroupAws#dimensions}
    */
    readonly dimensions?: ElastigroupAwsMultipleMetricsMetricsDimensions[] | cdktf.IResolvable;
}
export declare function elastigroupAwsMultipleMetricsMetricsToTerraform(struct?: ElastigroupAwsMultipleMetricsMetrics | cdktf.IResolvable): any;
export declare function elastigroupAwsMultipleMetricsMetricsToHclTerraform(struct?: ElastigroupAwsMultipleMetricsMetrics | cdktf.IResolvable): any;
export declare class ElastigroupAwsMultipleMetricsMetricsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAwsMultipleMetricsMetrics | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAwsMultipleMetricsMetrics | cdktf.IResolvable | undefined);
    private _extendedStatistic?;
    get extendedStatistic(): string;
    set extendedStatistic(value: string);
    resetExtendedStatistic(): void;
    get extendedStatisticInput(): string | undefined;
    private _metricName?;
    get metricName(): string;
    set metricName(value: string);
    get metricNameInput(): string | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _namespace?;
    get namespace(): string;
    set namespace(value: string);
    get namespaceInput(): string | undefined;
    private _statistic?;
    get statistic(): string;
    set statistic(value: string);
    resetStatistic(): void;
    get statisticInput(): string | undefined;
    private _unit?;
    get unit(): string;
    set unit(value: string);
    resetUnit(): void;
    get unitInput(): string | undefined;
    private _dimensions;
    get dimensions(): ElastigroupAwsMultipleMetricsMetricsDimensionsList;
    putDimensions(value: ElastigroupAwsMultipleMetricsMetricsDimensions[] | cdktf.IResolvable): void;
    resetDimensions(): void;
    get dimensionsInput(): cdktf.IResolvable | ElastigroupAwsMultipleMetricsMetricsDimensions[] | undefined;
}
export declare class ElastigroupAwsMultipleMetricsMetricsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAwsMultipleMetricsMetrics[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAwsMultipleMetricsMetricsOutputReference;
}
export interface ElastigroupAwsMultipleMetrics {
    /**
    * expressions block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#expressions ElastigroupAws#expressions}
    */
    readonly expressions?: ElastigroupAwsMultipleMetricsExpressions[] | cdktf.IResolvable;
    /**
    * metrics block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#metrics ElastigroupAws#metrics}
    */
    readonly metrics?: ElastigroupAwsMultipleMetricsMetrics[] | cdktf.IResolvable;
}
export declare function elastigroupAwsMultipleMetricsToTerraform(struct?: ElastigroupAwsMultipleMetricsOutputReference | ElastigroupAwsMultipleMetrics): any;
export declare function elastigroupAwsMultipleMetricsToHclTerraform(struct?: ElastigroupAwsMultipleMetricsOutputReference | ElastigroupAwsMultipleMetrics): any;
export declare class ElastigroupAwsMultipleMetricsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAwsMultipleMetrics | undefined;
    set internalValue(value: ElastigroupAwsMultipleMetrics | undefined);
    private _expressions;
    get expressions(): ElastigroupAwsMultipleMetricsExpressionsList;
    putExpressions(value: ElastigroupAwsMultipleMetricsExpressions[] | cdktf.IResolvable): void;
    resetExpressions(): void;
    get expressionsInput(): cdktf.IResolvable | ElastigroupAwsMultipleMetricsExpressions[] | undefined;
    private _metrics;
    get metrics(): ElastigroupAwsMultipleMetricsMetricsList;
    putMetrics(value: ElastigroupAwsMultipleMetricsMetrics[] | cdktf.IResolvable): void;
    resetMetrics(): void;
    get metricsInput(): cdktf.IResolvable | ElastigroupAwsMultipleMetricsMetrics[] | undefined;
}
export interface ElastigroupAwsNetworkInterface {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#associate_ipv6_address ElastigroupAws#associate_ipv6_address}
    */
    readonly associateIpv6Address?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#associate_public_ip_address ElastigroupAws#associate_public_ip_address}
    */
    readonly associatePublicIpAddress?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#delete_on_termination ElastigroupAws#delete_on_termination}
    */
    readonly deleteOnTermination?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#description ElastigroupAws#description}
    */
    readonly description?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#device_index ElastigroupAws#device_index}
    */
    readonly deviceIndex: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#network_interface_id ElastigroupAws#network_interface_id}
    */
    readonly networkInterfaceId?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#private_ip_address ElastigroupAws#private_ip_address}
    */
    readonly privateIpAddress?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#secondary_private_ip_address_count ElastigroupAws#secondary_private_ip_address_count}
    */
    readonly secondaryPrivateIpAddressCount?: string;
}
export declare function elastigroupAwsNetworkInterfaceToTerraform(struct?: ElastigroupAwsNetworkInterface | cdktf.IResolvable): any;
export declare function elastigroupAwsNetworkInterfaceToHclTerraform(struct?: ElastigroupAwsNetworkInterface | cdktf.IResolvable): any;
export declare class ElastigroupAwsNetworkInterfaceOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAwsNetworkInterface | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAwsNetworkInterface | cdktf.IResolvable | undefined);
    private _associateIpv6Address?;
    get associateIpv6Address(): boolean | cdktf.IResolvable;
    set associateIpv6Address(value: boolean | cdktf.IResolvable);
    resetAssociateIpv6Address(): void;
    get associateIpv6AddressInput(): boolean | cdktf.IResolvable | undefined;
    private _associatePublicIpAddress?;
    get associatePublicIpAddress(): boolean | cdktf.IResolvable;
    set associatePublicIpAddress(value: boolean | cdktf.IResolvable);
    resetAssociatePublicIpAddress(): void;
    get associatePublicIpAddressInput(): boolean | cdktf.IResolvable | undefined;
    private _deleteOnTermination?;
    get deleteOnTermination(): boolean | cdktf.IResolvable;
    set deleteOnTermination(value: boolean | cdktf.IResolvable);
    resetDeleteOnTermination(): void;
    get deleteOnTerminationInput(): boolean | cdktf.IResolvable | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _deviceIndex?;
    get deviceIndex(): string;
    set deviceIndex(value: string);
    get deviceIndexInput(): string | undefined;
    private _networkInterfaceId?;
    get networkInterfaceId(): string;
    set networkInterfaceId(value: string);
    resetNetworkInterfaceId(): void;
    get networkInterfaceIdInput(): string | undefined;
    private _privateIpAddress?;
    get privateIpAddress(): string;
    set privateIpAddress(value: string);
    resetPrivateIpAddress(): void;
    get privateIpAddressInput(): string | undefined;
    private _secondaryPrivateIpAddressCount?;
    get secondaryPrivateIpAddressCount(): string;
    set secondaryPrivateIpAddressCount(value: string);
    resetSecondaryPrivateIpAddressCount(): void;
    get secondaryPrivateIpAddressCountInput(): string | undefined;
}
export declare class ElastigroupAwsNetworkInterfaceList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAwsNetworkInterface[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAwsNetworkInterfaceOutputReference;
}
export interface ElastigroupAwsResourceRequirements {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#excluded_instance_families ElastigroupAws#excluded_instance_families}
    */
    readonly excludedInstanceFamilies?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#excluded_instance_generations ElastigroupAws#excluded_instance_generations}
    */
    readonly excludedInstanceGenerations?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#excluded_instance_types ElastigroupAws#excluded_instance_types}
    */
    readonly excludedInstanceTypes?: string[];
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#required_gpu_maximum ElastigroupAws#required_gpu_maximum}
    */
    readonly requiredGpuMaximum?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#required_gpu_minimum ElastigroupAws#required_gpu_minimum}
    */
    readonly requiredGpuMinimum?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#required_memory_maximum ElastigroupAws#required_memory_maximum}
    */
    readonly requiredMemoryMaximum: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#required_memory_minimum ElastigroupAws#required_memory_minimum}
    */
    readonly requiredMemoryMinimum: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#required_vcpu_maximum ElastigroupAws#required_vcpu_maximum}
    */
    readonly requiredVcpuMaximum: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#required_vcpu_minimum ElastigroupAws#required_vcpu_minimum}
    */
    readonly requiredVcpuMinimum: number;
}
export declare function elastigroupAwsResourceRequirementsToTerraform(struct?: ElastigroupAwsResourceRequirements | cdktf.IResolvable): any;
export declare function elastigroupAwsResourceRequirementsToHclTerraform(struct?: ElastigroupAwsResourceRequirements | cdktf.IResolvable): any;
export declare class ElastigroupAwsResourceRequirementsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAwsResourceRequirements | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAwsResourceRequirements | cdktf.IResolvable | undefined);
    private _excludedInstanceFamilies?;
    get excludedInstanceFamilies(): string[];
    set excludedInstanceFamilies(value: string[]);
    resetExcludedInstanceFamilies(): void;
    get excludedInstanceFamiliesInput(): string[] | undefined;
    private _excludedInstanceGenerations?;
    get excludedInstanceGenerations(): string[];
    set excludedInstanceGenerations(value: string[]);
    resetExcludedInstanceGenerations(): void;
    get excludedInstanceGenerationsInput(): string[] | undefined;
    private _excludedInstanceTypes?;
    get excludedInstanceTypes(): string[];
    set excludedInstanceTypes(value: string[]);
    resetExcludedInstanceTypes(): void;
    get excludedInstanceTypesInput(): string[] | undefined;
    private _requiredGpuMaximum?;
    get requiredGpuMaximum(): number;
    set requiredGpuMaximum(value: number);
    resetRequiredGpuMaximum(): void;
    get requiredGpuMaximumInput(): number | undefined;
    private _requiredGpuMinimum?;
    get requiredGpuMinimum(): number;
    set requiredGpuMinimum(value: number);
    resetRequiredGpuMinimum(): void;
    get requiredGpuMinimumInput(): number | undefined;
    private _requiredMemoryMaximum?;
    get requiredMemoryMaximum(): number;
    set requiredMemoryMaximum(value: number);
    get requiredMemoryMaximumInput(): number | undefined;
    private _requiredMemoryMinimum?;
    get requiredMemoryMinimum(): number;
    set requiredMemoryMinimum(value: number);
    get requiredMemoryMinimumInput(): number | undefined;
    private _requiredVcpuMaximum?;
    get requiredVcpuMaximum(): number;
    set requiredVcpuMaximum(value: number);
    get requiredVcpuMaximumInput(): number | undefined;
    private _requiredVcpuMinimum?;
    get requiredVcpuMinimum(): number;
    set requiredVcpuMinimum(value: number);
    get requiredVcpuMinimumInput(): number | undefined;
}
export declare class ElastigroupAwsResourceRequirementsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAwsResourceRequirements[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAwsResourceRequirementsOutputReference;
}
export interface ElastigroupAwsResourceTagSpecification {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#should_tag_amis ElastigroupAws#should_tag_amis}
    */
    readonly shouldTagAmis?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#should_tag_enis ElastigroupAws#should_tag_enis}
    */
    readonly shouldTagEnis?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#should_tag_snapshots ElastigroupAws#should_tag_snapshots}
    */
    readonly shouldTagSnapshots?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#should_tag_volumes ElastigroupAws#should_tag_volumes}
    */
    readonly shouldTagVolumes?: boolean | cdktf.IResolvable;
}
export declare function elastigroupAwsResourceTagSpecificationToTerraform(struct?: ElastigroupAwsResourceTagSpecification | cdktf.IResolvable): any;
export declare function elastigroupAwsResourceTagSpecificationToHclTerraform(struct?: ElastigroupAwsResourceTagSpecification | cdktf.IResolvable): any;
export declare class ElastigroupAwsResourceTagSpecificationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAwsResourceTagSpecification | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAwsResourceTagSpecification | cdktf.IResolvable | undefined);
    private _shouldTagAmis?;
    get shouldTagAmis(): boolean | cdktf.IResolvable;
    set shouldTagAmis(value: boolean | cdktf.IResolvable);
    resetShouldTagAmis(): void;
    get shouldTagAmisInput(): boolean | cdktf.IResolvable | undefined;
    private _shouldTagEnis?;
    get shouldTagEnis(): boolean | cdktf.IResolvable;
    set shouldTagEnis(value: boolean | cdktf.IResolvable);
    resetShouldTagEnis(): void;
    get shouldTagEnisInput(): boolean | cdktf.IResolvable | undefined;
    private _shouldTagSnapshots?;
    get shouldTagSnapshots(): boolean | cdktf.IResolvable;
    set shouldTagSnapshots(value: boolean | cdktf.IResolvable);
    resetShouldTagSnapshots(): void;
    get shouldTagSnapshotsInput(): boolean | cdktf.IResolvable | undefined;
    private _shouldTagVolumes?;
    get shouldTagVolumes(): boolean | cdktf.IResolvable;
    set shouldTagVolumes(value: boolean | cdktf.IResolvable);
    resetShouldTagVolumes(): void;
    get shouldTagVolumesInput(): boolean | cdktf.IResolvable | undefined;
}
export declare class ElastigroupAwsResourceTagSpecificationList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAwsResourceTagSpecification[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAwsResourceTagSpecificationOutputReference;
}
export interface ElastigroupAwsRevertToSpot {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#perform_at ElastigroupAws#perform_at}
    */
    readonly performAt: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#time_windows ElastigroupAws#time_windows}
    */
    readonly timeWindows?: string[];
}
export declare function elastigroupAwsRevertToSpotToTerraform(struct?: ElastigroupAwsRevertToSpotOutputReference | ElastigroupAwsRevertToSpot): any;
export declare function elastigroupAwsRevertToSpotToHclTerraform(struct?: ElastigroupAwsRevertToSpotOutputReference | ElastigroupAwsRevertToSpot): any;
export declare class ElastigroupAwsRevertToSpotOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAwsRevertToSpot | undefined;
    set internalValue(value: ElastigroupAwsRevertToSpot | undefined);
    private _performAt?;
    get performAt(): string;
    set performAt(value: string);
    get performAtInput(): string | undefined;
    private _timeWindows?;
    get timeWindows(): string[];
    set timeWindows(value: string[]);
    resetTimeWindows(): void;
    get timeWindowsInput(): string[] | undefined;
}
export interface ElastigroupAwsScalingDownPolicyDimensions {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#name ElastigroupAws#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#value ElastigroupAws#value}
    */
    readonly value?: string;
}
export declare function elastigroupAwsScalingDownPolicyDimensionsToTerraform(struct?: ElastigroupAwsScalingDownPolicyDimensions | cdktf.IResolvable): any;
export declare function elastigroupAwsScalingDownPolicyDimensionsToHclTerraform(struct?: ElastigroupAwsScalingDownPolicyDimensions | cdktf.IResolvable): any;
export declare class ElastigroupAwsScalingDownPolicyDimensionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAwsScalingDownPolicyDimensions | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAwsScalingDownPolicyDimensions | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
}
export declare class ElastigroupAwsScalingDownPolicyDimensionsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAwsScalingDownPolicyDimensions[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAwsScalingDownPolicyDimensionsOutputReference;
}
export interface ElastigroupAwsScalingDownPolicyStepAdjustmentsAction {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#adjustment ElastigroupAws#adjustment}
    */
    readonly adjustment?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#max_target_capacity ElastigroupAws#max_target_capacity}
    */
    readonly maxTargetCapacity?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#maximum ElastigroupAws#maximum}
    */
    readonly maximum?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#min_target_capacity ElastigroupAws#min_target_capacity}
    */
    readonly minTargetCapacity?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#minimum ElastigroupAws#minimum}
    */
    readonly minimum?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#target ElastigroupAws#target}
    */
    readonly target?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#type ElastigroupAws#type}
    */
    readonly type: string;
}
export declare function elastigroupAwsScalingDownPolicyStepAdjustmentsActionToTerraform(struct?: ElastigroupAwsScalingDownPolicyStepAdjustmentsActionOutputReference | ElastigroupAwsScalingDownPolicyStepAdjustmentsAction): any;
export declare function elastigroupAwsScalingDownPolicyStepAdjustmentsActionToHclTerraform(struct?: ElastigroupAwsScalingDownPolicyStepAdjustmentsActionOutputReference | ElastigroupAwsScalingDownPolicyStepAdjustmentsAction): any;
export declare class ElastigroupAwsScalingDownPolicyStepAdjustmentsActionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAwsScalingDownPolicyStepAdjustmentsAction | undefined;
    set internalValue(value: ElastigroupAwsScalingDownPolicyStepAdjustmentsAction | undefined);
    private _adjustment?;
    get adjustment(): string;
    set adjustment(value: string);
    resetAdjustment(): void;
    get adjustmentInput(): string | undefined;
    private _maxTargetCapacity?;
    get maxTargetCapacity(): string;
    set maxTargetCapacity(value: string);
    resetMaxTargetCapacity(): void;
    get maxTargetCapacityInput(): string | undefined;
    private _maximum?;
    get maximum(): string;
    set maximum(value: string);
    resetMaximum(): void;
    get maximumInput(): string | undefined;
    private _minTargetCapacity?;
    get minTargetCapacity(): string;
    set minTargetCapacity(value: string);
    resetMinTargetCapacity(): void;
    get minTargetCapacityInput(): string | undefined;
    private _minimum?;
    get minimum(): string;
    set minimum(value: string);
    resetMinimum(): void;
    get minimumInput(): string | undefined;
    private _target?;
    get target(): string;
    set target(value: string);
    resetTarget(): void;
    get targetInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
}
export interface ElastigroupAwsScalingDownPolicyStepAdjustments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#threshold ElastigroupAws#threshold}
    */
    readonly threshold: number;
    /**
    * action block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#action ElastigroupAws#action}
    */
    readonly action: ElastigroupAwsScalingDownPolicyStepAdjustmentsAction;
}
export declare function elastigroupAwsScalingDownPolicyStepAdjustmentsToTerraform(struct?: ElastigroupAwsScalingDownPolicyStepAdjustments | cdktf.IResolvable): any;
export declare function elastigroupAwsScalingDownPolicyStepAdjustmentsToHclTerraform(struct?: ElastigroupAwsScalingDownPolicyStepAdjustments | cdktf.IResolvable): any;
export declare class ElastigroupAwsScalingDownPolicyStepAdjustmentsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAwsScalingDownPolicyStepAdjustments | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAwsScalingDownPolicyStepAdjustments | cdktf.IResolvable | undefined);
    private _threshold?;
    get threshold(): number;
    set threshold(value: number);
    get thresholdInput(): number | undefined;
    private _action;
    get action(): ElastigroupAwsScalingDownPolicyStepAdjustmentsActionOutputReference;
    putAction(value: ElastigroupAwsScalingDownPolicyStepAdjustmentsAction): void;
    get actionInput(): ElastigroupAwsScalingDownPolicyStepAdjustmentsAction | undefined;
}
export declare class ElastigroupAwsScalingDownPolicyStepAdjustmentsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAwsScalingDownPolicyStepAdjustments[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAwsScalingDownPolicyStepAdjustmentsOutputReference;
}
export interface ElastigroupAwsScalingDownPolicy {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#action_type ElastigroupAws#action_type}
    */
    readonly actionType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#adjustment ElastigroupAws#adjustment}
    */
    readonly adjustment?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#cooldown ElastigroupAws#cooldown}
    */
    readonly cooldown?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#evaluation_periods ElastigroupAws#evaluation_periods}
    */
    readonly evaluationPeriods?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#is_enabled ElastigroupAws#is_enabled}
    */
    readonly isEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#max_target_capacity ElastigroupAws#max_target_capacity}
    */
    readonly maxTargetCapacity?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#maximum ElastigroupAws#maximum}
    */
    readonly maximum?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#metric_name ElastigroupAws#metric_name}
    */
    readonly metricName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#min_target_capacity ElastigroupAws#min_target_capacity}
    */
    readonly minTargetCapacity?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#minimum ElastigroupAws#minimum}
    */
    readonly minimum?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#namespace ElastigroupAws#namespace}
    */
    readonly namespace: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#operator ElastigroupAws#operator}
    */
    readonly operator?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#period ElastigroupAws#period}
    */
    readonly period?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#policy_name ElastigroupAws#policy_name}
    */
    readonly policyName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#source ElastigroupAws#source}
    */
    readonly source?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#statistic ElastigroupAws#statistic}
    */
    readonly statistic?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#target ElastigroupAws#target}
    */
    readonly target?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#threshold ElastigroupAws#threshold}
    */
    readonly threshold?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#unit ElastigroupAws#unit}
    */
    readonly unit?: string;
    /**
    * dimensions block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#dimensions ElastigroupAws#dimensions}
    */
    readonly dimensions?: ElastigroupAwsScalingDownPolicyDimensions[] | cdktf.IResolvable;
    /**
    * step_adjustments block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#step_adjustments ElastigroupAws#step_adjustments}
    */
    readonly stepAdjustments?: ElastigroupAwsScalingDownPolicyStepAdjustments[] | cdktf.IResolvable;
}
export declare function elastigroupAwsScalingDownPolicyToTerraform(struct?: ElastigroupAwsScalingDownPolicy | cdktf.IResolvable): any;
export declare function elastigroupAwsScalingDownPolicyToHclTerraform(struct?: ElastigroupAwsScalingDownPolicy | cdktf.IResolvable): any;
export declare class ElastigroupAwsScalingDownPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAwsScalingDownPolicy | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAwsScalingDownPolicy | cdktf.IResolvable | undefined);
    private _actionType?;
    get actionType(): string;
    set actionType(value: string);
    resetActionType(): void;
    get actionTypeInput(): string | undefined;
    private _adjustment?;
    get adjustment(): string;
    set adjustment(value: string);
    resetAdjustment(): void;
    get adjustmentInput(): string | undefined;
    private _cooldown?;
    get cooldown(): number;
    set cooldown(value: number);
    resetCooldown(): void;
    get cooldownInput(): number | undefined;
    private _evaluationPeriods?;
    get evaluationPeriods(): number;
    set evaluationPeriods(value: number);
    resetEvaluationPeriods(): void;
    get evaluationPeriodsInput(): number | undefined;
    private _isEnabled?;
    get isEnabled(): boolean | cdktf.IResolvable;
    set isEnabled(value: boolean | cdktf.IResolvable);
    resetIsEnabled(): void;
    get isEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _maxTargetCapacity?;
    get maxTargetCapacity(): string;
    set maxTargetCapacity(value: string);
    resetMaxTargetCapacity(): void;
    get maxTargetCapacityInput(): string | undefined;
    private _maximum?;
    get maximum(): string;
    set maximum(value: string);
    resetMaximum(): void;
    get maximumInput(): string | undefined;
    private _metricName?;
    get metricName(): string;
    set metricName(value: string);
    get metricNameInput(): string | undefined;
    private _minTargetCapacity?;
    get minTargetCapacity(): string;
    set minTargetCapacity(value: string);
    resetMinTargetCapacity(): void;
    get minTargetCapacityInput(): string | undefined;
    private _minimum?;
    get minimum(): string;
    set minimum(value: string);
    resetMinimum(): void;
    get minimumInput(): string | undefined;
    private _namespace?;
    get namespace(): string;
    set namespace(value: string);
    get namespaceInput(): string | undefined;
    private _operator?;
    get operator(): string;
    set operator(value: string);
    resetOperator(): void;
    get operatorInput(): string | undefined;
    private _period?;
    get period(): number;
    set period(value: number);
    resetPeriod(): void;
    get periodInput(): number | undefined;
    private _policyName?;
    get policyName(): string;
    set policyName(value: string);
    get policyNameInput(): string | undefined;
    private _source?;
    get source(): string;
    set source(value: string);
    resetSource(): void;
    get sourceInput(): string | undefined;
    private _statistic?;
    get statistic(): string;
    set statistic(value: string);
    resetStatistic(): void;
    get statisticInput(): string | undefined;
    private _target?;
    get target(): string;
    set target(value: string);
    resetTarget(): void;
    get targetInput(): string | undefined;
    private _threshold?;
    get threshold(): number;
    set threshold(value: number);
    resetThreshold(): void;
    get thresholdInput(): number | undefined;
    private _unit?;
    get unit(): string;
    set unit(value: string);
    resetUnit(): void;
    get unitInput(): string | undefined;
    private _dimensions;
    get dimensions(): ElastigroupAwsScalingDownPolicyDimensionsList;
    putDimensions(value: ElastigroupAwsScalingDownPolicyDimensions[] | cdktf.IResolvable): void;
    resetDimensions(): void;
    get dimensionsInput(): cdktf.IResolvable | ElastigroupAwsScalingDownPolicyDimensions[] | undefined;
    private _stepAdjustments;
    get stepAdjustments(): ElastigroupAwsScalingDownPolicyStepAdjustmentsList;
    putStepAdjustments(value: ElastigroupAwsScalingDownPolicyStepAdjustments[] | cdktf.IResolvable): void;
    resetStepAdjustments(): void;
    get stepAdjustmentsInput(): cdktf.IResolvable | ElastigroupAwsScalingDownPolicyStepAdjustments[] | undefined;
}
export declare class ElastigroupAwsScalingDownPolicyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAwsScalingDownPolicy[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAwsScalingDownPolicyOutputReference;
}
export interface ElastigroupAwsScalingStrategy {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#terminate_at_end_of_billing_hour ElastigroupAws#terminate_at_end_of_billing_hour}
    */
    readonly terminateAtEndOfBillingHour?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#termination_policy ElastigroupAws#termination_policy}
    */
    readonly terminationPolicy?: string;
}
export declare function elastigroupAwsScalingStrategyToTerraform(struct?: ElastigroupAwsScalingStrategy | cdktf.IResolvable): any;
export declare function elastigroupAwsScalingStrategyToHclTerraform(struct?: ElastigroupAwsScalingStrategy | cdktf.IResolvable): any;
export declare class ElastigroupAwsScalingStrategyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAwsScalingStrategy | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAwsScalingStrategy | cdktf.IResolvable | undefined);
    private _terminateAtEndOfBillingHour?;
    get terminateAtEndOfBillingHour(): boolean | cdktf.IResolvable;
    set terminateAtEndOfBillingHour(value: boolean | cdktf.IResolvable);
    resetTerminateAtEndOfBillingHour(): void;
    get terminateAtEndOfBillingHourInput(): boolean | cdktf.IResolvable | undefined;
    private _terminationPolicy?;
    get terminationPolicy(): string;
    set terminationPolicy(value: string);
    resetTerminationPolicy(): void;
    get terminationPolicyInput(): string | undefined;
}
export declare class ElastigroupAwsScalingStrategyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAwsScalingStrategy[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAwsScalingStrategyOutputReference;
}
export interface ElastigroupAwsScalingTargetPolicyDimensions {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#name ElastigroupAws#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#value ElastigroupAws#value}
    */
    readonly value?: string;
}
export declare function elastigroupAwsScalingTargetPolicyDimensionsToTerraform(struct?: ElastigroupAwsScalingTargetPolicyDimensions | cdktf.IResolvable): any;
export declare function elastigroupAwsScalingTargetPolicyDimensionsToHclTerraform(struct?: ElastigroupAwsScalingTargetPolicyDimensions | cdktf.IResolvable): any;
export declare class ElastigroupAwsScalingTargetPolicyDimensionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAwsScalingTargetPolicyDimensions | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAwsScalingTargetPolicyDimensions | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
}
export declare class ElastigroupAwsScalingTargetPolicyDimensionsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAwsScalingTargetPolicyDimensions[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAwsScalingTargetPolicyDimensionsOutputReference;
}
export interface ElastigroupAwsScalingTargetPolicy {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#cooldown ElastigroupAws#cooldown}
    */
    readonly cooldown?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#evaluation_periods ElastigroupAws#evaluation_periods}
    */
    readonly evaluationPeriods?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#max_capacity_per_scale ElastigroupAws#max_capacity_per_scale}
    */
    readonly maxCapacityPerScale?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#metric_name ElastigroupAws#metric_name}
    */
    readonly metricName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#namespace ElastigroupAws#namespace}
    */
    readonly namespace: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#period ElastigroupAws#period}
    */
    readonly period?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#policy_name ElastigroupAws#policy_name}
    */
    readonly policyName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#predictive_mode ElastigroupAws#predictive_mode}
    */
    readonly predictiveMode?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#source ElastigroupAws#source}
    */
    readonly source?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#statistic ElastigroupAws#statistic}
    */
    readonly statistic?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#target ElastigroupAws#target}
    */
    readonly target: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#unit ElastigroupAws#unit}
    */
    readonly unit?: string;
    /**
    * dimensions block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#dimensions ElastigroupAws#dimensions}
    */
    readonly dimensions?: ElastigroupAwsScalingTargetPolicyDimensions[] | cdktf.IResolvable;
}
export declare function elastigroupAwsScalingTargetPolicyToTerraform(struct?: ElastigroupAwsScalingTargetPolicy | cdktf.IResolvable): any;
export declare function elastigroupAwsScalingTargetPolicyToHclTerraform(struct?: ElastigroupAwsScalingTargetPolicy | cdktf.IResolvable): any;
export declare class ElastigroupAwsScalingTargetPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAwsScalingTargetPolicy | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAwsScalingTargetPolicy | cdktf.IResolvable | undefined);
    private _cooldown?;
    get cooldown(): number;
    set cooldown(value: number);
    resetCooldown(): void;
    get cooldownInput(): number | undefined;
    private _evaluationPeriods?;
    get evaluationPeriods(): number;
    set evaluationPeriods(value: number);
    resetEvaluationPeriods(): void;
    get evaluationPeriodsInput(): number | undefined;
    private _maxCapacityPerScale?;
    get maxCapacityPerScale(): string;
    set maxCapacityPerScale(value: string);
    resetMaxCapacityPerScale(): void;
    get maxCapacityPerScaleInput(): string | undefined;
    private _metricName?;
    get metricName(): string;
    set metricName(value: string);
    get metricNameInput(): string | undefined;
    private _namespace?;
    get namespace(): string;
    set namespace(value: string);
    get namespaceInput(): string | undefined;
    private _period?;
    get period(): number;
    set period(value: number);
    resetPeriod(): void;
    get periodInput(): number | undefined;
    private _policyName?;
    get policyName(): string;
    set policyName(value: string);
    get policyNameInput(): string | undefined;
    private _predictiveMode?;
    get predictiveMode(): string;
    set predictiveMode(value: string);
    resetPredictiveMode(): void;
    get predictiveModeInput(): string | undefined;
    private _source?;
    get source(): string;
    set source(value: string);
    resetSource(): void;
    get sourceInput(): string | undefined;
    private _statistic?;
    get statistic(): string;
    set statistic(value: string);
    resetStatistic(): void;
    get statisticInput(): string | undefined;
    private _target?;
    get target(): number;
    set target(value: number);
    get targetInput(): number | undefined;
    private _unit?;
    get unit(): string;
    set unit(value: string);
    resetUnit(): void;
    get unitInput(): string | undefined;
    private _dimensions;
    get dimensions(): ElastigroupAwsScalingTargetPolicyDimensionsList;
    putDimensions(value: ElastigroupAwsScalingTargetPolicyDimensions[] | cdktf.IResolvable): void;
    resetDimensions(): void;
    get dimensionsInput(): cdktf.IResolvable | ElastigroupAwsScalingTargetPolicyDimensions[] | undefined;
}
export declare class ElastigroupAwsScalingTargetPolicyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAwsScalingTargetPolicy[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAwsScalingTargetPolicyOutputReference;
}
export interface ElastigroupAwsScalingUpPolicyDimensions {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#name ElastigroupAws#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#value ElastigroupAws#value}
    */
    readonly value?: string;
}
export declare function elastigroupAwsScalingUpPolicyDimensionsToTerraform(struct?: ElastigroupAwsScalingUpPolicyDimensions | cdktf.IResolvable): any;
export declare function elastigroupAwsScalingUpPolicyDimensionsToHclTerraform(struct?: ElastigroupAwsScalingUpPolicyDimensions | cdktf.IResolvable): any;
export declare class ElastigroupAwsScalingUpPolicyDimensionsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAwsScalingUpPolicyDimensions | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAwsScalingUpPolicyDimensions | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
}
export declare class ElastigroupAwsScalingUpPolicyDimensionsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAwsScalingUpPolicyDimensions[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAwsScalingUpPolicyDimensionsOutputReference;
}
export interface ElastigroupAwsScalingUpPolicyStepAdjustmentsAction {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#adjustment ElastigroupAws#adjustment}
    */
    readonly adjustment?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#max_target_capacity ElastigroupAws#max_target_capacity}
    */
    readonly maxTargetCapacity?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#maximum ElastigroupAws#maximum}
    */
    readonly maximum?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#min_target_capacity ElastigroupAws#min_target_capacity}
    */
    readonly minTargetCapacity?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#minimum ElastigroupAws#minimum}
    */
    readonly minimum?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#target ElastigroupAws#target}
    */
    readonly target?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#type ElastigroupAws#type}
    */
    readonly type: string;
}
export declare function elastigroupAwsScalingUpPolicyStepAdjustmentsActionToTerraform(struct?: ElastigroupAwsScalingUpPolicyStepAdjustmentsActionOutputReference | ElastigroupAwsScalingUpPolicyStepAdjustmentsAction): any;
export declare function elastigroupAwsScalingUpPolicyStepAdjustmentsActionToHclTerraform(struct?: ElastigroupAwsScalingUpPolicyStepAdjustmentsActionOutputReference | ElastigroupAwsScalingUpPolicyStepAdjustmentsAction): any;
export declare class ElastigroupAwsScalingUpPolicyStepAdjustmentsActionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAwsScalingUpPolicyStepAdjustmentsAction | undefined;
    set internalValue(value: ElastigroupAwsScalingUpPolicyStepAdjustmentsAction | undefined);
    private _adjustment?;
    get adjustment(): string;
    set adjustment(value: string);
    resetAdjustment(): void;
    get adjustmentInput(): string | undefined;
    private _maxTargetCapacity?;
    get maxTargetCapacity(): string;
    set maxTargetCapacity(value: string);
    resetMaxTargetCapacity(): void;
    get maxTargetCapacityInput(): string | undefined;
    private _maximum?;
    get maximum(): string;
    set maximum(value: string);
    resetMaximum(): void;
    get maximumInput(): string | undefined;
    private _minTargetCapacity?;
    get minTargetCapacity(): string;
    set minTargetCapacity(value: string);
    resetMinTargetCapacity(): void;
    get minTargetCapacityInput(): string | undefined;
    private _minimum?;
    get minimum(): string;
    set minimum(value: string);
    resetMinimum(): void;
    get minimumInput(): string | undefined;
    private _target?;
    get target(): string;
    set target(value: string);
    resetTarget(): void;
    get targetInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
}
export interface ElastigroupAwsScalingUpPolicyStepAdjustments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#threshold ElastigroupAws#threshold}
    */
    readonly threshold: number;
    /**
    * action block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#action ElastigroupAws#action}
    */
    readonly action: ElastigroupAwsScalingUpPolicyStepAdjustmentsAction;
}
export declare function elastigroupAwsScalingUpPolicyStepAdjustmentsToTerraform(struct?: ElastigroupAwsScalingUpPolicyStepAdjustments | cdktf.IResolvable): any;
export declare function elastigroupAwsScalingUpPolicyStepAdjustmentsToHclTerraform(struct?: ElastigroupAwsScalingUpPolicyStepAdjustments | cdktf.IResolvable): any;
export declare class ElastigroupAwsScalingUpPolicyStepAdjustmentsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAwsScalingUpPolicyStepAdjustments | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAwsScalingUpPolicyStepAdjustments | cdktf.IResolvable | undefined);
    private _threshold?;
    get threshold(): number;
    set threshold(value: number);
    get thresholdInput(): number | undefined;
    private _action;
    get action(): ElastigroupAwsScalingUpPolicyStepAdjustmentsActionOutputReference;
    putAction(value: ElastigroupAwsScalingUpPolicyStepAdjustmentsAction): void;
    get actionInput(): ElastigroupAwsScalingUpPolicyStepAdjustmentsAction | undefined;
}
export declare class ElastigroupAwsScalingUpPolicyStepAdjustmentsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAwsScalingUpPolicyStepAdjustments[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAwsScalingUpPolicyStepAdjustmentsOutputReference;
}
export interface ElastigroupAwsScalingUpPolicy {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#action_type ElastigroupAws#action_type}
    */
    readonly actionType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#adjustment ElastigroupAws#adjustment}
    */
    readonly adjustment?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#cooldown ElastigroupAws#cooldown}
    */
    readonly cooldown?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#evaluation_periods ElastigroupAws#evaluation_periods}
    */
    readonly evaluationPeriods?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#is_enabled ElastigroupAws#is_enabled}
    */
    readonly isEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#max_target_capacity ElastigroupAws#max_target_capacity}
    */
    readonly maxTargetCapacity?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#maximum ElastigroupAws#maximum}
    */
    readonly maximum?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#metric_name ElastigroupAws#metric_name}
    */
    readonly metricName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#min_target_capacity ElastigroupAws#min_target_capacity}
    */
    readonly minTargetCapacity?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#minimum ElastigroupAws#minimum}
    */
    readonly minimum?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#namespace ElastigroupAws#namespace}
    */
    readonly namespace: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#operator ElastigroupAws#operator}
    */
    readonly operator?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#period ElastigroupAws#period}
    */
    readonly period?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#policy_name ElastigroupAws#policy_name}
    */
    readonly policyName: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#source ElastigroupAws#source}
    */
    readonly source?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#statistic ElastigroupAws#statistic}
    */
    readonly statistic?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#target ElastigroupAws#target}
    */
    readonly target?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#threshold ElastigroupAws#threshold}
    */
    readonly threshold?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#unit ElastigroupAws#unit}
    */
    readonly unit?: string;
    /**
    * dimensions block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#dimensions ElastigroupAws#dimensions}
    */
    readonly dimensions?: ElastigroupAwsScalingUpPolicyDimensions[] | cdktf.IResolvable;
    /**
    * step_adjustments block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#step_adjustments ElastigroupAws#step_adjustments}
    */
    readonly stepAdjustments?: ElastigroupAwsScalingUpPolicyStepAdjustments[] | cdktf.IResolvable;
}
export declare function elastigroupAwsScalingUpPolicyToTerraform(struct?: ElastigroupAwsScalingUpPolicy | cdktf.IResolvable): any;
export declare function elastigroupAwsScalingUpPolicyToHclTerraform(struct?: ElastigroupAwsScalingUpPolicy | cdktf.IResolvable): any;
export declare class ElastigroupAwsScalingUpPolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAwsScalingUpPolicy | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAwsScalingUpPolicy | cdktf.IResolvable | undefined);
    private _actionType?;
    get actionType(): string;
    set actionType(value: string);
    resetActionType(): void;
    get actionTypeInput(): string | undefined;
    private _adjustment?;
    get adjustment(): string;
    set adjustment(value: string);
    resetAdjustment(): void;
    get adjustmentInput(): string | undefined;
    private _cooldown?;
    get cooldown(): number;
    set cooldown(value: number);
    resetCooldown(): void;
    get cooldownInput(): number | undefined;
    private _evaluationPeriods?;
    get evaluationPeriods(): number;
    set evaluationPeriods(value: number);
    resetEvaluationPeriods(): void;
    get evaluationPeriodsInput(): number | undefined;
    private _isEnabled?;
    get isEnabled(): boolean | cdktf.IResolvable;
    set isEnabled(value: boolean | cdktf.IResolvable);
    resetIsEnabled(): void;
    get isEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _maxTargetCapacity?;
    get maxTargetCapacity(): string;
    set maxTargetCapacity(value: string);
    resetMaxTargetCapacity(): void;
    get maxTargetCapacityInput(): string | undefined;
    private _maximum?;
    get maximum(): string;
    set maximum(value: string);
    resetMaximum(): void;
    get maximumInput(): string | undefined;
    private _metricName?;
    get metricName(): string;
    set metricName(value: string);
    get metricNameInput(): string | undefined;
    private _minTargetCapacity?;
    get minTargetCapacity(): string;
    set minTargetCapacity(value: string);
    resetMinTargetCapacity(): void;
    get minTargetCapacityInput(): string | undefined;
    private _minimum?;
    get minimum(): string;
    set minimum(value: string);
    resetMinimum(): void;
    get minimumInput(): string | undefined;
    private _namespace?;
    get namespace(): string;
    set namespace(value: string);
    get namespaceInput(): string | undefined;
    private _operator?;
    get operator(): string;
    set operator(value: string);
    resetOperator(): void;
    get operatorInput(): string | undefined;
    private _period?;
    get period(): number;
    set period(value: number);
    resetPeriod(): void;
    get periodInput(): number | undefined;
    private _policyName?;
    get policyName(): string;
    set policyName(value: string);
    get policyNameInput(): string | undefined;
    private _source?;
    get source(): string;
    set source(value: string);
    resetSource(): void;
    get sourceInput(): string | undefined;
    private _statistic?;
    get statistic(): string;
    set statistic(value: string);
    resetStatistic(): void;
    get statisticInput(): string | undefined;
    private _target?;
    get target(): string;
    set target(value: string);
    resetTarget(): void;
    get targetInput(): string | undefined;
    private _threshold?;
    get threshold(): number;
    set threshold(value: number);
    resetThreshold(): void;
    get thresholdInput(): number | undefined;
    private _unit?;
    get unit(): string;
    set unit(value: string);
    resetUnit(): void;
    get unitInput(): string | undefined;
    private _dimensions;
    get dimensions(): ElastigroupAwsScalingUpPolicyDimensionsList;
    putDimensions(value: ElastigroupAwsScalingUpPolicyDimensions[] | cdktf.IResolvable): void;
    resetDimensions(): void;
    get dimensionsInput(): cdktf.IResolvable | ElastigroupAwsScalingUpPolicyDimensions[] | undefined;
    private _stepAdjustments;
    get stepAdjustments(): ElastigroupAwsScalingUpPolicyStepAdjustmentsList;
    putStepAdjustments(value: ElastigroupAwsScalingUpPolicyStepAdjustments[] | cdktf.IResolvable): void;
    resetStepAdjustments(): void;
    get stepAdjustmentsInput(): cdktf.IResolvable | ElastigroupAwsScalingUpPolicyStepAdjustments[] | undefined;
}
export declare class ElastigroupAwsScalingUpPolicyList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAwsScalingUpPolicy[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAwsScalingUpPolicyOutputReference;
}
export interface ElastigroupAwsScheduledTask {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#adjustment ElastigroupAws#adjustment}
    */
    readonly adjustment?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#adjustment_percentage ElastigroupAws#adjustment_percentage}
    */
    readonly adjustmentPercentage?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#batch_size_percentage ElastigroupAws#batch_size_percentage}
    */
    readonly batchSizePercentage?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#cron_expression ElastigroupAws#cron_expression}
    */
    readonly cronExpression?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#frequency ElastigroupAws#frequency}
    */
    readonly frequency?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#grace_period ElastigroupAws#grace_period}
    */
    readonly gracePeriod?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#is_enabled ElastigroupAws#is_enabled}
    */
    readonly isEnabled?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#max_capacity ElastigroupAws#max_capacity}
    */
    readonly maxCapacity?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#min_capacity ElastigroupAws#min_capacity}
    */
    readonly minCapacity?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#scale_max_capacity ElastigroupAws#scale_max_capacity}
    */
    readonly scaleMaxCapacity?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#scale_min_capacity ElastigroupAws#scale_min_capacity}
    */
    readonly scaleMinCapacity?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#scale_target_capacity ElastigroupAws#scale_target_capacity}
    */
    readonly scaleTargetCapacity?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#start_time ElastigroupAws#start_time}
    */
    readonly startTime?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#target_capacity ElastigroupAws#target_capacity}
    */
    readonly targetCapacity?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#task_type ElastigroupAws#task_type}
    */
    readonly taskType: string;
}
export declare function elastigroupAwsScheduledTaskToTerraform(struct?: ElastigroupAwsScheduledTask | cdktf.IResolvable): any;
export declare function elastigroupAwsScheduledTaskToHclTerraform(struct?: ElastigroupAwsScheduledTask | cdktf.IResolvable): any;
export declare class ElastigroupAwsScheduledTaskOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAwsScheduledTask | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAwsScheduledTask | cdktf.IResolvable | undefined);
    private _adjustment?;
    get adjustment(): string;
    set adjustment(value: string);
    resetAdjustment(): void;
    get adjustmentInput(): string | undefined;
    private _adjustmentPercentage?;
    get adjustmentPercentage(): string;
    set adjustmentPercentage(value: string);
    resetAdjustmentPercentage(): void;
    get adjustmentPercentageInput(): string | undefined;
    private _batchSizePercentage?;
    get batchSizePercentage(): string;
    set batchSizePercentage(value: string);
    resetBatchSizePercentage(): void;
    get batchSizePercentageInput(): string | undefined;
    private _cronExpression?;
    get cronExpression(): string;
    set cronExpression(value: string);
    resetCronExpression(): void;
    get cronExpressionInput(): string | undefined;
    private _frequency?;
    get frequency(): string;
    set frequency(value: string);
    resetFrequency(): void;
    get frequencyInput(): string | undefined;
    private _gracePeriod?;
    get gracePeriod(): string;
    set gracePeriod(value: string);
    resetGracePeriod(): void;
    get gracePeriodInput(): string | undefined;
    private _isEnabled?;
    get isEnabled(): boolean | cdktf.IResolvable;
    set isEnabled(value: boolean | cdktf.IResolvable);
    resetIsEnabled(): void;
    get isEnabledInput(): boolean | cdktf.IResolvable | undefined;
    private _maxCapacity?;
    get maxCapacity(): string;
    set maxCapacity(value: string);
    resetMaxCapacity(): void;
    get maxCapacityInput(): string | undefined;
    private _minCapacity?;
    get minCapacity(): string;
    set minCapacity(value: string);
    resetMinCapacity(): void;
    get minCapacityInput(): string | undefined;
    private _scaleMaxCapacity?;
    get scaleMaxCapacity(): string;
    set scaleMaxCapacity(value: string);
    resetScaleMaxCapacity(): void;
    get scaleMaxCapacityInput(): string | undefined;
    private _scaleMinCapacity?;
    get scaleMinCapacity(): string;
    set scaleMinCapacity(value: string);
    resetScaleMinCapacity(): void;
    get scaleMinCapacityInput(): string | undefined;
    private _scaleTargetCapacity?;
    get scaleTargetCapacity(): string;
    set scaleTargetCapacity(value: string);
    resetScaleTargetCapacity(): void;
    get scaleTargetCapacityInput(): string | undefined;
    private _startTime?;
    get startTime(): string;
    set startTime(value: string);
    resetStartTime(): void;
    get startTimeInput(): string | undefined;
    private _targetCapacity?;
    get targetCapacity(): string;
    set targetCapacity(value: string);
    resetTargetCapacity(): void;
    get targetCapacityInput(): string | undefined;
    private _taskType?;
    get taskType(): string;
    set taskType(value: string);
    get taskTypeInput(): string | undefined;
}
export declare class ElastigroupAwsScheduledTaskList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAwsScheduledTask[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAwsScheduledTaskOutputReference;
}
export interface ElastigroupAwsSignal {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#name ElastigroupAws#name}
    */
    readonly name: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#timeout ElastigroupAws#timeout}
    */
    readonly timeout?: number;
}
export declare function elastigroupAwsSignalToTerraform(struct?: ElastigroupAwsSignal | cdktf.IResolvable): any;
export declare function elastigroupAwsSignalToHclTerraform(struct?: ElastigroupAwsSignal | cdktf.IResolvable): any;
export declare class ElastigroupAwsSignalOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAwsSignal | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAwsSignal | cdktf.IResolvable | undefined);
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _timeout?;
    get timeout(): number;
    set timeout(value: number);
    resetTimeout(): void;
    get timeoutInput(): number | undefined;
}
export declare class ElastigroupAwsSignalList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAwsSignal[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAwsSignalOutputReference;
}
export interface ElastigroupAwsStatefulDeallocation {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#should_delete_images ElastigroupAws#should_delete_images}
    */
    readonly shouldDeleteImages?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#should_delete_network_interfaces ElastigroupAws#should_delete_network_interfaces}
    */
    readonly shouldDeleteNetworkInterfaces?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#should_delete_snapshots ElastigroupAws#should_delete_snapshots}
    */
    readonly shouldDeleteSnapshots?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#should_delete_volumes ElastigroupAws#should_delete_volumes}
    */
    readonly shouldDeleteVolumes?: boolean | cdktf.IResolvable;
}
export declare function elastigroupAwsStatefulDeallocationToTerraform(struct?: ElastigroupAwsStatefulDeallocationOutputReference | ElastigroupAwsStatefulDeallocation): any;
export declare function elastigroupAwsStatefulDeallocationToHclTerraform(struct?: ElastigroupAwsStatefulDeallocationOutputReference | ElastigroupAwsStatefulDeallocation): any;
export declare class ElastigroupAwsStatefulDeallocationOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAwsStatefulDeallocation | undefined;
    set internalValue(value: ElastigroupAwsStatefulDeallocation | undefined);
    private _shouldDeleteImages?;
    get shouldDeleteImages(): boolean | cdktf.IResolvable;
    set shouldDeleteImages(value: boolean | cdktf.IResolvable);
    resetShouldDeleteImages(): void;
    get shouldDeleteImagesInput(): boolean | cdktf.IResolvable | undefined;
    private _shouldDeleteNetworkInterfaces?;
    get shouldDeleteNetworkInterfaces(): boolean | cdktf.IResolvable;
    set shouldDeleteNetworkInterfaces(value: boolean | cdktf.IResolvable);
    resetShouldDeleteNetworkInterfaces(): void;
    get shouldDeleteNetworkInterfacesInput(): boolean | cdktf.IResolvable | undefined;
    private _shouldDeleteSnapshots?;
    get shouldDeleteSnapshots(): boolean | cdktf.IResolvable;
    set shouldDeleteSnapshots(value: boolean | cdktf.IResolvable);
    resetShouldDeleteSnapshots(): void;
    get shouldDeleteSnapshotsInput(): boolean | cdktf.IResolvable | undefined;
    private _shouldDeleteVolumes?;
    get shouldDeleteVolumes(): boolean | cdktf.IResolvable;
    set shouldDeleteVolumes(value: boolean | cdktf.IResolvable);
    resetShouldDeleteVolumes(): void;
    get shouldDeleteVolumesInput(): boolean | cdktf.IResolvable | undefined;
}
export interface ElastigroupAwsStatefulInstanceAction {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#stateful_instance_id ElastigroupAws#stateful_instance_id}
    */
    readonly statefulInstanceId: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#type ElastigroupAws#type}
    */
    readonly type: string;
}
export declare function elastigroupAwsStatefulInstanceActionToTerraform(struct?: ElastigroupAwsStatefulInstanceAction | cdktf.IResolvable): any;
export declare function elastigroupAwsStatefulInstanceActionToHclTerraform(struct?: ElastigroupAwsStatefulInstanceAction | cdktf.IResolvable): any;
export declare class ElastigroupAwsStatefulInstanceActionOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAwsStatefulInstanceAction | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAwsStatefulInstanceAction | cdktf.IResolvable | undefined);
    private _statefulInstanceId?;
    get statefulInstanceId(): string;
    set statefulInstanceId(value: string);
    get statefulInstanceIdInput(): string | undefined;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
}
export declare class ElastigroupAwsStatefulInstanceActionList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAwsStatefulInstanceAction[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAwsStatefulInstanceActionOutputReference;
}
export interface ElastigroupAwsTags {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#key ElastigroupAws#key}
    */
    readonly key?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#value ElastigroupAws#value}
    */
    readonly value?: string;
}
export declare function elastigroupAwsTagsToTerraform(struct?: ElastigroupAwsTags | cdktf.IResolvable): any;
export declare function elastigroupAwsTagsToHclTerraform(struct?: ElastigroupAwsTags | cdktf.IResolvable): any;
export declare class ElastigroupAwsTagsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    private resolvableValue?;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): ElastigroupAwsTags | cdktf.IResolvable | undefined;
    set internalValue(value: ElastigroupAwsTags | cdktf.IResolvable | undefined);
    private _key?;
    get key(): string;
    set key(value: string);
    resetKey(): void;
    get keyInput(): string | undefined;
    private _value?;
    get value(): string;
    set value(value: string);
    resetValue(): void;
    get valueInput(): string | undefined;
}
export declare class ElastigroupAwsTagsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    internalValue?: ElastigroupAwsTags[] | cdktf.IResolvable;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): ElastigroupAwsTagsOutputReference;
}
export interface ElastigroupAwsUpdatePolicyRollConfigStrategyOnFailure {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#action_type ElastigroupAws#action_type}
    */
    readonly actionType: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#batch_num ElastigroupAws#batch_num}
    */
    readonly batchNum?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#draining_timeout ElastigroupAws#draining_timeout}
    */
    readonly drainingTimeout?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#should_decrement_target_capacity ElastigroupAws#should_decrement_target_capacity}
    */
    readonly shouldDecrementTargetCapacity?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#should_handle_all_batches ElastigroupAws#should_handle_all_batches}
    */
    readonly shouldHandleAllBatches?: boolean | cdktf.IResolvable;
}
export declare function elastigroupAwsUpdatePolicyRollConfigStrategyOnFailureToTerraform(struct?: ElastigroupAwsUpdatePolicyRollConfigStrategyOnFailureOutputReference | ElastigroupAwsUpdatePolicyRollConfigStrategyOnFailure): any;
export declare function elastigroupAwsUpdatePolicyRollConfigStrategyOnFailureToHclTerraform(struct?: ElastigroupAwsUpdatePolicyRollConfigStrategyOnFailureOutputReference | ElastigroupAwsUpdatePolicyRollConfigStrategyOnFailure): any;
export declare class ElastigroupAwsUpdatePolicyRollConfigStrategyOnFailureOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAwsUpdatePolicyRollConfigStrategyOnFailure | undefined;
    set internalValue(value: ElastigroupAwsUpdatePolicyRollConfigStrategyOnFailure | undefined);
    private _actionType?;
    get actionType(): string;
    set actionType(value: string);
    get actionTypeInput(): string | undefined;
    private _batchNum?;
    get batchNum(): number;
    set batchNum(value: number);
    resetBatchNum(): void;
    get batchNumInput(): number | undefined;
    private _drainingTimeout?;
    get drainingTimeout(): number;
    set drainingTimeout(value: number);
    resetDrainingTimeout(): void;
    get drainingTimeoutInput(): number | undefined;
    private _shouldDecrementTargetCapacity?;
    get shouldDecrementTargetCapacity(): boolean | cdktf.IResolvable;
    set shouldDecrementTargetCapacity(value: boolean | cdktf.IResolvable);
    resetShouldDecrementTargetCapacity(): void;
    get shouldDecrementTargetCapacityInput(): boolean | cdktf.IResolvable | undefined;
    private _shouldHandleAllBatches?;
    get shouldHandleAllBatches(): boolean | cdktf.IResolvable;
    set shouldHandleAllBatches(value: boolean | cdktf.IResolvable);
    resetShouldHandleAllBatches(): void;
    get shouldHandleAllBatchesInput(): boolean | cdktf.IResolvable | undefined;
}
export interface ElastigroupAwsUpdatePolicyRollConfigStrategy {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#action ElastigroupAws#action}
    */
    readonly action: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#batch_min_healthy_percentage ElastigroupAws#batch_min_healthy_percentage}
    */
    readonly batchMinHealthyPercentage?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#should_drain_instances ElastigroupAws#should_drain_instances}
    */
    readonly shouldDrainInstances?: boolean | cdktf.IResolvable;
    /**
    * on_failure block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#on_failure ElastigroupAws#on_failure}
    */
    readonly onFailure?: ElastigroupAwsUpdatePolicyRollConfigStrategyOnFailure;
}
export declare function elastigroupAwsUpdatePolicyRollConfigStrategyToTerraform(struct?: ElastigroupAwsUpdatePolicyRollConfigStrategyOutputReference | ElastigroupAwsUpdatePolicyRollConfigStrategy): any;
export declare function elastigroupAwsUpdatePolicyRollConfigStrategyToHclTerraform(struct?: ElastigroupAwsUpdatePolicyRollConfigStrategyOutputReference | ElastigroupAwsUpdatePolicyRollConfigStrategy): any;
export declare class ElastigroupAwsUpdatePolicyRollConfigStrategyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAwsUpdatePolicyRollConfigStrategy | undefined;
    set internalValue(value: ElastigroupAwsUpdatePolicyRollConfigStrategy | undefined);
    private _action?;
    get action(): string;
    set action(value: string);
    get actionInput(): string | undefined;
    private _batchMinHealthyPercentage?;
    get batchMinHealthyPercentage(): number;
    set batchMinHealthyPercentage(value: number);
    resetBatchMinHealthyPercentage(): void;
    get batchMinHealthyPercentageInput(): number | undefined;
    private _shouldDrainInstances?;
    get shouldDrainInstances(): boolean | cdktf.IResolvable;
    set shouldDrainInstances(value: boolean | cdktf.IResolvable);
    resetShouldDrainInstances(): void;
    get shouldDrainInstancesInput(): boolean | cdktf.IResolvable | undefined;
    private _onFailure;
    get onFailure(): ElastigroupAwsUpdatePolicyRollConfigStrategyOnFailureOutputReference;
    putOnFailure(value: ElastigroupAwsUpdatePolicyRollConfigStrategyOnFailure): void;
    resetOnFailure(): void;
    get onFailureInput(): ElastigroupAwsUpdatePolicyRollConfigStrategyOnFailure | undefined;
}
export interface ElastigroupAwsUpdatePolicyRollConfig {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#batch_size_percentage ElastigroupAws#batch_size_percentage}
    */
    readonly batchSizePercentage: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#grace_period ElastigroupAws#grace_period}
    */
    readonly gracePeriod?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#health_check_type ElastigroupAws#health_check_type}
    */
    readonly healthCheckType?: string;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#wait_for_roll_percentage ElastigroupAws#wait_for_roll_percentage}
    */
    readonly waitForRollPercentage?: number;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#wait_for_roll_timeout ElastigroupAws#wait_for_roll_timeout}
    */
    readonly waitForRollTimeout?: number;
    /**
    * strategy block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#strategy ElastigroupAws#strategy}
    */
    readonly strategy?: ElastigroupAwsUpdatePolicyRollConfigStrategy;
}
export declare function elastigroupAwsUpdatePolicyRollConfigToTerraform(struct?: ElastigroupAwsUpdatePolicyRollConfigOutputReference | ElastigroupAwsUpdatePolicyRollConfig): any;
export declare function elastigroupAwsUpdatePolicyRollConfigToHclTerraform(struct?: ElastigroupAwsUpdatePolicyRollConfigOutputReference | ElastigroupAwsUpdatePolicyRollConfig): any;
export declare class ElastigroupAwsUpdatePolicyRollConfigOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAwsUpdatePolicyRollConfig | undefined;
    set internalValue(value: ElastigroupAwsUpdatePolicyRollConfig | undefined);
    private _batchSizePercentage?;
    get batchSizePercentage(): number;
    set batchSizePercentage(value: number);
    get batchSizePercentageInput(): number | undefined;
    private _gracePeriod?;
    get gracePeriod(): number;
    set gracePeriod(value: number);
    resetGracePeriod(): void;
    get gracePeriodInput(): number | undefined;
    private _healthCheckType?;
    get healthCheckType(): string;
    set healthCheckType(value: string);
    resetHealthCheckType(): void;
    get healthCheckTypeInput(): string | undefined;
    private _waitForRollPercentage?;
    get waitForRollPercentage(): number;
    set waitForRollPercentage(value: number);
    resetWaitForRollPercentage(): void;
    get waitForRollPercentageInput(): number | undefined;
    private _waitForRollTimeout?;
    get waitForRollTimeout(): number;
    set waitForRollTimeout(value: number);
    resetWaitForRollTimeout(): void;
    get waitForRollTimeoutInput(): number | undefined;
    private _strategy;
    get strategy(): ElastigroupAwsUpdatePolicyRollConfigStrategyOutputReference;
    putStrategy(value: ElastigroupAwsUpdatePolicyRollConfigStrategy): void;
    resetStrategy(): void;
    get strategyInput(): ElastigroupAwsUpdatePolicyRollConfigStrategy | undefined;
}
export interface ElastigroupAwsUpdatePolicy {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#auto_apply_tags ElastigroupAws#auto_apply_tags}
    */
    readonly autoApplyTags?: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#should_resume_stateful ElastigroupAws#should_resume_stateful}
    */
    readonly shouldResumeStateful: boolean | cdktf.IResolvable;
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#should_roll ElastigroupAws#should_roll}
    */
    readonly shouldRoll: boolean | cdktf.IResolvable;
    /**
    * roll_config block
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#roll_config ElastigroupAws#roll_config}
    */
    readonly rollConfig?: ElastigroupAwsUpdatePolicyRollConfig;
}
export declare function elastigroupAwsUpdatePolicyToTerraform(struct?: ElastigroupAwsUpdatePolicyOutputReference | ElastigroupAwsUpdatePolicy): any;
export declare function elastigroupAwsUpdatePolicyToHclTerraform(struct?: ElastigroupAwsUpdatePolicyOutputReference | ElastigroupAwsUpdatePolicy): any;
export declare class ElastigroupAwsUpdatePolicyOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): ElastigroupAwsUpdatePolicy | undefined;
    set internalValue(value: ElastigroupAwsUpdatePolicy | undefined);
    private _autoApplyTags?;
    get autoApplyTags(): boolean | cdktf.IResolvable;
    set autoApplyTags(value: boolean | cdktf.IResolvable);
    resetAutoApplyTags(): void;
    get autoApplyTagsInput(): boolean | cdktf.IResolvable | undefined;
    private _shouldResumeStateful?;
    get shouldResumeStateful(): boolean | cdktf.IResolvable;
    set shouldResumeStateful(value: boolean | cdktf.IResolvable);
    get shouldResumeStatefulInput(): boolean | cdktf.IResolvable | undefined;
    private _shouldRoll?;
    get shouldRoll(): boolean | cdktf.IResolvable;
    set shouldRoll(value: boolean | cdktf.IResolvable);
    get shouldRollInput(): boolean | cdktf.IResolvable | undefined;
    private _rollConfig;
    get rollConfig(): ElastigroupAwsUpdatePolicyRollConfigOutputReference;
    putRollConfig(value: ElastigroupAwsUpdatePolicyRollConfig): void;
    resetRollConfig(): void;
    get rollConfigInput(): ElastigroupAwsUpdatePolicyRollConfig | undefined;
}
/**
* Represents a {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws spotinst_elastigroup_aws}
*/
export declare class ElastigroupAws extends cdktf.TerraformResource {
    static readonly tfResourceType = "spotinst_elastigroup_aws";
    /**
    * Generates CDKTF code for importing a ElastigroupAws resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the ElastigroupAws to import
    * @param importFromId The id of the existing ElastigroupAws that should be imported. Refer to the {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the ElastigroupAws to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/spotinst/spotinst/1.216.1/docs/resources/elastigroup_aws spotinst_elastigroup_aws} Resource
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options ElastigroupAwsConfig
    */
    constructor(scope: Construct, id: string, config: ElastigroupAwsConfig);
    private _autoHealing?;
    get autoHealing(): boolean | cdktf.IResolvable;
    set autoHealing(value: boolean | cdktf.IResolvable);
    resetAutoHealing(): void;
    get autoHealingInput(): boolean | cdktf.IResolvable | undefined;
    private _availabilityZones?;
    get availabilityZones(): string[];
    set availabilityZones(value: string[]);
    resetAvailabilityZones(): void;
    get availabilityZonesInput(): string[] | undefined;
    private _blockDevicesMode?;
    get blockDevicesMode(): string;
    set blockDevicesMode(value: string);
    resetBlockDevicesMode(): void;
    get blockDevicesModeInput(): string | undefined;
    private _capacityUnit?;
    get capacityUnit(): string;
    set capacityUnit(value: string);
    resetCapacityUnit(): void;
    get capacityUnitInput(): string | undefined;
    private _considerOdPricing?;
    get considerOdPricing(): boolean | cdktf.IResolvable;
    set considerOdPricing(value: boolean | cdktf.IResolvable);
    resetConsiderOdPricing(): void;
    get considerOdPricingInput(): boolean | cdktf.IResolvable | undefined;
    private _cpuCredits?;
    get cpuCredits(): string;
    set cpuCredits(value: string);
    resetCpuCredits(): void;
    get cpuCreditsInput(): string | undefined;
    private _description?;
    get description(): string;
    set description(value: string);
    resetDescription(): void;
    get descriptionInput(): string | undefined;
    private _desiredCapacity?;
    get desiredCapacity(): number;
    set desiredCapacity(value: number);
    resetDesiredCapacity(): void;
    get desiredCapacityInput(): number | undefined;
    private _drainingTimeout?;
    get drainingTimeout(): number;
    set drainingTimeout(value: number);
    resetDrainingTimeout(): void;
    get drainingTimeoutInput(): number | undefined;
    private _ebsOptimized?;
    get ebsOptimized(): boolean | cdktf.IResolvable;
    set ebsOptimized(value: boolean | cdktf.IResolvable);
    resetEbsOptimized(): void;
    get ebsOptimizedInput(): boolean | cdktf.IResolvable | undefined;
    private _elasticIps?;
    get elasticIps(): string[];
    set elasticIps(value: string[]);
    resetElasticIps(): void;
    get elasticIpsInput(): string[] | undefined;
    private _elasticLoadBalancers?;
    get elasticLoadBalancers(): string[];
    set elasticLoadBalancers(value: string[]);
    resetElasticLoadBalancers(): void;
    get elasticLoadBalancersInput(): string[] | undefined;
    private _enableMonitoring?;
    get enableMonitoring(): boolean | cdktf.IResolvable;
    set enableMonitoring(value: boolean | cdktf.IResolvable);
    resetEnableMonitoring(): void;
    get enableMonitoringInput(): boolean | cdktf.IResolvable | undefined;
    private _fallbackToOndemand?;
    get fallbackToOndemand(): boolean | cdktf.IResolvable;
    set fallbackToOndemand(value: boolean | cdktf.IResolvable);
    get fallbackToOndemandInput(): boolean | cdktf.IResolvable | undefined;
    private _healthCheckGracePeriod?;
    get healthCheckGracePeriod(): number;
    set healthCheckGracePeriod(value: number);
    resetHealthCheckGracePeriod(): void;
    get healthCheckGracePeriodInput(): number | undefined;
    private _healthCheckType?;
    get healthCheckType(): string;
    set healthCheckType(value: string);
    resetHealthCheckType(): void;
    get healthCheckTypeInput(): string | undefined;
    private _healthCheckUnhealthyDurationBeforeReplacement?;
    get healthCheckUnhealthyDurationBeforeReplacement(): number;
    set healthCheckUnhealthyDurationBeforeReplacement(value: number);
    resetHealthCheckUnhealthyDurationBeforeReplacement(): void;
    get healthCheckUnhealthyDurationBeforeReplacementInput(): number | undefined;
    private _iamInstanceProfile?;
    get iamInstanceProfile(): string;
    set iamInstanceProfile(value: string);
    resetIamInstanceProfile(): void;
    get iamInstanceProfileInput(): string | undefined;
    private _id?;
    get id(): string;
    set id(value: string);
    resetId(): void;
    get idInput(): string | undefined;
    private _imageId?;
    get imageId(): string;
    set imageId(value: string);
    resetImageId(): void;
    get imageIdInput(): string | undefined;
    private _immediateOdRecoverThreshold?;
    get immediateOdRecoverThreshold(): number;
    set immediateOdRecoverThreshold(value: number);
    resetImmediateOdRecoverThreshold(): void;
    get immediateOdRecoverThresholdInput(): number | undefined;
    private _instanceTypesOndemand?;
    get instanceTypesOndemand(): string;
    set instanceTypesOndemand(value: string);
    resetInstanceTypesOndemand(): void;
    get instanceTypesOndemandInput(): string | undefined;
    private _instanceTypesPreferredSpot?;
    get instanceTypesPreferredSpot(): string[];
    set instanceTypesPreferredSpot(value: string[]);
    resetInstanceTypesPreferredSpot(): void;
    get instanceTypesPreferredSpotInput(): string[] | undefined;
    private _instanceTypesSpot?;
    get instanceTypesSpot(): string[];
    set instanceTypesSpot(value: string[]);
    resetInstanceTypesSpot(): void;
    get instanceTypesSpotInput(): string[] | undefined;
    private _keyName?;
    get keyName(): string;
    set keyName(value: string);
    resetKeyName(): void;
    get keyNameInput(): string | undefined;
    private _lifetimePeriod?;
    get lifetimePeriod(): string;
    set lifetimePeriod(value: string);
    resetLifetimePeriod(): void;
    get lifetimePeriodInput(): string | undefined;
    private _maxReplacementsPercentage?;
    get maxReplacementsPercentage(): number;
    set maxReplacementsPercentage(value: number);
    resetMaxReplacementsPercentage(): void;
    get maxReplacementsPercentageInput(): number | undefined;
    private _maxSize?;
    get maxSize(): number;
    set maxSize(value: number);
    resetMaxSize(): void;
    get maxSizeInput(): number | undefined;
    private _minSize?;
    get minSize(): number;
    set minSize(value: number);
    resetMinSize(): void;
    get minSizeInput(): number | undefined;
    private _minimumInstanceLifetime?;
    get minimumInstanceLifetime(): number;
    set minimumInstanceLifetime(value: number);
    resetMinimumInstanceLifetime(): void;
    get minimumInstanceLifetimeInput(): number | undefined;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _onDemandTypes?;
    get onDemandTypes(): string[];
    set onDemandTypes(value: string[]);
    resetOnDemandTypes(): void;
    get onDemandTypesInput(): string[] | undefined;
    private _ondemandCount?;
    get ondemandCount(): number;
    set ondemandCount(value: number);
    resetOndemandCount(): void;
    get ondemandCountInput(): number | undefined;
    private _orientation?;
    get orientation(): string;
    set orientation(value: string);
    get orientationInput(): string | undefined;
    private _persistBlockDevices?;
    get persistBlockDevices(): boolean | cdktf.IResolvable;
    set persistBlockDevices(value: boolean | cdktf.IResolvable);
    resetPersistBlockDevices(): void;
    get persistBlockDevicesInput(): boolean | cdktf.IResolvable | undefined;
    private _persistPrivateIp?;
    get persistPrivateIp(): boolean | cdktf.IResolvable;
    set persistPrivateIp(value: boolean | cdktf.IResolvable);
    resetPersistPrivateIp(): void;
    get persistPrivateIpInput(): boolean | cdktf.IResolvable | undefined;
    private _persistRootDevice?;
    get persistRootDevice(): boolean | cdktf.IResolvable;
    set persistRootDevice(value: boolean | cdktf.IResolvable);
    resetPersistRootDevice(): void;
    get persistRootDeviceInput(): boolean | cdktf.IResolvable | undefined;
    private _placementTenancy?;
    get placementTenancy(): string;
    set placementTenancy(value: string);
    resetPlacementTenancy(): void;
    get placementTenancyInput(): string | undefined;
    private _preferredAvailabilityZones?;
    get preferredAvailabilityZones(): string[];
    set preferredAvailabilityZones(value: string[]);
    resetPreferredAvailabilityZones(): void;
    get preferredAvailabilityZonesInput(): string[] | undefined;
    private _privateIps?;
    get privateIps(): string[];
    set privateIps(value: string[]);
    resetPrivateIps(): void;
    get privateIpsInput(): string[] | undefined;
    private _product?;
    get product(): string;
    set product(value: string);
    get productInput(): string | undefined;
    private _region?;
    get region(): string;
    set region(value: string);
    resetRegion(): void;
    get regionInput(): string | undefined;
    private _restrictSingleAz?;
    get restrictSingleAz(): boolean | cdktf.IResolvable;
    set restrictSingleAz(value: boolean | cdktf.IResolvable);
    resetRestrictSingleAz(): void;
    get restrictSingleAzInput(): boolean | cdktf.IResolvable | undefined;
    private _securityGroups?;
    get securityGroups(): string[];
    set securityGroups(value: string[]);
    get securityGroupsInput(): string[] | undefined;
    private _shutdownScript?;
    get shutdownScript(): string;
    set shutdownScript(value: string);
    resetShutdownScript(): void;
    get shutdownScriptInput(): string | undefined;
    private _spotPercentage?;
    get spotPercentage(): number;
    set spotPercentage(value: number);
    resetSpotPercentage(): void;
    get spotPercentageInput(): number | undefined;
    private _subnetIds?;
    get subnetIds(): string[];
    set subnetIds(value: string[]);
    resetSubnetIds(): void;
    get subnetIdsInput(): string[] | undefined;
    private _targetGroupArns?;
    get targetGroupArns(): string[];
    set targetGroupArns(value: string[]);
    resetTargetGroupArns(): void;
    get targetGroupArnsInput(): string[] | undefined;
    private _userData?;
    get userData(): string;
    set userData(value: string);
    resetUserData(): void;
    get userDataInput(): string | undefined;
    private _utilizeCommitments?;
    get utilizeCommitments(): boolean | cdktf.IResolvable;
    set utilizeCommitments(value: boolean | cdktf.IResolvable);
    resetUtilizeCommitments(): void;
    get utilizeCommitmentsInput(): boolean | cdktf.IResolvable | undefined;
    private _utilizeReservedInstances?;
    get utilizeReservedInstances(): boolean | cdktf.IResolvable;
    set utilizeReservedInstances(value: boolean | cdktf.IResolvable);
    resetUtilizeReservedInstances(): void;
    get utilizeReservedInstancesInput(): boolean | cdktf.IResolvable | undefined;
    private _waitForCapacity?;
    get waitForCapacity(): number;
    set waitForCapacity(value: number);
    resetWaitForCapacity(): void;
    get waitForCapacityInput(): number | undefined;
    private _waitForCapacityTimeout?;
    get waitForCapacityTimeout(): number;
    set waitForCapacityTimeout(value: number);
    resetWaitForCapacityTimeout(): void;
    get waitForCapacityTimeoutInput(): number | undefined;
    private _cpuOptions;
    get cpuOptions(): ElastigroupAwsCpuOptionsOutputReference;
    putCpuOptions(value: ElastigroupAwsCpuOptions): void;
    resetCpuOptions(): void;
    get cpuOptionsInput(): ElastigroupAwsCpuOptions | undefined;
    private _ebsBlockDevice;
    get ebsBlockDevice(): ElastigroupAwsEbsBlockDeviceList;
    putEbsBlockDevice(value: ElastigroupAwsEbsBlockDevice[] | cdktf.IResolvable): void;
    resetEbsBlockDevice(): void;
    get ebsBlockDeviceInput(): cdktf.IResolvable | ElastigroupAwsEbsBlockDevice[] | undefined;
    private _ephemeralBlockDevice;
    get ephemeralBlockDevice(): ElastigroupAwsEphemeralBlockDeviceList;
    putEphemeralBlockDevice(value: ElastigroupAwsEphemeralBlockDevice[] | cdktf.IResolvable): void;
    resetEphemeralBlockDevice(): void;
    get ephemeralBlockDeviceInput(): cdktf.IResolvable | ElastigroupAwsEphemeralBlockDevice[] | undefined;
    private _images;
    get images(): ElastigroupAwsImagesList;
    putImages(value: ElastigroupAwsImages[] | cdktf.IResolvable): void;
    resetImages(): void;
    get imagesInput(): cdktf.IResolvable | ElastigroupAwsImages[] | undefined;
    private _instanceTypesWeights;
    get instanceTypesWeights(): ElastigroupAwsInstanceTypesWeightsList;
    putInstanceTypesWeights(value: ElastigroupAwsInstanceTypesWeights[] | cdktf.IResolvable): void;
    resetInstanceTypesWeights(): void;
    get instanceTypesWeightsInput(): cdktf.IResolvable | ElastigroupAwsInstanceTypesWeights[] | undefined;
    private _integrationBeanstalk;
    get integrationBeanstalk(): ElastigroupAwsIntegrationBeanstalkOutputReference;
    putIntegrationBeanstalk(value: ElastigroupAwsIntegrationBeanstalk): void;
    resetIntegrationBeanstalk(): void;
    get integrationBeanstalkInput(): ElastigroupAwsIntegrationBeanstalk | undefined;
    private _integrationCodedeploy;
    get integrationCodedeploy(): ElastigroupAwsIntegrationCodedeployOutputReference;
    putIntegrationCodedeploy(value: ElastigroupAwsIntegrationCodedeploy): void;
    resetIntegrationCodedeploy(): void;
    get integrationCodedeployInput(): ElastigroupAwsIntegrationCodedeploy | undefined;
    private _integrationDockerSwarm;
    get integrationDockerSwarm(): ElastigroupAwsIntegrationDockerSwarmOutputReference;
    putIntegrationDockerSwarm(value: ElastigroupAwsIntegrationDockerSwarm): void;
    resetIntegrationDockerSwarm(): void;
    get integrationDockerSwarmInput(): ElastigroupAwsIntegrationDockerSwarm | undefined;
    private _integrationEcs;
    get integrationEcs(): ElastigroupAwsIntegrationEcsOutputReference;
    putIntegrationEcs(value: ElastigroupAwsIntegrationEcs): void;
    resetIntegrationEcs(): void;
    get integrationEcsInput(): ElastigroupAwsIntegrationEcs | undefined;
    private _integrationGitlab;
    get integrationGitlab(): ElastigroupAwsIntegrationGitlabOutputReference;
    putIntegrationGitlab(value: ElastigroupAwsIntegrationGitlab): void;
    resetIntegrationGitlab(): void;
    get integrationGitlabInput(): ElastigroupAwsIntegrationGitlab | undefined;
    private _integrationKubernetes;
    get integrationKubernetes(): ElastigroupAwsIntegrationKubernetesOutputReference;
    putIntegrationKubernetes(value: ElastigroupAwsIntegrationKubernetes): void;
    resetIntegrationKubernetes(): void;
    get integrationKubernetesInput(): ElastigroupAwsIntegrationKubernetes | undefined;
    private _integrationMesosphere;
    get integrationMesosphere(): ElastigroupAwsIntegrationMesosphereOutputReference;
    putIntegrationMesosphere(value: ElastigroupAwsIntegrationMesosphere): void;
    resetIntegrationMesosphere(): void;
    get integrationMesosphereInput(): ElastigroupAwsIntegrationMesosphere | undefined;
    private _integrationNomad;
    get integrationNomad(): ElastigroupAwsIntegrationNomadOutputReference;
    putIntegrationNomad(value: ElastigroupAwsIntegrationNomad): void;
    resetIntegrationNomad(): void;
    get integrationNomadInput(): ElastigroupAwsIntegrationNomad | undefined;
    private _integrationRancher;
    get integrationRancher(): ElastigroupAwsIntegrationRancherOutputReference;
    putIntegrationRancher(value: ElastigroupAwsIntegrationRancher): void;
    resetIntegrationRancher(): void;
    get integrationRancherInput(): ElastigroupAwsIntegrationRancher | undefined;
    private _integrationRoute53;
    get integrationRoute53(): ElastigroupAwsIntegrationRoute53OutputReference;
    putIntegrationRoute53(value: ElastigroupAwsIntegrationRoute53): void;
    resetIntegrationRoute53(): void;
    get integrationRoute53Input(): ElastigroupAwsIntegrationRoute53 | undefined;
    private _itf;
    get itf(): ElastigroupAwsItfList;
    putItf(value: ElastigroupAwsItf[] | cdktf.IResolvable): void;
    resetItf(): void;
    get itfInput(): cdktf.IResolvable | ElastigroupAwsItf[] | undefined;
    private _logging;
    get logging(): ElastigroupAwsLoggingOutputReference;
    putLogging(value: ElastigroupAwsLogging): void;
    resetLogging(): void;
    get loggingInput(): ElastigroupAwsLogging | undefined;
    private _metadataOptions;
    get metadataOptions(): ElastigroupAwsMetadataOptionsOutputReference;
    putMetadataOptions(value: ElastigroupAwsMetadataOptions): void;
    resetMetadataOptions(): void;
    get metadataOptionsInput(): ElastigroupAwsMetadataOptions | undefined;
    private _multipleMetrics;
    get multipleMetrics(): ElastigroupAwsMultipleMetricsOutputReference;
    putMultipleMetrics(value: ElastigroupAwsMultipleMetrics): void;
    resetMultipleMetrics(): void;
    get multipleMetricsInput(): ElastigroupAwsMultipleMetrics | undefined;
    private _networkInterface;
    get networkInterface(): ElastigroupAwsNetworkInterfaceList;
    putNetworkInterface(value: ElastigroupAwsNetworkInterface[] | cdktf.IResolvable): void;
    resetNetworkInterface(): void;
    get networkInterfaceInput(): cdktf.IResolvable | ElastigroupAwsNetworkInterface[] | undefined;
    private _resourceRequirements;
    get resourceRequirements(): ElastigroupAwsResourceRequirementsList;
    putResourceRequirements(value: ElastigroupAwsResourceRequirements[] | cdktf.IResolvable): void;
    resetResourceRequirements(): void;
    get resourceRequirementsInput(): cdktf.IResolvable | ElastigroupAwsResourceRequirements[] | undefined;
    private _resourceTagSpecification;
    get resourceTagSpecification(): ElastigroupAwsResourceTagSpecificationList;
    putResourceTagSpecification(value: ElastigroupAwsResourceTagSpecification[] | cdktf.IResolvable): void;
    resetResourceTagSpecification(): void;
    get resourceTagSpecificationInput(): cdktf.IResolvable | ElastigroupAwsResourceTagSpecification[] | undefined;
    private _revertToSpot;
    get revertToSpot(): ElastigroupAwsRevertToSpotOutputReference;
    putRevertToSpot(value: ElastigroupAwsRevertToSpot): void;
    resetRevertToSpot(): void;
    get revertToSpotInput(): ElastigroupAwsRevertToSpot | undefined;
    private _scalingDownPolicy;
    get scalingDownPolicy(): ElastigroupAwsScalingDownPolicyList;
    putScalingDownPolicy(value: ElastigroupAwsScalingDownPolicy[] | cdktf.IResolvable): void;
    resetScalingDownPolicy(): void;
    get scalingDownPolicyInput(): cdktf.IResolvable | ElastigroupAwsScalingDownPolicy[] | undefined;
    private _scalingStrategy;
    get scalingStrategy(): ElastigroupAwsScalingStrategyList;
    putScalingStrategy(value: ElastigroupAwsScalingStrategy[] | cdktf.IResolvable): void;
    resetScalingStrategy(): void;
    get scalingStrategyInput(): cdktf.IResolvable | ElastigroupAwsScalingStrategy[] | undefined;
    private _scalingTargetPolicy;
    get scalingTargetPolicy(): ElastigroupAwsScalingTargetPolicyList;
    putScalingTargetPolicy(value: ElastigroupAwsScalingTargetPolicy[] | cdktf.IResolvable): void;
    resetScalingTargetPolicy(): void;
    get scalingTargetPolicyInput(): cdktf.IResolvable | ElastigroupAwsScalingTargetPolicy[] | undefined;
    private _scalingUpPolicy;
    get scalingUpPolicy(): ElastigroupAwsScalingUpPolicyList;
    putScalingUpPolicy(value: ElastigroupAwsScalingUpPolicy[] | cdktf.IResolvable): void;
    resetScalingUpPolicy(): void;
    get scalingUpPolicyInput(): cdktf.IResolvable | ElastigroupAwsScalingUpPolicy[] | undefined;
    private _scheduledTask;
    get scheduledTask(): ElastigroupAwsScheduledTaskList;
    putScheduledTask(value: ElastigroupAwsScheduledTask[] | cdktf.IResolvable): void;
    resetScheduledTask(): void;
    get scheduledTaskInput(): cdktf.IResolvable | ElastigroupAwsScheduledTask[] | undefined;
    private _signal;
    get signal(): ElastigroupAwsSignalList;
    putSignal(value: ElastigroupAwsSignal[] | cdktf.IResolvable): void;
    resetSignal(): void;
    get signalInput(): cdktf.IResolvable | ElastigroupAwsSignal[] | undefined;
    private _statefulDeallocation;
    get statefulDeallocation(): ElastigroupAwsStatefulDeallocationOutputReference;
    putStatefulDeallocation(value: ElastigroupAwsStatefulDeallocation): void;
    resetStatefulDeallocation(): void;
    get statefulDeallocationInput(): ElastigroupAwsStatefulDeallocation | undefined;
    private _statefulInstanceAction;
    get statefulInstanceAction(): ElastigroupAwsStatefulInstanceActionList;
    putStatefulInstanceAction(value: ElastigroupAwsStatefulInstanceAction[] | cdktf.IResolvable): void;
    resetStatefulInstanceAction(): void;
    get statefulInstanceActionInput(): cdktf.IResolvable | ElastigroupAwsStatefulInstanceAction[] | undefined;
    private _tags;
    get tags(): ElastigroupAwsTagsList;
    putTags(value: ElastigroupAwsTags[] | cdktf.IResolvable): void;
    resetTags(): void;
    get tagsInput(): cdktf.IResolvable | ElastigroupAwsTags[] | undefined;
    private _updatePolicy;
    get updatePolicy(): ElastigroupAwsUpdatePolicyOutputReference;
    putUpdatePolicy(value: ElastigroupAwsUpdatePolicy): void;
    resetUpdatePolicy(): void;
    get updatePolicyInput(): ElastigroupAwsUpdatePolicy | undefined;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
